<?php
/*
Translates pseudo code to a module load array

Author: Remco Kouw
Site: http://www.hacksuite.com
Last Edit: 13-06-2024
*/
function LoadModules($sPseudo){
	// find all modules load tags
	preg_match_all('/\[load=(.*?)\](.*?)\[\/load\]/s',$sPseudo,$aLoads,PREG_SET_ORDER);
	$aExtractedData = array();
	// each load tag represents a module
	foreach($aLoads as $aLoad){
		$aLoadTag = $aLoad[1];
		$aLoadContent = trim($aLoad[2]);
		$aVariables = array();
		// values for post variables
		preg_match('/\[p\](.*?)\[\/p\]/s',$aLoadContent,$aP);
		if(!empty($aP)){
			$sPContent = trim($aP[1]);
			preg_match_all('/"(.*?)"="(.*?)"/',$sPContent,$aPVarMatches,PREG_SET_ORDER);
			foreach($aPVarMatches as $aVariable){
				$sName = $aVariable[1];
				$sValue = $aVariable[2];
				$aVariables['p'][$sName] = $sValue;
			}
		}
		// values for get variables
		preg_match('/\[g\](.*?)\[\/g\]/s',$aLoadContent,$aG);
		if(!empty($aG)){
			$sGContent = trim($aG[1]);
			preg_match_all('/"(.*?)"="(.*?)"/',$sGContent,$aGVarMatches,PREG_SET_ORDER);
			foreach($aGVarMatches as $aVariable){
				$sName = $aVariable[1];
				$sValue = $aVariable[2];
				$aVariables['g'][$sName] = $sValue;
			}
		}
		// values for local variables
		preg_match('/\[l\](.*?)\[\/l\]/s',$aLoadContent,$aL);
		if(!empty($aL)){
			$sLContent = trim($aL[1]);
			preg_match_all('/"(.*?)"="(.*?)"/',$sLContent,$aLVarMatches,PREG_SET_ORDER);
			foreach($aLVarMatches as $aVariable){
				$sName = $aVariable[1];
				$sValue = $aVariable[2];
				$aVariables['l'][$sName] = $sValue;
			}
		}
		// values for memory cleaning
		preg_match('/\[c\](.*?)\[\/c\]/s',$aLoadContent,$aC);
		if(!empty($aC)){
			$sCContent = trim($aC[1]);
			preg_match_all('/"(.*?)"="(.*?)"/',$sCContent,$aCVarMatches,PREG_SET_ORDER);
			foreach($aCVarMatches as $aVariable){
				$sName = $aVariable[1];
				$sValue = $aVariable[2];
				$aVariables['c'][$sName] = $sValue;
			}
		}
		// values for validation
		preg_match('/\[v\](.*?)\[\/v\]/s',$aLoadContent,$aV);
		if(!empty($aV)){
			$sVContent = trim($aV[1]);
			preg_match_all('/"(.*?)"="(.*?)"/',$sVContent,$aVVarMatches,PREG_SET_ORDER);
			foreach($aVVarMatches as $aVariable){
				$sName = $aVariable[1];
				$sValue = $aVariable[2];
				$aVariables['v'][$sName] = $sValue;
			}
		}
		// file names
		preg_match('/\[f\](.*?)\[\/f\]/s',$aLoadContent,$aFMatches);
		if(!empty($aFMatches)){
			$sFContent = trim($aFMatches[1]);
			$aFiles = array_map('trim',explode(',',$sFContent));
		}
		else{
			$aFiles = array();
		}
		$aLoadData = array(
			'load_tag' => $aLoadTag,
			'variables' => $aVariables,
			'files' => $aFiles
		);
		$aExtractedData[] = $aLoadData;
	}
	return $aExtractedData;
}
?>