<?php
/*
Runs the specified command in ModGlue

Author: Remco Kouw
Site: http://www.hacksuite.com
Last Edit: 13-06-2024
*/
$_DYNAMIC_ROOT = "../..";
include_once("../../header.php");
include_once("header.php");
$_CONTEXT['modglue']['loadvalid'] = true;
if(!isset($_GET['sCode'])){
	echo"No data sent";
}
else{
	// quick check
	$aData = @unserialize($_GET['sCode']);
	if(isset($aData[0]['load_tag']) && isset($aData[0]['variables']) && isset($aData[0]['files'])){
		echo"Modules requested: ".($iData = count($aData))."<br />\n";
		foreach($aData as $iKey=>$aValueVars){
			echo"<b>Verifying module name: ".$aData[$iKey]['load_tag'].": ".(file_exists("../../Modules/".$aData[$iKey]['load_tag']."/setup.php") ? "passed" : "failed")."</b><br />\n";
			if(isset($aValueVars['load_tag'])){
				echo"Found module tag<br />\n";
				if(isset($aValueVars['variables']['p']) || isset($aValueVars['variables']['g'])){
					echo"POST or GET method variables found<br />\n";
					if(isset($aValueVars['files'][0])){
						echo"Include file(s) found<br />\n";
						if(isset($aValueVars['variables']['p'])){
							echo"Using _POST method: ".var_export($aValueVars['variables']['p'],true)."<br />\n";
						}
						else{
							echo"Using _GET method: ".var_export($aValueVars['variables']['g'],true)."<br />\n";
						}
						if(isset($aValueVars['variables']['l'])){
							echo"Local variables storage will be assigned to modglue context<br />\n";
						}
						if(isset($aValueVars['variables']['c'])){
							echo"Variables will be unset as requested<br />\n";
						}
						if(isset($aValueVars['variables']['v'])){
							echo"Variables validation is set<br />\n";
						}
						// get all module names
						if(!function_exists("GetDirByDir")){
							$sDest = $_PATHS['functions_root']."/getdirbydir.php";
							if(!file_exists($sDest)){
								echo"Failed to find GetDirByDir function<br />\n";
								$_CONTEXT['modglue']['loadvalid'] = false;
							}
							else{
								include($sDest);
							}
						}
						if(!is_array($_CONTEXT['modglue']['modsloaded'] = GetDirByDir("../../Modules",0))){
							echo"Failed to find get module names<br />\n";
							$_CONTEXT['modglue']['loadvalid'] = false;
						}
					}
					else{
						echo"No include file(s) found<br />\n";
						$_CONTEXT['modglue']['loadvalid'] = false;
					}
				}
				else{
					echo"POST or GET method variables missing<br />\n";
					$_CONTEXT['modglue']['loadvalid'] = false;
				}
			}
			else{
				echo"No module tag found<br />\n";
				$_CONTEXT['modglue']['loadvalid'] = false;
			}
		}
	}
	else{
		echo"Invalid serialized data";
		$_CONTEXT['modglue']['loadvalid'] = false;
	}
}

if($_CONTEXT['modglue']['loadvalid']){
	echo"<p><b>abstract validation completed...running...</b></p><hr />";
	// even though we didn't do a thorough check at least we should be able to run now
	$_CONTEXT['modglue']['default_mod_root'] = $_PATHS['module_default_root'];
	$_CONTEXT['modglue']['moduleruns'] = 0;
	// set the environment
	foreach($aData as $iKey=>$aValueVars){
		$_CONTEXT['modglue']['currentmod'] = $aData[$iKey]['load_tag'];
		echo"<b>Running module: ".$_CONTEXT['modglue']['currentmod']."</b><br />\n";
		/* $_GET */
		if(isset($aValueVars['variables']['g'])){
			foreach($aValueVars['variables']['g'] as $sVarName=>$sValue){
				if($sVarName[0]=="a"){
					// expecting an array
					$aValue = explode(",",$sValue);
					$_GET[$sVarName] = $aValue;
				}
				elseif($sVarName[0]=="b"){
					// expecting a boolean
					$_GET[$sVarName] = $sValue==0 ? false : true;
				}
				elseif($sVarName[0]=="i"){
					// expecting an integer or decimal numeric value
					$_GET[$sVarName] = intval($sValue);
				}
				elseif($sVarName[0]=="~"){
					// if the first character is a ~ it means the value is a path to a variable
					$sVarName = substr($sVarName,1);
					if($sValue[0]=="@"){
						// variable path from $_CONTEXT except modules
						$_CONTEXT['modglue']['assignedparts'] = explode("@",$sValue);
						$_CONTEXT['modglue']['assignedpartscount'] = count($_CONTEXT['modglue']['assignedparts']);
						if($_CONTEXT['modglue']['assignedpartscount']>3){
							die("<p><b>".$_CONTEXT['modglue']['currentmod'].":</b> Can only obtain data from two sub arrays in context variable</p>");
						}
						if($_CONTEXT['modglue']['assignedpartscount']==2){
							// @value1
							if(!isset($_CONTEXT[$_CONTEXT['modglue']['assignedparts'][1]])){
								die("<p><b>".$_CONTEXT['modglue']['currentmod'].":</b> Variable \$_CONTEXT['".$_CONTEXT['modglue']['assignedparts'][1]."'] is undefined</p>");
							}
							$_GET[$sVarName] = $_CONTEXT[$_CONTEXT['modglue']['assignedparts'][1]];
						}
						elseif($_CONTEXT['modglue']['assignedpartscount']==3){
							// @value1@value2
							if(!isset($_CONTEXT[$_CONTEXT['modglue']['assignedparts'][1]][$_CONTEXT['modglue']['assignedparts'][2]])){
								die("<p><b>".$_CONTEXT['modglue']['currentmod'].":</b> Variable \$_CONTEXT['".$_CONTEXT['modglue']['assignedparts'][1]."']['".$_CONTEXT['modglue']['assignedparts'][2]."'] is undefined</p>");
							}
							$_GET[$sVarName] = $_CONTEXT[$_CONTEXT['modglue']['assignedparts'][1]][$_CONTEXT['modglue']['assignedparts'][2]];
						}
					}
					elseif($sValue[0]=="*"){
						// variable path from earlier executed modules
						if(!$_CONTEXT['modglue']['moduleruns']){
							die("<p><b>".$_CONTEXT['modglue']['currentmod'].":</b> Can't use data from earlier used modules if no module has been executed yet</p>");
						}
						$_CONTEXT['modglue']['assignedparts'] = explode("*",$sValue);
						$_CONTEXT['modglue']['assignedpartscount'] = count($_CONTEXT['modglue']['assignedparts']);
						if(!in_array($_CONTEXT['modglue'][$_CONTEXT['modglue']['assignedparts'][1]],$_CONTEXT['modglue']['modsloaded'])){
							die("<p><b>".$_CONTEXT['modglue']['currentmod'].":</b> Module ".$_CONTEXT['modglue'][$_CONTEXT['modglue']['assignedparts'][1]]." doesn't exist, make sure to include module name after first * character</p>");
						}
						if(!isset($_CONTEXT['modglue'][$_CONTEXT['modglue']['assignedparts'][1]])){
							die("<p><b>".$_CONTEXT['modglue']['currentmod'].":</b> Module output for ".$_CONTEXT['modglue']['assignedparts'][1]." hasn't been stored yet</p>");
						}
						if($_CONTEXT['modglue']['assignedpartscount']>=5){
							die("<p><b>".$_CONTEXT['modglue']['currentmod'].":</b> Can only obtain data from three sub arrays in modglue module context variable</p>");
						}
						if($_CONTEXT['modglue']['assignedpartscount']==3){
							// *modulename*value1
							if(!isset($_CONTEXT['modglue'][$_CONTEXT['modglue']['assignedparts'][1]][$_CONTEXT['modglue']['assignedparts'][2]])){
								die("<p><b>".$_CONTEXT['modglue']['currentmod'].":</b> Variable \$_CONTEXT['modglue']['".$_CONTEXT['modglue']['assignedparts'][1]."']['".$_CONTEXT['modglue']['assignedparts'][2]."'] is undefined</p>");
							}
							$_GET[$sVarName] = $_CONTEXT['modglue'][$_CONTEXT['modglue']['assignedparts'][1]][$_CONTEXT['modglue']['assignedparts'][2]];
						}
						if($_CONTEXT['modglue']['assignedpartscount']==4){
							// *modulename*value1*value2
							if(!isset($_CONTEXT['modglue'][$_CONTEXT['modglue']['assignedparts'][1]][$_CONTEXT['modglue']['assignedparts'][2]][$_CONTEXT['modglue']['assignedparts'][3]])){
								die("<p><b>".$_CONTEXT['modglue']['currentmod'].":</b> Variable \$_CONTEXT['modglue']['".$_CONTEXT['modglue']['assignedparts'][1]."']['".$_CONTEXT['modglue']['assignedparts'][2]."']['".$_CONTEXT['modglue']['assignedparts'][3]."'] is undefined</p>");
							}
							$_GET[$sVarName] = $_CONTEXT['modglue'][$_CONTEXT['modglue']['assignedparts'][1]][$_CONTEXT['modglue']['assignedparts'][2]][$_CONTEXT['modglue']['assignedparts'][3]];
						}
					}
					elseif($sValue[0]=="#"){
						// variable name defined in code
						$_CONTEXT['modglue']['assignedparts'] = explode("#",$sValue);
						$_CONTEXT['modglue']['assignedpartscount'] = count($_CONTEXT['modglue']['assignedparts']);
						if(!isset(${$_CONTEXT['modglue']['assignedparts'][1]})){
							die("<p><b>".$_CONTEXT['modglue']['currentmod'].":</b> Variable \$".$_CONTEXT['modglue']['assignedparts'][1]." is undefined</p>");
						}
						if($_CONTEXT['modglue']['assignedpartscount']>2){
							// this should be an array
							$_CONTEXT['modglue']['tempvar'] = ${$_CONTEXT['modglue']['assignedparts'][1]};
							if(!is_array($_CONTEXT['modglue']['tempvar'])){
								die("<p><b>".$_CONTEXT['modglue']['currentmod'].":</b> Variable \$".$_CONTEXT['modglue']['assignedparts'][1]." is not an array</p>");
							}
							if($_CONTEXT['modglue']['assignedpartscount']>=5){
								die("<p><b>".$_CONTEXT['modglue']['currentmod'].":</b> Variable \$".$_CONTEXT['modglue']['assignedparts'][1]." can have only two depth levels</p>");
							}
							elseif($_CONTEXT['modglue']['assignedpartscount']==3){
								if(!isset($_CONTEXT['modglue']['tempvar'][$_CONTEXT['modglue']['assignedparts'][2]])){
									die("<p><b>".$_CONTEXT['modglue']['currentmod'].":</b> Index ".$_CONTEXT['modglue']['assignedparts'][2]." doesn't exist</p>");
								}
								$_GET[$sVarName] = $_CONTEXT['modglue']['tempvar'][$_CONTEXT['modglue']['assignedparts'][2]];
							}
							else{
								if(!isset($_CONTEXT['modglue']['tempvar'][$_CONTEXT['modglue']['assignedparts'][2]])){
									die("<p><b>".$_CONTEXT['modglue']['currentmod'].":</b> Index ".$_CONTEXT['modglue']['assignedparts'][3]." doesn't exist</p>");
								}
								$_GET[$sVarName] = $_CONTEXT['modglue']['tempvar'][$_CONTEXT['modglue']['assignedparts'][2]][$_CONTEXT['modglue']['assignedparts'][3]];
							}
						}
						else{
							$_GET[$sVarName] = ${$_CONTEXT['modglue']['assignedparts'][1]};
						}
					}
					else{
						// unknown variable defined
						die("<p><b>".$_CONTEXT['modglue']['currentmod'].":</b> When you use ~ as the first character of a variable name, you need either @, * or # to assign a defined variable</p>");
					}
				}
				else{
					$_GET[$sVarName] = $sValue;
				}
			}
		}
		/* $_POST */
		elseif(isset($aValueVars['variables']['p'])){
			foreach($aValueVars['variables']['p'] as $sVarName=>$sValue){
				if($sVarName[0]=="a"){
					$aValue = explode(",",$sValue);
					$_POST[$sVarName] = $aValue;
				}
				elseif($sVarName[0]=="b"){
					$_POST[$sVarName] = $sValue==0 ? false : true;
				}
				elseif($sVarName[0]=="i"){
					$_POST[$sVarName] = intval($sValue);
				}
				elseif($sVarName[0]=="~"){
					// if the first character is a ~ it means the value is a path to a variable
					$sVarName = substr($sVarName,1);
					if($sValue[0]=="@"){
						// variable path from $_CONTEXT except modules
						$_CONTEXT['modglue']['assignedparts'] = explode("@",$sValue);
						$_CONTEXT['modglue']['assignedpartscount'] = count($_CONTEXT['modglue']['assignedparts']);
						if($_CONTEXT['modglue']['assignedpartscount']>3){
							die("<p><b>".$_CONTEXT['modglue']['currentmod'].":</b> Can only obtain data from two sub arrays in context variable</p>");
						}
						if($_CONTEXT['modglue']['assignedpartscount']==2){
							// @value1
							if(!isset($_CONTEXT[$_CONTEXT['modglue']['assignedparts'][1]])){
								die("<p><b>".$_CONTEXT['modglue']['currentmod'].":</b> Variable \$_CONTEXT['".$_CONTEXT['modglue']['assignedparts'][1]."'] is undefined</p>");
							}
							$_POST[$sVarName] = $_CONTEXT[$_CONTEXT['modglue']['assignedparts'][1]];
						}
						elseif($_CONTEXT['modglue']['assignedpartscount']==3){
							// @value1@value2
							if(!isset($_CONTEXT[$_CONTEXT['modglue']['assignedparts'][1]][$_CONTEXT['modglue']['assignedparts'][2]])){
								die("<p><b>".$_CONTEXT['modglue']['currentmod'].":</b> Variable \$_CONTEXT['".$_CONTEXT['modglue']['assignedparts'][1]."']['".$_CONTEXT['modglue']['assignedparts'][2]."'] is undefined</p>");
							}
							$_POST[$sVarName] = $_CONTEXT[$_CONTEXT['modglue']['assignedparts'][1]][$_CONTEXT['modglue']['assignedparts'][2]];
						}
					}
					elseif($sValue[0]=="*"){
						// variable path from earlier executed modules
						if(!$_CONTEXT['modglue']['moduleruns']){
							die("<p><b>".$_CONTEXT['modglue']['currentmod'].":</b> Can't use data from earlier used modules if no module has been executed yet</p>");
						}
						$_CONTEXT['modglue']['assignedparts'] = explode("*",$sValue);
						$_CONTEXT['modglue']['assignedpartscount'] = count($_CONTEXT['modglue']['assignedparts']);
						if(!in_array($_CONTEXT['modglue']['assignedparts'][1],$_CONTEXT['modglue']['modsloaded'])){
							die("<p><b>".$_CONTEXT['modglue']['currentmod'].":</b> Module ".$_CONTEXT['modglue']['assignedparts'][1]." doesn't exist, make sure to include module name after first * character</p>");
						}
						if(!isset($_CONTEXT['modglue'][$_CONTEXT['modglue']['assignedparts'][1]])){
							die("<p><b>".$_CONTEXT['modglue']['currentmod'].":</b> Module output for ".$_CONTEXT['modglue']['assignedparts'][1]." hasn't been stored yet</p>");
						}
						if($_CONTEXT['modglue']['assignedpartscount']>=5){
							die("<p><b>".$_CONTEXT['modglue']['currentmod'].":</b> Can only obtain data from three sub arrays in modglue module context variable</p>");
						}
						if($_CONTEXT['modglue']['assignedpartscount']==3){
							// *modulename*value1
							if(!isset($_CONTEXT['modglue'][$_CONTEXT['modglue']['assignedparts'][1]][$_CONTEXT['modglue']['assignedparts'][2]])){
								die("<p><b>".$_CONTEXT['modglue']['currentmod'].":</b> Variable \$_CONTEXT['modglue']['".$_CONTEXT['modglue']['assignedparts'][1]."']['".$_CONTEXT['modglue']['assignedparts'][2]."'] is undefined</p>");
							}
							$_POST[$sVarName] = $_CONTEXT['modglue'][$_CONTEXT['modglue']['assignedparts'][1]][$_CONTEXT['modglue']['assignedparts'][2]];
						}
						if($_CONTEXT['modglue']['assignedpartscount']==4){
							// *modulename*value1*value2
							if(!isset($_CONTEXT[$_CONTEXT['modglue']['assignedparts'][1]][$_CONTEXT['modglue']['assignedparts'][2]][$_CONTEXT['modglue']['assignedparts'][3]])){
								die("<p><b>".$_CONTEXT['modglue']['currentmod'].":</b> Variable \$_CONTEXT['".$_CONTEXT['modglue']['assignedparts'][1]."']['".$_CONTEXT['modglue']['assignedparts'][2]."']['".$_CONTEXT['modglue']['assignedparts'][3]."'] is undefined</p>");
							}
							$_POST[$sVarName] = $_CONTEXT[$_CONTEXT['modglue']['assignedparts'][1]][$_CONTEXT['modglue']['assignedparts'][2]][$_CONTEXT['modglue']['assignedparts'][3]];
						}
					}
					elseif($sValue[0]=="#"){
						// variable name defined in code
						$_CONTEXT['modglue']['assignedparts'] = explode("#",$sValue);
						$_CONTEXT['modglue']['assignedpartscount'] = count($_CONTEXT['modglue']['assignedparts']);
						if(!isset(${$_CONTEXT['modglue']['assignedparts'][1]})){
							die("<p><b>".$_CONTEXT['modglue']['currentmod'].":</b> Variable \$".$_CONTEXT['modglue']['assignedparts'][1]." is undefined</p>");
						}
						if($_CONTEXT['modglue']['assignedpartscount']>2){
							// this should be an array
							$_CONTEXT['modglue']['tempvar'] = ${$_CONTEXT['modglue']['assignedparts'][1]};
							if(!is_array($_CONTEXT['modglue']['tempvar'])){
								die("<p><b>".$_CONTEXT['modglue']['currentmod'].":</b> Variable \$".$_CONTEXT['modglue']['assignedparts'][1]." is not an array</p>");
							}
							if($_CONTEXT['modglue']['assignedpartscount']>=5){
								die("<p><b>".$_CONTEXT['modglue']['currentmod'].":</b> Variable \$".$_CONTEXT['modglue']['assignedparts'][1]." can have only two depth levels</p>");
							}
							elseif($_CONTEXT['modglue']['assignedpartscount']==3){
								if(!isset($_CONTEXT['modglue']['tempvar'][$_CONTEXT['modglue']['assignedparts'][2]])){
									die("<p><b>".$_CONTEXT['modglue']['currentmod'].":</b> Index ".$_CONTEXT['modglue']['assignedparts'][2]." doesn't exist</p>");
								}
								$_POST[$sVarName] = $_CONTEXT['modglue']['tempvar'][$_CONTEXT['modglue']['assignedparts'][2]];
							}
							else{
								if(!isset($_CONTEXT['modglue']['tempvar'][$_CONTEXT['modglue']['assignedparts'][2]])){
									die("<p><b>".$_CONTEXT['modglue']['currentmod'].":</b> Index ".$_CONTEXT['modglue']['assignedparts'][3]." doesn't exist</p>");
								}
								$_POST[$sVarName] = $_CONTEXT['modglue']['tempvar'][$_CONTEXT['modglue']['assignedparts'][2]][$_CONTEXT['modglue']['assignedparts'][3]];
							}
						}
						else{
							$_POST[$sVarName] = ${$_CONTEXT['modglue']['assignedparts'][1]};
						}
					}
					else{
						// unknown variable defined
						die("<p><b>".$_CONTEXT['modglue']['currentmod'].":</b> When you use ~ as the first character of a variable name, you need either @, * or # to assign a defined variable</p>");
					}
				}
				else{
					$_POST[$sVarName] = $sValue;
				}
			}
		}
		/* EXECUTE MODULE FILES */
		$_CONTEXT['modglue']['moduleruns']++;
		$iRuns = @count($aValueVars['files']);
		if(isset($aValueVars['files'])){
			for($x=0;$x<$iRuns;$x++){
				$_PATHS['module_default_root'] = $_CONTEXT['modglue']['default_mod_root']."/".$_CONTEXT['modglue']['currentmod'];
				echo"<hr />\n";
				include("../../Modules/".$_CONTEXT['modglue']['currentmod']."/".$aValueVars['files'][$x]);
				echo"<hr />\n";
			}
		}
		/* STORE MODGLUE VARIABLES */
		if(isset($aValueVars['variables']['l'])){
			// store in $_CONTEXT['modglue'] directly
			if(!isset($_CONTEXT['modglue'][$_CONTEXT['modglue']['currentmod']])){
				$_CONTEXT['modglue'][$_CONTEXT['modglue']['currentmod']] = array();
			}
			foreach($aValueVars['variables']['l'] as $sVarName=>$sValue){
				$_CONTEXT['modglue']['dataparts'] = explode("&",$sValue);
				$_CONTEXT['modglue']['datapartscount'] = @count($_CONTEXT['modglue']['dataparts']);
				if($_CONTEXT['modglue']['datapartscount']==1){
					if(!isset($_CONTEXT[$_CONTEXT['modglue']['currentmod']][$sValue])){
						die("<p><b>".$_CONTEXT['modglue']['currentmod'].":</b> Can't assign a non existent value to variable ".$sVarName."</p>");
					}
					$_CONTEXT['modglue'][$_CONTEXT['modglue']['currentmod']][$sVarName] = $_CONTEXT[$_CONTEXT['modglue']['currentmod']][$sValue];
				}
				elseif($_CONTEXT['modglue']['datapartscount']==2){
					if(!isset($_CONTEXT[$_CONTEXT['modglue']['currentmod']][$_CONTEXT['modglue']['dataparts'][0]][$_CONTEXT['modglue']['dataparts'][1]])){
						die("<p><b>".$_CONTEXT['modglue']['currentmod'].":</b> Can't assign a non existent value to variable ".$sVarName."</p>");
					}
					$_CONTEXT['modglue'][$_CONTEXT['modglue']['currentmod']][$sVarName] = $_CONTEXT[$_CONTEXT['modglue']['currentmod']][$_CONTEXT['modglue']['dataparts'][0]][$_CONTEXT['modglue']['dataparts'][1]];
				}
				elseif($_CONTEXT['modglue']['datapartscount']==3){
					if(!isset($_CONTEXT[$_CONTEXT['modglue']['currentmod']][$_CONTEXT['modglue']['dataparts'][0]][$_CONTEXT['modglue']['dataparts'][1]][$_CONTEXT['modglue']['dataparts'][2]])){
						die("<p><b>".$_CONTEXT['modglue']['currentmod'].":</b> Can't assign a non existent value to variable ".$sVarName."</p>");
					}
					$_CONTEXT['modglue'][$_CONTEXT['modglue']['currentmod']][$sVarName] = $_CONTEXT[$_CONTEXT['modglue']['currentmod']][$_CONTEXT['modglue']['dataparts'][0]][$_CONTEXT['modglue']['dataparts'][1]][$_CONTEXT['modglue']['dataparts'][2]];
				}
				else{
					die("<p><b>".$_CONTEXT['modglue']['currentmod'].":</b> Can't assign variables with a depth higher than 3 to ".$sVarName." variable</p>");
				}
			}
		}
		/* COMPARE MODGLUE VARIABLES */
		if(isset($aValueVars['variables']['v'])){
			// validate variables
			foreach($aValueVars['variables']['v'] as $sVarName=>$sValue){
				if(!isset($_CONTEXT['modglue']['currentmod'][$sVarName])){
					die("<p><b>".$_CONTEXT['modglue']['currentmod'].":</b> Variable \$_CONTEXT['modglue']['currentmod']['".$sVarName."'] doesn't exist</p>");
				}
				if($sValue=="true"){
					if($_CONTEXT['modglue']['currentmod'][$sVarName]!==true){
						die("<p><b>".$_CONTEXT['modglue']['currentmod'].":</b> Variable \$_CONTEXT['modglue']['currentmod']['".$sVarName."'] is expected to be true</p>");
					}
				}
				elseif($sValue=="false"){
					if($_CONTEXT['modglue']['currentmod'][$sVarName]!==false){
						die("<p><b>".$_CONTEXT['modglue']['currentmod'].":</b> Variable \$_CONTEXT['modglue']['currentmod']['".$sVarName."'] is expected to be false</p>");
					}
				}
				elseif($sValue=="array"){
					if(!is_array($_CONTEXT['modglue']['currentmod'][$sVarName])){
						die("<p><b>".$_CONTEXT['modglue']['currentmod'].":</b> Variable \$_CONTEXT['modglue']['currentmod']['".$sVarName."'] is expected to be an array</p>");
					}
				}
				elseif($sValue=="object"){
					if(!is_object($_CONTEXT['modglue']['currentmod'][$sVarName])){
						die("<p><b>".$_CONTEXT['modglue']['currentmod'].":</b> Variable \$_CONTEXT['modglue']['currentmod']['".$sVarName."'] is expected to be an object</p>");
					}
				}
				elseif($sValue=="resource"){
					if(!is_resource($_CONTEXT['modglue']['currentmod'][$sVarName])){
						die("<p><b>".$_CONTEXT['modglue']['currentmod'].":</b> Variable \$_CONTEXT['modglue']['currentmod']['".$sVarName."'] is expected to be a resource pointer</p>");
					}
				}
				else{
					if($_CONTEXT['modglue']['currentmod'][$sVarName]!=$sValue){
						die("<p><b>".$_CONTEXT['modglue']['currentmod'].":</b> Variable \$_CONTEXT['modglue']['currentmod']['".$sVarName."'] is expected to have ".htmlspecialchars($sValue)." as a value</p>");
					}
				}
			}
		}
		/* UNSET MODGLUE AND CONTEXT VARIABLES */
		if(isset($aValueVars['variables']['c'])){
			foreach($aValueVars['variables']['c'] as $sVarName=>$sValue){
				if($sValue=="1"){
					// remove modglue and context module variables
					unset($_CONTEXT['modglue'][$sVarName]);
					unset($_CONTEXT[$sVarName]);
				}
				else{
					// remove modglue variables
					unset($_CONTEXT['modglue'][$sVarName]);
				}
			}
		}
	}
}
else{
	echo"<p>Modglue action aborted</p>";
}
?>