<?php
/* Handler for backup table

Author: Remco Kouw
Site: http://www.hacksuite.com
Last Edit: 04-04-2019
*/
if(!defined('IN_SCRIPT')){
	exit;
}
$bProceed = false;
$aAccounts = array();
$iProfile = 0;
if(@filesize($sDestAccounts)!=false){
	// there are accounts that we can use for validation
	include($sDestAccounts);
	for($x=0;$x<count($aAccounts);$x++){
		if($aAccounts[$x]['profile_name']==$_POST['sProfileName']){
			$bProceed = true;
			$aAccounts = $aAccounts[$x];
			$iProfile = $x;
			break;
		}
	}
	if($bProceed){
		if(!$cGen->ConnectDB($aAccounts['database_host'],$aAccounts['database_name'],$aAccounts['database_user'],$aAccounts['database_pass'])){
			$aDataR['jmessage'] = "Please check your credentials, failed to connect to database";
			$bProceed = false;
		}
	}
}
$sBackupPath = "../backup/".$aProduct[0]."/".$aProduct[1];
if($bProceed){
	include($sDestDBFields);
	$sNewFolder = "";
	$bProceed = true;
	if($aAccounts['database_backup']==""){
		// no backups yet, let's create a new folder first
		$sNewFolder = $cGen->RandomString(15);
		if(!@mkdir($sBackupPath."/".$sNewFolder,0777)){
			$aDataR['jmessage'] = "Failed to create backup folder";
			$bProceed = false;
		}
		else{
			// now that we have a folder, let's update this profile
			$sData = @file_get_contents($sDestAccounts);
			$sData = str_replace("\$aAccounts[".$iProfile."]['database_backup'] = \"\";","\$aAccounts[".$iProfile."]['database_backup'] = \"".$sNewFolder."\";",$sData);
			if(!$cGen->WriteF($sDestAccounts,$sData,"w")){
				$aDataR['jmessage'] = "Failed to bind folder ".$sNewFolder." to profile";
				$bProceed = false;
			}
			// create an index page to prevent directory traversal
			$cGen->WriteF($sBackupPath."/index.php","","w");
		}
	}
	else{
		$sNewFolder = $aAccounts['database_backup'];
	}
	if($bProceed){
		// set file name with timestamp as filename, because we want unique file names
		$sFile = time().".txt";
		$cGen->SetPrefix($aAccounts['database_table_prefix']);
		$cGen->SetTable($aAccounts['database_table_users']);
		// check which users we want to extract
		$aUsers = array();
		$aUsersX = array();
		if($_POST['sUser']!=""){
			// extract one or more users
			if(strpos($_POST['sUser'],",")>0){
				// userids separated by commas
				$aUsersTemp = explode(",",$_POST['sUser']);
				for($x=0;$x<count($aUsersTemp);$x++){
					$iUser = @intval(trim($aUsersTemp[$x]));
					if(is_int($iUser)){
						if(!in_array($iUser,$aUsers)){
							$aUsers[] = $iUser;
						}
					}
				}
			}
			else{
				$iUser = @intval(trim($_POST['sUser']));
				if(is_int($iUser)){
					$aUsers[] = $iUser;
				}
			}
			if(false==($iUsers = count($aUsers))){
				$aDataR['jmessage'] = "Invalid userids as input";
			}
			else{
				if(!$aUsersX = $cGen->ExtractUsers($aParasite['fields'],$aUsers)){
					$aDataR['jmessage'] = "Failed to extract user data";
				}
			}
		}
		else{
			// extract whole table
			if(!$aUsersX = $cGen->ExtractUsers($aParasite['fields'])){
				$aDataR['jmessage'] = "Failed to extract user data";
			}
			else{
				if(!isset($aParasite['fields']['userid'])){
					include("../query_data/".$aProduct[0]."/".$aProduct[1]."/parasite_db.php");
				}
				// collect userids for all acccounts on forum
				for($y=0;$y<count($aUsersX);$y++){
					$aUsers[] = $aUsersX[$y][$aParasite['fields']['userid']];
				}
			}
		}
		if($aUsersX!=false && count($aUsersX)!=0){
			// create new file with serialized data
			$sPath = $sBackupPath."/".$sNewFolder."/".$sFile;
			if(!$cGen->WriteF($sPath,serialize($aUsersX),"w")){
				$aDataR['jmessage'] = "Failed to create data file";
			}
			else{
				$aDataR['jmessage'] = "Successfully extracted data and stored it in ".$sPath;
				$aDataR['jresult'] = true;
			}
		}
	}
}
else{
	$aDataR['jmessage'] = "Profile doesn't exist";
}
?>