<?php
/*
Default page for Parasite, used when no product or profile has been set.

Author: Remco Kouw
Site: http://www.hacksuite.com
Last Edit: 07-08-2019
*/
if(!defined('IN_SCRIPT')){
	exit;
}
if(false==($aSelect = $cGen->GetSupportedProducts())){
	echo"No products found";
}
else{
	// product select
	$sSelect = "<select name=\"sProduct\" class=\"sSelectProduct\">";
	$sSelect .= "<option value=\"\">select product</option>";
	foreach($aSelect as $sProduct=>$aVersions){
		for($x=0;$x<count($aVersions);$x++){
			$sSelect .= "<option value=\"".$sProduct.":".$aVersions[$x]."\">".$sProduct." ".$aVersions[$x]."</option>";
		}
	}
	$sSelect .= "</select>";
	// actions select
	$sSelectActions = "<select name=\"iActions\" class=\"sActions\">";
	$sSelectActions .= "<option value=\"\">select action</option>";
	$sSelectActions .= "<option value=\"2\">test connection</option>";
	$sSelectActions .= "<option value=\"3\">test table</option>";
	$sSelectActions .= "<option value=\"4\">dump setup</option>";
	$sSelectActions .= "<option value=\"5\">backup table</option>";
	$sSelectActions .= "<option value=\"6\">parasite accounts</option>";
	$sSelectActions .= "<option value=\"7\">recover table</option>";
	$sSelectActions .= "<option value=\"8\">create accounts</option>";
	$sSelectActions .= "<option value=\"9\">truncate username file</option>";
	$sSelectActions .= "<option value=\"10\">remove backup files</option>";
	$sSelectActions .= "<option value=\"11\">create new profile</option>";
	$sSelectActions .= "</select>";
	// get wordlists selection menu
	$sNotification = "";
	// added in 0.6.1: automatic selection of a certain wordlist
	$sWordlistHighlight = "usernames.txt";
	include($_PATHS['includes_root']."/wordlists.php");
	if(!in_array("usernames.txt",$aWordlists)){
		$sNotification = "<br /><b>it is recommended to use <a href=\"http://www.hacksuite.com/usernames.txt\">this</a> username file</b>";
	}
	echo"		<div class=\"row\" id=\"def\">\n";
	echo"			<div class=\"text\">choose your product</div>\n";
	echo"			<div class=\"input\">".$sSelect."</div>\n";
	echo"		</div>\n";
	echo"		<div class=\"clear\"></div>\n";
	echo"		<div class=\"row\" id=\"defxplain\">\n";
	echo"			<div class=\"xplain fieldhighlighter\">Parasite can be used to reset, backup and overwrite passwords on any account on all supported fora, this means you can take full control over a forum without knowing the administrator password.<br />
<p>You can also append an infinite amount of new user accounts to the user table using wordlists.</p>
</div>\n";
	echo"		</div>\n";
	echo"		<div class=\"clear\"></div>\n";
	echo"<script type=\"text/javascript\">\n";
	// fetches product properties when selection changes
	echo"\$(document).on(\"change\",\".sSelectProduct\",function(e){\n";
	echo"	e.preventDefault();\n";
	echo"	if(\$(this).val()==\"\"){\n";
	echo"		return(false);\n";
	echo"	}\n";
	echo"	dataString = \$(this).serialize();\n";
	echo"	product = '<input type=\"hidden\" class=\"sPrdct\" name=\"sProduct\" value=\"'+\$(this).val()+'\" />';\n";
	echo"	\$.ajax({\n";
	echo"		type: \"POST\",\n";
	echo"		data: dataString,\n";
	echo"		url: \"./JSON/handler.php\",\n";
	echo"		dataType: \"json\",\n";
	echo"		success: function(json){\n\n";
	echo"			if(json.jresult==true){\n";
	echo"				\$('div.row_extra').remove();\n";
	echo"				if(json.jaccounts){\n";
	echo"					// show accounts for this product and remove selection menu\n";
	echo"					\$('div.text').html('select profile');\n";
	echo"					\$('div.input').html(json.jaccounts);\n";
	echo"					\$('div#def').after('<div class=\"row\" id=\"actions\"><div class=\"text\">select action</div><div class=\"input\">'+product+'".$sSelectActions."</div></div>');\n";
	echo"				}\n";
	echo"				else if(json.jnew){\n";
	echo"					// show form to create profile and the selection menu\n";
	echo"					\$('div#def').after('<div class=\"row_extra\" id=\"field1\"><div class=\"text\">profile name</div><div class=\"input\"><input type=\"text\" name=\"sProfile\" value=\"\" /><br />name of profile</div></div>');\n";
	echo"					\$('div#field1').after('<div class=\"row_extra\" id=\"field2\"><div class=\"text\">host name</div><div class=\"input\"><input type=\"text\" name=\"sHost\" value=\"\" /><br />name of host eg 192.168.2.1</div></div>');\n";
	echo"					\$('div#field2').after('<div class=\"row_extra\" id=\"field3\"><div class=\"text\">database user</div><div class=\"input\"><input type=\"text\" name=\"sDatabaseUser\" value=\"\" /><br />database username</div></div>');\n";
	echo"					\$('div#field3').after('<div class=\"row_extra\" id=\"field4\"><div class=\"text\">database pass</div><div class=\"input\"><input type=\"password\" name=\"sDatabasePass\" value=\"\" /><br />database pass</div></div>');\n";
	echo"					\$('div#field4').after('<div class=\"row_extra\" id=\"field5\"><div class=\"text\">database name</div><div class=\"input\"><input type=\"text\" name=\"sDatabaseName\" value=\"\" /><br />name of the database</div></div>');\n";
	echo"					\$('div#field5').after('<div class=\"row_extra\" id=\"field6\"><div class=\"text\">users table</div><div class=\"input\"><input type=\"text\" name=\"sTable\" value=\"\" /><br />you can leave this empty, unless the table name isn\'t '+json.jtable+'</div></div>');\n";
	echo"					\$('div#field6').after('<div class=\"row_extra\" id=\"field7\"><div class=\"text\">table prefix</div><div class=\"input\"><input type=\"text\" name=\"sPrefix\" value=\"\" /><br />prefix of table eg <b>rt_</b>'+json.jtable+'</div></div>');\n";
	echo"					\$('div#field7').after('<div class=\"row_extra\" id=\"field8\"><div class=\"text\"></div><div class=\"input\">'+product+'<input type=\"hidden\" name=\"iActions\" value=\"1\" /><input type=\"submit\" name=\"submit\" value=\"Create Account\" /></div></div>');\n";
	echo"				}\n";
	echo"			}\n";
	echo"			else{\n";
	echo"				// something went wrong\n";
	echo"				alert(json.jmessage);\n";
	echo"			}\n";
	echo"		},\n";
	echo"		error: function(xhr, textStatus, errorThrown){\n";
	echo"			alert(errorThrown);\n";
	echo"		}\n";
	echo"	});\n";
	echo"});\n";
	// fetches product properties when selection changes
	echo"\$(document).on(\"change\",\".sActions\",function(e){\n";
	echo"	e.preventDefault();\n";
	echo"	\$('.row_extra').remove();\n";
	echo"	if(\$(this).val()==\"2\"){\n";
	echo"		// test connection\n";
	echo"		\$('div.xplain').html('Makes a test connection with the database, to check whether the credentials in your setup are correct.');\n";
	echo"		\$('div.xplain').after('<div class=\"row_extra\" id=\"field1\"><div class=\"text\"></div><div class=\"input\"><input type=\"submit\" name=\"submit\" value=\"Test Connection\" /></div></div>');\n";
	echo"	}\n";
	echo"	else if(\$(this).val()==\"3\"){\n";
	echo"		// test users table\n";
	echo"		\$('div.xplain').html('Validates the user table, if you get an error you might have provided an invalid table name.');\n";
	echo"		\$('div.xplain').after('<div class=\"row_extra\" id=\"field1\"><div class=\"text\"></div><div class=\"input\"><input type=\"submit\" name=\"submit\" value=\"Test Table\" /></div></div>');\n";
	echo"	}\n";
	echo"	else if(\$(this).val()==\"4\"){\n";
	echo"		// dump setup\n";
	echo"		\$('div.xplain').html('Dumps the connection setup, which allows you to check the credentials for the connection.');\n";
	echo"		\$('div.xplain').after('<div class=\"row_extra\" id=\"field1\"><div class=\"text\"></div><div class=\"input\"><input type=\"submit\" name=\"submit\" value=\"Dump Setup\" /></div></div>');\n";
	echo"	}\n";
	echo"	else if(\$(this).val()==\"5\"){\n";
	echo"		// backup users table\n";
	echo"		\$('div.xplain').html('Makes a backup of the entire table or the selected userids, you can use this feature in order to restore parasited accounts.');\n";
	echo"		\$('div.xplain').after('<div class=\"row_extra\" id=\"field1\"><div class=\"text\">users</div><div class=\"input\"><input type=\"text\" name=\"sUser\" value=\"\" /><br />separate userids by comma, no value backups all accounts</div></div><div class=\"row_extra\" id=\"field2\"><div class=\"text\"></div><div class=\"input\"><input type=\"submit\" name=\"submit\" value=\"Backup Table\" /></div></div>');\n";
	echo"	}\n";
	echo"	else if(\$(this).val()==\"6\"){\n";
	echo"		// parasite accounts\n";
	echo"		\$('div.xplain').html('Parasites all or a number of selected accounts on a forum by overwriting user passwords in the user table.<br />Password that will be used is: <b>".$cGen->GetPass()."</b><p>You can change this password by setting \$cGen->SetPass() or by manually overwriting the password value in <b>/classes/gencontent.php</b></p>');\n";
	echo"		\$('div.xplain').after('<div class=\"row_extra\" id=\"field1\"><div class=\"text\">users</div><div class=\"input\"><input type=\"text\" name=\"sUser\" value=\"\" /><br />separate userids by comma, no value parasites all accounts</div></div><div class=\"row_extra\" id=\"field2\"><div class=\"text\"></div><div class=\"input\"><input type=\"submit\" name=\"submit\" value=\"Parasite Users\" /></div></div>');\n";
	echo"	}\n";
	echo"	else if(\$(this).val()==\"7\"){\n";
	echo"		// recover table\n";
	echo"		\$.ajax({\n";
	echo"			type: \"POST\",\n";
	echo"			data: \"sProfileX=\"+\$('.sProfileNameX').val()+\"&sProduct=\"+\$('input.sPrdct').val(),\n";
	echo"			url: \"./JSON/handler.php\",\n";
	echo"			dataType: \"json\",\n";
	echo"			success: function(json){\n";
	echo"				if(json.jresult==true){\n";
	echo"					\$('.row#actions').append('<div class=\"row_extra\" id=\"field1\"><div class=\"text\">backup</div><div class=\"input\">'+json.jbackups+'</div></div>');\n";
	echo"				}\n";
	echo"				else{\n";
	echo"					alert(json.jmessage);\n";
	echo"				}\n";
	echo"			},\n";
	echo"			error: function(xhr, textStatus, errorThrown){\n";
	echo"				alert(errorThrown);\n";
	echo"			}\n";
	echo"		});\n";
	echo"		\$('div.xplain').html('Restores a parasited user table, always make sure you make backup before you start to parasite accounts.');\n";
	echo"		\$('div.xplain').after('<div class=\"row_extra\" id=\"field1\"><div class=\"text\"></div><div class=\"input\"><input type=\"submit\" name=\"submit\" value=\"Recover Table\" /></div></div>');\n";
	echo"	}\n";
	echo"	else if(\$(this).val()==\"8\"){\n";
	echo"		// create new users\n";
	echo"		\$('div.xplain').html('Creates an x amount of new users, Parasite uses wordlists to create bogus accounts, each account has the same password.<br />Password that will be used is: <b>".$cGen->GetPass()."</b><p>You can change this password by setting \$cGen->SetPass() or by manually overwriting the password value in <b>/classes/gencontent.php</b></p>');\n";
	echo"		\$('div.xplain').after('<div class=\"row_extra\" id=\"field1\"><div class=\"text\">amount of users</div><div class=\"input\"><input type=\"text\" name=\"iUsers\" value=\"\" /><br />use a number lower than the amount of users in the wordlist<br />if you get a json error, you need to open index.php and increase the memory limit</div></div><div class=\"row_extra\" id=\"field2\"><div class=\"text\">wordlist</div><div class=\"input\">".str_replace("\n","",$sSelectWord).$sNotification."</div></div><div class=\"row_extra\" id=\"field3\"><div class=\"text\"></div><div class=\"input\"><input type=\"submit\" name=\"submit\" value=\"Create Accounts\" /></div></div>');\n";
	echo"	}\n";
	echo"	else if(\$(this).val()==\"9\"){\n";
	echo"		// truncate username file\n";
	echo"		\$('div.xplain').html('Perform the following action on the user wordlist:<br /><p>- remove passwords smaller than 8 characters<br />- remove passwords bigger than 12 characters<br />- remove passwords containing period characters<br />- remove passwords that are entirely made of numbers</p>');\n";	
	echo"		\$('div.xplain').after('<div class=\"clear\"></div><div class=\"row_extra\" id=\"field1\"><div class=\"text\">wordlist</div><div class=\"input\">".str_replace("\n","",$sSelectWord)."<br />use wordlists with usernames only<br />if you get a json error, you need to open index.php and increase the memory limit</div></div><div class=\"row_extra\" id=\"field2\"><div class=\"text\"></div><div class=\"input\"><input type=\"submit\" name=\"submit\" value=\"Truncate File\" /></div></div>');\n";
	echo"	}\n";
	echo"	else if(\$(this).val()==\"10\"){\n";
	echo"		// delete backup files\n";
	echo"		\$.ajax({\n";
	echo"			type: \"POST\",\n";
	echo"			data: \"sProfileX=\"+\$('.sProfileNameX').val()+\"&sProduct=\"+\$('input.sPrdct').val(),\n";
	echo"			url: \"./JSON/handler.php\",\n";
	echo"			dataType: \"json\",\n";
	echo"			success: function(json){\n";
	echo"				if(json.jresult==true){\n";
	echo"					\$('.row#actions').append('<div class=\"row_extra\" id=\"field1\"><div class=\"text\">backup</div><div class=\"input\">'+json.jbackups+'</div></div>');\n";
	echo"				}\n";
	echo"				else{\n";
	echo"					alert(json.jmessage);\n";
	echo"				}\n";
	echo"			},\n";
	echo"			error: function(xhr, textStatus, errorThrown){\n";
	echo"				alert(errorThrown);\n";
	echo"			}\n";
	echo"		});\n";
	echo"		\$('div.xplain').html('Removes a backup file. Always make sure you don\'t need it anymore, parasited accounts will be irreversible.');\n";	
	echo"		\$('div.xplain').after('<div class=\"row_extra\" id=\"field1\"><div class=\"text\"></div><div class=\"input\"><input type=\"submit\" name=\"submit\" value=\"Delete File\" /></div></div>');\n";
	echo"	}\n";
	echo"	else if(\$(this).val()==\"11\"){\n";
	echo"		// add a profile\n";
	echo"		\$('div.xplain').html('Creates a new attack profile for a supported target.');\n";	
	echo"		\$('div.xplain').after('<div class=\"clear\"></div><div class=\"row_extra\" id=\"field1\"><div class=\"text\">profile name</div><div class=\"input\"><input type=\"text\" name=\"sProfile\" value=\"\" /><br />name of profile</div></div>');\n";
	echo"		\$('div#field1').after('<div class=\"row_extra\" id=\"field2\"><div class=\"text\">host name</div><div class=\"input\"><input type=\"text\" name=\"sHost\" value=\"\" /><br />name of host eg 192.168.2.1</div></div>');\n";
	echo"		\$('div#field2').after('<div class=\"row_extra\" id=\"field3\"><div class=\"text\">database user</div><div class=\"input\"><input type=\"text\" name=\"sDatabaseUser\" value=\"\" /><br />database username</div></div>');\n";
	echo"		\$('div#field3').after('<div class=\"row_extra\" id=\"field4\"><div class=\"text\">database pass</div><div class=\"input\"><input type=\"password\" name=\"sDatabasePass\" value=\"\" /><br />database pass</div></div>');\n";
	echo"		\$('div#field4').after('<div class=\"row_extra\" id=\"field5\"><div class=\"text\">database name</div><div class=\"input\"><input type=\"text\" name=\"sDatabaseName\" value=\"\" /><br />name of the database</div></div>');\n";
	echo"		\$('div#field5').after('<div class=\"row_extra\" id=\"field6\"><div class=\"text\">users table</div><div class=\"input\"><input type=\"text\" name=\"sTable\" value=\"\" /><br />you can leave this empty, unless the table name isn\'t equal to the default value in parasite_db.php</div></div>');\n";
	echo"		\$('div#field6').after('<div class=\"row_extra\" id=\"field7\"><div class=\"text\">table prefix</div><div class=\"input\"><input type=\"text\" name=\"sPrefix\" value=\"\" /><br />prefix of table eg <b>rt_</b>users</div></div>');\n";
	echo"		\$('div#field7').after('<div class=\"row_extra\" id=\"field8\"><div class=\"text\"></div><div class=\"input\">'+product+'<input type=\"hidden\" name=\"iActions\" value=\"11\" /><input type=\"submit\" name=\"submit\" value=\"Create Account\" /></div></div>');\n";
	echo"	}\n";
	echo"});\n";
	// submit form to parasite handlers
	echo"\$(document).on(\"submit\",\"form.sendform\",function(e){\n";
	echo"	e.preventDefault();\n";
	echo"	dataString = \$(this).serialize();\n";
	echo"	\$.ajax({\n";
	echo"		type: \"POST\",\n";
	echo"		data: dataString,\n";
	echo"		url: \"./JSON/handler.php\",\n";
	echo"		dataType: \"json\",\n";
	echo"		success: function(json){\n\n";
	echo"			if(json.jresult==true){\n";
	echo"				\$('div#defxplain').after(json.jmessage+'<p><a href=\"".trim($_SERVER['PHP_SELF'])."\">back to previous page</a></p>');\n";
	echo"				\$('div#def').remove();\n";
	echo"				\$('.row#actions').remove();\n";
	echo"				\$('.row_extra').remove();\n";
	echo"				\$('div.xplain').remove();\n";
	echo"			}\n";
	echo"			else{\n";
	echo"				// something went wrong\n";
	echo"				alert(json.jmessage);\n";
	echo"			}\n";
	echo"		},\n";
	echo"		error: function(xhr, textStatus, errorThrown){\n";
	echo"			alert(errorThrown);\n";
	echo"		}\n";
	echo"	});\n";
	echo"});\n";
	echo"</script>\n";
}
?>