<?php
/* Writes a string to specified file

Writes a string to a file, if the destination doesn't exist it will attempt to create it.

PARAMETERS:
$sDest: filepath to write to
$sWrite: data to write
$sMode: write mode {a or w}

RETURNS:
FALSE: failed to write file data
TRUE: success

Author: Remco Kouw
Site: http://www.hacksuite.com
Last Edit: 04-02-2024
*/

function WriteF($sDest,$sWrite,$sMode="a"){

	global $_CONTEXT;

	if($sMode!="a" && $sMode!="w"){
		$sMode = "a";
	}
	if(!$rNew = @fopen($sDest,$sMode)){
		// define the error
		$_CONTEXT['errors'][] = array('error'=>'Failed to open file <b>'.$sDest.'</b> in <b>'.$sMode.'</b> mode','type'=>'1','fatal'=>'1','line'=>__LINE__,'file'=>__FILE__);
		return(false);
	}
	@fputs($rNew,$sWrite);
	@fclose($rNew);
	return(true);
}
?>