<?php
/* Fetches data from files

Fetches data from a local or remote file.

PARAMETERS:
$sFile: file to fetch

RETURNS:
FALSE: failed to fetch filedata
STRING: data from specified file

Author: Remco Kouw
Site: http://www.hacksuite.com
Last Edit: 25-01-2024
*/

function GetFileData($sFile){

	global $_CONTEXT;

	if(false===($rPointer = @fopen($sFile,"r"))){
		$_CONTEXT['errors'][] = array('error'=>'Failed to open location <b>'.htmlspecialchars($sFile).'</b>','type'=>'1','fatal'=>'1','line'=>__LINE__,'file'=>__FILE__);
		return(false);
	}
	$sBuffer = "";
	while(!feof($rPointer)){
		$sBuffer .= fgets($rPointer,128);
	}
	fclose($rPointer);
	return($sBuffer);
}
?>