<?php
/* Fetches a webpage through proxy

Opens a connection with a proxy and fetches a location.

PARAMETERS:
$sUrl: url of the page to fetch
$sProxyUrl: location of the proxy
$iPort: port where the proxy service listens on
$sPass: username:password

RETURNS:
STRING: output of curl_exec()

Author: Remco Kouw
Site: http://www.hacksuite.com
Last Edit: 19-05-2023
*/

function ProxyConnect($sUrl,$sProxyUrl,$iPort="",$sPass=""){
    $ch = curl_init($sUrl);
    curl_setopt_array($ch, [
        CURLOPT_RETURNTRANSFER => 1,
        CURLOPT_PROXY => $sProxyUrl,
    ]);
    if ($iPort !== "") {
        curl_setopt($ch, CURLOPT_PROXYPORT, $iPort);
    }
    if ($sPass !== "") {
        curl_setopt($ch, CURLOPT_PROXYUSERPWD, $sPass);
    }
    $sResponse = curl_exec($ch);
    curl_close($ch);
    return $sResponse;
}
?>