<?php
/* Finds keywords in native files, modules and apps

Author: Remco Kouw
Site: http://www.hacksuite.com
Last Edit: 22-02-2024
*/
if(!defined('IN_SCRIPT')){
	exit;
}
if($_CONTEXT['keywords_spider']){
	$_CONTEXT['scanlabel']['version_check'] = "spider keywords";
	$_CONTEXT['keywords_spider_data'] = "";
	$_CONTEXT['spider'] = array();
	$aRequire = array($_PATHS['functions_root']."/fwrite.php",$_PATHS['functions_root']."/getdirbydir.php",$_PATHS['functions_root']."/getfilebydir.php");
	for($x=0;$x<count($aRequire);$x++){
		(!IsThere($aRequire[$x]) ? include_once($_PATHS['end']) : include_once($aRequire[$x]));
	}
	$_CONTEXT['targetpaths'] = array();
	$_CONTEXT['targetpaths']['native'] = $_PATHS['root']."/Native";
	$_CONTEXT['targetpaths']['apps'] = $_PATHS['root']."/Apps";
	$_CONTEXT['targetpaths']['modules'] = $_PATHS['root']."/Modules";
	// native files are in the native folder and contain keywords in the files themselves
	$_CONTEXT['spider']['nativeroot'] = GetFilesByDirectory($_CONTEXT['targetpaths']['native']);
	if(isset($_CONTEXT['errors'][0])){
		include_once($_PATHS['end']);
	}
	for($x=0;$x<count($_CONTEXT['spider']['nativeroot']);$x++){
		if($_CONTEXT['spider']['nativeroot'][$x]!="index.php"){
			$_CONTEXT['spider']['native'][] = $_CONTEXT['targetpaths']['native']."/".$_CONTEXT['spider']['nativeroot'][$x];
		}
	}
	unset($_CONTEXT['spider']['nativeroot']);
	$_CONTEXT['spider']['apps'] = array();
	// apps have the keywords in setup.php, but any app can contain multiple applications 
	$oIterate = new RecursiveIteratorIterator(new RecursiveDirectoryIterator($_CONTEXT['targetpaths']['apps']),RecursiveIteratorIterator::SELF_FIRST);
	foreach($oIterate as $oFile){
		if($oFile->isFile() && $oFile->getFilename()=="setup.php"){
			$aInfo = pathinfo($oFile->getPathname());
			$aPath = explode("Apps",$oFile->getPath());
			$_CONTEXT['spider']['apps'][] = array('file'=>$oFile->getPathname(),'folder'=>substr($aPath[1],1));
		}
	}
	// modules also have keywords in setup.php, the modules always have one setup.php
	$oIterate = new RecursiveIteratorIterator(new RecursiveDirectoryIterator($_CONTEXT['targetpaths']['modules']),RecursiveIteratorIterator::SELF_FIRST);
	foreach($oIterate as $oFile){
		if($oFile->isFile() && $oFile->getFilename()=="setup.php"){
			$aInfo = pathinfo($oFile->getPathname());
			$aPath = explode("Modules",$oFile->getPath());
			$_CONTEXT['spider']['modules'][] = array('file'=>$oFile->getPathname(),'folder'=>substr($aPath[1],1));
		}
	}
	$_CONTEXT['spider']['data'] = array();
	define('SPIDER',1);
	// index native files
	for($x=0;$x<count($_CONTEXT['spider']['native']);$x++){
		$_CONTEXT['nativekeywords'] = array();
		include($_CONTEXT['spider']['native'][$x]);
		$_CONTEXT['spider']['data']['native'][] = $_CONTEXT['nativekeywords'];
	}
	// index app setups
	for($x=0;$x<count($_CONTEXT['spider']['apps']);$x++){
		include($_CONTEXT['spider']['apps'][$x]['file']);
		$_CONTEXT['spider']['data']['apps'][] = array($_CONTEXT['spider']['apps'][$x]['folder'],$aProperties['keywords']);
	}
	// index module setups
	for($x=0;$x<count($_CONTEXT['spider']['modules']);$x++){
		include($_CONTEXT['spider']['modules'][$x]['file']);
		$_CONTEXT['spider']['data']['modules'][] = array($_CONTEXT['spider']['modules'][$x]['folder'],$aProperties['keywords']);
	}
	$_CONTEXT['scandata']['keywords_spider_data'] = WriteF($_PATHS['data_root']."/search.php",serialize($_CONTEXT['spider']['data']),"w") ? "Successfully indexed keywords" : "Failed to store keywords";
}
?>