<?php
/* Listing of all apps, modules, callbacks and testservers

Author: Remco Kouw
Site: http://www.hacksuite.com
Last Edit: 22-12-2023
*/
if(!defined('IN_SCRIPT')){
	exit;
}
if(!function_exists("GetDirByDir")){
	$sDest = $_PATHS['functions_root']."/getdirbydir.php";
	include_once($sDest);
}
$aDirs = GetDirByDir($_PATHS['root'],0);
$sFalseImg = $_PATHS['style_root_http']."/images/unknown.png";
// modules
foreach($_CONTEXT['modcats'] as $sCat=>$aValues){
	$sCode .= "			<div class=\"cc_summary emboss borderr5 border1pxtrans pad5 edgeglow\">\n";
	// every word starts with uppercase character to make it look tidy
	$sCat1 = str_replace("_"," ",$sCat);
	$aCat1 = explode(" ",$sCat1);
	$sCat = "";
	if(1!=($iCat1 = @count($aCat1))){
		for($x=0;$x<$iCat1;$x++){
			if($x!=0){
				$sCat .= " ";
			}
			$sCat .= ucfirst($aCat1[$x]);
		}
	}
	else{
		$sCat = ucfirst($sCat1);
	}
	$sCode .= "				<div class=\"embosshdrnocenter border1pxtrans pad10\">Module Development: ".$sCat."</div>\n";
	for($x=0;$x<count($aValues);$x++){
		$sMod = $aValues[$x][0];
		$sCode .= "				<div class=\"pad5 blk overflw\">\n";
		$sCode .= "					<div class=\"overflw\">\n";
		$sDest = (file_exists($_PATHS['root']."/Modules/".$sMod."/".$sMod.".png") ? $_PATHS['root_http']."/Modules/".$sMod."/".$sMod.".png" : $sFalseImg);
		$sCode .= "						<div><img src=\"".$sDest."\" width=\"70\" border=\"0\" class=\"padt10 padl5\" /></div>\n";
		$sCode .= "						<div class=\"borderr15 border1pxstrans pad10 emboss h80\">".$aValues[$x][1]." - ".$_CONTEXT['modules'][$sMod]['version']."<br />[ <a href=\"index.php?module=".$sMod."\">launch</a> || <a href=\"development.php?action=edit&mod=".$sMod."\">edit setup</a>  || <a href=\"development.php?action=manage&mod=".$sMod."\">file manager</a> || <a href=\"development.php?action=uninstall&module=".$sMod."\">uninstall</a> || <a href=\"development.php?action=avatar&mod=".$sMod."\">avatar</a> || <a href=\"development.php?action=modglue&mod=".$sMod."\">modglue variables</a>  ]</div>\n";
		$sCode .= "					</div>\n";
		$sCode .= "				</div>\n";
	}
	$sCode .= "				</div>\n";
}
// apps
if(false!=($iExtra = @count($aExtra))){
	$sCode .= "			<div class=\"cc_summary emboss borderr5 border1pxtrans pad5 edgeglow\">\n";
	$sCode .= "				<div class=\"embosshdrnocenter border1pxtrans pad10\">Apps Development</div>\n";
	for($x=0;$x<$iExtra;$x++){
		include_once($aExtra[$x][1]."/setup.php");
		$sCode .= "				<div class=\"pad5 blk overflw\">\n";
		$sCode .= "					<div class=\"overflw\">\n";
		$sDest = (file_exists($aExtra[$x][1]."/avatar.png") ? $aExtra[$x][1]."/avatar.png" : $sFalseImg);
		$sCode .= "						<div><img src=\"".$sDest."\" width=\"70\" border=\"0\" class=\"padt10 padl5\" /></div>\n";
		$sCode .= "						<div class=\"borderr15 border1pxstrans pad10 emboss h80\">".$aProperties['name']." - ".$aProperties['version']."<br />[ <a href=\"".$_PATHS['root_http']."/".$aExtra[$x][1]."\">launch</a> || <a href=\"development.php?action=edit&apps=".$aExtra[$x][0]."\">edit setup</a>  || <a href=\"development.php?action=manage&apps=".$aExtra[$x][0]."\">file manager</a> || <a href=\"development.php?action=avatar&apps=".$aExtra[$x][0]."\">avatar</a> || <a href=\"development.php?action=uninstall&apps=".$aExtra[$x][0]."\">uninstall</a>  ]</div>\n";
		$sCode .= "					</div>\n";
		$sCode .= "				</div>\n";
	}
	$sCode .= "				</div>\n";
}
else{
	$sCode .= "	<div class=\"emboss pad5\">\n";
	$sCode .= "		<div>no apps installed</div>\n";
	$sCode .= "	</div>\n";
}
// callbacks
$aFiles = GetFilesByDirectory($_PATHS['root']."/Modules/thc_ss/CALLBACKS");
include_once("Modules/thc_ss/properties.php");
if(false!=($iFiles = @count($aFiles))){
	$sCode .= "			<div class=\"cc_summary emboss borderr5 border1pxtrans pad5 edgeglow\">\n";
	$sCode .= "				<div class=\"embosshdrnocenter border1pxtrans pad10\">Callback Development</div>\n";
	for($x=0;$x<$iFiles;$x++){
		include_once($_PATHS['root']."/Modules/thc_ss/CALLBACKS/".$aFiles[$x]);
		$sCode .= "				<div class=\"pad5 blk overflw\">\n";
		$sCode .= "					<div class=\"overflw\">\n";
		$sCode .= "						<div><img src=\"".$_PATHS['style_root_http']."/images/callback.png\" width=\"70\" border=\"0\" class=\"padt10 padl5\" /></div>\n";
		$sCode .= "						<div class=\"borderr15 border1pxstrans pad10 emboss h80\">".$_CBACKD[0]."<br />[ <a href=\"development.php?action=edit&callback=".$_CBACKD[0]."\">edit callback</a> || <a href=\"development.php?action=uninstall&callback=".$_CBACKD[0]."\">uninstall</a>  ]</div>\n";
		$sCode .= "					</div>\n";
		$sCode .= "				</div>\n";
	}
	$sCode .= "				</div>\n";
}
else{
	$sCode .= "	<div class=\"emboss pad5\">\n";
	$sCode .= "		<div>no callbacks installed</div>\n";
	$sCode .= "	</div>\n";
}
// test servers
if(false!=($iFiles = @count($_CONTEXT['services']))){
	$sCode .= "			<div class=\"cc_summary emboss borderr5 border1pxtrans pad5 edgeglow\">\n";
	$sCode .= "				<div class=\"embosshdrnocenter border1pxtrans pad10\">TestServers Development</div>\n";
	for($x=0;$x<$iFiles;$x++){
		$sDest = (file_exists($_PATHS['style_root']."/images/".$_CONTEXT['services'][$x][2]) ? $_PATHS['style_root_http']."/images/".$_CONTEXT['services'][$x][2] : $sFalseImg);
		$sCode .= "				<div class=\"pad5 blk overflw\">\n";
		$sCode .= "					<div class=\"overflw\">\n";
		$sCode .= "						<div><img src=\"".$sDest."\" width=\"70\" border=\"0\" class=\"padt10 padl5\" /></div>\n";
		$sCode .= "						<div class=\"borderr15 border1pxstrans pad10 emboss h80\">".$_CONTEXT['services'][$x][1]."<br />[ <a href=\"TestServers/".$_CONTEXT['services'][$x][0]."\">launch</a> || [ <span class=\"editcfg\" title=\"".$_CONTEXT['services'][$x][0]."\">change settings</span> ]</div>\n";
		$sCode .= "					</div>\n";
		$sCode .= "				</div>\n";
	}
	$sCode .= "				</div>\n";
}
else{
	$sCode .= "	<div class=\"emboss pad5\">\n";
	$sCode .= "		<div>no testservers installed</div>\n";
	$sCode .= "	</div>\n";
}
$sCode .= "</div>\n";
?>