<?php
/* Shows (running) tasks and updates every second

Author: Remco Kouw
Site: http://www.hacksuite.com
Last Edit: 29-06-2024
*/
if(!defined('IN_SCRIPT')){
	exit;
}
if($_CONTEXT['rightdisplay']['show_tasks']){
	$sDiv = "";
	$sScript = "";
	$_CONTEXT['htmlo'] .= "			<div class=\"subname\" id=\"tsks\">tasks</div>\n";
	if(!isset($_PATHS['task_file']) || $_PATHS['task_file']==""){
		$sDest = $_PATHS['data_root']."/running.txt";
	}
	else{
		$sDest = $_PATHS['task_file'];
	}
	if(@filesize($sDest)>0){
		if(!function_exists("RawToArray")){
			include_once($_PATHS['functions_root']."/raw_to_array.php");
		}
		if(false!==($aFileContentT = RawToArray($sDest))){
			// generate the script and divs, first see if there are tasks that are currently running
			$aFileContent = array();
			$bRunning = false;
			// ok we got a running.txt that isn't empty, but are there tasks that are still running?
			if(0!=($iFileDataT = @count($aFileContentT))){
				for($x=0;$x<$iFileDataT;$x++){
					if($aFileContentT[$x][2]==0){
						$bRunning = true;
						$aFileContent[] = $aFileContentT[$x];
					}
				}
			}
			$iFileData = @count($aFileContent);
			if($bRunning){
				$_CONTEXT['rtasks'] = 0;
				$sDiv = "";
				$sScript = "			<script>\n";
				$sScript .= "			\$(document).ready(function(){\n";
				$sScript .= "				var refreshId = setInterval(function(){\n";
				for($x=0;$x<$iFileData;$x++){
					if($aFileContent[$x][2]==0){
						// filter running tasks
						$sDiv .= "<div class=\"running\" id=\"".$aFileContent[$x][0].$aFileContent[$x][1]."\"></div>";
						if($aFileContent[$x][1]<(time()-86400)){
							// tasks that are running for more than a day
							$_CONTEXT['rtasks']++;
						}
						$sScript .= "					\$('#".$aFileContent[$x][0].$aFileContent[$x][1]."').load('task_bot.php?module=".$aFileContent[$x][0]."&start=".$aFileContent[$x][1]."');\n";
					}
				}
				$sScript .= "					var tasksRunning = \$('.running').length;\n";
				$sScript .= "					\$('.lnk .running').each(function(){\n";
				$sScript .= "						if(\$(this).text().includes('completed')){\n";
				$sScript .= "							tasksRunning--;\n";
				$sScript .= "						}\n";
				$sScript .= "					});\n";
				$sScript .= "					if(tasksRunning==0){\n";
				$sScript .= "						clearInterval(refreshId);\n";
				$sScript .= "					}\n";
				$sScript .= "				}, 1000);\n";
				$sScript .= "			});\n";
				$sScript .= "			</script>";
				$_CONTEXT['htmlo'] .= $sScript."\n			<div class=\"lnk\">".$sDiv."</div>\n";
			}
			else{
				$_CONTEXT['htmlo'] .= "			<div class=\"lnk\">present tasks ended</div>\n";
			}
		}
	}
	else{
		$_CONTEXT['htmlo'] .= "			<div class=\"lnk\">no tasks running</div>\n";
	}
}
?>