<?php
/* Handles request for dork and sql entries

Author: Remco Kouw
Site: http://www.hacksuite.com
Last Edit: 10-02-2024
*/
session_cache_limiter('nocache');
header('Expires: '.gmdate('r',0));
header('Content-type: application/json');
$_DYNAMIC_ROOT = "..";
include_once("../header.php");
$aDataR = array();
$aDataR['jresult'] = false;
$aDataR['jmessage'] = "An error occured";
// make selection menu for dorks and sql errors automatically
$_CONTEXT['makeselect'] = 1;
$aFiles = array($_PATHS['functions_root']."/fwrite.php",$_PATHS['functions_root']."/get_file_data.php",$_PATHS['data_root']."/dork_options.php",$_PATHS['includes_root']."/dorkssqlhandler.php");
for($x=0;$x<count($aFiles);$x++){
	// we can't just do a single line if else statement, because we need to tell the logging handler that the error has to be returned as a json object
	if(!IsThere($aFiles[$x])){
		$_CONTEXT['errors'][count($_CONTEXT['errors'])-1] = array('error'=>'Missing required file: '.$aFiles[$x],'type'=>'2','fatal'=>'1','json'=>'1','line'=>__LINE__,'file'=>__FILE__);
		include_once($_PATHS['end']);
	}
	include_once($aFiles[$x]);
}
// always send the selection menu after each successful action
$aDataR['jselectitem'] = "<select name=\"sSelectItem\" class=\"selectitem\">\n";
$aDataR['jselectitem'] .= "<option value=\"-1\">select an option</option>\n";
$_OPTDORK = array(1,3);
if(isset($_CONTEXT['dselect'])){
	// there are google dorks available
	$_OPTDORK[] = 0;
}
if(isset($_CONTEXT['sselect'])){
	// there are sql errors available
	$_OPTDORK[] = 2;
}
for($x=0;$x<count($_OPTDORK);$x++){
	$aDataR['jselectitem'] .= "	<option value=\"".$_CONTEXT['doptions'][$_OPTDORK[$x]]['submit']."\">".$_CONTEXT['doptions'][$_OPTDORK[$x]]['label']."</option>\n";
}
$aDataR['jselectitem'] .= "</select>\n";
$aDataR['jselectdork'] = isset($_CONTEXT['dselect']) ? str_replace("\n","",$_CONTEXT['dselect']) : "";
$aDataR['jselectsql'] = isset($_CONTEXT['sselect']) ? str_replace("\n","",$_CONTEXT['sselect']) : "";
$sDest = $_PATHS['data_root']."/googledorks.txt";
// handle the request
if(isset($_POST['sDork'])){
	// dork add
	$_POST['sDork'] = trim($_POST['sDork']);
	if($_POST['sDork']!=""){
		$aFile = @file($sDest);
		if(isset($aFile[0]) && $aFile[0]!=""){
			for($x=0;$x<count($aFile);$x++){
				if(trim($aFile[$x])==$_POST['sDork']){
					$_CONTEXT['abortupdate'] = true;
					break;
				}
			}
		}
		if(isset($_CONTEXT['abortupdate'])){
			$aDataR['jmessage'] = "This keyword already exists";
		}
		else{
			if(!WriteF($sDest,(@filesize($sDest)>0 ? "\n" : "").$_POST['sDork'],"a")){
				$_CONTEXT['errors'][count($_CONTEXT['errors'])-1] = array('error'=>'Failed to update '.$sDest,'type'=>'2','fatal'=>'1','json'=>'1','line'=>__LINE__,'file'=>__FILE__);
				include_once($_PATHS['end']);
			}
			else{
				$aDataR['jresult'] = true;
			}
		}
	}
	else{
		$aDataR['jmessage'] = "You didn't submit a dork";
	}
}
elseif(isset($_POST['iDork'])){
	// dork remove
	$_CONTEXT['dfound'] = false;
	$iDorks = count($_CONTEXT['dorks']);
	$iDork = intval($_POST['iDork']);
	$_CONTEXT['dorkbuffer'] = "";
	for($x=0;$x<$iDorks;$x++){
		$_CONTEXT['dorks'][$x] = trim($_CONTEXT['dorks'][$x]);
		if($_CONTEXT['dorkbuffer']!=""){
			if($_CONTEXT['dorkbuffer']!=""){
				$_CONTEXT['dorkbuffer'] .= "\n";
			}
		}
		if($_CONTEXT['dorks'][$x]!=""){
			if($x==$iDork){
				$_CONTEXT['dfound'] = true;
				$_CONTEXT['dorkbuffer'] = trim($_CONTEXT['dorkbuffer']);
			}
			else{
				$_CONTEXT['dorkbuffer'] .= $_CONTEXT['dorks'][$x];
			}
		}
	}
	if($_CONTEXT['dfound']){
		if(!WriteF($sDest,trim($_CONTEXT['dorkbuffer']),"w")){
			$_CONTEXT['errors'][count($_CONTEXT['errors'])-1] = array('error'=>'Failed to write dorks','type'=>'2','fatal'=>'1','json'=>'1','line'=>__LINE__,'file'=>__FILE__);
			include_once($_PATHS['end']);
		}
		else{
			$aDataR['jresult'] = true;
		}
	}
	else{
		$aDataR['jmessage'] = "No items to update";
	}
}
elseif(isset($_POST['sSQL'])){
	// sql error add
	$_POST['sSQL'] = trim($_POST['sSQL']);
	if($_POST['sSQL']!=""){
		$sDest = $_PATHS['data_root']."/sqlerrors.txt";
		$aFile = @file($sDest);
		if(isset($aFile[0]) && $aFile[0]!=""){
			for($x=0;$x<count($aFile);$x++){
				if(trim($aFile[$x])==$_POST['sSQL']){
					$_CONTEXT['abortupdate'] = true;
					break;
				}
			}
		}
		if(isset($_CONTEXT['abortupdate'])){
			$aDataR['jmessage'] = "This keyword already exists";
		}
		else{
			if(!WriteF($sDest,(@filesize($sDest)>0 ? "\n" : "").$_POST['sSQL'],"a")){
				$_CONTEXT['errors'][count($_CONTEXT['errors'])-1] = array('error'=>'Failed to write sql errors to error file','type'=>'2','fatal'=>'1','json'=>'1','line'=>__LINE__,'file'=>__FILE__);
				include_once($_PATHS['end']);
			}
			else{
				$aDataR['jresult'] = true;
			}
		}
	}
	else{
		$aDataR['jmessage'] = "You didn't submit a sql keyword to search for vulnerabilities";
	}
}
elseif(isset($_POST['iSQL'])){
	// sql error remove
	$_CONTEXT['sfound'] = false;
	$_CONTEXT['sqlbuffer'] = "";
	$iSQLS = count($_CONTEXT['sqli']);
	$iSQL = intval($_POST['iSQL']);
	for($x=0;$x<count($_CONTEXT['sqli']);$x++){
		$_CONTEXT['sqli'][$x] = trim($_CONTEXT['sqli'][$x]);
		if($_CONTEXT['sqli'][$x]!=""){
			if($x==$iSQL){
				$_CONTEXT['sfound'] = true;
			}
			else{
				$_CONTEXT['sqlbuffer'] .= $_CONTEXT['sqli'][$x]."\n";
			}
		}
	}
	if($_CONTEXT['sfound']){
		if(!WriteF($_PATHS['data_root']."/sqlerrors.txt",trim($_CONTEXT['sqlbuffer']),"w")){
			$_CONTEXT['errors'][count($_CONTEXT['errors'])-1] = array('error'=>'Failed to remove sql error','type'=>'2','fatal'=>'1','json'=>'1','line'=>__LINE__,'file'=>__FILE__);
			include_once($_PATHS['end']);
		}
		else{
			$aDataR['jresult'] = true;
		}
	}
	else{
		$aDataR['jmessage'] = "No items to update";
	}
}
else{
	$aDataR['jmessage'] = "Invalid submission button value";
}
echo json_encode($aDataR);
?>