<?php
/* Login handler

Author: Remco Kouw
Site: http://www.hacksuite.com
Last Edit: 14-02-2024
*/
session_cache_limiter('nocache');
header('Expires: '.gmdate('r',0));
header('Content-type: application/json');
$_DYNAMIC_ROOT = "..";
define('PASS_WO_LOGIN',1);
include_once("../header.php");
$aDataR = array();
$aDataR['jresult'] = false;
if(!isset($_CONTEXT['pass_access']) || !$_CONTEXT['pass_access']){
	$_CONTEXT['errors'][] = array('error'=>'You need to setup a password using the setup file','type'=>'2','fatal'=>'1','json'=>'1','line'=>__LINE__,'file'=>__FILE__);
	include_once($_PATHS['end']);
}
else{
	if(!isset($_POST['sPass'])){
		$aDataR['jmessage'] = "No password specified";
	}
	else{
		$iValidUntil = time()+$_CONTEXT['cookielife'];
		$sCookieName = "";
		$_POST['sPass'] = trim($_POST['sPass']);
		if(@sha1($_CONTEXT['pass_salt'].":".$_POST['sPass'])==$_CONTEXT['pass_hash']){
			$sCookieName = "thcauth_".substr($_CONTEXT['pass_hash'],0,5);
			setcookie($sCookieName,$_CONTEXT['pass_hash'],$iValidUntil,"/");
			$aDataR['jresult'] = true;
			$aDataR['jmessage'] = "<div class=\"success\">Thank you for logging in, your session remains valid until:<br />".date($_CONTEXT['time_pattern']." H:i:s",$iValidUntil)."<p>Click <a href=\"index.php\">here</a> to continue..</div>";
		}
		else{
			if(!function_exists("WriteF")){
				@include_once($_PATHS['functions_root']."/fwrite.php");
			}
			$sDest = $_PATHS['data_root']."/logsdata.php";
			if(!isset($_CONTEXT['l_formats'][2]['file'])){
				if(file_exists($sDest)){
					include($sDest);
					if(!isset($_CONTEXT['l_formats'][2]['file'])){
						$_CONTEXT['errors'][] = array('error'=>'Expecting log for login failures to be defined in '.$sDest,'type'=>'2','fatal'=>'1','json'=>'1','line'=>__LINE__,'file'=>__FILE__);
						include_once($_PATHS['end']);
					}
				}
				else{
					$_CONTEXT['errors'][] = array('error'=>'Failed to find file containing log properties, expected in '.$sDest,'type'=>'2','fatal'=>'1','json'=>'1','line'=>__LINE__,'file'=>__FILE__);
					include_once($_PATHS['end']);
				}
			}
			// log into different books
			$_CONTEXT['errors'][] = array('error'=>'Invalid credentials specified, password: '.htmlspecialchars($_POST['sPass']),'log'=>$_CONTEXT['l_formats'][2]['file'],'fatal'=>'0','json'=>'1');
			$_CONTEXT['errors'][] = array('error'=>'Invalid credentials specified','type'=>'2','fatal'=>'1','json'=>'1','line'=>__LINE__,'file'=>__FILE__);
			include_once($_PATHS['end']);
		}
	}
}
if(!$aDataR['jresult']){
	// failed login
	@sleep($_CONTEXT['sleeptime']);
}
echo json_encode($aDataR);
?>