<?php
/* Configure maintenance scanner

Author: Remco Kouw
Site: http://www.hacksuite.com
Last Edit: 18-02-2024
*/
session_cache_limiter('nocache');
header('Expires: '.gmdate('r',0));
header('Content-type: application/json');
$_DYNAMIC_ROOT = "..";
include_once("../header.php");
$sDest = "../vars.php";
$aDataR = array();
$aDataR['jresult'] = false;
$aDataR['jmessage'] = "an error occured";
$aFiles = array($_PATHS['functions_root']."/fwrite.php",$_PATHS['functions_root']."/get_file_data.php",$_PATHS['data_root']."/monitor_files.php",$_PATHS['data_root']."/monitor_dirs.php",$_PATHS['functions_root']."/getfilebydir.php");
for($x=0;$x<count($aFiles);$x++){
	if(!file_exists($aFiles[$x])){
		$_CONTEXT['errors'][] = array('error'=>'Missing required file: '.$aFiles[$x],'type'=>'2','fatal'=>'1','json'=>'1','line'=>__LINE__,'file'=>__FILE__);
		include_once($_PATHS['end']);
	}
	@include_once($aFiles[$x]);
}
// handler for INCLUDES_DIR/cc_filesize_check.php
if(isset($_POST['iTruncate'])){
	// keeps track of which record in the ui we have to delete
	if(!isset($_POST['iID'])){
		$aDataR['jmessage'] = "Expecting id number to be posted";
		die(json_encode($aDataR));
	}
	elseif(!isset($_POST['sTitle'])){
		$aDataR['jmessage'] = "Expecting file name to be posted";
		die(json_encode($aDataR));
	}
	else{
		if(!preg_match('/^[0-9]+$/',$_POST['iID'])){
			$aDataR['jmessage'] = "Invalid id structure posted";
			die(json_encode($aDataR));
		}
		elseif(!preg_match('/^[a-z0-9_\-]+\.[a-z0-9_\-]+$/i',$_POST['sTitle'])){
			$aDataR['jmessage'] = "Invalid file name structure posted";
			die(json_encode($aDataR));
		}
		$aDataR['jid'] = intval($_POST['iID']);
		if(!isset($_CONTEXT['monitor_f'][$_POST['iID']]) || $_CONTEXT['monitor_f'][$_POST['iID']][1]!=$_POST['sTitle']){
			$aDataR['jmessage'] = "You can only truncate files from the whitelist";
			die(json_encode($aDataR));
		}
		$sDest = $_CONTEXT['monitor_f'][$_POST['iID']][0]."/".$_CONTEXT['monitor_f'][$_POST['iID']][1];
		if(!file_exists($sDest)){
			$aDataR['jmessage'] = "Destination file doesn't exist";
			die(json_encode($aDataR));
		}
		if(!WriteF($sDest,"","w")){
			$_CONTEXT['errors'][count($_CONTEXT['errors'])-1] = array('error'=>'Failed to clean file '.$sDest,'type'=>'2','fatal'=>'1','json'=>'1','line'=>__LINE__,'file'=>__FILE__);
			include_once($_PATHS['end']);
		}
		else{
			$aDataR['jmessage'] = "Successfully deleted data in ".$_POST['sTitle'];
			$aDataR['jresult'] = true;
		}
	}
}
// handler for INCLUDES_DIR/cc_filesindir_check.php
elseif(isset($_POST['iDeleteFiles'])){
	// keeps track of which record in the ui we have to delete
	if(!isset($_POST['iID'])){
		$aDataR['jmessage'] = "Expecting id number to be posted";
		die(json_encode($aDataR));
	}
	elseif(!isset($_POST['sTitle'])){
		$aDataR['jmessage'] = "Expecting file name to be posted";
		die(json_encode($aDataR));
	}
	else{
		if(!preg_match('/^[0-9]+$/',$_POST['iID'])){
			$aDataR['jmessage'] = "Invalid id structure posted";
			die(json_encode($aDataR));
		}
		elseif(!preg_match('/^(\/[a-z0-9_\-]+)+$/i',$_POST['sTitle'])){
			$aDataR['jmessage'] = "Invalid folder name structure posted";
			die(json_encode($aDataR));
		}
		$aDataR['jid'] = intval($_POST['iID']);
		if($_CONTEXT['monitor_d'][$aDataR['jid']]!=$_POST['sTitle']){
			$aDataR['jmessage'] = "Invalid folder name specified";
			die(json_encode($aDataR));
		}
		else{
			$sFolder = $_PATHS['root'].$_POST['sTitle'];
			if(!$aFiles = GetFilesByDirectory($sFolder)){
				$_CONTEXT['errors'][count($_CONTEXT['errors'])-1] = array('error'=>'Failed to open folder to delete files from '.$sFolder,'type'=>'0','fatal'=>'1','json'=>'1','line'=>__LINE__,'file'=>__FILE__);
				include_once($_PATHS['end']);
			}
			else{
				for($x=0;$x<count($aFiles);$x++){
					@unlink($sFolder."/".$aFiles[$x]);
				}
			}
			$aDataR['jresult'] = true;
		}
	}
}
// handler for INCLUDES_DIR/cc_function_check.php
elseif(isset($_POST['iDownloadFiles'])){
	// keeps track of records in the ui
	if(!isset($_POST['iID'])){
		$aDataR['jmessage'] = "Expecting id number to be posted";
		die(json_encode($aDataR));
	}
	elseif(!isset($_POST['sFile'])){
		$aDataR['jmessage'] = "Expecting file name to be posted";
		die(json_encode($aDataR));
	}
	else{
		if(!preg_match('/^[0-9]+$/',$_POST['iID'])){
			$aDataR['jmessage'] = "Invalid id structure posted";
			die(json_encode($aDataR));
		}
		elseif(!preg_match('/^[a-z0-9_\-]+\.[a-z0-9_\-]+$/i',$_POST['sFile'])){
			$aDataR['jmessage'] = "Invalid file name structure posted";
			die(json_encode($aDataR));
		}
		else{
			if(!$aFiles = GetFilesByDirectory($_PATHS['functions_root'])){
				$_CONTEXT['errors'][count($_CONTEXT['errors'])-1] = array('error'=>'Failed to open functions folder','type'=>'2','fatal'=>'1','json'=>'1','line'=>__LINE__,'file'=>__FILE__);
				include_once($_PATHS['end']);
			}
			if(in_array($_POST['sFile'],$aFiles)){
				$aDataR['jmessage'] = "File already exists";
				die(json_encode($aDataR));
			}
			if(!function_exists("curl_init")){
				$_CONTEXT['errors'][] = array('error'=>'Curl module isn\'t enabled','type'=>'2','fatal'=>'1','json'=>'1','line'=>__LINE__,'file'=>__FILE__);
				include_once($_PATHS['end']);
			}
			$rCurl = curl_init();
			$sDest = $_PATHS['functions_root']."/".$_POST['sFile'];
			$aDataR['jid'] = $_POST['iID'];
			curl_setopt($rCurl,CURLOPT_URL, "http://hacksuite.com/maintenance_functions.php?sFile=".$_POST['sFile']);
			curl_setopt($rCurl,CURLOPT_HEADER, false);
			curl_setopt($rCurl,CURLOPT_RETURNTRANSFER, true);
			$sOutput = curl_exec($rCurl);
			curl_close($rCurl);
			// let's extract the data
			$aData = @json_decode($sOutput);
			if(isset($aData->jdata)){
				if(!WriteF($sDest,$aData->jdata,"w")){
					$aDataR['jmessage'] = "Failed to write function data";
				}
				else{
					// success, update log_activity.php
					$sNewD = "<?php\n";
					$sNewD .= "/* Activity log\n\n";
					$sNewD .= "Author: Remco Kouw\n";
					$sNewD .= "Site: http://www.hacksuite.com\n";
					$sNewD .= "Last Edit: ".date($_CONTEXT['time_pattern'],time())."\n";
					$sNewD .= "*/\n";
					$sNewD .= "if(!defined('IN_SCRIPT')){\n";
					$sNewD .= "\texit;\n";
					$sNewD .= "}\n";
					$sNewD .= "\$_CONTEXT['useraccessdata'] = array();\n";
					$sNewD .= "\$_CONTEXT['useraccessdata']['installed'] = ".$_CONTEXT['useraccessdata']['installed'].";\n";
					$sNewD .= "\$_CONTEXT['useraccessdata']['last_update'] = ".time().";\n";
					$sNewD .= "\$_CONTEXT['useraccessdata']['ip'] = array(\"".$_SERVER['REMOTE_ADDR']."\");\n";
					$sNewD .= "\$_CONTEXT['useraccessdata']['last_scan'] = ".$_CONTEXT['useraccessdata']['last_scan'].";\n";
					$sNewD .= "\$_CONTEXT['useraccessdata']['action'] = \"Updated function ".$_POST['sFile']."\";\n";
					$sNewD .= "?>";
					WriteF($_PATHS['log_root']."/log_activity.php",$sNewD,"w");
					$aDataR['jresult'] = true;
				}
			}
			else{
				$aDataR['jmessage'] = "No file data found";
			}
		}
	}
}
// handler for evil code scan
elseif(isset($_POST['iShowSource'])){
	$sLocationA = substr(trim($_POST['sFile']),strpos($_SERVER['REQUEST_URI'],"JSON"));
	$sLocationA = "../".str_replace("/","\\",$sLocationA);
	$aDataR['jdata'] = nl2br(str_replace("<","&lt;",file_get_contents($sLocationA)));
	$aDataR['jresult'] = true;
}
die(json_encode($aDataR));
?>