<?php
/* Search handler

Author: Remco Kouw
Site: http://www.hacksuite.com
Last Edit: 19-02-2024
*/
session_cache_limiter('nocache');
header('Expires: '.gmdate('r',0));
header('Content-type: application/json');
$_DYNAMIC_ROOT = "..";
include_once("../header.php");
$aDataR = array();
$aDataR['jresult'] = false;
$aDataR['jmessage'] = "An error occured";
$aDataR['jtotal'] = 0;
$aDataR['jsearch'] = array();
$aDataR['jsearch']['native'] = array();
$aDataR['jsearch']['modules'] = array();
$aDataR['jsearch']['apps'] = array();
if(isset($_POST['sSearch']) || strlen($_POST['sSearch'])>2){
	$sDest = $_PATHS['data_root']."/search.php";
	if(!file_exists($sDest)){
		$_CONTEXT['errors'][] = array('error'=>'No search file exists in data folder, expecting content in '.$sDest,'type'=>'2','fatal'=>'1','json'=>'1','line'=>__LINE__,'file'=>__FILE__);
		include_once($_PATHS['end']);
	}
	else{
		if(!filesize($sDest)){
			$_CONTEXT['errors'][] = array('error'=>'No data in search data file '.$sDest,'type'=>'2','fatal'=>'1','json'=>'1','line'=>__LINE__,'file'=>__FILE__);
			include_once($_PATHS['end']);
		}
		else{
			$sData = file_get_contents($sDest);
			$aData = unserialize($sData);
			$sConfigFile = $_PATHS['data_root']."/nativeconfig.php";
			if(!file_exists($sConfigFile)){
				$_CONTEXT['errors'][] = array('error'=>'Failed to find native configuration file '.$sConfigFile,'type'=>'2','fatal'=>'1','json'=>'1','line'=>__LINE__,'file'=>__FILE__);
				include_once($_PATHS['end']);
			}
			include($sConfigFile);
			// native results
			for($x=0;$x<count($aData['native']);$x++){
				foreach($aData['native'][$x] as $sKey=>$aKeywords){
					for($y=0;$y<count($aKeywords);$y++){
						$aResult = explode($_POST['sSearch'],$aKeywords[$y]);
						if(count($aResult)>1){
							$aDataR['jtotal']++;
							$aDataR['jsearch']['native'][] = array($sKey,$aKeywords[$y],ucfirst($_CONTEXT['native'][$sKey][3]));
							break;
						}
					}
				}
			}
			// modules results
			for($x=0;$x<count($aData['modules']);$x++){
				$sKey = $aData['modules'][$x][0];
				$aKeywords = $aData['modules'][$x][1];
				for($y=0;$y<count($aKeywords);$y++){
					$aResult = explode($_POST['sSearch'],$aKeywords[$y]);
					if(count($aResult)>1){
						include("../Modules/".$sKey."/setup.php");
						$aDataR['jtotal']++;
						$aDataR['jsearch']['modules'][] = array($sKey,$aProperties['name'],$aProperties['description'],$aKeywords[$y]);
						break;
					}
				}
			}
			// apps results
			for($x=0;$x<count($aData['apps']);$x++){
				$sKey = $aData['apps'][$x][0];
				$aKeywords = $aData['apps'][$x][1];
				for($y=0;$y<count($aKeywords);$y++){
					$aResult = explode($_POST['sSearch'],$aKeywords[$y]);
					if(count($aResult)>1){
						include("../Apps/".$sKey."/setup.php");
						$aDataR['jtotal']++;
						$aDataR['jsearch']['apps'][] = array($sKey,$aProperties['name'],$aProperties['description'],$aKeywords[$y]);
						break;
					}
				}
			}
			$aDataR['jresult'] = true;
			$aDataR['jmessage'] = "Successfully went through search data";
		}
	}
}
if(!$aDataR['jresult']){
	@sleep($_CONTEXT['sleeptime']);
}
echo json_encode($aDataR);
?>