<?php
/* Displays processor usage in percents

Author: Remco Kouw
Site: http://www.hacksuite.com
Last Edit: 20-02-2024
*/
session_cache_limiter('nocache');
header('Expires: '.gmdate('r',0));
header('Content-type: application/json');
$_DYNAMIC_ROOT = "..";
include_once("../header.php");
$aDataR = array();
/* Windows CPU measurer */
function WinCPU(){
	exec('typeperf  -sc 1  "\Processor(_Total)\% Processor Time"',$aLines,$iReturn);
	if($iReturn==0){
		$aValues = str_getcsv($aLines[2]);
		return floatval($aValues[1]);
	}
	else{
		return false;
	}
}
/* Linux CPU measurer */
function NixCPU(){
	$aData = getrusage();
	$aData["ru_utime.tv_usec"] = ($aData["ru_utime.tv_sec"]*1e6+$aData["ru_utime.tv_usec"])-PHP_RUSAGE;
	$iTime = (microtime(true)-PHP_TUSAGE)*1000000;
	// cpu per request
	if($iTime>0){
		$iTime = sprintf("%01.2f",($aData["ru_utime.tv_usec"]/$iTime)*100);
	}
	else{
		$dCPU = '0.00';
	}
	return $dCPU;
}
$aDataR['jdata'] = "CPU: ";
$aDataR['jmemory'] = "MEM: ";
if(strtoupper(substr(PHP_OS,0,3))==="WIN"){
	if(false==($mPerc = WinCPU())){
		$mPerc = "???";
	}
	$aDataR['jdata'] .= $mPerc;
	$aOutput = array();
	if(false===($sResult = @exec('tasklist /fi "PID eq '.getmypid().'"',$aOutput))){
		$aDataR['jmemory'] .= "???";
	}
	else{
		$aResult = explode(" ",$sResult);
		$sMemKB = $aResult[count($aResult)-2];
		$aDataR['jmemory'] .= round((intval(str_replace(".","",$sMemKB))/1024),2);
	}
}
else{
	$aData = getrusage();
	define('PHP_TUSAGE',microtime(true));
	define('PHP_RUSAGE',$aData["ru_utime.tv_sec"]*1e6+$aData["ru_utime.tv_usec"]);
	$aDataR['jdata'] .= NixCPU();
	$aDataR['jmemory'] .= round(((memory_get_usage()/1024)/1024),2);
}
$aDataR['jdata'] .= "%";
$aDataR['jmemory'] .= "MB";
$aDataR['jresult'] = false;
echo json_encode($aDataR);
?>