<?php
/*
Extract form data

Author: Remco Kouw
Site: http://www.hacksuite.com
Last Edit: 16-03-2019
*/
session_cache_limiter('nocache');
header('Expires: '.gmdate('r',0));
header('Content-type: application/json');
$_DYNAMIC_ROOT = "../..";
include_once("../../header.php");
$aDataR = array();
$aDataR['jresult'] = false;
$aDataR['jmessage'] = "No valid forms detected in source";
$aDataR['jform'] = -1;
$bSocket = false;
$bCurl = false;
if(function_exists("fsockopen")){
	$bSocket = true;
}
if(function_exists("curl_init")){
	$bCurl = true;
}
if(!$bSocket && !$bCurl){
	// even though we don't use these functions now, we will need them to do the bruteforce
	$aDataR['jmessage'] = "You need either curl or sockets to perform this attack";
	die(json_encode($aDataR));
}
// check if there's a query
$aUrl = @parse_url($_POST['sInput']);
if(!isset($aUrl['scheme']) || ($aUrl['scheme']!="http" && $aUrl['scheme']!="https")){
	$aDataR['jmessage'] = "Invalid protocol specified, you need to enter a full http/https url";
	die(json_encode($aDataR));
}
$_CONTEXT['attack_url'] = array();
$_CONTEXT['attack_url']['base'] = $aUrl['scheme']."://".$aUrl['host'];
$_CONTEXT['attack_url']['path'] = $_CONTEXT['attack_url']['base'].(isset($aUrl['path']) ? $aUrl['path'] : "");
$_CONTEXT['attack_url']['folder'] = substr($_CONTEXT['attack_url']['path'],0,strrpos($_CONTEXT['attack_url']['path'],"/")+1);
$_CONTEXT['attack_url']['full'] = $_POST['sInput'];
$_CONTEXT['attack_url']['query'] = isset($aUrl['query']) ? $aUrl['query'] : "";
// we can use sockets or curl as fallback when file_get_contents is not an option 
if($_CONTEXT['attack_url']['query']!=""){
	// we can't use file_get_contents if there's a query specified, instead use socket or curl
	if($bCurl){
		// post data using curl
		if(false!=($rConnect = @curl_init())){
			curl_setopt($rConnect,CURLOPT_URL,$_CONTEXT['attack_url']['path']);
			curl_setopt($rConnect,CURLOPT_POST,1);
			curl_setopt($rConnect,CURLOPT_RETURNTRANSFER,1);
			curl_setopt($rConnect,CURLOPT_POSTFIELDS,urlencode($_CONTEXT['attack_url']['query']));
			curl_setopt($rConnect,CURLOPT_HEADER,false);
			$sFileData = @curl_exec($rConnect);
			if(false!=($iError = @curl_errno($rConnect))){
				$sError = @curl_strerror($iError);
			}
			curl_close($rConnect);
			if(isset($sError)){
				$aDataR['jmessage'] = $sError;
				die(json_encode($aDataR));
			}
		}
		else{
			$aDataR['jmessage'] = "Failed to initialize curl session";
			die(json_encode($aDataR));
		}
	}
	else{
		// post data using sockets
		if(false==($rConnect = @fsockopen($aUrl['host'],80,$iError,$sError,10))){
			$aDataR['jmessage'] = "Failed to get file data using sockets, ".$sError;
			die(json_encode($aDataR));
		}
		else{
			// setup headers
			$sData = urlencode($_CONTEXT['attack_url']['query']);
			$sOut = "POST ".$aUrl['path']." HTTP/1.0\r\n";
			$sOut .= "Host: ".$aUrl['host']."\r\n";
			$sOut .= "Content-Type: application/x-www-form-urlencoded\r\n";
			$sOut .= "Content-Length: ".strlen($sData)."\r\n";
			$sOut .= "Connection: Close\r\n\r\n";
			fputs($rConnect,$sOut);
			fputs($rConnect,$sData);
			$sFileData = "";
			// get response
			while(!feof($rConnect)){
				$sFileData .= stream_get_line($rConnect,1024,"\n");
			}
			fclose($rConnect);
		}
	}
}
else{
	if(false==($sFileData = @file_get_contents($_POST['sInput']))){
		$aDataR['jmessage'] = "Failed to fetch filedata";
		die(json_encode($aDataR));
	}
}
preg_match_all('/<form.*>(.*)<\/form>/Uis',$sFileData,$aDump);
$aForms = $aDump[0];
$iMultiplePasswordFields = 0;
$_CONTEXT['forms'] = array();
$aDataR['jform'] = array();
if(false!=($iForms = @count($aForms))){
	for($x=0;$x<$iForms;$x++){
		$_CONTEXT['forms'][$x] = array();
		$_CONTEXT['forms'][$x]['password_field'] = false;
		$_CONTEXT['forms'][$x]['fields'] = array();
		// get rid of multiple spaces
		$aForms[$x] = preg_replace('/\s+/',' ',$aForms[$x]);
		$aForms[$x] = str_replace("> ",">",$aForms[$x]);
		$aForms[$x] = str_replace("'","",$aForms[$x]);
		$aForms[$x] = str_replace("\"","",$aForms[$x]);
		$aForms[$x] = str_replace("`","",$aForms[$x]);
		$aItems = explode(">",$aForms[$x]);
		$iInput = 0;
		for($y=0;$y<count($aItems);$y++){
			// filter all inputs
			if(substr($aItems[$y],1,5)=="input"){
				$_CONTEXT['forms'][$x]['fields'][$iInput] = array();
				$aAttributes = explode(" ",$aItems[$y]);
				// not interested in tag name, so we start from 1
				for($z=1;$z<count($aAttributes);$z++){
					$aAttributePair = explode("=",$aAttributes[$z]);
					if($aAttributePair[0]!="type" && $aAttributePair[0]!="name" && $aAttributePair[0]!="value"){
						continue;
					}
					// there's a password field present, so this is probably the form we are looking for
					if($aAttributePair[0]=="type" && $aAttributePair[1]=="password"){
						$iMultiplePasswordFields++;
						$_CONTEXT['forms'][$x]['password_field'] = true;
						$aDataR['jform'][] = $x;
						$aDataR['jresult'] = true;
					}
					$_CONTEXT['forms'][$x]['fields'][$iInput][$aAttributePair[0]] = $aAttributePair[1];
				}
				$iInput++;
			}
		}
		// the first item is the form
		$aFormProperties = explode(" ",$aItems[0]);
		$_CONTEXT['forms'][$x]['form_properties'] = array();
		// not interested in tag name, so we start from 1
		for($y=1;$y<count($aFormProperties);$y++){
			$aAttributePair = explode("=",$aFormProperties[$y],2);
			$_CONTEXT['forms'][$x]['form_properties'][$aAttributePair[0]] = $aAttributePair[1];
		}
		// create a full url of the login target
		if(isset($_CONTEXT['forms'][$x]['form_properties']['action'])){
			if(!isset($_CONTEXT['forms'][$x]['form_properties']['action'][0])){
				// empty, so same page
				$_CONTEXT['forms'][$x]['form_properties']['action'] = $_POST['sInput'];
			}
			else{
				if($_CONTEXT['forms'][$x]['form_properties']['action'][0]=="/"){
					// if last character in target contains a slash, remove it
					$_CONTEXT['forms'][$x]['form_properties']['action'] = $_CONTEXT['attack_url']['folder'].substr($_CONTEXT['forms'][$x]['form_properties']['action'],1);
				}
				elseif($_CONTEXT['forms'][$x]['form_properties']['action'][0]=="?"){
					$_CONTEXT['forms'][$x]['form_properties']['action'] = $_CONTEXT['attack_url']['path'].$_CONTEXT['forms'][$x]['form_properties']['action'];
				}
				elseif($_CONTEXT['forms'][$x]['form_properties']['action'][0]=="."){
					// dir ups
					$aDirsForm = explode("../",$_CONTEXT['forms'][$x]['form_properties']['action']);
					$iResults = count($aDirsForm);
					$sFileName = $aDirsForm[$iResults-1];
					$sPathOnly = substr($_CONTEXT['attack_url']['folder'],strlen($_CONTEXT['attack_url']['base']));
					$aPathOnly = explode("/",$sPathOnly);
					$sUpDir = "";
					for($i=0;$i<(count($aPathOnly)-$iResults);$i++){
						if($i!=0){
							$sUpDir .= "/";
						}
						$sUpDir .= $aPathOnly[$i];
					}
					$_CONTEXT['forms'][$x]['form_properties']['action'] = $_CONTEXT['attack_url']['base'].$sUpDir."/".$sFileName;
				}
				elseif($_CONTEXT['forms'][$x]['form_properties']['action'][0]=="h"){
					// is it start with a full http address or a filename?
					$sCheck = substr($_CONTEXT['forms'][$x]['form_properties']['action'],0,7);
					if($sCheck=="http://" || $sCheck=="https:/"){
						$_CONTEXT['forms'][$x]['form_properties']['action'] = $_CONTEXT['forms'][$x]['form_properties']['action'];
					}
					else{
						// filename that start with h
						$_CONTEXT['forms'][$x]['form_properties']['action'] = $_CONTEXT['attack_url']['folder'].$_CONTEXT['forms'][$x]['form_properties']['action'];
					}
				}
				else{
					$_CONTEXT['forms'][$x]['form_properties']['action'] = $_CONTEXT['attack_url']['folder'].$_CONTEXT['forms'][$x]['form_properties']['action'];
				}
			}
		}
		else{
			// if it's not set, the form will be send to the same page
			$_CONTEXT['forms'][$x]['form_properties']['method'] = $_POST['sInput'];
		}
	}
}
else{
	$aDataR['jmessage'] = "No forms found";
}
$aDataR['jmultiplefields'] = $iMultiplePasswordFields>1 ? true : false;
if($iMultiplePasswordFields==1){
	// this is the best situation, we don't have to do anything
	$aDataR['jmessage'] = $_CONTEXT['forms'][$aDataR['jform'][0]];
}
else{
	// multiple forms
	for($x=0;$x<count($aDataR['jform']);$x++){
		if(!in_array($x,$aDataR['jform'])){
			unset($_CONTEXT['forms'][$x]);
		}
	}
	$aDataR['jmessage'] = array_values($_CONTEXT['forms']);
	if($_POST['iForm']!="undefined"){
		// user selected form
		if(!isset($_CONTEXT['forms'][$_POST['iForm']])){
			$aDataR['jmessage'] = "Invalid form selected";
			$aDataR['jresult'] = false;
		}
		else{
			// selection was correct, return specified form
			$aDataR['jmessage'] = $_CONTEXT['forms'][$_POST['iForm']];
			$aDataR['jmultiplefields'] = false;
		}
	}
}
if(!$aDataR['jmessage']){
	$aDataR['jmessage'] = "Invalid file content";
}
echo json_encode($aDataR);
?>