<?php
/*
Functions for CollectPanels

Author: Remco Kouw
Site: http://www.hacksuite.com
Last Edit: 01-06-2023
*/
function IsValidDomain($sDomain){
    $sPattern = "/^(?:[a-z0-9](?:[a-z0-9-]{0,61}[a-z0-9])?\.)+[a-z]{2,}$/i";
    return preg_match($sPattern,$sDomain);
}
function IsCPanelValid($sUrl){
	$iHTTP = 0;
	// Try cURL connection first
	if(function_exists('curl_version')){
		$ch = curl_init($sUrl);
		curl_setopt($ch,CURLOPT_RETURNTRANSFER,true);
		curl_setopt($ch,CURLOPT_CONNECTTIMEOUT,5);
		curl_setopt($ch,CURLOPT_TIMEOUT,5);
		curl_setopt($ch,CURLOPT_FOLLOWLOCATION,true);
		curl_exec($ch);
		$iHTTP = curl_getinfo($ch,CURLINFO_HTTP_CODE);
		curl_close($ch);
	}
	elseif(function_exists('fsockopen')){
		// Fallback to socket connection if cURL is not available
		$aUrlParts = parse_url($sUrl);
		$sScheme = !isset($aUrlParts['scheme']) ? false : $aUrlParts['scheme'];
		$sHost = !isset($aUrlParts['host']) ? false : $aUrlParts['host'];
		$iPort = !isset($aUrlParts['port']) ?  false : $aUrlParts['port'];
		if(!$iPort){
			$aUrlParts['port'] = $sScheme=="https" ? 443 : 80;
		}
		else{
			$sPath = !isset($aUrlParts['path']) ? "" : $aUrlParts['path'];
		}
		$fp = @fsockopen($sHost,$iPort,$errno,$errstr,5);
		if($fp){
			$sRequest = "GET $sPath HTTP/1.1\r\n";
			$sRequest .= "Host: $sHost\r\n";
			$sRequest .= "Connection: close\r\n\r\n";
			fwrite($fp,$sRequest);
			$response = fread($fp,4096);
			fclose($fp);
			if(preg_match('/^HTTP\/\d+\.\d+\s+(\d+)/',$sResponse,$aMatches)){
				$iHTTP = intval($aMatches[1]);
			}
		}
	}
	else{
		return(false);
	}
    // Check if the HTTP response code indicates a successful connection
	if($iHTTP>=200 && $iHTTP<300){
		return true;
	}
	return false;
}
function CreateArrayFromString($sString){
	$aValues = preg_split('/[\|\n,]/',$sString);
	$aValues = array_map('trim',$aValues);
	$aValues = array_filter($aValues);
	$aUniqueValues = array_unique($aValues);
	return $aUniqueValues;
}
function GenerateCpanelUrls($sString){
	// input should be a url
	$aFormats = array();
	$aUrlComponents = parse_url($sString);
	$aFormats[] = "http://".$aUrlComponents['host'].":2082";
	$aFormats[] = "https://".$aUrlComponents['host'].":2083";
	$aFormats[] = "http://".$aUrlComponents['host']."/cpanel";
	$aFormats[] = "https://".$aUrlComponents['host']."/cpanel";
	return($aFormats);
}
?>