<?php
/*
Handler for CollectPanels

ModGlue Variables:
$_CONTEXT['thc_cp']['log']
$_CONTEXT['thc_cp']['urldata']
$_CONTEXT['thc_cp']['found']
$_CONTEXT['thc_cp']['up']
$_CONTEXT['thc_cp']['down']
$_CONTEXT['thc_cp']['logdata']
$_CONTEXT['thc_cp']['totalvariants']
$_CONTEXT['thc_cp']['urls']
$_CONTEXT['thc_cp']['resultstring']

Author: Remco Kouw
Site: http://www.hacksuite.com
Last Edit: 04-05-2024
*/
// set variable to be able to save a task
$_MODULE_C = "thc_cp";
include_once("../../Includes/screen_header.php");
include_once($_PATHS['style_root']."/screen.php");
include_once($_PATHS['functions_root']."/scrn.php");
include_once($_PATHS['module_default_root']."/functions.php");
$_CONTEXT['thc_cp'] = array();
$_CONTEXT['thc_cp']['log'] = $_PATHS['module_default_root']."/logs/".time().".php";
// options
$sOptions = "<b>logging:</b> ".($_CONTEXT['log']==true ? "on" : "off")."<br>\n";
$sOptions .= "<b>silence:</b> ".($_CONTEXT['silent']==true ? "on" : "off")."<br>\n";
$sOptions .= "<b>verbose:</b> ".($_CONTEXT['verbose']==true ? "on" : "off")."\n";
$_CONTEXT['thc_cp']['urldata'] = false;
if(isset($_POST['submit'])){
	switch($_POST['submit']){
		// Check
		case"Check":
		// get it on with..
		if(!function_exists("fsockopen") && !function_exists("curl_init")){
			echo Screen("You need curl or sockets to be enabled");
			exit;
		}
		if(isset($_POST['sFile'])){
			// gather information from file
			$_POST['sFileData'] = @file_get_contents($_POST['sFile']);
		}
		else{
			if(!isset($_POST['sFileData'])){
				// textarea data
				$_POST['sFileData'] = false;
			}
		}
		if(false!=($_CONTEXT['thc_cp']['urldata'] = CreateArrayFromString($_POST['sFileData']))){
			include($_PATHS['includes_root']."/task_start.php");
		}
		else{
			echo Screen("No such file exists in the log folder",$_CONTEXT['verbose'],$_CONTEXT['silent']);
			exit;
		}
		echo Screen($sOut,$_CONTEXT['verbose'],$_CONTEXT['silent']);
		break;
		default:
		// default template
		die(Screen($sOut.$sOptions.$sEnd,$_CONTEXT['verbose'],$_CONTEXT['silent']));
	}
}
else{
	die(Screen($sOut.$sOptions.$sEnd,$_CONTEXT['verbose'],$_CONTEXT['silent']));
}
echo Screen("<br />\n<b>Running..</b><p>\n",$_CONTEXT['verbose'],$_CONTEXT['silent']);
// spit fire...
flush();
ob_flush();
$_CONTEXT['thc_cp']['found'] = false;
$_CONTEXT['thc_cp']['up'] = 0;
$_CONTEXT['thc_cp']['down'] = 0;
$_CONTEXT['thc_cp']['logdata'] = "";
$_CONTEXT['thc_cp']['totalvariants'] = 0;
echo Screen("<b>trying to find cPanels:</b><br>\n",$_CONTEXT['verbose'],$_CONTEXT['silent']);
flush();
ob_flush();
if(false!=($iUrlData = @count($_CONTEXT['thc_cp']['urldata']))){
	echo Screen("<b>total of ".$iUrlData." site".($iUrlData==1 ? "" : "s")." to test:</b><br>\n",$_CONTEXT['verbose'],$_CONTEXT['silent']);
	for($x=0;$x<count($_CONTEXT['thc_cp']['urldata']);$x++){
		// could be a domain or url
		if(IsValidDomain($_CONTEXT['thc_cp']['urldata'][$x])){
			// this is a domain not an url
			$sUrl = "http://".$_CONTEXT['thc_cp']['urldata'][$x];
		}
		if($_POST['sType']==1){
			// only check the specified target to see whether it's a cpanel url
			if(IsCPanelValid($_CONTEXT['thc_cp']['urldata'][$x])){
				$bState = true;
				$_CONTEXT['thc_cp']['up']++;
				$sState = "<b id=h6>up</b>";
			}
			else{
				$_CONTEXT['thc_cp']['down']++;
				$sState = "<b id=h7>down</b>";
			}
			echo Screen("testing url: ".$_CONTEXT['thc_cp']['urldata'][$x]." ".$sState."<br />\n",$_CONTEXT['verbose'],$_CONTEXT['silent']);
			if($_POST['sLogResults']==1){
				$_CONTEXT['thc_cp']['logdata'] .= time()."|".$_CONTEXT['thc_cp']['urldata'][$x]."\n";
			}
		}
		else{
			// create possible cpanel variations based on specified host
			$_CONTEXT['thc_cp']['urls'] = GenerateCpanelUrls($sUrl);
			for($y=0;$y<count($_CONTEXT['thc_cp']['urls']);$y++){
				$sState = "";
				$bState = false;
				$_CONTEXT['thc_cp']['totalvariants']++;
				if(IsCPanelValid($_CONTEXT['thc_cp']['urls'][$y])){
					$bState = true;
					$_CONTEXT['thc_cp']['up']++;
					$sState = "<b id=h6>up</b>";
				}
				else{
					$_CONTEXT['thc_cp']['down']++;
					$sState = "<b id=h7>down</b>";
				}
				echo Screen("testing url: ".$_CONTEXT['thc_cp']['urls'][$y]." ".$sState."<br />\n",$_CONTEXT['verbose'],$_CONTEXT['silent']);
				if($_POST['sLogResults']==1){
					$_CONTEXT['thc_cp']['logdata'] .= time()."|".$_CONTEXT['thc_cp']['urls'][$y]."\n";
				}
				if($bState && $_POST['sTryAll']==0){
					// stop trying urls when a match was found
					break;
				}
			}
		}
		ob_flush();
		flush();
	}
	// write report
	$_CONTEXT['thc_cp']['resultstring'] = "Urls specified: ".$iUrlData."<br />";
	$_CONTEXT['thc_cp']['resultstring'] .= "Variants Tested: ".$iUrlData."<br />";
	$_CONTEXT['thc_cp']['resultstring'] .= "Urls UP: ".$_CONTEXT['thc_cp']['up']."<br />";
	$_CONTEXT['thc_cp']['resultstring'] .= "Urls DOWN: ".$_CONTEXT['thc_cp']['down']."<br />";
	if($_POST['sLogResults']==1){
		$_CONTEXT['thc_cp']['resultstring'] .= "<br />\nSaved as: ".$_CONTEXT['thc_cp']['log'];
		WriteF($_CONTEXT['thc_cp']['log'],$_CONTEXT['thc_cp']['logdata']);
	}
	echo Screen("<p>".$_CONTEXT['thc_cp']['resultstring']."</p>",$_CONTEXT['verbose'],$_CONTEXT['silent']);
	// update entry in background task file
	include($_PATHS['includes_root']."/task_end.php");
}
else{
	echo Screen("Failed to find urls to test",$_CONTEXT['verbose'],$_CONTEXT['silent']);
}
echo Screen($sEnd,$_CONTEXT['verbose'],$_CONTEXT['silent']);
?>
