<?php
/* xCrypt

Author: Remco Kouw
Site: http://www.hacksuite.com
Last Edit: 17-09-2023
*/
if(!defined("IN_SCRIPT")){
	exit;
}
$_CONTEXT['thc_ct'] = array();
$_CONTEXT['thc_ct']['opensslalgorithms'] = $_PATHS['module_default_root']."/openssl.php";
$_CONTEXT['thc_ct']['mcryptalgorithms'] = $_PATHS['module_default_root']."/mcrypt.php";
$_CONTEXT['thc_ct']['otheralgorithms'] = $_PATHS['module_default_root']."/encrypt.php";
$_CONTEXT['thc_ct']['mcryptmodes'] = $_PATHS['module_default_root']."/mcryptmodes.php";
// default encryption and encoding select
(!IsThere($_CONTEXT['thc_ct']['otheralgorithms']) ? include_once($_PATHS['end']) : include_once($_CONTEXT['thc_ct']['otheralgorithms']));
$_CONTEXT['thc_ct']['encselect'] = "<select name=\"sAlgorithms\" class=\"algorithmselect\">\n";
for($x=0;$x<count($_CONTEXT['algorithms_other']);$x++){
	$_CONTEXT['thc_ct']['encselect'] .= "	<option value=\"".$_CONTEXT['algorithms_other'][$x]."\">".$_CONTEXT['algorithms_other'][$x]."</option>\n";
}
$_CONTEXT['thc_ct']['encselect'] .= "</select>\n";
// openssl algorithms
$_CONTEXT['thc_ct']['opensslselect'] = "";
$_CONTEXT['thc_ct']['opensslavailable'] = !function_exists("openssl_encrypt") ? false : true;
if($_CONTEXT['thc_ct']['opensslavailable']){
	(!IsThere($_CONTEXT['thc_ct']['opensslalgorithms']) ? include_once($_PATHS['end']) : include_once($_CONTEXT['thc_ct']['opensslalgorithms']));
	$_CONTEXT['thc_ct']['opensslselect'] .= "<select name=\"sOpenSSL\" class=\"sslselect\">\n";
	for($x=0;$x<count($_CONTEXT['algorithms_openssl']);$x++){
		$_CONTEXT['thc_ct']['opensslselect'] .= "	<option value=\"".$_CONTEXT['algorithms_openssl'][$x][0]."\" alt=\"".$_CONTEXT['algorithms_openssl'][$x][1]."\">".$_CONTEXT['algorithms_openssl'][$x][0]."</option>\n";
	}
	$_CONTEXT['thc_ct']['opensslselect'] .= "</select>\n";
}
else{
	$_CONTEXT['thc_ct']['opensslselect'] .= "OpenSSL isn't enabled in this php configuration";
}
// mcrypt algorithms
$_CONTEXT['thc_ct']['mcryptselect'] = "";
$_CONTEXT['thc_ct']['mcryptavailable'] = !function_exists("mcrypt_encrypt") ? false : true;
if($_CONTEXT['thc_ct']['mcryptavailable']){
	(!IsThere($_CONTEXT['thc_ct']['mcryptalgorithms']) ? include_once($_PATHS['end']) : include_once($_CONTEXT['thc_ct']['mcryptalgorithms']));
	$_CONTEXT['thc_ct']['mcryptselect'] .= "<select name=\"sCrypt\" class=\"mcryptselect\">\n";
	for($x=0;$x<count($_CONTEXT['algorithms_mcrypt']);$x++){
		$_CONTEXT['thc_ct']['mcryptselect'] .= "	<option value=\"".$_CONTEXT['algorithms_mcrypt'][$x][0]."\" alt=\"".$_CONTEXT['algorithms_mcrypt'][$x][1]."\">".$_CONTEXT['algorithms_mcrypt'][$x][0]."</option>\n";
	}
	$_CONTEXT['thc_ct']['mcryptselect'] .= "</select>\n";
}
else{
	$_CONTEXT['thc_ct']['mcryptselect'] .= "mCrypt isn't enabled in this php configuration";
}
// hash_hmac algorithms
$_CONTEXT['thc_ct']['hmacselect'] = "";
$_CONTEXT['thc_ct']['hmacavailable'] = !function_exists("hash_hmac_algos") ? false : true;
if($_CONTEXT['thc_ct']['hmacavailable']){
	$_CONTEXT['thc_ct']['algorithms_hmac'] = @hash_hmac_algos();
	$_CONTEXT['thc_ct']['hmacselect'] .= "<select name=\"sHMAC\" class=\hmacselect\">\n";
	for($x=0;$x<count($_CONTEXT['thc_ct']['algorithms_hmac']);$x++){
		$_CONTEXT['thc_ct']['hmacselect'] .= "	<option value=\"".$_CONTEXT['thc_ct']['algorithms_hmac'][$x]."\">".$_CONTEXT['thc_ct']['algorithms_hmac'][$x]."</option>\n";
	}
	$_CONTEXT['thc_ct']['hmacselect'] .= "</select>\n";
}
else{
	$_CONTEXT['thc_ct']['hmacselect'] .= "HMAC isn't enabled in this php configuration";
}
// hash algorithms
$_CONTEXT['thc_ct']['hashselect'] = "";
$_CONTEXT['thc_ct']['hashavailable'] = !function_exists("hash") ? false : true;
if($_CONTEXT['thc_ct']['hashavailable']){
	$_CONTEXT['thc_ct']['hashalgorithms'] = @hash_algos();
	$_CONTEXT['thc_ct']['hashselect'] .= "<select name=\"sHash\" class=\hashselect\">\n";
	for($x=0;$x<count($_CONTEXT['thc_ct']['hashalgorithms']);$x++){
		$_CONTEXT['thc_ct']['hashselect'] .= "	<option value=\"".$_CONTEXT['thc_ct']['hashalgorithms'][$x]."\">".$_CONTEXT['thc_ct']['hashalgorithms'][$x]."</option>\n";
	}
	$_CONTEXT['thc_ct']['hashselect'] .= "</select>\n";
}
else{
	$_CONTEXT['thc_ct']['hashselect'] .= "Hash functions aren't enabled in this php configuration";
}
// mcrypt modes
$_CONTEXT['thc_ct']['mcryptmodestext'] = "";
(!IsThere($_CONTEXT['thc_ct']['mcryptmodes']) ? include_once($_PATHS['end']) : include_once($_CONTEXT['thc_ct']['mcryptmodes']));
if(isset($_CONTEXT['mcrypt_modes'])){
	$_CONTEXT['thc_ct']['mcryptmodestext'] .= "<select name=\"sMode\" class=\modeselect\">\n";
	for($x=0;$x<count($_CONTEXT['mcrypt_modes']);$x++){
		$_CONTEXT['thc_ct']['mcryptmodestext'] .= "	<option value=\"".$_CONTEXT['mcrypt_modes'][$x]."\">".$_CONTEXT['mcrypt_modes'][$x]."</option>\n";
	}
	$_CONTEXT['thc_ct']['mcryptmodestext'] .= "</select>\n";
}
else{
	$_CONTEXT['thc_ct']['mcryptmodestext'] .= "mCrypt modes not found";
}
/* keeps track of the current row when defining properties, which makes it easier to add and remove new rows */
$_CONTEXT['mfs']['currentrow'] = 0;
/* form properties */
$_CONTEXT['mfs']['module'] = $_CONTEXT['module_current'];
$_CONTEXT['mfs']['form'] = array();
$_CONTEXT['mfs']['form']['target'] = $_CONTEXT['screen']['name'];
$_CONTEXT['mfs']['form']['method'] = "post";
$_CONTEXT['mfs']['form']['action'] = $_CONTEXT['screen']['src'];
/* table */
$_CONTEXT['mfs']['table'] = array();
/* table header */
$_CONTEXT['mfs']['table']['header'] = array();
$_CONTEXT['mfs']['table']['header']['name'] = $_CONTEXT['modules'][$_CONTEXT['mfs']['module']]['name'];
$_CONTEXT['mfs']['table']['header']['description'] = $_CONTEXT['modules'][$_CONTEXT['mfs']['module']]['description'];
/* table rows */
$_CONTEXT['mfs']['table']['rows'] = array();
$_CONTEXT['mfs']['table']['rows'][$_CONTEXT['mfs']['currentrow']] = array();
$_CONTEXT['mfs']['table']['rows'][$_CONTEXT['mfs']['currentrow']]['class'] = "modrow";
$_CONTEXT['mfs']['table']['rows'][$_CONTEXT['mfs']['currentrow']]['id'] = "def";
$_CONTEXT['mfs']['table']['rows'][$_CONTEXT['mfs']['currentrow']]['cells'] = array();
$_CONTEXT['mfs']['table']['rows'][$_CONTEXT['mfs']['currentrow']]['cells'][0] = array();
$_CONTEXT['mfs']['table']['rows'][$_CONTEXT['mfs']['currentrow']]['cells'][0]['class'] = "modleft";
$_CONTEXT['mfs']['table']['rows'][$_CONTEXT['mfs']['currentrow']]['cells'][0]['value'] = "text";
$_CONTEXT['mfs']['table']['rows'][$_CONTEXT['mfs']['currentrow']]['cells'][1] = array();
$_CONTEXT['mfs']['table']['rows'][$_CONTEXT['mfs']['currentrow']]['cells'][1]['class'] = "modright";
$_CONTEXT['mfs']['table']['rows'][$_CONTEXT['mfs']['currentrow']]['cells'][1]['value'] = "<textarea name=\"sText\"></textarea><br /><i>text to encrypt</i>";
$_CONTEXT['mfs']['currentrow']++;
$_CONTEXT['mfs']['table']['rows'][$_CONTEXT['mfs']['currentrow']] = array();
$_CONTEXT['mfs']['table']['rows'][$_CONTEXT['mfs']['currentrow']]['class'] = "modrow";
$_CONTEXT['mfs']['table']['rows'][$_CONTEXT['mfs']['currentrow']]['id'] = "def";
$_CONTEXT['mfs']['table']['rows'][$_CONTEXT['mfs']['currentrow']]['cells'] = array();
$_CONTEXT['mfs']['table']['rows'][$_CONTEXT['mfs']['currentrow']]['cells'][0] = array();
$_CONTEXT['mfs']['table']['rows'][$_CONTEXT['mfs']['currentrow']]['cells'][0]['class'] = "modleft";
$_CONTEXT['mfs']['table']['rows'][$_CONTEXT['mfs']['currentrow']]['cells'][0]['value'] = "encryption/encoding";
$_CONTEXT['mfs']['table']['rows'][$_CONTEXT['mfs']['currentrow']]['cells'][1] = array();
$_CONTEXT['mfs']['table']['rows'][$_CONTEXT['mfs']['currentrow']]['cells'][1]['class'] = "modright";
$_CONTEXT['mfs']['table']['rows'][$_CONTEXT['mfs']['currentrow']]['cells'][1]['value'] = $_CONTEXT['thc_ct']['encselect']."<br /><i>select an encoding or encryption method</i>";
$_CONTEXT['mfs']['currentrow']++;
$_CONTEXT['mfs']['table']['rows'][$_CONTEXT['mfs']['currentrow']] = array();
$_CONTEXT['mfs']['table']['rows'][$_CONTEXT['mfs']['currentrow']]['class'] = "modrow";
$_CONTEXT['mfs']['table']['rows'][$_CONTEXT['mfs']['currentrow']]['id'] = "openssl";
$_CONTEXT['mfs']['table']['rows'][$_CONTEXT['mfs']['currentrow']]['cells'] = array();
$_CONTEXT['mfs']['table']['rows'][$_CONTEXT['mfs']['currentrow']]['cells'][0] = array();
$_CONTEXT['mfs']['table']['rows'][$_CONTEXT['mfs']['currentrow']]['cells'][0]['class'] = "modleft";
$_CONTEXT['mfs']['table']['rows'][$_CONTEXT['mfs']['currentrow']]['cells'][0]['value'] = "openssl algorithm";
$_CONTEXT['mfs']['table']['rows'][$_CONTEXT['mfs']['currentrow']]['cells'][1] = array();
$_CONTEXT['mfs']['table']['rows'][$_CONTEXT['mfs']['currentrow']]['cells'][1]['class'] = "modright";
$_CONTEXT['mfs']['table']['rows'][$_CONTEXT['mfs']['currentrow']]['cells'][1]['value'] = $_CONTEXT['thc_ct']['opensslselect'].($_CONTEXT['thc_ct']['opensslselect'][0]=="<" ? "<br />encryption algorithms specific to openssl" : "");
$_CONTEXT['mfs']['currentrow']++;
$_CONTEXT['mfs']['table']['rows'][$_CONTEXT['mfs']['currentrow']] = array();
$_CONTEXT['mfs']['table']['rows'][$_CONTEXT['mfs']['currentrow']]['class'] = "modrow";
$_CONTEXT['mfs']['table']['rows'][$_CONTEXT['mfs']['currentrow']]['id'] = "mcrypt";
$_CONTEXT['mfs']['table']['rows'][$_CONTEXT['mfs']['currentrow']]['cells'] = array();
$_CONTEXT['mfs']['table']['rows'][$_CONTEXT['mfs']['currentrow']]['cells'][0] = array();
$_CONTEXT['mfs']['table']['rows'][$_CONTEXT['mfs']['currentrow']]['cells'][0]['class'] = "modleft";
$_CONTEXT['mfs']['table']['rows'][$_CONTEXT['mfs']['currentrow']]['cells'][0]['value'] = "mcrypt algorithm";
$_CONTEXT['mfs']['table']['rows'][$_CONTEXT['mfs']['currentrow']]['cells'][1] = array();
$_CONTEXT['mfs']['table']['rows'][$_CONTEXT['mfs']['currentrow']]['cells'][1]['class'] = "modright";
$_CONTEXT['mfs']['table']['rows'][$_CONTEXT['mfs']['currentrow']]['cells'][1]['value'] = $_CONTEXT['thc_ct']['mcryptselect'].($_CONTEXT['thc_ct']['mcryptselect'][0]=="<" ? "<br />encryption algorithms specific to mcrypt" : "");
$_CONTEXT['mfs']['currentrow']++;
$_CONTEXT['mfs']['table']['rows'][$_CONTEXT['mfs']['currentrow']] = array();
$_CONTEXT['mfs']['table']['rows'][$_CONTEXT['mfs']['currentrow']]['class'] = "modrow";
$_CONTEXT['mfs']['table']['rows'][$_CONTEXT['mfs']['currentrow']]['id'] = "hmac";
$_CONTEXT['mfs']['table']['rows'][$_CONTEXT['mfs']['currentrow']]['cells'] = array();
$_CONTEXT['mfs']['table']['rows'][$_CONTEXT['mfs']['currentrow']]['cells'][0] = array();
$_CONTEXT['mfs']['table']['rows'][$_CONTEXT['mfs']['currentrow']]['cells'][0]['class'] = "modleft";
$_CONTEXT['mfs']['table']['rows'][$_CONTEXT['mfs']['currentrow']]['cells'][0]['value'] = "hmac algorithm";
$_CONTEXT['mfs']['table']['rows'][$_CONTEXT['mfs']['currentrow']]['cells'][1] = array();
$_CONTEXT['mfs']['table']['rows'][$_CONTEXT['mfs']['currentrow']]['cells'][1]['class'] = "modright";
$_CONTEXT['mfs']['table']['rows'][$_CONTEXT['mfs']['currentrow']]['cells'][1]['value'] = $_CONTEXT['thc_ct']['hmacselect'].($_CONTEXT['thc_ct']['hmacselect'][0]=="<" ? "<br />encryption algorithms specific to hmac" : "");
$_CONTEXT['mfs']['currentrow']++;
$_CONTEXT['mfs']['table']['rows'][$_CONTEXT['mfs']['currentrow']] = array();
$_CONTEXT['mfs']['table']['rows'][$_CONTEXT['mfs']['currentrow']]['class'] = "modrow";
$_CONTEXT['mfs']['table']['rows'][$_CONTEXT['mfs']['currentrow']]['id'] = "hash";
$_CONTEXT['mfs']['table']['rows'][$_CONTEXT['mfs']['currentrow']]['cells'] = array();
$_CONTEXT['mfs']['table']['rows'][$_CONTEXT['mfs']['currentrow']]['cells'][0] = array();
$_CONTEXT['mfs']['table']['rows'][$_CONTEXT['mfs']['currentrow']]['cells'][0]['class'] = "modleft";
$_CONTEXT['mfs']['table']['rows'][$_CONTEXT['mfs']['currentrow']]['cells'][0]['value'] = "hash algorithm";
$_CONTEXT['mfs']['table']['rows'][$_CONTEXT['mfs']['currentrow']]['cells'][1] = array();
$_CONTEXT['mfs']['table']['rows'][$_CONTEXT['mfs']['currentrow']]['cells'][1]['class'] = "modright";
$_CONTEXT['mfs']['table']['rows'][$_CONTEXT['mfs']['currentrow']]['cells'][1]['value'] = $_CONTEXT['thc_ct']['hashselect'].($_CONTEXT['thc_ct']['hashselect'][0]=="<" ? "<br />encryption algorithms specific to hash" : "");
$_CONTEXT['mfs']['currentrow']++;
$_CONTEXT['mfs']['table']['rows'][$_CONTEXT['mfs']['currentrow']] = array();
$_CONTEXT['mfs']['table']['rows'][$_CONTEXT['mfs']['currentrow']]['class'] = "modrow";
$_CONTEXT['mfs']['table']['rows'][$_CONTEXT['mfs']['currentrow']]['id'] = "initvector";
$_CONTEXT['mfs']['table']['rows'][$_CONTEXT['mfs']['currentrow']]['cells'] = array();
$_CONTEXT['mfs']['table']['rows'][$_CONTEXT['mfs']['currentrow']]['cells'][0] = array();
$_CONTEXT['mfs']['table']['rows'][$_CONTEXT['mfs']['currentrow']]['cells'][0]['class'] = "modleft";
$_CONTEXT['mfs']['table']['rows'][$_CONTEXT['mfs']['currentrow']]['cells'][0]['value'] = "vector";
$_CONTEXT['mfs']['table']['rows'][$_CONTEXT['mfs']['currentrow']]['cells'][1] = array();
$_CONTEXT['mfs']['table']['rows'][$_CONTEXT['mfs']['currentrow']]['cells'][1]['class'] = "modright";
$_CONTEXT['mfs']['table']['rows'][$_CONTEXT['mfs']['currentrow']]['cells'][1]['value'] = "<input type=\"text\" name=\"iVector\" class=\"vector\" /><br />initialization vector number of bytes";
$_CONTEXT['mfs']['currentrow']++;
$_CONTEXT['mfs']['table']['rows'][$_CONTEXT['mfs']['currentrow']] = array();
$_CONTEXT['mfs']['table']['rows'][$_CONTEXT['mfs']['currentrow']]['class'] = "modrow";
$_CONTEXT['mfs']['table']['rows'][$_CONTEXT['mfs']['currentrow']]['id'] = "binary";
$_CONTEXT['mfs']['table']['rows'][$_CONTEXT['mfs']['currentrow']]['cells'] = array();
$_CONTEXT['mfs']['table']['rows'][$_CONTEXT['mfs']['currentrow']]['cells'][0] = array();
$_CONTEXT['mfs']['table']['rows'][$_CONTEXT['mfs']['currentrow']]['cells'][0]['class'] = "modleft";
$_CONTEXT['mfs']['table']['rows'][$_CONTEXT['mfs']['currentrow']]['cells'][0]['value'] = "binary output";
$_CONTEXT['mfs']['table']['rows'][$_CONTEXT['mfs']['currentrow']]['cells'][1] = array();
$_CONTEXT['mfs']['table']['rows'][$_CONTEXT['mfs']['currentrow']]['cells'][1]['class'] = "modright";
$_CONTEXT['mfs']['table']['rows'][$_CONTEXT['mfs']['currentrow']]['cells'][1]['value'] = "<input type=\"checkbox\" name=\"iBinary\" class=\"binary\" /><br />output in binary format";
$_CONTEXT['mfs']['currentrow']++;
$_CONTEXT['mfs']['table']['rows'][$_CONTEXT['mfs']['currentrow']] = array();
$_CONTEXT['mfs']['table']['rows'][$_CONTEXT['mfs']['currentrow']]['class'] = "modrow";
$_CONTEXT['mfs']['table']['rows'][$_CONTEXT['mfs']['currentrow']]['id'] = "secret";
$_CONTEXT['mfs']['table']['rows'][$_CONTEXT['mfs']['currentrow']]['cells'] = array();
$_CONTEXT['mfs']['table']['rows'][$_CONTEXT['mfs']['currentrow']]['cells'][0] = array();
$_CONTEXT['mfs']['table']['rows'][$_CONTEXT['mfs']['currentrow']]['cells'][0]['class'] = "modleft";
$_CONTEXT['mfs']['table']['rows'][$_CONTEXT['mfs']['currentrow']]['cells'][0]['value'] = "secret key";
$_CONTEXT['mfs']['table']['rows'][$_CONTEXT['mfs']['currentrow']]['cells'][1] = array();
$_CONTEXT['mfs']['table']['rows'][$_CONTEXT['mfs']['currentrow']]['cells'][1]['class'] = "modright";
$_CONTEXT['mfs']['table']['rows'][$_CONTEXT['mfs']['currentrow']]['cells'][1]['value'] = "<input type=\"text\" name=\"sSecret\" class=\"secretkey\" placeholder=\"key\" /><br />string of characters [<a href=\"#\" class=\"generate\">generate</a>]";
$_CONTEXT['mfs']['currentrow']++;
$_CONTEXT['mfs']['table']['rows'][$_CONTEXT['mfs']['currentrow']] = array();
$_CONTEXT['mfs']['table']['rows'][$_CONTEXT['mfs']['currentrow']]['class'] = "modrow";
$_CONTEXT['mfs']['table']['rows'][$_CONTEXT['mfs']['currentrow']]['id'] = "mode";
$_CONTEXT['mfs']['table']['rows'][$_CONTEXT['mfs']['currentrow']]['cells'] = array();
$_CONTEXT['mfs']['table']['rows'][$_CONTEXT['mfs']['currentrow']]['cells'][0] = array();
$_CONTEXT['mfs']['table']['rows'][$_CONTEXT['mfs']['currentrow']]['cells'][0]['class'] = "modleft";
$_CONTEXT['mfs']['table']['rows'][$_CONTEXT['mfs']['currentrow']]['cells'][0]['value'] = "mode";
$_CONTEXT['mfs']['table']['rows'][$_CONTEXT['mfs']['currentrow']]['cells'][1] = array();
$_CONTEXT['mfs']['table']['rows'][$_CONTEXT['mfs']['currentrow']]['cells'][1]['class'] = "modright";
$_CONTEXT['mfs']['table']['rows'][$_CONTEXT['mfs']['currentrow']]['cells'][1]['value'] = $_CONTEXT['thc_ct']['mcryptmodestext']."<br />type of mcrypt mode";
$_CONTEXT['mfs']['currentrow']++;
$_CONTEXT['mfs']['table']['rows'][$_CONTEXT['mfs']['currentrow']] = array();
$_CONTEXT['mfs']['table']['rows'][$_CONTEXT['mfs']['currentrow']]['class'] = "modrow";
$_CONTEXT['mfs']['table']['rows'][$_CONTEXT['mfs']['currentrow']]['value'] = "<div class=\"modrowleft mt5\"><input type=\"submit\" name=\"submit\" class=\"encrypt\" value=\"Encrypt\" /> <input type=\"submit\" class=\"decrypt\" name=\"submit\" value=\"Decrypt\" /></div>";
// create output form
$sCode = ModForm($_CONTEXT['mfs']);
// js
$sCode .= "<script type=\"text/javascript\">\n";
$sCode .= "\$(document).ready(function(){\n";
$sCode .= "	\$(\".modrow#initvector\").hide();\n";
$sCode .= "	\$(\".modrow#secret\").hide();\n";
$sCode .= "	\$(\".modrow#openssl\").hide();\n";
$sCode .= "	\$(\".modrow#mcrypt\").hide();\n";
$sCode .= "	\$(\"input.decrypt\").hide();\n";
$sCode .= "	\$(\".modrow#hmac\").hide();\n";
$sCode .= "	\$(\".modrow#binary\").hide();\n";
$sCode .= "	\$(\".modrow#hash\").hide();\n";
$sCode .= "	\$(\".modrow#mode\").hide();\n";
$sCode .= "});\n";
$sCode .= "\$(\"select.algorithmselect\").change(function(e){\n";
$sCode .= "	e.preventDefault();\n";
$sCode .= "	if(\$(this).val()=='openssl'){\n";
$sCode .= "		\$(\".modrow#openssl\").show();\n";
$sCode .= "		\$(\".modrow#initvector\").show();\n";
$sCode .= "		\$(\".modrow#secret\").show();\n";
$sCode .= "		\$(\".modrow#mcrypt\").hide();\n";
$sCode .= "		\$(\".modrow#hmac\").hide();\n";
$sCode .= "		\$(\".modrow#binary\").hide();\n";
$sCode .= "		\$(\".modrow#hash\").hide();\n";
$sCode .= "		\$(\".modrow#mode\").hide();\n";
$sCode .= "	}\n";
$sCode .= "	else if(\$(this).val()=='hmac'){\n";
$sCode .= "		\$(\".modrow#secret\").show();\n";
$sCode .= "		\$(\".modrow#openssl\").hide();\n";
$sCode .= "		\$(\".modrow#initvector\").hide();\n";
$sCode .= "		\$(\".modrow#mcrypt\").hide();\n";
$sCode .= "		\$(\".modrow#hmac\").show();\n";
$sCode .= "		\$(\".modrow#binary\").show();\n";
$sCode .= "		\$(\".modrow#hash\").hide();\n";
$sCode .= "		\$(\".modrow#mode\").hide();\n";
$sCode .= "	}\n";
$sCode .= "	else if(\$(this).val()=='mcrypt'){\n";
$sCode .= "		if(\$('.modrow#mcrypt .modright').text().charAt(0)==='<'){\n";
$sCode .= "			\$(\".modrow#initvector\").show();\n";
$sCode .= "			\$(\".modrow#secret\").show();\n";
$sCode .= "		}\n";
$sCode .= "		\$(\".modrow#mode\").show();\n";
$sCode .= "		\$(\".modrow#mcrypt\").show();\n";
$sCode .= "		\$(\".modrow#openssl\").hide();\n";
$sCode .= "		\$(\".modrow#hmac\").hide();\n";
$sCode .= "		\$(\".modrow#binary\").hide();\n";
$sCode .= "		\$(\".modrow#hash\").hide();\n";
$sCode .= "	}\n";
$sCode .= "	else if(\$(this).val()=='hash'){\n";
$sCode .= "		\$(\".modrow#initvector\").hide();\n";
$sCode .= "		\$(\".modrow#secret\").hide();\n";
$sCode .= "		\$(\".modrow#mcrypt\").hide();\n";
$sCode .= "		\$(\".modrow#openssl\").hide();\n";
$sCode .= "		\$(\".modrow#hmac\").hide();\n";
$sCode .= "		\$(\".modrow#binary\").hide();\n";
$sCode .= "		\$(\".modrow#hash\").show();\n";
$sCode .= "		\$(\".modrow#mode\").hide();\n";
$sCode .= "	}\n";
$sCode .= "	else{\n";
$sCode .= "		\$(\".modrow#initvector\").hide();\n";
$sCode .= "		\$(\".modrow#secret\").hide();\n";
$sCode .= "		\$(\".modrow#mcrypt\").hide();\n";
$sCode .= "		\$(\".modrow#openssl\").hide();\n";
$sCode .= "		\$(\".modrow#hmac\").hide();\n";
$sCode .= "		\$(\".modrow#binary\").hide();\n";
$sCode .= "		\$(\".modrow#hash\").hide();\n";
$sCode .= "	}\n";
$sCode .= "});\n";
$sCode .= "\$(\"select.sslselect\").change(function(e){\n";
$sCode .= "	var selectedOption = \$(this).find(':selected');\n";
$sCode .= "	\$(\"input.vector\").val(selectedOption.attr('alt'));\n";
$sCode .= "});\n";
$sCode .= "\$('a.generate').click(function(){\n";
$sCode .= "	var characters = 'abcdefghijklmnopqrstuvwxyzABCDEFGHIJKLMNOPQRSTUVWXYZ0123456789 ';\n";
$sCode .= "	var result = '';\n";
$sCode .= "	for(var i=0;i<15;i++){\n";
$sCode .= "		var randomIndex = Math.floor(Math.random()*characters.length);\n";
$sCode .= "		result += characters[randomIndex];\n";
$sCode .= "	}\n";
$sCode .= "	\$('input.secretkey').val(result);\n";
$sCode .= "});\n";
$sCode .= "</script>\n";
?>