<?php
/*
Handler for xCrypt

ModGlue Variables:
$_CONTEXT['thc_ct']['opensslalgorithms']
$_CONTEXT['thc_ct']['mcryptalgorithms']
$_CONTEXT['thc_ct']['mcryptmodes']
$_CONTEXT['thc_ct']['result']
$_CONTEXT['thc_ct']['success']
$_CONTEXT['thc_ct']['searchlength']
$_CONTEXT['thc_ct']['hmacalgorithms']
$_CONTEXT['thc_ct']['hashalgorithms']

Author: Remco Kouw
Site: http://www.hacksuite.com
Last Edit: 14-10-2023
*/
$_MODULE_C = "thc_ct";
include_once("../../Includes/screen_header.php");
include_once($_PATHS['style_root']."/screen.php");
include_once($_PATHS['functions_root']."/scrn.php");
$_CONTEXT['thc_ct'] = array();
$_CONTEXT['thc_ct']['opensslalgorithms'] = $_PATHS['module_default_root']."/openssl.php";
$_CONTEXT['thc_ct']['mcryptalgorithms'] = $_PATHS['module_default_root']."/mcrypt.php";
$_CONTEXT['thc_ct']['mcryptmodes'] = $_PATHS['module_default_root']."/mcryptmodes.php";
// options
$sOptions = "<b>logging:</b> ".($_CONTEXT['log']==true ? "on" : "off")."<br>\n";
$sOptions .= "<b>silence:</b> ".($_CONTEXT['silent']==true ? "on" : "off")."<br>\n";
$sOptions .= "<b>verbose:</b> ".($_CONTEXT['verbose']==true ? "on" : "off")."\n";
$_CONTEXT['thc_ct']['result'] = "No search query was specified";
$_CONTEXT['thc_ct']['success'] = true;
$_POST['sText'] = !isset($_POST['sText']) ? "" : trim($_POST['sText']);
if(false!=($_CONTEXT['thc_ct']['searchlength'] = strlen($_POST['sText']))){
	if(isset($_POST['submit'])){
		echo Screen($sOut,$_CONTEXT['verbose'],$_CONTEXT['silent']);
		switch($_POST['submit']){
			/* Encrypt */
			case"Encrypt":
			switch($_POST['sAlgorithms']){
				/* md2 */
				case"md2":
				$_CONTEXT['thc_ct']['result'] = hash('md2',$_POST['sText']);
				break;
				/* md4 */
				case"md4":
				$_CONTEXT['thc_ct']['result'] = hash('md4',$_POST['sText']);
				break;
				/* md5 */
				case"md5":
				$_CONTEXT['thc_ct']['result'] = md5($_POST['sText']);
				break;
				/* sha1 */
				case"sha1":
				$_CONTEXT['thc_ct']['result'] = sha1($_POST['sText']);
				break;
				/* sha256 */
				case"sha256":
				$_CONTEXT['thc_ct']['result'] = hash('sha256',$_POST['sText']);
				break;
				/* urlencode */
				case"urlencode":
				$_CONTEXT['thc_ct']['result'] = urlencode($_POST['sText']);
				break;
				/* base64encode */
				case"base64_encode":
				$_CONTEXT['thc_ct']['result'] = base64_encode($_POST['sText']);
				break;
				/* crc32 */
				case"crc32":
				$_CONTEXT['thc_ct']['result'] = sprintf("%08x",crc32($_POST['sText']));
				break;
				/* hmac */
				case"hmac":
				$_CONTEXT['thc_ct']['hmacalgorithms'] = @hash_hmac_algos();
				if(!is_array($_CONTEXT['thc_ct']['hmacalgorithms'])){
					$_CONTEXT['thc_ct']['result'] = "No hmac algorithms found";
					$_CONTEXT['thc_ct']['success'] = false;
				}
				elseif(!in_array($_POST['sHMAC'],$_CONTEXT['thc_ct']['hmacalgorithms'])){
					$_CONTEXT['thc_ct']['result'] = "Algorithm is unknown";
					$_CONTEXT['thc_ct']['success'] = false;
				}
				else{
					if(strlen($_POST['sSecret'])==0){
						$_CONTEXT['thc_ct']['result'] = "No shared key has been specified";
						$_CONTEXT['thc_ct']['success'] = false;
					}
					else{
						if(isset($_POST['iBinary']) && $_POST['iBinary']==1){
							$_CONTEXT['thc_ct']['result'] = hash_hmac($_POST['sHMAC'],$_POST['sText'],$_POST['sSecret'],true);
						}
						else{
							$_CONTEXT['thc_ct']['result'] = hash_hmac($_POST['sHMAC'],$_POST['sText'],$_POST['sSecret']);
						}
						$_CONTEXT['thc_ct']['result'] = !$_CONTEXT['thc_ct']['result'] ? "Failed to encrypt message" : $_CONTEXT['thc_ct']['result'];
					}
				}
				break;
				/* hash */
				case"hash":
				$_CONTEXT['thc_ct']['hashalgorithms'] = @hash_algos();
				if(!is_array($_CONTEXT['thc_ct']['hashalgorithms'])){
					$_CONTEXT['thc_ct']['success'] = false;
					$_CONTEXT['thc_ct']['result'] = "No hash algorithms found";
				}
				elseif(!in_array($_POST['sHMAC'],$_CONTEXT['thc_ct']['hashalgorithms'])){
					$_CONTEXT['thc_ct']['success'] = false;
					$_CONTEXT['thc_ct']['result'] = "Algorithm is unknown";
				}
				else{
					$_CONTEXT['thc_ct']['result'] = hash($_POST['sHash'],$_POST['sText']);
					$_CONTEXT['thc_ct']['result'] = !$_CONTEXT['thc_ct']['result'] ? "Failed to encrypt message" : $_CONTEXT['thc_ct']['result'];
				}
				break;
				/* mcrypt */
				case"mcrypt":
				$_CONTEXT['algorithmfound'] = false;
				include($_CONTEXT['thc_ct']['mcryptalgorithms']);
				include($_CONTEXT['thc_ct']['mcryptmodes']);
				for($x=0;$x<count($_CONTEXT['algorithms_mcrypt']);$x++){
					if($_CONTEXT['algorithms_mcrypt'][$x][0]==$_POST['sCrypt']){
						$_CONTEXT['algorithmfound'] = true;
						$_CONTEXT['algorithmiv'] = $_CONTEXT['algorithms_mcrypt'][$x][1];
						break;
					}
				}
				if(!$_CONTEXT['algorithmfound']){
					$_CONTEXT['thc_ct']['success'] = false;
					$_CONTEXT['thc_ct']['result'] = "Unknown mCrypt algorithm specified";
				}
				else{
					if(!isset($_POST['sSecret']) || $_POST['sSecret']==""){
						$_CONTEXT['thc_ct']['success'] = false;
						$_CONTEXT['thc_ct']['result'] = "No secret key was specified";

					}
					else{
						if(!isset($_POST['iVector']) || $_POST['iVector']=="" || !is_numeric($_POST['iVector'])){
							$_POST['iVector'] = $_CONTEXT['algorithmiv'];
						}
						$_POST['iVector'] = intval($_POST['iVector']);
						if(!in_array($_POST['sMode'],$_CONTEXT['mcrypt_modes'])){
							$_CONTEXT['thc_ct']['success'] = false;
							$_CONTEXT['thc_ct']['result'] = "Invalid mCrypt mode";
						}
						else{
							$_CONTEXT['thc_ct']['result'] = mcrypt_encrypt($_POST['sCrypt'],$_POST['sSecret'],$_POST['sText'],$_POST['sMode'],$_POST['iVector']);
							$_CONTEXT['thc_ct']['result'] = !$_CONTEXT['thc_ct']['result'] ? "Failed to encrypt message" : $_CONTEXT['thc_ct']['result'];
						}
					}
				}
				break;
				/* openssl */
				case"openssl":
				$_CONTEXT['algorithmfound'] = false;
				include($_CONTEXT['thc_ct']['opensslalgorithms']);
				for($x=0;$x<count($_CONTEXT['algorithms_openssl']);$x++){
					if($_CONTEXT['algorithms_openssl'][$x][0]==$_POST['sOpenSSL']){
						$_CONTEXT['algorithmfound'] = true;
						$_CONTEXT['algorithmiv'] = $_CONTEXT['algorithms_openssl'][$x][1];
						break;
					}
				}
				if(!$_CONTEXT['algorithmfound']){
					$_CONTEXT['thc_ct']['success'] = false;
					$_CONTEXT['thc_ct']['result'] = "Unknown OpenSSL algorithm specified";
				}
				else{
					if(!isset($_POST['sSecret']) || $_POST['sSecret']==""){
						$_CONTEXT['thc_ct']['success'] = false;
						$_CONTEXT['thc_ct']['result'] = "No secret key was specified";
					}
					else{
						if(!isset($_POST['iVector']) || $_POST['iVector']=="" || !is_numeric($_POST['iVector'])){
							$_POST['iVector'] = $_CONTEXT['algorithmiv'];
						}
						$_POST['iVector'] = intval($_POST['iVector']);
						$_CONTEXT['thc_ct']['result'] = openssl_encrypt($_POST['sText'],$_POST['sOpenSSL'],$_POST['sSecret'],0,$_POST['iVector']);
						$_CONTEXT['thc_ct']['result'] = !$_CONTEXT['thc_ct']['result'] ? "Failed to encrypt message" : $_CONTEXT['thc_ct']['result'];
					}
				}
				break;
				default:
				die(Screen($sOut.$sOptions.$sEnd,$_CONTEXT['verbose'],$_CONTEXT['silent']));
			}
			break;
		}
		echo Screen($_CONTEXT['thc_ct']['result'],$_CONTEXT['verbose'],$_CONTEXT['silent']);
		echo Screen($sEnd,$_CONTEXT['verbose'],$_CONTEXT['silent']);
	}
	else{
		die(Screen($sOut.$sOptions.$sEnd,$_CONTEXT['verbose'],$_CONTEXT['silent']));
	}
}
elseif(!isset($_POST['submit'])){
	echo Screen($sOut.$sOptions.$sEnd,$_CONTEXT['verbose'],$_CONTEXT['silent']);
}
else{
	echo Screen($sOut.$_CONTEXT['thc_ct']['result'].$sEnd,$_CONTEXT['verbose'],$_CONTEXT['silent']);
}
?>