<?php
/* Searches for browsable directories */
if(!defined("IN_SCRIPT")){
	exit;
}
echo Screen("<br />\n<b>Searching browsable directories...</b><blockquote>\n",$_CONTEXT['verbose'],$_CONTEXT['silent']);
// we want robots.txt, but we won't have to get it if we already did
if(!isset($_CONTEXT['thc_ds']['browsedirs'])){
	// let's get the file
	$ch = curl_init();
	$_CONTEXT['thc_ds'][$aValues[2]]['target'] = $_CONTEXT['thc_ds']['host']."/robots.txt";
	curl_setopt($ch, CURLOPT_URL, $_CONTEXT['thc_ds'][$aValues[2]]['target']);
	curl_setopt($ch, CURLOPT_RETURNTRANSFER, true);
	curl_setopt($ch, CURLOPT_USERAGENT, 'Mozilla/5.0 (X11; U; Linux i686; en-US; rv:1.9.2.13) Gecko/20101506 Ubuntu/10.04 (lucid) Firefox/3.6.13 GTB7.1');
	$_CONTEXT['thc_ds'][$aValues[2]]['sourcedata'] = @curl_exec($ch);
	$_CONTEXT['thc_ds'][$aValues[2]]['http_response'] = @curl_getinfo($ch, CURLINFO_HTTP_CODE);
	curl_close($ch);
	if($_CONTEXT['thc_ds'][$aValues[2]]['http_response']==200){
		$_CONTEXT['thc_ds']['browsedirs'] = $_CONTEXT['thc_ds'][$aValues[2]]['sourcedata'];
	}
}
$_CONTEXT['thc_ds']['checkdirs'] = array();
// do we have the file content now?
if(isset($_CONTEXT['thc_ds']['browsedirs'])){
	preg_match_all("/Disallow: ([^\r\n]*)/",$_CONTEXT['thc_ds']['browsedirs'],$_CONTEXT['thc_ds']['results'],PREG_SET_ORDER);
	for($y=0;$y<count($_CONTEXT['thc_ds']['results']);$y++){
		// extract dirs
		if(strpos($_CONTEXT['thc_ds']['results'][$y][1],"?")===false && strpos($_CONTEXT['thc_ds']['results'][$y][1],".")===false){
			$_CONTEXT['thc_ds']['checkdirs'][] = str_replace("//","/",$_CONTEXT['thc_ds']['host']."/".$_CONTEXT['thc_ds']['results'][$y][1]);
		}
	}
}
else{
	echo Screen("<br />\n<b>Can't find robots.txt, trying to find folders on ".$_CONTEXT['thc_ds']['host']."</b><br />\n",$_CONTEXT['verbose'],$_CONTEXT['silent']);
	flush();
	ob_flush();
}
$_CONTEXT['thc_ds']['parsehtml2'] = array();
$oHTML = new DOMDocument();
@$oHTML->loadHTMLFile($_CONTEXT['thc_ds']['host']);
// images
foreach($oHTML->getElementsByTagName('img') as $oImages){
	$_CONTEXT['thc_ds']['parsehtml2'][] = $oImages->getAttribute('src');
}
// iframes
foreach($oHTML->getElementsByTagName('iframe') as $oIframes){
	$_CONTEXT['thc_ds']['parsehtml2'][] = $oIframes->getAttribute('src');
}
// embeds
foreach($oHTML->getElementsByTagName('embed') as $oEmbed){
	$_CONTEXT['thc_ds']['parsehtml2'][] = $oEmbed->getAttribute('src');
}
// scripts
foreach($oHTML->getElementsByTagName('script') as $oScript){
	$_CONTEXT['thc_ds']['parsehtml2'][] = $oScript->getAttribute('src');
}
// links
foreach($oHTML->getElementsByTagName('a') as $oHref){
	$_CONTEXT['thc_ds']['parsehtml2'][] = $oHref->getAttribute('href');
}
// parse all files
for($y=0;$y<count($_CONTEXT['thc_ds']['parsehtml2']);$y++){
	// absolute path
	$_CONTEXT['thc_ds']['urlparts'] = parse_url($_CONTEXT['thc_ds']['parsehtml2'][$y]);
	// is it the same host?
	if(isset($_CONTEXT['thc_ds']['urlparts']['host']) && "http://".$_CONTEXT['thc_ds']['urlparts']['host']!=$_CONTEXT['thc_ds']['host']){
		// nope, we're only interested in folders on this host
		continue;
	}
	if(substr($_CONTEXT['thc_ds']['parsehtml2'][$y],0,6)!="http://" || substr($_CONTEXT['thc_ds']['parsehtml2'][$y],0,7)!="https://"){
		if(!isset($_CONTEXT['thc_ds']['parsehtml2'][$y][0])){
			continue;
		}
		$_CONTEXT['thc_ds']['parsehtml2'][$y] = $_CONTEXT['thc_ds']['host'].($_CONTEXT['thc_ds']['parsehtml2'][$y][0]=="/" ? "" : "/").$_CONTEXT['thc_ds']['parsehtml2'][$y];
	}
	if($_CONTEXT['thc_ds']['parsehtml2'][$y]==$_CONTEXT['thc_ds']['host']){
		continue;
	}
	// does it have a path?
	$iPath = @strlen($_CONTEXT['thc_ds']['urlparts']['path']);
	if(!isset($_CONTEXT['thc_ds']['urlparts']['path']) || $iPath==1){
		// nope, we're interested in folders only
		continue;
	}
	// does it have a directory?
	if(0==($iPos = strrpos($_CONTEXT['thc_ds']['urlparts']['path'],"/"))){
		if(strpos($_CONTEXT['thc_ds']['urlparts']['path'],".")>0 || strpos($_CONTEXT['thc_ds']['urlparts']['path'],"?")>0){
			continue;
		}
		// single directory
		$_CONTEXT['thc_ds']['checkdirs'][] = $_CONTEXT['thc_ds']['host'].$_CONTEXT['thc_ds']['urlparts']['path'];
	}
	else{
		$_CONTEXT['thc_ds']['checkdirs'][] = $_CONTEXT['thc_ds']['host'].substr($_CONTEXT['thc_ds']['urlparts']['path'],0,$iPos);
	}
}
$_CONTEXT['thc_ds']['checkdirs'] = array_unique($_CONTEXT['thc_ds']['checkdirs']);
$_CONTEXT['thc_ds']['checkdirs'] = array_values($_CONTEXT['thc_ds']['checkdirs']);
$_CONTEXT['thc_ds']['browsable'] = 0;
$_CONTEXT['thc_ds']['browsablefolders'] = array();
for($y=0;$y<count($_CONTEXT['thc_ds']['checkdirs']);$y++){
	$_CONTEXT['thc_ds']['resultdirs'] = false;
	$iLen = strlen($_CONTEXT['thc_ds']['checkdirs'][$y]);
	$_CONTEXT['thc_ds']['checkdirs'][$y] = ($_CONTEXT['thc_ds']['checkdirs'][$y][$iLen-1]=="/" ? substr($_CONTEXT['thc_ds']['checkdirs'][$y],0,-1) : $_CONTEXT['thc_ds']['checkdirs'][$y]);
	$ch = curl_init();
	curl_setopt($ch, CURLOPT_URL, $_CONTEXT['thc_ds']['checkdirs'][$y]);
	curl_setopt($ch, CURLOPT_RETURNTRANSFER, true);
	curl_setopt($ch, CURLOPT_FOLLOWLOCATION, true);
	curl_setopt($ch, CURLOPT_USERAGENT, 'Mozilla/5.0 (X11; U; Linux i686; en-US; rv:1.9.2.13) Gecko/20101506 Ubuntu/10.04 (lucid) Firefox/3.6.13 GTB7.1');
	$_CONTEXT['thc_ds']['sourcedata'] = curl_exec($ch);
	curl_close($ch);
	$_CONTEXT['thc_ds']['folders'] = explode("/",$_CONTEXT['thc_ds']['checkdirs'][$y]);
	$_CONTEXT['thc_ds']['folder'] = "/".$_CONTEXT['thc_ds']['folders'][count($_CONTEXT['thc_ds']['folders'])-1];
	$_CONTEXT['thc_ds']['resultdirs'] = (strpos($_CONTEXT['thc_ds']['sourcedata'],"<title>Index of ".$_CONTEXT['thc_ds']['folder']."</title>")!=0 ? true : false);
	if($_CONTEXT['thc_ds']['resultdirs']){
		$_CONTEXT['thc_ds']['browsable']++;
		$_CONTEXT['thc_ds']['browsablefolders'][] = $_CONTEXT['thc_ds']['checkdirs'][$y];
		echo Screen("Folder: <a href=\"".$_CONTEXT['thc_ds']['checkdirs'][$y]."\" target=\"blank\">".$_CONTEXT['thc_ds']['folder']."</a> &gt; <b id=h6>BROWSABLE</b><br />\n",$_CONTEXT['verbose'],$_CONTEXT['silent']);
	}
	else{
		echo Screen("Folder: ".$_CONTEXT['thc_ds']['folder']." &gt; <b id=h7>NOT BROWSABLE</b><br />\n",$_CONTEXT['verbose'],$_CONTEXT['silent']);
	}
	flush();
	ob_flush();
}
echo Screen("<br />\n<b>Found ".count($_CONTEXT['thc_ds']['checkdirs'])." directories of which ".$_CONTEXT['thc_ds']['browsable']." is/are browsable</b>\n",$_CONTEXT['verbose'],$_CONTEXT['silent']);
echo Screen("</blockquote>\n",$_CONTEXT['verbose'],$_CONTEXT['silent']);
flush();
ob_flush();
?>