<?php
/* Enumerates usernames from a service

ModGlue Variables:
$_CONTEXT['thc_en']['enumerate_results_file']
$_CONTEXT['thc_en']['enumerate_users']
$_CONTEXT['thc_en']['existing_files']
$_CONTEXT['thc_en']['wordlist']
$_CONTEXT['thc_en']['users']
$_CONTEXT['thc_en']['userscount']
$_CONTEXT['thc_en']['port']
$_CONTEXT['thc_en']['template']
$_CONTEXT['thc_en']['enumerate_results']
$_CONTEXT['thc_en']['enumerate_results_count']
$_CONTEXT['thc_en']['update']
$_CONTEXT['thc_en']['record_number']
$_CONTEXT['thc_en']['valid_file']
$_CONTEXT['thc_en']['enumerate_file']
$_CONTEXT['thc_en']['enumerate_properties']['users']
$_CONTEXT['thc_en']['enumerated_accounts']
$_CONTEXT['thc_en']['enumerate_properties']['protocol']
$_CONTEXT['thc_en']['enumerate_properties']['host']
$_CONTEXT['thc_en']['enumerate_properties']['time']
$_CONTEXT['thc_en']['valid']
$_CONTEXT['thc_en']['templatenew']
$_CONTEXT['thc_en']['newfile']
$_CONTEXT['thc_en']['newfilepath']

Author: Remco Kouw
Site: http://www.hacksuite.com
Last Edit: 10-05-2024
*/
// set variable to be able to save a task
$_MODULE_C = "thc_en";
include_once("../../Includes/screen_header.php");
include_once($_PATHS['style_root']."/screen.php");
include_once($_PATHS['functions_root']."/scrn.php");
// sockets are required for this
if(!function_exists("socket_create")){
	die($sOut."This module requires sockets to be enabled. You can open your php.ini file and uncomment the socket extension(remove semicolon), save and restart your server.");
}
if(!function_exists("WriteF")){
	include_once($_PATHS['functions_root']."/fwrite.php");
}
$_CONTEXT['thc_en'] = array();
// options
$sOptions = "<b>logging:</b> ".($_CONTEXT['log']==true ? "on" : "off")."<br>\n";
$sOptions .= "<b>silence:</b> ".($_CONTEXT['silent']==true ? "on" : "off")."<br>\n";
$sOptions .= "<b>verbose:</b> ".($_CONTEXT['verbose']==true ? "on" : "off")."\n";
// enumeration results file
$_CONTEXT['thc_en']['enumerate_results_file'] = $_PATHS['module_default_root']."/enumerations.php";
if(isset($_POST['submit'])){
	switch($_POST['submit']){
		// enumerate users
		case"Enumerate":
		// get all usernames
		if(isset($_POST['sEnumerateUsers'])){
			// get users from manually specified string
			if($_POST['sEnumerateUsers']!=""){
				$_CONTEXT['thc_en']['enumerate_users'] = explode(",",$_POST['sEnumerateUsers']);
			}
			else{
				die(Screen($sOut."No usernames specified.",$_CONTEXT['verbose'],$_CONTEXT['silent']));
			}
		}
		elseif(isset($_POST['sWordlist'])){
			// get users froma  wordlist
			if(!function_exists("GetFilesByDirectory")){
				include($_PATHS['functions_root']."/getfilebydir.php");
			}
			if(false==($_CONTEXT['thc_en']['existing_files'] = GetFilesByDirectory($_PATHS['wordlist_root']))){
				die(Screen($sOut."No files found.",$_CONTEXT['verbose'],$_CONTEXT['silent']));
			}
			else{
				if(!in_array($_POST['sWordlist'],$_CONTEXT['thc_en']['existing_files'])){
					die(Screen($sOut."File doesn't exist.",$_CONTEXT['verbose'],$_CONTEXT['silent']));
				}
				else{
					$_CONTEXT['thc_en']['wordlist'] = $_PATHS['wordlist_root']."/".$_POST['sWordlist'];
					$_CONTEXT['thc_en']['enumerate_users'] = @file($_CONTEXT['thc_en']['wordlist']);
				}
			}
		}
		// filter usernames
		$_CONTEXT['thc_en']['users'] = array();
		for($x=0;$x<count($_CONTEXT['thc_en']['enumerate_users']);$x++){
			$_CONTEXT['thc_en']['enumerate_users'][$x] = @trim($_CONTEXT['thc_en']['enumerate_users'][$x]);
			if(!$_CONTEXT['thc_en']['enumerate_users'][$x] || $_CONTEXT['thc_en']['enumerate_users'][$x]==""){
				continue;
			}
			$_CONTEXT['thc_en']['users'][] = $_CONTEXT['thc_en']['enumerate_users'][$x];
		}
		if(false==($_CONTEXT['thc_en']['userscount'] = @count($_CONTEXT['thc_en']['users']))){
			die(Screen($sOut."No valid users specified",$_CONTEXT['verbose'],$_CONTEXT['silent']));
		}
		// validate port number
		$_CONTEXT['thc_en']['port'] = @intval($_POST['iPort']);
		if($_CONTEXT['thc_en']['port']<1 || $_CONTEXT['thc_en']['port']>65535){
			die(Screen($sOut."Invalid port specified",$_CONTEXT['verbose'],$_CONTEXT['silent']));
		}
		include($_PATHS['includes_root']."/task_start.php");
		echo Screen($sOut,$_CONTEXT['verbose'],$_CONTEXT['silent']);
		break;
		// remove file
		case"Remove File":
		@include($_CONTEXT['thc_en']['enumerate_results_file']);
		echo Screen($sOut,$_CONTEXT['verbose'],$_CONTEXT['silent']);
		// set template for enumeration data
		$_CONTEXT['thc_en']['template'] = "<?php\n/* Enumeration results for THC_EN\n\nAuthor: Remco Kouw\nSite: http://www.hacksuite.com\nLast Edit: ".date($_CONTEXT['time_pattern'],time())."\n*/\nif(!defined('IN_SCRIPT')){\n\texit;\n}\n\$_CONTEXT['thc_en']['enumerate_results'] = array();\n";
		$_CONTEXT['thc_en']['enumerate_results_count'] = @count($_CONTEXT['thc_en']['enumerate_results']);
		$_CONTEXT['thc_en']['update'] = false;
		$_CONTEXT['thc_en']['record_number'] = 0;
		if($_CONTEXT['thc_en']['enumerate_results_count']!=0){
			// add old records
			for($x=0;$x<$_CONTEXT['thc_en']['enumerate_results_count'];$x++){
				if($_CONTEXT['thc_en']['enumerate_results'][$x]['filename']==$_POST['sEnumerateResults']){
					$_CONTEXT['thc_en']['update'] = true;
					continue;
				}
				$_CONTEXT['thc_en']['template'] .= "\$_CONTEXT['thc_en']['enumerate_results'][".$_CONTEXT['thc_en']['record_number']."] = array();\n";
				$_CONTEXT['thc_en']['template'] .= "\$_CONTEXT['thc_en']['enumerate_results'][".$_CONTEXT['thc_en']['record_number']."]['host'] = \"".$_CONTEXT['thc_en']['enumerate_results'][$x]['host']."\";\n";
				$_CONTEXT['thc_en']['template'] .= "\$_CONTEXT['thc_en']['enumerate_results'][".$_CONTEXT['thc_en']['record_number']."]['protocol'] = \"".$_CONTEXT['thc_en']['enumerate_results'][$x]['protocol']."\";\n";
				$_CONTEXT['thc_en']['template'] .= "\$_CONTEXT['thc_en']['enumerate_results'][".$_CONTEXT['thc_en']['record_number']."]['time'] = \"".$_CONTEXT['thc_en']['enumerate_results'][$x]['time']."\";\n";
				$_CONTEXT['thc_en']['template'] .= "\$_CONTEXT['thc_en']['enumerate_results'][".$_CONTEXT['thc_en']['record_number']."]['filename'] = \"".$_CONTEXT['thc_en']['enumerate_results'][$x]['filename']."\";\n";
				$_CONTEXT['thc_en']['record_number']++;
			}
		}
		else{
			die(Screen("No records present in <b>".$_CONTEXT['thc_en']['enumerate_results']."</b>",$_CONTEXT['verbose'],$_CONTEXT['silent']));
		}
		if($_CONTEXT['thc_en']['update']){
			@unlink($_PATHS['module_default_root']."/results/".$_POST['sEnumerateResults']);
			if(!WriteF($_CONTEXT['thc_en']['enumerate_results_file'],$_CONTEXT['thc_en']['template']."?>","w")){
				die(Screen("Failed to update enumeration file",$_CONTEXT['verbose'],$_CONTEXT['silent']));
			}
			else{
				die(Screen("Successfully removed file properties",$_CONTEXT['verbose'],$_CONTEXT['silent']));
			}
		}
		else{
			die(Screen("Specified file properties don't exist",$_CONTEXT['verbose'],$_CONTEXT['silent']));
		}
		exit;
		break;
		// dump of open ports on hosts
		case"View File":
		echo Screen($sOut,$_CONTEXT['verbose'],$_CONTEXT['silent']);
		@include($_CONTEXT['thc_en']['enumerate_results_file']);
		if(!isset($_CONTEXT['thc_en']['enumerate_results'][0])){
			die(Screen("No records found in <b>".$_CONTEXT['thc_en']['enumerate_results']."</b>",$_CONTEXT['verbose'],$_CONTEXT['silent']));
		}
		$_CONTEXT['thc_en']['valid_file'] = false;
		$_CONTEXT['thc_en']['enumerate_properties'] = array();
		for($x=0;$x<count($_CONTEXT['thc_en']['enumerate_results']);$x++){
			// get enumeration properties
			if($_CONTEXT['thc_en']['enumerate_results'][$x]['filename']==$_POST['sEnumerateResults']){
				$_CONTEXT['thc_en']['valid_file'] = true;
				$_CONTEXT['thc_en']['enumerate_file'] = $_PATHS['module_default_root']."/results/".$_POST['sEnumerateResults'];
				$_CONTEXT['thc_en']['enumerate_properties'] = $_CONTEXT['thc_en']['enumerate_results'][$x];
				$_CONTEXT['thc_en']['enumerate_properties']['users'] = json_decode(file_get_contents($_CONTEXT['thc_en']['enumerate_file']),true);
				break;
			}
		}
		if($_CONTEXT['thc_en']['valid_file']){
			// dump enumeration properties
			$_CONTEXT['thc_en']['enumerated_accounts'] = implode(", ",$_CONTEXT['thc_en']['enumerate_properties']['users']);
		 	echo"<table border=\"0\" cellspacing=\"3\" cellpadding=\"3\">\n";
		 	echo"<tr><th>protocol</th><th>host</th><th>users</th><th>time</th></tr>\n";
			echo"<tr><td>".$_CONTEXT['thc_en']['enumerate_properties']['protocol']."</td><td>".$_CONTEXT['thc_en']['enumerate_properties']['host']."</td><td>".($_CONTEXT['thc_en']['enumerated_accounts']!="" ? $_CONTEXT['thc_en']['enumerated_accounts'] : "no enumerated accounts")."</td><td>".date($_CONTEXT['time_pattern'].' H:i:s',$_CONTEXT['thc_en']['enumerate_properties']['time'])."</td></tr>\n";
		 	echo"</table>\n";
		}
		else{
			die(Screen("No properties found for the specified file",$_CONTEXT['verbose'],$_CONTEXT['silent']));
		}
		echo Screen($sEnd,$_CONTEXT['verbose'],$_CONTEXT['silent']);
		exit;
		break;
		// just show index
		default:
		die(Screen($sOut.$sOptions.$sEnd,$_CONTEXT['verbose'],$_CONTEXT['silent']));
	}
}
else{
	die(Screen($sOut.$sOptions.$sEnd,$_CONTEXT['verbose'],$_CONTEXT['silent']));
}
$_CONTEXT['thc_en']['valid'] = array();
// let's enumerate the target
$_CONTEXT['thc_en']['templatenew'] = "";
echo Screen("<br />\n<b>Running..</b><p>\n",$_CONTEXT['verbose'],$_CONTEXT['silent']);
// spit fire...
flush();
ob_flush();
switch($_POST['sType']){
	/* smtp enumeration */
	case"smtp":
	include($_PATHS['module_default_root']."/protocols/smtp.php");
	break;
	/* ftp enumeration */
	case"ftp":
	include($_PATHS['module_default_root']."/protocols/ftp.php");
	break;
	default:
	include($_PATHS['includes_root']."/task_end.php");
	die(Screen("<p>Protocol not supported</p>\n".$sEnd,$_CONTEXT['verbose'],$_CONTEXT['silent']));
}
// write valid data $aValid wordt context valid users
$_CONTEXT['thc_en']['newfile'] = time()."-".substr(md5(mt_rand(0,1000)),0,mt_rand(5,9)).".php";
$_CONTEXT['thc_en']['newfilepath'] = $_PATHS['module_default_root']."/results/".$_CONTEXT['thc_en']['newfile'];
if(!WriteF($_CONTEXT['thc_en']['newfilepath'],json_encode($_CONTEXT['thc_en']['valid']),"w")){
	echo Screen("<p>Failed to write enumerated users to <b>results/".$_CONTEXT['thc_en']['newfile']."</b></p>\n",$_CONTEXT['verbose'],$_CONTEXT['silent']);
}
else{
	// if file was successfully created, make a new template
	$_CONTEXT['thc_en']['template'] = "<?php\n/* Enumeration results for THC_EN\n\nAuthor: Remco Kouw\nSite: http://www.hacksuite.com\nLast Edit: ".date($_CONTEXT['time_pattern'],time())."\n*/\nif(!defined('IN_SCRIPT')){\n\texit;\n}\n\$_CONTEXT['thc_en']['enumerate_results'] = array();\n";
	@include($_CONTEXT['thc_en']['enumerate_results_file']);
	$_CONTEXT['thc_en']['enumerate_results_count'] = @count($_CONTEXT['thc_en']['enumerate_results']);
	if($_CONTEXT['thc_en']['enumerate_results_count']!=0){
		// add old records
		for($x=0;$x<$_CONTEXT['thc_en']['enumerate_results_count'];$x++){
			$_CONTEXT['thc_en']['template'] .= "\$_CONTEXT['thc_en']['enumerate_results'][".$x."] = array();\n";
			$_CONTEXT['thc_en']['template'] .= "\$_CONTEXT['thc_en']['enumerate_results'][".$x."]['host'] = \"".$_CONTEXT['thc_en']['enumerate_results'][$x]['host']."\";\n";
			$_CONTEXT['thc_en']['template'] .= "\$_CONTEXT['thc_en']['enumerate_results'][".$x."]['protocol'] = \"".$_CONTEXT['thc_en']['enumerate_results'][$x]['protocol']."\";\n";
			$_CONTEXT['thc_en']['template'] .= "\$_CONTEXT['thc_en']['enumerate_results'][".$x."]['time'] = \"".$_CONTEXT['thc_en']['enumerate_results'][$x]['time']."\";\n";
			$_CONTEXT['thc_en']['template'] .= "\$_CONTEXT['thc_en']['enumerate_results'][".$x."]['filename'] = \"".$_CONTEXT['thc_en']['enumerate_results'][$x]['filename']."\";\n";
		}
	}
	$_CONTEXT['thc_en']['templatenew'] .= "\$_CONTEXT['thc_en']['enumerate_results'][".$_CONTEXT['thc_en']['enumerate_results_count']."] = array();\n";
	$_CONTEXT['thc_en']['templatenew'] .= "\$_CONTEXT['thc_en']['enumerate_results'][".$_CONTEXT['thc_en']['enumerate_results_count']."]['host'] = \"".$_POST['sInput']."\";\n";
	$_CONTEXT['thc_en']['templatenew'] .= "\$_CONTEXT['thc_en']['enumerate_results'][".$_CONTEXT['thc_en']['enumerate_results_count']."]['protocol'] = \"".$_POST['sType']."\";\n";
	$_CONTEXT['thc_en']['templatenew'] .= "\$_CONTEXT['thc_en']['enumerate_results'][".$_CONTEXT['thc_en']['enumerate_results_count']."]['time'] = \"".$_CONTEXT['start_task']."\";\n";
	$_CONTEXT['thc_en']['templatenew'] .= "\$_CONTEXT['thc_en']['enumerate_results'][".$_CONTEXT['thc_en']['enumerate_results_count']."]['filename'] = \"".$_CONTEXT['thc_en']['newfile']."\";\n";
	if(!WriteF($_CONTEXT['thc_en']['enumerate_results_file'],$_CONTEXT['thc_en']['template'].$_CONTEXT['thc_en']['templatenew']."?>","w")){
		echo Screen("<p>Failed to update enumeration data file</p>\n",$_CONTEXT['verbose'],$_CONTEXT['silent']);
	}
}
// update entry in background task file
include($_PATHS['includes_root']."/task_end.php");
echo Screen($sEnd,$_CONTEXT['verbose'],$_CONTEXT['silent']);
?>
