<?php
/* Windows IIS Check - web.config file

Author: Remco Kouw
Site: http://www.hacksuite.com
Last Edit: 15-08-2024
*/
if(!defined("IN_SCRIPT")){
	exit;
}
$_CONTEXT['thc_hf']['winiis'] = array();
$_CONTEXT['thc_hf']['winiis'][0] = array("Check if Output Caching is disabled for sensitive content","//system.webServer/caching[@enabled='false']");
$_CONTEXT['thc_hf']['winiis'][1] = array("Check if X-Content-Type-Options header is set","//system.webServer/httpProtocol/customHeaders/add[@name='X-Content-Type-Options' and @value='nosniff']");
$_CONTEXT['thc_hf']['winiis'][2] = array("Check if X-Frame-Options header is set","//system.webServer/httpProtocol/customHeaders/add[@name='X-Frame-Options' and @value='SAMEORIGIN']");
$_CONTEXT['thc_hf']['winiis'][3] = array("Check if X-XSS-Protection header is set","//system.webServer/httpProtocol/customHeaders/add[@name='X-XSS-Protection' and @value='1; mode=block']");
$_CONTEXT['thc_hf']['winiis'][4] = array("Check if Content Security Policy (CSP) is set","//system.webServer/httpProtocol/customHeaders/add[@name='Content-Security-Policy']");
$_CONTEXT['thc_hf']['winiis'][5] = array("Check if HTTP Strict Transport Security (HSTS) is enabled","//system.webServer/httpProtocol/customHeaders/add[@name='Strict-Transport-Security' and contains(@value, 'max-age')]");
?>