<?php
/*
Handler for THC HostFortification

ModGlue Variables:
$_CONTEXT['thc_hf']['os_details']
$_CONTEXT['thc_hf']['server_details']
$_CONTEXT['thc_hf']['completed_successfully']
$_CONTEXT['thc_hf']['os']
$_CONTEXT['thc_hf']['server']
$_CONTEXT['thc_hf']['platform']
$_CONTEXT['thc_hf']['server_settings']
$_CONTEXT['thc_hf']['files_found']
$_CONTEXT['thc_hf']['files_required']
$_CONTEXT['thc_hf']['results']
$_CONTEXT['thc_hf']['files_temp']
$_CONTEXT['thc_hf']['files_found_amount']
$_CONTEXT['thc_hf']['configkey']

Author: Remco Kouw
Site: http://www.hacksuite.com
Last Edit: 16-08-2024
*/
$_MODULE_C = "thc_hf";
$_CONTEXT['thc_hf'] = array();
include_once("../../Includes/screen_header.php");
include_once($_PATHS['style_root']."/screen.php");
include_once($_PATHS['functions_root']."/scrn.php");
// options
$sOptions = "<b>logging:</b> ".($_CONTEXT['log']==true ? "on" : "off")."<br>\n";
$sOptions .= "<b>silence:</b> ".($_CONTEXT['silent']==true ? "on" : "off")."<br>\n";
$sOptions .= "<b>verbose:</b> ".($_CONTEXT['verbose']==true ? "on" : "off")."\n";
if(!isset($_POST['submit'])){
	die(Screen($sOut.$sOptions.$sEnd,$_CONTEXT['verbose'],$_CONTEXT['silent']));
}
// determine os and software
$_CONTEXT['thc_hf']['os_details'] = php_uname('s');
$_CONTEXT['thc_hf']['server_details'] = $_SERVER['SERVER_SOFTWARE'];
$sDest = $_PATHS['module_default_root']."/determine.php";
$_CONTEXT['thc_hf']['completed_successfully'] = false;
(!IsThere($sDest) ? include_once($_PATHS['end']) : include_once($sDest));
if($_CONTEXT['thc_hf']['os_details']==$_CONTEXT['thc_hf']['os'] || $_CONTEXT['thc_hf']['server_details']==$_CONTEXT['thc_hf']['server']){
	die(Screen($sOut."<b id=h7>Failed to determine os or server software</b>".$sEnd,$_CONTEXT['verbose'],$_CONTEXT['silent']));
}
// check if configuration file is present
$sDest = $_PATHS['module_default_root']."/servers.php";
(!IsThere($sDest) ? include_once($_PATHS['end']) : include_once($sDest));
// make sure we have settings for this option
if(!isset($_CONTEXT['thc_hf']['platform'][$_CONTEXT['thc_hf']['os']][$_CONTEXT['thc_hf']['server']])){
	die(Screen($sOut."<b id=h7>Option isn't configured</b>".$sEnd,$_CONTEXT['verbose'],$_CONTEXT['silent']));
}
// get all the settings for each file
$_CONTEXT['thc_hf']['server_settings'] = $_CONTEXT['thc_hf']['platform'][$_CONTEXT['thc_hf']['os']][$_CONTEXT['thc_hf']['server']];
$_CONTEXT['thc_hf']['files_found'] = array();
$_CONTEXT['thc_hf']['files_required'] = count($_CONTEXT['thc_hf']['server_settings'][0]['application_host_folder']);
$_CONTEXT['thc_hf']['results'] = array();
// combine the settings for file locations that have been successfully validated
for($x=0;$x<count($_CONTEXT['thc_hf']['server_settings']);$x++){
	for($y=0;$y<$_CONTEXT['thc_hf']['files_required'];$y++){
		$_CONTEXT['thc_hf']['files_temp'] = $_CONTEXT['thc_hf']['server_settings'][$x]['application_host_folder'][$y].$_CONTEXT['thc_hf']['server_settings'][$x]['application_host_filename'];
		if(file_exists($_CONTEXT['thc_hf']['files_temp'])){
			//die(var_dump($_CONTEXT['thc_hf']['server_settings']));
			$_CONTEXT['thc_hf']['files_found'][] = array($_CONTEXT['thc_hf']['server_settings'][$x]['validationfile'],$_CONTEXT['thc_hf']['files_temp'],$_CONTEXT['thc_hf']['server_settings'][$x]['xml']);
			break;
		}
	}
}
if(false==($_CONTEXT['thc_hf']['files_found_amount'] = count($_CONTEXT['thc_hf']['files_found']))){
	die(Screen($sOut."<b id=h7>Failed to find any of the required files</b>".$sEnd,$_CONTEXT['verbose'],$_CONTEXT['silent']));
}
// run assessment files
echo Screen($sOut,$_CONTEXT['verbose'],$_CONTEXT['silent']);
for($x=0;$x<$_CONTEXT['thc_hf']['files_found_amount'];$x++){
	include($_PATHS['module_default_root']."/plugins/".$_CONTEXT['thc_hf']['files_found'][$x][0]);
	if($_CONTEXT['thc_hf']['files_found'][$x][2]==1){
		// xml output
		$oFileData = @simplexml_load_file($_CONTEXT['thc_hf']['files_found'][$x][1]);
		for($y=0;$y<count($_CONTEXT['thc_hf'][$_CONTEXT['thc_hf']['configkey']]);$y++){
			$_CONTEXT['thc_hf']['results'][] = (!empty($oFileData->xpath($_CONTEXT['thc_hf'][$_CONTEXT['thc_hf']['configkey']][$y][1])) ? "<b id=h6>" : "<b id=h7>").$_CONTEXT['thc_hf'][$_CONTEXT['thc_hf']['configkey']][$y][0]."</b>";
		}
	}
	else{
		// regular plain text
		$sFileData = file_get_contents($_CONTEXT['thc_hf']['files_found'][$x][1]);
		for($y=0;$y<count($_CONTEXT['thc_hf'][$_CONTEXT['thc_hf']['configkey']]);$y++){
			$_CONTEXT['thc_hf']['results'][] = ((strpos($sFileData,$_CONTEXT['thc_hf'][$_CONTEXT['thc_hf']['configkey']][$y][1])!==false) ? "<b id=h6>" : "<b id=h7>").$_CONTEXT['thc_hf'][$_CONTEXT['thc_hf']['configkey']][$y][0]."</b>";
		}
	}
}
$_CONTEXT['thc_hf']['completed_successfully'] = true;
echo Screen(implode("<br />",$_CONTEXT['thc_hf']['results']),$_CONTEXT['verbose'],$_CONTEXT['silent']).$sEnd;
?>