<?php
/*
Handler for xIF

ModGlue Variables:
$_CONTEXT['thc_if']['imagefolder']
$_CONTEXT['thc_if']['testimagefolder']
$_CONTEXT['thc_if']['exiftypes']
$_CONTEXT['thc_if']['exiftypesstring']
$_CONTEXT['thc_if']['search']
$_CONTEXT['thc_if']['string']
$_CONTEXT['thc_if']['regex']
$_CONTEXT['thc_if']['gps']
$_CONTEXT['thc_if']['data']
$_CONTEXT['thc_if']['imagesinfolder']
$_CONTEXT['thc_if']['imagesinfoldercount']
$_CONTEXT['thc_if']['lastfound']
$_CONTEXT['thc_if']['lastimage']
$_CONTEXT['thc_if']['lastexif']
$_CONTEXT['thc_if']['lastfoundcount']

Author: Remco Kouw
Site: http://www.hacksuite.com
Last Edit: 23-05-2024
*/
set_time_limit(0);
$_MODULE_C = "thc_if";
include_once("../../Includes/screen_header.php");
include_once($_PATHS['style_root']."/screen.php");
include_once($_PATHS['functions_root']."/scrn.php");
$_CONTEXT['thc_if'] = array();
$_CONTEXT['thc_if']['imagefolder'] = $_PATHS['module_default_root']."/images";
$_CONTEXT['thc_if']['testimagefolder'] = !isset($_POST['sFolder']) || $_POST['sFolder']=="" ? false : $_CONTEXT['thc_if']['imagefolder']."/".$_POST['sFolder'];
$_CONTEXT['thc_if']['exiftypes'] = array("jpg","jpeg","raw","tif");
$_CONTEXT['thc_if']['exiftypesstring'] = implode(",",$_CONTEXT['thc_if']['exiftypes']);
// options
$sOptions = "<b>logging:</b> ".($_CONTEXT['log']==true ? "on" : "off")."<br>\n";
$sOptions .= "<b>silence:</b> ".($_CONTEXT['silent']==true ? "on" : "off")."<br>\n";
$sOptions .= "<b>verbose:</b> ".($_CONTEXT['verbose']==true ? "on" : "off")."\n";
if(!function_exists("GetFilesByDirectory")){
	$sDest = $_PATHS['functions_root']."/getfilebydir.php";
	(!IsThere($sDest) ? include_once($_PATHS['end']) : include_once($sDest));
}
echo Screen($sOut,$_CONTEXT['verbose'],$_CONTEXT['silent']);
if(isset($_POST['submit'])){
	switch($_POST['submit']){
		/* search */
		case"Search":
		if(!file_exists($_CONTEXT['thc_if']['testimagefolder']) && is_dir($_CONTEXT['thc_if']['testimagefolder'])){
			die(Screen("Folder doesn't exist",$_CONTEXT['verbose'],$_CONTEXT['silent']));
		}
		else{
			if(isset($_POST['iType'])){
				$_CONTEXT['thc_if']['search'] = false;
				$_CONTEXT['thc_if']['string'] = false;
				$_CONTEXT['thc_if']['regex'] = false;
				$_CONTEXT['thc_if']['gps'] = false;
				$_CONTEXT['thc_if']['data'] = false;
				if($_POST['iType']==="0"){
					// search specific text in images
					$_CONTEXT['thc_if']['search'] = true;
					if(!isset($_POST['sSearch']) || $_POST['sSearch']==""){
						die(Screen("No search term specified",$_CONTEXT['verbose'],$_CONTEXT['silent']));
					}
					else{
						$_POST['sSearch'] = trim($_POST['sSearch']);
						if(isset($_POST['iRegex']) && $_POST['iRegex']==1){
							if(!preg_match('/^\/.*[sui]?$/',$_POST['sSearch'])){
								die(Screen("You need to input a valid regular expression that looks like /pattern/",$_CONTEXT['verbose'],$_CONTEXT['silent']));
							}
							$_CONTEXT['thc_if']['regex'] = true;
						}
						$_CONTEXT['thc_if']['string'] = $_POST['sSearch'];
					}
				}
				elseif($_POST['iType']==1){
					// dump gps coordinates data
					$_CONTEXT['thc_if']['gps'] = true;
					function FormatGPS($aGPS) {
						$dDegrees = floatval($aGPS[0]);
						$dMinutes = floatval($aGPS[1]);
						$dSeconds = floatval($aGPS[2]);
						return(($dDegrees+($dMinutes/60)+($dSeconds/3600)));
					}
				}
				elseif($_POST['iType']==2){
					// dump metata data from images
					$_CONTEXT['thc_if']['data'] = true;
				}
				else{
					// invalid action
					die(Screen("Invalid action has been specified",$_CONTEXT['verbose'],$_CONTEXT['silent']));
				}
				include($_PATHS['includes_root']."/task_start.php");
				echo Screen($sOut,$_CONTEXT['verbose'],$_CONTEXT['silent']);
				echo Screen("<br>\n<b>Running..</b><p>\n",$_CONTEXT['verbose'],$_CONTEXT['silent']);
				// spit fire...
				flush();
				ob_flush();
				echo Screen("<b>Opening folder ".$_CONTEXT['thc_if']['testimagefolder'].":</b><br />\n",$_CONTEXT['verbose'],$_CONTEXT['silent']);
				flush();
				ob_flush();
				$_CONTEXT['thc_if']['imagesinfolder'] = glob($_CONTEXT['thc_if']['testimagefolder']."/*.{".$_CONTEXT['thc_if']['exiftypesstring']."}",GLOB_BRACE);
				$_CONTEXT['thc_if']['imagesinfoldercount'] = count($_CONTEXT['thc_if']['imagesinfolder']);
				echo Screen("<b>Found ".$_CONTEXT['thc_if']['imagesinfoldercount']." file".($_CONTEXT['thc_if']['imagesinfoldercount']!=1 ? "s" : "")." matching ".$_CONTEXT['thc_if']['exiftypesstring']." extension:</b><br>\n",$_CONTEXT['verbose'],$_CONTEXT['silent']);
				if($_CONTEXT['thc_if']['imagesinfoldercount']==0){
					include($_PATHS['includes_root']."/task_end.php");
					die(Screen("<p><b>No images that match allowed extensions</b></p>\n",$_CONTEXT['verbose'],$_CONTEXT['silent']));
				}
				// go through files that may potentially contain exif data
				for($x=0;$x<$_CONTEXT['thc_if']['imagesinfoldercount'];$x++){
					// found exif data
					$_CONTEXT['thc_if']['lastfound'] = array();
					$_CONTEXT['thc_if']['lastimage'] = $_CONTEXT['thc_if']['imagesinfolder'][$x];
					echo Screen("<br />\nreading ".substr($_CONTEXT['thc_if']['lastimage'],strlen($_CONTEXT['thc_if']['testimagefolder'])).": ",$_CONTEXT['verbose'],$_CONTEXT['silent']);
					if($_CONTEXT['thc_if']['search']){
						$_CONTEXT['thc_if']['lastexif'] = @exif_read_data($_CONTEXT['thc_if']['lastimage']);
						foreach($_CONTEXT['thc_if']['lastexif'] as $sKey=>$mValue){
							if(is_array($mValue)){
								$mValue = implode(",",$mValue);
							}
							if(!$_CONTEXT['thc_if']['regex']){
								$iPos = strpos($mValue,$_CONTEXT['thc_if']['string']);
								if(is_string($mValue) && $iPos!==false){
									$_CONTEXT['thc_if']['lastfound'][] = $mValue;
								}
							}
							else{
								if(is_string($mValue) && preg_match($_CONTEXT['thc_if']['string'],$mValue)){
									$_CONTEXT['thc_if']['lastfound'][] = $mValue;
								}
							}
						}
					}
					elseif($_CONTEXT['thc_if']['gps']){
						$_CONTEXT['thc_if']['lastexif'] = @exif_read_data($_CONTEXT['thc_if']['lastimage'],'GPS');
						if(!empty($_CONTEXT['thc_if']['lastexif']['GPSLatitude']) && !empty($_CONTEXT['thc_if']['lastexif']['GPSLongitude'])){
							$aLatitude = $_CONTEXT['thc_if']['lastexif']['GPSLatitude'];
							$aLongitude = $_CONTEXT['thc_if']['lastexif']['GPSLongitude'];
							$_CONTEXT['thc_if']['lastfound'][] = "LAT: ".FormatGPS($aLatitude).", LON: ".FormatGPS($aLongitude);
						}
					}
					else{
						$_CONTEXT['thc_if']['lastexif'] = @exif_read_data($_CONTEXT['thc_if']['lastimage'],'IFD0',true);
						if(is_array($_CONTEXT['thc_if']['lastexif'])){
							$_CONTEXT['thc_if']['lastfound'][0] = "";
							foreach($_CONTEXT['thc_if']['lastexif'] as $sName=>$aSection){
								$_CONTEXT['thc_if']['lastfound'][0] .= "<b>Section:</b> ".$sName."<br />\n";
								foreach($aSection as $sKey=>$mValue){
									if(is_array($mValue)){
										$_CONTEXT['thc_if']['lastfound'][0] .= "- ".$sKey.": [".implode(", ",$mValue)."]<br />\n";
									}
									else{
										$_CONTEXT['thc_if']['lastfound'][0] .= "- ".$sKey.":".$mValue."<br />\n";
									}
								}
							}
						}
					}
					// check if there's exif data
					if(!$_CONTEXT['thc_if']['lastexif']){
						echo Screen("no related exif data found<br />\n",$_CONTEXT['verbose'],$_CONTEXT['silent']);
					}
					else{
						echo Screen("exif data present<br />\n",$_CONTEXT['verbose'],$_CONTEXT['silent']);
					}
					if(false!=($_CONTEXT['thc_if']['lastfoundcount'] = count($_CONTEXT['thc_if']['lastfound']))){
						for($y=0;$y<$_CONTEXT['thc_if']['lastfoundcount'];$y++){
							echo Screen($_CONTEXT['thc_if']['lastfound'][$y],$_CONTEXT['verbose'],$_CONTEXT['silent']);
						}
					}
					else{
						echo Screen("- no matches found",$_CONTEXT['verbose'],$_CONTEXT['silent']);
					}
					echo Screen("<br />\n",$_CONTEXT['verbose'],$_CONTEXT['silent']);
					flush();
					ob_flush();
				}
				// update entry in background task file
				include($_PATHS['includes_root']."/task_end.php");
			}
			else{
				die(Screen("No action has been specified",$_CONTEXT['verbose'],$_CONTEXT['silent']));
			}
		}
		break;
		default:
		die(Screen($sOut.$sOptions.$sEnd,$_CONTEXT['verbose'],$_CONTEXT['silent']));
	}
}
else{
	die(Screen($sOut.$sOptions.$sEnd,$_CONTEXT['verbose'],$_CONTEXT['silent']));
}
?>