<?php
/* THC Investigate

Author: Remco Kouw
Site: http://www.hacksuite.com
Last Edit: 16-07-2023
*/
class Investigate {
	private $sSource;
	public $aDetected = array();
	public function __construct($sSource) {
		$this->sSource = $sSource;
	}
	function GetDetected(){
		return($this->aDetected);
	}
	function SetDetected($sType,$mValues){
		$this->aDetected[$sType] = $mValues;
	}
	function DetectCMS(){
		$aData = array(
			'WordPress' => '/<meta name=["\']generator["\'] content=["\']WordPress/i',
			'Joomla' => '/<meta name=["\']generator["\'] content=["\']Joomla/i',
			'Drupal' => '/<meta name=["\']generator["\'] content=["\']Drupal/i',
			'Magento' => '/<meta name=["\']generator["\'] content=["\']Magento/i',
			'phpBB' => '/<!--\s*Powered\s*by\s*phpBB/i',
			'vBulletin' => '/<meta name=["\']generator["\'] content=["\']vBulletin/i',
			'XenForo' => '/<link[^>]+?href=["\'][^>]+?xenforo[^>]+?>/i',
			'bbPress' => '/<meta name=["\']generator["\'] content=["\']bbPress/i',
			'MyBB' => '/<meta name=["\']generator["\'] content=["\']MyBB/i',
			'SMF' => '/<meta name=["\']generator["\'] content=["\']SMF/i',
			'PunBB' => '/<link[^>]+?href=["\'][^>]+?punbb[^>]+?>/i',
			'MODX' => '/<meta name=["\']generator["\'] content=["\']MODX/i',
			'Typo3' => '/<meta name=["\']generator["\'] content=["\']TYPO3/i',
			'Blogger' => '/<meta name=["\']generator["\'] content=["\']Blogger/i',
			'MediaWiki' => '/<meta name=["\']generator["\'] content=["\']MediaWiki/i',
			'DokuWiki' => '/<meta name=["\']generator["\'] content=["\']DokuWiki/i',
			'phpMyFAQ' => '/Powered\s*by\s*phpMyFAQ/i',
			'PrestaShop' => '/<link[^>]+?href=["\'][^>]+?prestashop[^>]+?>/i',
			'OpenCart' => '/<link[^>]+?href=["\'][^>]+?opencart[^>]+?>/i',
			'Shopify' => '/<link[^>]+?href=["\'][^>]+?shopify[^>]+?>/i',
			'WooCommerce' => '/<link[^>]+?href=["\'][^>]+?woocommerce[^>]+?>/i',
			'BigCommerce' => '/<link[^>]+?href=["\'][^>]+?bigcommerce[^>]+?>/i',
			'Zen Cart' => '/<link[^>]+?href=["\'][^>]+?zencart[^>]+?>/i',
			'osCommerce' => '/<link[^>]+?href=["\'][^>]+?oscommerce[^>]+?>/i',
			'phpList' => '/Powered\s*by\s*phpList/i',
			'Simple Machines Forum' => '/<meta name=["\']generator["\'] content=["\']Simple Machines Forum/i',
			'Flarum' => '/<meta name=["\']generator["\'] content=["\']Flarum/i',
			'Kunena' => '/<meta name=["\']generator["\'] content=["\']Kunena/i',
			'NodeBB' => '/<meta name=["\']generator["\'] content=["\']NodeBB/i',
			'Vanilla Forums' => '/<meta name=["\']generator["\'] content=["\']Vanilla Forums/i',
			'bbPress' => '/<meta name=["\']generator["\'] content=["\']bbPress/i',
			'WoltLab Suite' => '/<meta name=["\']generator["\'] content=["\']WoltLab Suite/i',
			'Invision Community' => '/<meta name=["\']generator["\'] content=["\']Invision Community/i',
			'XMB' => '/Powered\s*by\s*XMB/i',
			'Phorum' => '/<meta name=["\']generator["\'] content=["\']Phorum/i',
			'UseBB' => '/Powered\s*by\s*UseBB/i',
			'ExpressionEngine' => '/<meta name=["\']generator["\'] content=["\']ExpressionEngine/i',
			'Concrete5' => '/Powered\s*by\s*Concrete5/i',
			'Textpattern' => '/<meta name=["\']generator["\'] content=["\']Textpattern/i',
			'CMS Made Simple' => '/<meta name=["\']generator["\'] content=["\']CMS Made Simple/i',
			'Moodle' => '/<meta name=["\']generator["\'] content=["\']Moodle/i',
			'Pimcore' => '/<meta name=["\']generator["\'] content=["\']Pimcore/i',
			'Tiki Wiki CMS Groupware' => '/<meta name=["\']generator["\'] content=["\']Tiki/i',
			'AdaptCMS' => '/Powered\s*by\s*AdaptCMS/i',
			'phpWCMS' => '/<meta name=["\']generator["\'] content=["\']phpWCMS/i',
			'Zikula' => '/Powered\s*by\s*Zikula/i',
			'Laravel' => '/<meta name=["\']generator["\'] content=["\']Laravel/i',
			'Grav' => '/<meta name=["\']generator["\'] content=["\']Grav/i',
			'October CMS' => '/<meta name=["\']generator["\'] content=["\']October/i',
			'Symfony' => '/<meta name=["\']generator["\'] content=["\']Symfony/i',
			'CodeIgniter' => '/<meta name=["\']generator["\'] content=["\']CodeIgniter/i',
			'CakePHP' => '/<meta name=["\']generator["\'] content=["\']CakePHP/i',
			'Yii' => '/<meta name=["\']generator["\'] content=["\']Yii/i',
			'FuelPHP' => '/<meta name=["\']generator["\'] content=["\']FuelPHP/i',
			'Zend Framework' => '/<meta name=["\']generator["\'] content=["\']Zend Framework/i',
			'Silex' => '/<meta name=["\']generator["\'] content=["\']Silex/i',
			'SilverStripe' => '/<meta name=["\']generator["\'] content=["\']SilverStripe/i',
			'CMSimple' => '/<meta name=["\']generator["\'] content=["\']CMSimple/i',
		);
		$aDetected = array();
		foreach($aData as $sName=>$sPattern){
			if(preg_match($sPattern,$this->sSource)){
				$aDetected[] = $sName;
			}
		}
		$this->SetDetected("cms",$aDetected);
	}
	function DetectECommerce(){
		$aData = array(
			'Magento' => '/<meta name=["\']generator["\'] content=["\']Magento/i',
			'WooCommerce' => '/<link[^>]+?href=["\'][^>]+?woocommerce[^>]+?>/i',
			'Shopify' => '/<link[^>]+?href=["\'][^>]+?shopify[^>]+?>/i',
			'OpenCart' => '/<link[^>]+?href=["\'][^>]+?opencart[^>]+?>/i',
			'PrestaShop' => '/<link[^>]+?href=["\'][^>]+?prestashop[^>]+?>/i',
			'BigCommerce' => '/<link[^>]+?href=["\'][^>]+?bigcommerce[^>]+?>/i',
			'Zen Cart' => '/<link[^>]+?href=["\'][^>]+?zencart[^>]+?>/i',
			'osCommerce' => '/<link[^>]+?href=["\'][^>]+?oscommerce[^>]+?>/i',
			'Wix' => '/<meta name=["\']generator["\'] content=["\']Wix\.com/i',
			'Volusion' => '/Powered\s*by\s*Volusion/i',
			'Squarespace' => '/<meta name=["\']generator["\'] content=["\']Squarespace/i',
			'Weebly' => '/<meta name=["\']generator["\'] content=["\']Weebly/i',
			'3dcart' => '/Powered\s*by\s*3dcart/i',
			'Big Cartel' => '/<meta name=["\']generator["\'] content=["\']Big Cartel/i',
			'Ecwid' => '/<link[^>]+?href=["\'][^>]+?ecwid[^>]+?>/i',
			'X-Cart' => '/Powered\s*by\s*X-Cart/i',
			'CubeCart' => '/Powered\s*by\s*CubeCart/i',
			'Sana Commerce' => '/<!--\s*Powered\s*by\s*Sana\s*Commerce/i',
			'Pinnacle Cart' => '/Powered\s*by\s*Pinnacle\s*Cart/i',
			'Miva' => '/Powered\s*by\s*Miva/i',
			'CS-Cart' => '/Powered\s*by\s*CS-Cart/i',
			'Ubercart' => '/Powered\s*by\s*Ubercart/i',
			'Jigoshop' => '/<meta name=["\']generator["\'] content=["\']Jigoshop/i',
			'osCmax' => '/Powered\s*by\s*osCmax/i',
			'Loaded Commerce' => '/Powered\s*by\s*Loaded\s*Commerce/i',
			'Avactis' => '/Powered\s*by\s*Avactis/i',
			'GoDaddy Online Store' => '/Powered\s*by\s*GoDaddy\s*Online\s*Store/i',
			'CoreCommerce' => '/Powered\s*by\s*CoreCommerce/i',
			'SunShop' => '/Powered\s*by\s*SunShop/i',
			'Zeuscart' => '/Powered\s*by\s*Zeuscart/i',
			'TomatoCart' => '/Powered\s*by\s*TomatoCart/i',
			'OXID eSales' => '/Powered\s*by\s*OXID\s*eSales/i',
			'LiteCart' => '/Powered\s*by\s*LiteCart/i',
			'AgoraCart' => '/Powered\s*by\s*AgoraCart/i',
			'Advansys' => '/Powered\s*by\s*Advansys/i',
			'MerchantTribe' => '/Powered\s*by\s*MerchantTribe/i',
			'FoxyCart' => '/<meta name=["\']generator["\'] content=["\']FoxyCart/i',
			'AmeriCommerce' => '/<link[^>]+?href=["\'][^>]+?americommerce[^>]+?>/i',
			'eCRATER' => '/Powered\s*by\s*eCRATER/i',
			'nopCommerce' => '/Powered\s*by\s*nopCommerce/i',
			'Ecwid' => '/Powered\s*by\s*Ecwid/i',
			'Shopp' => '/Powered\s*by\s*Shopp/i',
			'Interspire' => '/Powered\s*by\s*Interspire/i',
			'Salesforce Commerce Cloud' => '/<meta name=["\']generator["\'] content=["\']Demandware/i',
			'OroCommerce' => '/Powered\s*by\s*OroCommerce/i',
			'Xt-Cart' => '/Powered\s*by\s*Xt-Cart/i',
			'InSales' => '/powered_by_insales/i',
			'Xt-Commerce' => '/Powered\s*by\s*Xt-Commerce/i',
			'Salesforce Commerce Cloud' => '/<meta name=["\']generator["\'] content=["\']Demandware/i',
		);
		$aDetected = array();
		foreach($aData as $sName=>$sPattern){
			if(preg_match($sPattern,$this->sSource)){
				$aDetected[] = $sName;
			}
		}
		$this->SetDetected("ecommerce",$aDetected);
	}
	function DetectFramework(){
		$aData = array(
			'Laravel' => '/<meta name=["\']generator["\'] content=["\']Laravel/i',
			'Django' => '/<meta name=["\']generator["\'] content=["\']Django/i',
			'Ruby on Rails' => '/<meta name=["\']generator["\'] content=["\']Ruby on Rails/i',
			'AngularJS' => '/<script[^>]+?src=["\'][^>]+?angular\.js[^>]+?>/i',
			'React' => '/<script[^>]+?src=["\'][^>]+?react\.js[^>]+?>/i',
			'Vue.js' => '/<script[^>]+?src=["\'][^>]+?vue\.js[^>]+?>/i',
			'Ember.js' => '/<script[^>]+?src=["\'][^>]+?ember\.js[^>]+?>/i',
			'Symfony' => '/<meta name=["\']generator["\'] content=["\']Symfony/i',
			'CodeIgniter' => '/<meta name=["\']generator["\'] content=["\']CodeIgniter/i',
			'CakePHP' => '/<meta name=["\']generator["\'] content=["\']CakePHP/i',
			'Yii' => '/<meta name=["\']generator["\'] content=["\']Yii/i',
			'Zend Framework' => '/<meta name=["\']generator["\'] content=["\']Zend Framework/i',
			'Express' => '/require\(["\']express["\']\)/i',
			'Meteor' => '/<script[^>]+?src=["\'][^>]+?meteor\.js[^>]+?>/i',
			'Flask' => '/<meta name=["\']generator["\'] content=["\']Flask/i',
			'Spring' => '/<meta name=["\']generator["\'] content=["\']Spring/i',
			'ASP.NET' => '/<script[^>]+?src=["\'][^>]+?\.net[^>]+?>/i',
		);
		$aDetected = array();
		foreach($aData as $sName=>$sPattern){
			if(preg_match($sPattern,$this->sSource)){
				$aDetected[] = $sName;
			}
		}
		$this->SetDetected("frameworks",$aDetected);
	}
	function DetectPayGateways(){
		$aData = array(
			'PayPal' => '/<script[^>]+?src=["\'][^>]+?paypal\.com[^>]+?>/i',
			'Stripe' => '/<script[^>]+?src=["\'][^>]+?stripe\.com[^>]+?>/i',
			'Braintree' => '/<script[^>]+?src=["\'][^>]+?braintreegateway\.com[^>]+?>/i',
			'Authorize.Net' => '/<script[^>]+?src=["\'][^>]+?authorizenet\.com[^>]+?>/i',
			'2Checkout' => '/<script[^>]+?src=["\'][^>]+?2checkout\.com[^>]+?>/i',
			'PayU' => '/<script[^>]+?src=["\'][^>]+?payu\.com[^>]+?>/i',
			'Worldpay' => '/<script[^>]+?src=["\'][^>]+?worldpay\.com[^>]+?>/i',
			'Skrill' => '/<script[^>]+?src=["\'][^>]+?skrill\.com[^>]+?>/i',
			'Square' => '/<script[^>]+?src=["\'][^>]+?squareup\.com[^>]+?>/i',
			'Payza' => '/<script[^>]+?src=["\'][^>]+?payza\.com[^>]+?>/i',
			'Payoneer' => '/<script[^>]+?src=["\'][^>]+?payoneer\.com[^>]+?>/i',
			'WePay' => '/<script[^>]+?src=["\'][^>]+?wepay\.com[^>]+?>/i',
			'GoCardless' => '/<script[^>]+?src=["\'][^>]+?gocardless\.com[^>]+?>/i',
			'Alipay' => '/<script[^>]+?src=["\'][^>]+?alipay\.com[^>]+?>/i',
			'Klarna' => '/<script[^>]+?src=["\'][^>]+?klarna\.com[^>]+?>/i',
			'Paytm' => '/<script[^>]+?src=["\'][^>]+?paytm\.in[^>]+?>/i',
			'Venmo' => '/<script[^>]+?src=["\'][^>]+?venmo\.com[^>]+?>/i',
			'Paddle' => '/<script[^>]+?src=["\'][^>]+?paddle\.com[^>]+?>/i',
			'Dwolla' => '/<script[^>]+?src=["\'][^>]+?dwolla\.com[^>]+?>/i',
			'Paysera' => '/<script[^>]+?src=["\'][^>]+?paysera\.com[^>]+?>/i',
			'BlueSnap' => '/<script[^>]+?src=["\'][^>]+?bluesnap\.com[^>]+?>/i',
			'Amazon Pay' => '/<script[^>]+?src=["\'][^>]+?amazon\-pay\.com[^>]+?>/i',
			'Apple Pay' => '/<script[^>]+?src=["\'][^>]+?apple\-pay\.com[^>]+?>/i',
			'Google Pay' => '/<script[^>]+?src=["\'][^>]+?google\-pay\.com[^>]+?>/i',
			'PayFast' => '/<script[^>]+?src=["\'][^>]+?payfast\.co\.za[^>]+?>/i',
		);
		$aDetected = array();
		foreach($aData as $sName=>$sPattern){
			if(preg_match($sPattern,$this->sSource)){
				$aDetected[] = $sName;
			}
		}
		$this->SetDetected("payment_gateways",$aDetected);
	}
	function DetectBlogPlatforms(){
		$aData = array(
			'WordPress' => '/<meta name=["\']generator["\'] content=["\']WordPress/i',
			'Blogger' => '/<meta name=["\']generator["\'] content=["\']Blogger/i',
			'Tumblr' => '/<meta name=["\']generator["\'] content=["\']Tumblr/i',
			'Ghost' => '/<meta name=["\']generator["\'] content=["\']Ghost/i',
			'Medium' => '/<meta property=["\']al:ios:app_name["\'] content=["\']Medium/i',
			'Wix' => '/<script[^>]+?src=["\'][^>]+?wix\.com[^>]+?>/i',
			'Squarespace' => '/<script[^>]+?src=["\'][^>]+?squarespace\.com[^>]+?>/i',
			'Joomla' => '/<meta name=["\']generator["\'] content=["\']Joomla/i',
			'Drupal' => '/<meta name=["\']generator["\'] content=["\']Drupal/i',
			'Typepad' => '/<meta name=["\']generator["\'] content=["\']TypePad/i',
			'Weebly' => '/<script[^>]+?src=["\'][^>]+?weebly\.com[^>]+?>/i',
			'Movable Type' => '/<meta name=["\']generator["\'] content=["\']Movable Type/i',
			'Jekyll' => '/<meta name=["\']generator["\'] content=["\']Jekyll/i',
			'Textpattern' => '/<meta name=["\']generator["\'] content=["\']Textpattern/i',
			'SilverStripe' => '/<meta name=["\']generator["\'] content=["\']SilverStripe/i',
			'LiveJournal' => '/<meta name=["\']generator["\'] content=["\']LiveJournal/i',
			'B2evolution' => '/<meta name=["\']generator["\'] content=["\']b2evolution/i',
			'ExpressionEngine' => '/<meta name=["\']generator["\'] content=["\']ExpressionEngine/i',
			'Serendipity' => '/<meta name=["\']generator["\'] content=["\']Serendipity/i',
			'PivotX' => '/<meta name=["\']generator["\'] content=["\']PivotX/i',
			'Anchor CMS' => '/<meta name=["\']generator["\'] content=["\']Anchor CMS/i',
			'Posthaven' => '/<meta name=["\']generator["\'] content=["\']Posthaven/i',
			'Subrion' => '/<meta name=["\']generator["\'] content=["\']Subrion/i',
			'Nucleus CMS' => '/<meta name=["\']generator["\'] content=["\']Nucleus CMS/i',
		);
		$aDetected = array();
		foreach($aData as $sName=>$sPattern){
			if(preg_match($sPattern,$this->sSource)){
				$aDetected[] = $sName;
			}
		}
		$this->SetDetected("blogs",$aDetected);
	}
	function DetectCDN(){
		$aData = array(
			'Cloudflare' => '/<script[^>]+?src=["\'][^>]+?cloudflare\.com[^>]+?>/i',
			'Amazon CloudFront' => '/<script[^>]+?src=["\'][^>]+?cloudfront\.net[^>]+?>/i',
			'Fastly' => '/<script[^>]+?src=["\'][^>]+?fastly\.net[^>]+?>/i',
			'Akamai' => '/<script[^>]+?src=["\'][^>]+?akamai\.net[^>]+?>/i',
			'MaxCDN' => '/<script[^>]+?src=["\'][^>]+?maxcdn\.com[^>]+?>/i',
			'StackPath' => '/<script[^>]+?src=["\'][^>]+?stackpath\.com[^>]+?>/i',
			'CDN77' => '/<script[^>]+?src=["\'][^>]+?cdn77\.com[^>]+?>/i',
			'Incapsula' => '/<script[^>]+?src=["\'][^>]+?incapsula\.com[^>]+?>/i',
			'BunnyCDN' => '/<script[^>]+?src=["\'][^>]+?b-cdn\.net[^>]+?>/i',
			'Google Cloud CDN' => '/<script[^>]+?src=["\'][^>]+?gcdn\.co[^>]+?>/i',
			'Microsoft Azure CDN' => '/<script[^>]+?src=["\'][^>]+?azureedge\.net[^>]+?>/i',
			'Rackspace CDN' => '/<script[^>]+?src=["\'][^>]+?rackcdn\.com[^>]+?>/i',
			'CacheFly' => '/<script[^>]+?src=["\'][^>]+?cachefly\.net[^>]+?>/i',
			'Level 3' => '/<script[^>]+?src=["\'][^>]+?level3\.net[^>]+?>/i',
			'Limelight Networks' => '/<script[^>]+?src=["\'][^>]+?llnw\.net[^>]+?>/i',
			'EdgeCast' => '/<script[^>]+?src=["\'][^>]+?edgecastcdn\.net[^>]+?>/i',
			'ChinaNetCenter' => '/<script[^>]+?src=["\'][^>]+?chinanetcenter\.com[^>]+?>/i',
			'Tencent Cloud' => '/<script[^>]+?src=["\'][^>]+?tencentcloudcdn\.com[^>]+?>/i',
			'CloudFront' => '/<script[^>]+?src=["\'][^>]+?cloudfront\.net[^>]+?>/i',
			'G-Core Labs' => '/<script[^>]+?src=["\'][^>]+?gcdn\.eu[^>]+?>/i',
			'Cachefly' => '/<script[^>]+?src=["\'][^>]+?cachefly\.net[^>]+?>/i',
			'Turbobytes' => '/<script[^>]+?src=["\'][^>]+?turbobytes\.com[^>]+?>/i',
			'KeyCDN' => '/<script[^>]+?src=["\'][^>]+?keycdn\.com[^>]+?>/i',
		);
		$aDetected = array();
		foreach($aData as $sName=>$sPattern){
			if(preg_match($sPattern,$this->sSource)){
				$aDetected[] = $sName;
			}
		}
		$this->SetDetected("cdns",$aDetected);
	}
	function DetectTaskRunners(){
		$aData = array(
			'Grunt' => '/<script[^>]+?src=["\'][^>]+?grunt\.js[^>]+?>/i',
			'Gulp' => '/<script[^>]+?src=["\'][^>]+?gulp\.js[^>]+?>/i',
			'Webpack' => '/<script[^>]+?src=["\'][^>]+?webpack\.js[^>]+?>/i',
			'Parcel' => '/<script[^>]+?src=["\'][^>]+?parcel\.js[^>]+?>/i',
			'Browserify' => '/<script[^>]+?src=["\'][^>]+?browserify\.js[^>]+?>/i',
			'Rollup' => '/<script[^>]+?src=["\'][^>]+?rollup\.js[^>]+?>/i',
			'Npm' => '/<script[^>]+?src=["\'][^>]+?npm\.js[^>]+?>/i',
			'Yarn' => '/<script[^>]+?src=["\'][^>]+?yarn\.js[^>]+?>/i',
			'Bower' => '/<script[^>]+?src=["\'][^>]+?bower\.js[^>]+?>/i',
			'Snowpack' => '/<script[^>]+?src=["\'][^>]+?snowpack\.js[^>]+?>/i',
			'FuseBox' => '/<script[^>]+?src=["\'][^>]+?fusebox\.js[^>]+?>/i',
			'Laravel Mix' => '/<script[^>]+?src=["\'][^>]+?laravel\-mix\.js[^>]+?>/i',
			'Rome' => '/<script[^>]+?src=["\'][^>]+?rome\.js[^>]+?>/i',
			'Scripty' => '/<script[^>]+?src=["\'][^>]+?scripty\.js[^>]+?>/i',
			'Stitch' => '/<script[^>]+?src=["\'][^>]+?stitch\.js[^>]+?>/i',
			'Fly' => '/<script[^>]+?src=["\'][^>]+?fly\.js[^>]+?>/i',
			'CakePHP' => '/<script[^>]+?src=["\'][^>]+?cakephp\.js[^>]+?>/i',
			'Volta' => '/<script[^>]+?src=["\'][^>]+?volta\.js[^>]+?>/i',
			'Brunch' => '/<script[^>]+?src=["\'][^>]+?brunch\.js[^>]+?>/i',
			'Poi' => '/<script[^>]+?src=["\'][^>]+?poi\.js[^>]+?>/i',
			'Karma' => '/<script[^>]+?src=["\'][^>]+?karma\.js[^>]+?>/i',
			'Rollup' => '/<script[^>]+?src=["\'][^>]+?rollup\.js[^>]+?>/i',
			'Browsify' => '/<script[^>]+?src=["\'][^>]+?browsify\.js[^>]+?>/i',
			'Browsersync' => '/<script[^>]+?src=["\'][^>]+?browsersync\.js[^>]+?>/i',
			'Duo' => '/<script[^>]+?src=["\'][^>]+?duo\.js[^>]+?>/i',
		);
		$aDetected = array();
		foreach($aData as $sName=>$sPattern){
			if(preg_match($sPattern,$this->sSource)){
				$aDetected[] = $sName;
			}
		}
		$this->SetDetected("js_task_runners",$aDetected);
	}
}
?>