/* THC Shodown Interface Creator

Author: Remco Kouw
Site: http://www.hacksuite.com
Last Edit: 01-02-2019
*/
/* create related form fields for shodan search */
$(document).on("change","select.method",function(){
	$('.modrow#hidemod').show();
	$('.modrow#percentage').remove();
	$('input.deleter').hide();
	$('input.shower').hide();
	$('#checkme').prop('checked',false);
	if($(this).val()==1){
		/* regular search */
		$('.modleft#queryfields').html("search");
		$('.modright#queryfields').html("<input type='text' name='sQueryField' value='' />");
	}
	else if($(this).val()==3){
		/* host search with(out) filters */
		$('.modleft#queryfields').html("search");
		$('.modright#queryfields').html("<input type='text' name='sQueryField' value='Niagara Web Server' />");
	}
	else if($(this).val()==5){
		/* ip search */
		$('.modleft#queryfields').html("ip");
		$('.modright#queryfields').html("<input type='text' name='sQueryField' value='54.231.184.227' />");
	}
	else if($(this).val()==8){
		/* honeypot detection */
		$('.modrow#hidemod').hide();
		$('.modleft#queryfields').html("ip");
		$('.modright#queryfields').html("<input type='text' name='sQueryField' value='54.231.184.227' />");
	}
	else if($(this).val()==10){
		/* ports crawled */
		$('.modrow#hidemod').hide();
		$('.modleft#queryfields').html("ports");
		$('.modright#queryfields').html("<b>searches for crawled ports</b>");
	}
	else if($(this).val()==11){
		/* protocols available */
		$('.modrow#hidemod').hide();
		$('.modleft#queryfields').html("protocols");
		$('.modright#queryfields').html("<b>searches for available protocols</b>");
	}
	else if($(this).val()==12){
		/* previous queries */
		$('.modrow#hidemod').hide();
		$('.modleft#queryfields').html("saved query");
		$.ajax({
			type: "POST",
			url: "Modules/thc_sh/load_queries.php",
			dataType: "json",
			success: function(json){
				if(json.jresult==false){
					alert(json.jmessage);
				}
				else{
					$('input.deleter').show();
					$('input.shower').show();
					$('.modright#queryfields').html(json.jmessage);
				}
			}
		});
	}
	else{
		/* invalid option */
		$('input.deleter').hide();
		$('input.shower').hide();
		$('.modrow#hidemod').hide();
		$('.modrow#percentage').remove();
		alert('Action doesn\'t exist');
	}
});
/* creates a hyperlink that will send a post form */
$(document).on("click","a.wrapsrch",function(e){
	e.preventDefault();
	var form = $('<form action="Modules/thc_sh/shodan_query.php" method="post" class="shodan">' + '<input type="hidden" name="sPageEncoded" value="'+$(this).attr('alt')+'" />' + '</form>');
	$('body').append(form);
	$(form).submit();
});
/* sends a delete request for a specific file and record */
$(document).on("click","input.deleter",function(e){
	e.preventDefault();
	var form = $('<form action="Modules/thc_sh/shodan_query.php" method="post" class="shodan">' + '<input type="hidden" name="iDelete" value="'+$('select.sQuery').val()+'" />' + '</form>');
	$('body').append(form);
	$(form).submit();
});
/* shows a raw output from specific file */
$(document).on("click","input.shower",function(e){
	e.preventDefault();
	var form = $('<form action="Modules/thc_sh/shodan_query.php" method="post" class="shodan">' + '<input type="hidden" name="iShow" value="'+$('select.sQuery').val()+'" />' + '</form>');
	$('body').append(form);
	$(form).submit();
});
/* shodan search */
$(document).on("submit","form.shodan",function(e){
	e.preventDefault();
	$('.modrow#percentage').remove();
	dataString = $(this).serialize();
	$.ajax({
		type: "POST",
		data: dataString,
		url: "Modules/thc_sh/shodan_query.php",
		dataType: "json",
		success: function(json){
			if(json.jresult==false){
				if(typeof json.jdeleted!=='undefined'){
					// remove from selection menu
					$(".sQuery option[value='"+json.jdeleted+"']").remove();
				}
				alert(json.jmessage);
			}
			else{
				/* some results are treated differently */
				if(json.jtype==8){
					/* honeypot percentage bar */
					if(json.jmessage>0){
						json.jmessage *= 100;
					}
					$('.modrow#hidemod').before('<div class="modrow" id="percentage"><div class="modleft">chance</div><div class="modright border1pxstrans"><div class="edgeglow" style="height:24px;width:'+json.jmessage+'%">&nbsp;'+json.jmessage+'%</div></div>');
				}
				else if(json.jtype==10){
					/* ports */
					$('.modrow#hidemod').before('<div class="modrow" id="percentage"><div class="modleft">results</div><div class="modright">'+json.jmessage+'</div></div>');
				}
				else if(json.jtype==11){
					/* protocols */
					var protoc = '';
					$.each(json.jmessage, function( index, value ) {
        				protoc += '<a href="http://www.google.com/search?q='+index+'" target="blank">'+index+'</a> '+value+'<br />';
        			});
					$('.modrow#hidemod').before('<div class="modrow" id="percentage"><div class="modleft">results</div><div class="modright">'+protoc+'</div></div>');
				}
				else{
					/* anything else, data has already been parsed */
					var html_text = '';
					$('#checkme').prop('checked',false);
					if(typeof json.jinitialmethod=='undefined'){
						// this allows both direct content from shodan and local file content to be handled in the same way, just to prevent double code 
						json.jinitialmethod = json.jtype;
					}
					// display results for every other search type
					if(json.jinitialmethod==1){
						// ordinary search
						for(var i = 0;i<json.jmessage.matches.length;i++){
							var object = json.jmessage.matches[i];
							var jpage = parseInt(json.jpage - 1); 
							html_text += '<hr width="500">';
							html_text += '<b>result '+(jpage*json.jresultperpage+(i+1))+'</b><br />';
							html_text += '<hr width="500">';
							html_text += '<i>'+json.jmessage.matches[i].description+'</i><br />';
							if(json.jmessage.matches[i].cve!='' && typeof json.jmessage.matches[i].cve!='undefined'){
								html_text += '<b>cve</b> '+json.jmessage.matches[i].cve+'<br />';
							}
							if(json.jmessage.matches[i].bid!='' && typeof json.jmessage.matches[i].bid!='undefined'){
								html_text += '<b>bugtraq</b> '+json.jmessage.matches[i].bid+'<br />';
							}
							if(json.jmessage.matches[i].osvdb!='' && typeof json.jmessage.matches[i].osvdb!='undefined'){
								html_text += '<b>osvdb</b> '+json.jmessage.matches[i].osvdb+'<br />';
							}
							if(typeof json.jmessage.matches[i].code!='undefined'){
								html_text += '<b>code</b> '+json.jmessage.matches[i].code+'<br />';
							}
							html_text += '<p></p>';
						}
						$('.modrow#hidemod').before('<div class="modrow" id="percentage"><div class="modleft">results</div><div class="modright">'+html_text+json.html+'</div></div>');
					}
					else if(json.jinitialmethod==3){
						/* host search */
						for(var i = 0;i<json.jmessage.matches.length;i++){
							var object = json.jmessage.matches[i];
							var jpage = parseInt(json.jpage - 1); 
							html_text += '<hr width="500">';
							html_text += '<b>result '+(jpage*json.jresultperpage+(i+1))+'</b><br />';
							html_text += '<hr width="500">';
							html_text += '<b>'+json.jmessage.matches[i].organization+' ('+json.jmessage.matches[i].ip+')</b><br /><b>last update: </b>'+json.jmessage.matches[i].last_update+'<br />';
							html_text += json.jmessage.matches[i].product+' - '+json.jmessage.matches[i].version+'<br />';
							html_text += '<b>type of device:</b> '+json.jmessage.matches[i].devicetype+'<br />';
							html_text += '<b>asn:</b> '+json.jmessage.matches[i].asn+'<br />';
							html_text += '<b>port:</b> '+json.jmessage.matches[i].port+'<br />';
							html_text += '<b>os:</b> '+json.jmessage.matches[i].os+'<br />';
							html_text += '<b>protocol:</b> '+json.jmessage.matches[i].transport+'<br />';
							html_text += '<b>country:</b> '+json.jmessage.matches[i].country+'('+json.jmessage.matches[i].country_code+')<br />';
							html_text += '<b>city:</b> '+json.jmessage.matches[i].city+'<br />';
							html_text += '<b>dma code:</b> '+json.jmessage.matches[i].dma_code+'<br />';
							html_text += '<b>region code:</b> '+json.jmessage.matches[i].region_code+'<br />';
							html_text += '<b>postal code:</b> '+json.jmessage.matches[i].postal_code+'<br />';
							html_text += '<b>area code:</b> '+json.jmessage.matches[i].area_code+'<br />';
							html_text += '<b>latitude:</b> '+json.jmessage.matches[i].latitude+'<br />';
							html_text += '<b>longitude:</b> '+json.jmessage.matches[i].longitude+'<br />';
							html_text += '<b>isp:</b> '+json.jmessage.matches[i].isp+'<br />';
							html_text += '<b>host:</b> '+json.jmessage.matches[i].http_host+'<br />';
							html_text += '<b>server:</b> '+json.jmessage.matches[i].http_server+'<br />';
							html_text += '<b>hostnames:</b> '+json.jmessage.matches[i].hostnames+'<br />';
							html_text += '<b>domains:</b> '+json.jmessage.matches[i].domains+'<br />';
							html_text += '<b>server:</b> '+json.jmessage.matches[i].http_server+'<br />';
							html_text += '<b>security.txt:</b> '+json.jmessage.matches[i].securitytxt+'<br />';
							html_text += '<b>hash:</b> '+json.jmessage.matches[i].securitytxthash+'<br />';
						}
						$('.modrow#hidemod').before('<div class="modrow" id="percentage"><div class="modleft">results</div><div class="modright">'+html_text+json.html+'</div></div>');
					}
					else if(json.jinitialmethod==5){
						/* ip search */
						html_text += '<hr width="500">';
						html_text += '<b>host search result for: '+json.jmessage.matches.ip+'</b><br /><b>last update: </b>'+json.jmessage.matches.last_update+'<br />';
						html_text += '<hr width="500">';
						html_text += '<iframe width="425" height="350" frameborder="0" scrolling="no" marginheight="0" marginwidth="0" src="https://www.openstreetmap.org/export/embed.html?bbox='+json.jmessage.matches.longitude+'%2C'+json.jmessage.matches.latitude+'%2C'+json.jmessage.matches.longitude+'%2C'+json.jmessage.matches.latitude+'&amp;layer=mapnik&amp;marker='+json.jmessage.matches.longitude+'%2C'+json.jmessage.matches.latitude+'"></iframe>';						
						html_text += '<hr width="500">';
						html_text += '<b>location:</b> '+json.jmessage.matches.city+' - '+json.jmessage.matches.region_code+' ('+json.jmessage.matches.country_name+' - '+json.jmessage.matches.country_code+')<br />';
						html_text += '<b>postal:</b> '+json.jmessage.matches.postal_code+'<br />';
						html_text += '<b>area:</b> '+json.jmessage.matches.area_code+'<br />';
						html_text += '<b>dma:</b> '+json.jmessage.matches.dma_code+'<br />';
						html_text += '<hr width="500">';
						html_text += '<b>organisation:</b> '+json.jmessage.matches.organization+'<br />';
						html_text += '<b>isp:</b> '+json.jmessage.matches.isp+'<br />';
						html_text += '<b>hostnames:</b> '+json.jmessage.matches.hostnames+'<br />';
						html_text += '<b>domains:</b> '+json.jmessage.matches.domains+'<br />';
						html_text += '<b>redirects:</b> '+json.jmessage.matches.http_redirects+'<br />';
						html_text += '<b>product:</b> '+json.jmessage.matches.product+'<br />';
						html_text += '<b>transport:</b> '+json.jmessage.matches.transport+'<br />';
						html_text += '<b>os:</b> '+json.jmessage.matches.os+'<br />';
						html_text += '<b>http server:</b> '+json.jmessage.matches.http_server+'<br />';
						html_text += '<b>http host:</b> '+json.jmessage.matches.http_host+'<br />';
						html_text += '<b>location:</b> '+json.jmessage.matches.http_location+'<br />';
						html_text += '<b>ports:</b> '+json.jmessage.matches.ports+'<br />';
						html_text += '<hr width="500">';
						html_text += '<b>asn:</b> '+json.jmessage.matches.asn+'<br />';
						html_text += '<b>tags:</b> '+json.jmessage.matches.tags+'<br />';
						html_text += '<b>components:</b> '+json.jmessage.matches.http_components+'<br />';
						html_text += '<b>security.txt:</b> '+json.jmessage.matches.http_securitytxt+'<br />';
						html_text += '<b>hash:</b> '+json.jmessage.matches.http_securitytxt_hash+'<br />';
						html_text += '<hr width="500">';
						html_text += '<b>sitemap:</b> '+json.jmessage.matches.http_sitemap+'<br />';
						html_text += '<b>data:</b> '+json.jmessage.matches.data+'<br />';
						html_text += '<hr width="500">';
						$('.modrow#hidemod').before('<div class="modrow" id="percentage"><div class="modleft">results</div><div class="modright">'+html_text+'</div></div>');
					}
					else{
						alert('Method doesn\'t have a handler.');
					}
				}
			}
		}
	});
});
/* set api key */
$(document).on("submit","form.apikey",function(e){
	e.preventDefault();
	dataString = $(this).serialize();
	$.ajax({
		type: "POST",
		data: dataString,
		url: "Modules/thc_sh/setapi.php",
		dataType: "json",
		success: function(json){
			if(json.jresult==false){
				alert(json.jmessage);
			}
			else{
				$('.modrow#apik').remove();
				$('.modrowleft').html(json.jmessage+'<br />Click <a href="index.php?module=thc_sh">here</a> to start using Shodown');
			}
		}
	});
});
/* prevent save query checkbox to show up if nothing has been selected */
$(document).ready(function(){
	$('.modrow#hidemod').hide();
	$('input.shower').hide();
	$('input.deleter').hide();
});