<?php
/*
Handler for xWhere

ModGlue Variables:
$_CONTEXT['thc_wh']['keyfile']
$_CONTEXT['thc_wh']['longitude']
$_CONTEXT['thc_wh']['latitude']
$_CONTEXT['thc_wh']['key']
$_CONTEXT['thc_wh']['geocodeurl']
$_CONTEXT['thc_wh']['geocodedata']
$_CONTEXT['thc_wh']['formattedaddress']
$_CONTEXT['thc_wh']['htmlout']
$_CONTEXT['thc_wh']['testurl']
$_CONTEXT['thc_wh']['writedata']
$_CONTEXT['thc_wh']['writeresult']

Author: Remco Kouw
Site: http://www.hacksuite.com
Last Edit: 19-05-2024
*/
$_MODULE_C = "thc_wh";
include_once("../../Includes/screen_header.php");
include_once($_PATHS['style_root']."/screen.php");
include_once($_PATHS['functions_root']."/scrn.php");
$_CONTEXT['thc_wh'] = array();
$_CONTEXT['thc_wh']['keyfile'] = $_PATHS['module_default_root']."/key.php";
// options
$sOptions = "<b>logging:</b> ".($_CONTEXT['log']==true ? "on" : "off")."<br>\n";
$sOptions .= "<b>silence:</b> ".($_CONTEXT['silent']==true ? "on" : "off")."<br>\n";
$sOptions .= "<b>verbose:</b> ".($_CONTEXT['verbose']==true ? "on" : "off")."\n";
if(file_exists($_CONTEXT['thc_wh']['keyfile']) && filesize($_CONTEXT['thc_wh']['keyfile'])>0){
	include($_CONTEXT['thc_wh']['keyfile']);
}
if(isset($_POST['submit'])){
	echo Screen($sOut,$_CONTEXT['verbose'],$_CONTEXT['silent']);
	switch($_POST['submit']){
		/* Retrieve */
		case"Retrieve":
		if(!is_numeric($_POST['dLatitude']) || $_POST['dLatitude']<-90 || $_POST['dLatitude']>90){
			die(Screen("Invalid latitude coordinates",$_CONTEXT['verbose'],$_CONTEXT['silent']));
		}
		if(!is_numeric($_POST['dLongitude']) || $_POST['dLongitude']<-180 || $_POST['dLongitude']>180){
			die(Screen("Invalid longitude coordinates",$_CONTEXT['verbose'],$_CONTEXT['silent']));
		}
		$_CONTEXT['thc_wh']['longitude'] = $_POST['dLongitude'];
		$_CONTEXT['thc_wh']['latitude'] = $_POST['dLatitude'];
		if(isset($_CONTEXT['thc_wh']['key'])){
			$_CONTEXT['thc_wh']['geocodeurl'] = "https://maps.googleapis.com/maps/api/geocode/json?key=".$_CONTEXT['thc_wh']['key']."&latlng=".$_CONTEXT['thc_wh']['latitude'].",".$_CONTEXT['thc_wh']['longitude'];
		}
		else{
			$_CONTEXT['thc_wh']['geocodeurl'] = "https://maps.googleapis.com/maps/api/geocode/json?latlng=".$_CONTEXT['thc_wh']['latitude'].",".$_CONTEXT['thc_wh']['longitude'];
		}
		$_CONTEXT['thc_wh']['geocodedata'] = @file_get_contents($_CONTEXT['thc_wh']['geocodeurl']);
		if(!$_CONTEXT['thc_wh']['geocodedata'] = @json_decode($_CONTEXT['thc_wh']['geocodedata'],true)){
			die(Screen("Failed to get geocode data array",$_CONTEXT['verbose'],$_CONTEXT['silent']));
		}
		if(isset($_CONTEXT['thc_wh']['geocodedata']['results'][0]['formatted_address'])){
			$_CONTEXT['thc_wh']['formattedaddress'] = $_CONTEXT['thc_wh']['geocodedata']['results'][0]['formatted_address'];
		}
		else{
			die(Screen("Failed to get formatted address".(isset($_CONTEXT['thc_wh']['geocodedata']['error_message']) ? "<p>".$_CONTEXT['thc_wh']['geocodedata']['error_message']."</p>" : ""),$_CONTEXT['verbose'],$_CONTEXT['silent']));
		}
		$_CONTEXT['thc_wh']['htmlout'] = $sOut;
		unset($sOut);
		if(isset($_CONTEXT['thc_wh']['key'])){
			// rewrite html output
			$_CONTEXT['thc_wh']['htmlout'] = str_replace("<body>","",$_CONTEXT['thc_wh']['htmlout']);
			$_CONTEXT['thc_wh']['htmlout'] .= "<script>\n";
			$_CONTEXT['thc_wh']['htmlout'] .= "function initMap(){\n";
			$_CONTEXT['thc_wh']['htmlout'] .= "	var coordinates = {lat:".$_CONTEXT['thc_wh']['latitude'].",lng:".$_CONTEXT['thc_wh']['longitude']."};\n";
			$_CONTEXT['thc_wh']['htmlout'] .= "	var map = new google.maps.Map(document.getElementById('map'),{center:coordinates,zoom:14});\n";
			$_CONTEXT['thc_wh']['htmlout'] .= "	var marker = new google.maps.Marker({position:coordinates,map:map,title:'".$_CONTEXT['thc_wh']['formattedaddress']."'});\n";
			$_CONTEXT['thc_wh']['htmlout'] .= "}\n";
			$_CONTEXT['thc_wh']['htmlout'] .= "</script>\n";
			$_CONTEXT['thc_wh']['htmlout'] .= "<script src=\"https://maps.googleapis.com/maps/api/js?key=".$_CONTEXT['thc_wh']['key']."\"></script>\n";
			$_CONTEXT['thc_wh']['htmlout'] .= "<body onload=\"initMap()\">\n";
			$_CONTEXT['thc_wh']['htmlout'] .= "	<h2>Location Information</h2>\n";
			$_CONTEXT['thc_wh']['htmlout'] .= "	<p>Coordinates: ".$_CONTEXT['thc_wh']['latitude'].",".$_CONTEXT['thc_wh']['longitude']."</p>\n";
			$_CONTEXT['thc_wh']['htmlout'] .= "	<p>Address: ".$_CONTEXT['thc_wh']['formattedaddress']."</p>\n";
			$_CONTEXT['thc_wh']['htmlout'] .= "	<div id=\"map\" style=\"width:100%;height:400px;\"></div>\n";
		}
		else{
			$_CONTEXT['thc_wh']['htmlout'] .= "	<h2>Location Information</h2>\n";
			$_CONTEXT['thc_wh']['htmlout'] .= "	<p>Coordinates: ".$_CONTEXT['thc_wh']['latitude'].",".$_CONTEXT['thc_wh']['longitude']."</p>\n";
			$_CONTEXT['thc_wh']['htmlout'] .= "	<p>Address: ".$_CONTEXT['thc_wh']['formattedaddress']."</p>\n";
		}
		$_CONTEXT['thc_wh']['htmlout'] .= "</body>\n";
		$_CONTEXT['thc_wh']['htmlout'] .= "</html>\n";
		echo Screen($_CONTEXT['thc_wh']['htmlout'],$_CONTEXT['verbose'],$_CONTEXT['silent']);
		break;
		/* Edit */
		case"Edit":
		if(!isset($_POST['sKey']) || $_POST['sKey']==""){
			die(Screen("Invalid API key specified",$_CONTEXT['verbose'],$_CONTEXT['silent']));
		}
		if(isset($_CONTEXT['thc_wh']['key']) && $_POST['sKey']==$_CONTEXT['thc_wh']['key']){
			die(Screen("Already have this key installed",$_CONTEXT['verbose'],$_CONTEXT['silent']));
		}
		$_CONTEXT['thc_wh']['testurl'] = "https://maps.googleapis.com/maps/api/geocode/json?address=1600+Amphitheatre+Parkway,+Mountain+View,+CA&key={".$_POST['sKey']."}";
		$sResponse = @file_get_contents($_CONTEXT['thc_wh']['testurl']);
		$aData = @json_decode($sResponse,true);
		if(!isset($aData['status']) || $aData['status']!="OK"){
			die(Screen("Failed to validate API key for maps",$_CONTEXT['verbose'],$_CONTEXT['silent']));
		}
		// just the lazy way, overwrite the file with new content
		include_once($_PATHS['functions_root']."/fwrite.php");
		$_CONTEXT['thc_wh']['writedata'] = "<?php\n/*\nGoogle API Key\n\nAuthor: Remco Kouw\nSite: http://www.hacksuite.com\nLast Edit: ".date($_CONTEXT['time_pattern'],time())."\n*/\nif(!defined(\"IN_SCRIPT\")){\n\texit;\n}\nif(!isset(\$_CONTEXT['thc_wh'])){\n\t\$_CONTEXT['thc_wh'] = array();\n}\n\$_CONTEXT['thc_wh']['key'] = \"".$_POST['sKey']."\";\n?>";
		$_CONTEXT['thc_wh']['writeresult'] = WriteF($_CONTEXT['thc_wh']['keyfile'],$_CONTEXT['thc_wh']['writedata'] ,"w");
		echo Screen($_CONTEXT['thc_wh']['writeresult']==true ? "Successfully installed api key" : "Failed to install api key");
		break;
		default:
		die(Screen($sOut.$sOptions.$sEnd,$_CONTEXT['verbose'],$_CONTEXT['silent']));
	}
}
else{
	die(Screen($sOut.$sOptions.$sEnd,$_CONTEXT['verbose'],$_CONTEXT['silent']));
}
?>