<?php
/* Setup for converter options

Author: Remco Kouw
Site: http://www.hacksuite.com
Last Edit: 03-12-2023
*/
$_OPT = 0;
$_CONVERT = array();
// cryptography
$_CONVERT[$_OPT] = array();
$_CONVERT[$_OPT]['label'] = "md5 encrypt";
$_CONVERT[$_OPT]['description'] = "Encrypts a string into a 32 bit hash";
$_CONVERT[$_OPT]['type'] = array(0);
$_CONVERT[$_OPT]['fieldnames'] = array("string");
$_CONVERT[$_OPT]['group'] = "cryptography";
$_CONVERT[$_OPT]['position'] = 0;
$_CONVERT[$_OPT]['function'] = "md5";
$_OPT++;
$_CONVERT[$_OPT] = array();
$_CONVERT[$_OPT]['label'] = "sha1 encrypt";
$_CONVERT[$_OPT]['description'] = "Encrypts a string into a 40 bit hash";
$_CONVERT[$_OPT]['type'] = array(0);
$_CONVERT[$_OPT]['fieldnames'] = array("string");
$_CONVERT[$_OPT]['group'] = "cryptography";
$_CONVERT[$_OPT]['position'] = 1;
$_CONVERT[$_OPT]['function'] = "sha1";
$_OPT++;
$_CONVERT[$_OPT] = array();
$_CONVERT[$_OPT]['label'] = "base64 encode";
$_CONVERT[$_OPT]['description'] = "Encodes a string to base64";
$_CONVERT[$_OPT]['type'] = array(0);
$_CONVERT[$_OPT]['group'] = "cryptography";
$_CONVERT[$_OPT]['fieldnames'] = array("string");
$_CONVERT[$_OPT]['position'] = 2;
$_CONVERT[$_OPT]['function'] = "base64_encode";
$_OPT++;
$_CONVERT[$_OPT] = array();
$_CONVERT[$_OPT]['label'] = "base64 decode";
$_CONVERT[$_OPT]['description'] = "Decodes a base64 string";
$_CONVERT[$_OPT]['type'] = array(0);
$_CONVERT[$_OPT]['group'] = "cryptography";
$_CONVERT[$_OPT]['fieldnames'] = array("string");
$_CONVERT[$_OPT]['position'] = 3;
$_CONVERT[$_OPT]['function'] = "base64_decode";
$_OPT++;
$_CONVERT[$_OPT] = array();
$_CONVERT[$_OPT]['label'] = "binary to hex";
$_CONVERT[$_OPT]['description'] = "Binary to hexadecimal";
$_CONVERT[$_OPT]['type'] = array(0);
$_CONVERT[$_OPT]['group'] = "cryptography";
$_CONVERT[$_OPT]['fieldnames'] = array("string");
$_CONVERT[$_OPT]['position'] = 4;
$_CONVERT[$_OPT]['function'] = "bin2hex";
$_OPT++;
$_CONVERT[$_OPT] = array();
$_CONVERT[$_OPT]['label'] = "binary to ascii";
$_CONVERT[$_OPT]['description'] = "Binary to ascii";
$_CONVERT[$_OPT]['type'] = array(0);
$_CONVERT[$_OPT]['group'] = "cryptography";
$_CONVERT[$_OPT]['fieldnames'] = array("string");
$_CONVERT[$_OPT]['position'] = 5;
$_CONVERT[$_OPT]['function'] = "bin2ascii";
$_OPT++;
$_CONVERT[$_OPT] = array();
$_CONVERT[$_OPT]['label'] = "octal to hex";
$_CONVERT[$_OPT]['description'] = "Octal to hexadecimal";
$_CONVERT[$_OPT]['type'] = array(0);
$_CONVERT[$_OPT]['group'] = "cryptography";
$_CONVERT[$_OPT]['fieldnames'] = array("string");
$_CONVERT[$_OPT]['position'] = 6;
$_CONVERT[$_OPT]['function'] = "oct2hex";
$_OPT++;
$_CONVERT[$_OPT] = array();
$_CONVERT[$_OPT]['label'] = "hex to binary";
$_CONVERT[$_OPT]['description'] = "Hexadecimal to binary";
$_CONVERT[$_OPT]['type'] = array(0);
$_CONVERT[$_OPT]['group'] = "cryptography";
$_CONVERT[$_OPT]['fieldnames'] = array("string");
$_CONVERT[$_OPT]['position'] = 7;
$_CONVERT[$_OPT]['function'] = "hex2bin";
$_OPT++;
$_CONVERT[$_OPT] = array();
$_CONVERT[$_OPT]['label'] = "hex to octal";
$_CONVERT[$_OPT]['description'] = "Hexadecimal to octal";
$_CONVERT[$_OPT]['type'] = array(0);
$_CONVERT[$_OPT]['group'] = "cryptography";
$_CONVERT[$_OPT]['fieldnames'] = array("string");
$_CONVERT[$_OPT]['position'] = 8;
$_CONVERT[$_OPT]['function'] = "hex2oct";
$_OPT++;
$_CONVERT[$_OPT] = array();
$_CONVERT[$_OPT]['label'] = "hex to decimal";
$_CONVERT[$_OPT]['description'] = "Hexadecimal to decimal";
$_CONVERT[$_OPT]['type'] = array(0);
$_CONVERT[$_OPT]['group'] = "cryptography";
$_CONVERT[$_OPT]['fieldnames'] = array("string");
$_CONVERT[$_OPT]['position'] = 9;
$_CONVERT[$_OPT]['function'] = "hexdec";
$_OPT++;
$_CONVERT[$_OPT] = array();
$_CONVERT[$_OPT]['label'] = "ascii to binary";
$_CONVERT[$_OPT]['description'] = "Ascii to Binary";
$_CONVERT[$_OPT]['type'] = array(0);
$_CONVERT[$_OPT]['group'] = "cryptography";
$_CONVERT[$_OPT]['fieldnames'] = array("string");
$_CONVERT[$_OPT]['position'] = 10;
$_CONVERT[$_OPT]['function'] = "ascii2bin";
$_OPT++;
$_CONVERT[$_OPT] = array();
$_CONVERT[$_OPT]['label'] = "pack network order formatting";
$_CONVERT[$_OPT]['description'] = "Creates network order characters for pack command formatting";
$_CONVERT[$_OPT]['type'] = array(0);
$_CONVERT[$_OPT]['group'] = "cryptography";
$_CONVERT[$_OPT]['fieldnames'] = array("hex[,hex]*");
$_CONVERT[$_OPT]['position'] = 11;
$_CONVERT[$_OPT]['function'] = "packformat";
$_OPT++;
// networking
$_CONVERT[$_OPT] = array();
$_CONVERT[$_OPT]['label'] = "ip to host";
$_CONVERT[$_OPT]['description'] = "Converts ip to host";
$_CONVERT[$_OPT]['type'] = array(0);
$_CONVERT[$_OPT]['group'] = "networking";
$_CONVERT[$_OPT]['fieldnames'] = array("ip");
$_CONVERT[$_OPT]['position'] = 0;
$_CONVERT[$_OPT]['function'] = "gethostbyaddr";
$_OPT++;
$_CONVERT[$_OPT] = array();
$_CONVERT[$_OPT]['label'] = "host to ip";
$_CONVERT[$_OPT]['description'] = "Converts host to ip";
$_CONVERT[$_OPT]['type'] = array(0);
$_CONVERT[$_OPT]['group'] = "networking";
$_CONVERT[$_OPT]['fieldnames'] = array("host");
$_CONVERT[$_OPT]['position'] = 1;
$_CONVERT[$_OPT]['function'] = "gethostbyname";
$_OPT++;
$_CONVERT[$_OPT] = array();
$_CONVERT[$_OPT]['label'] = "long to ip";
$_CONVERT[$_OPT]['description'] = "Converts long number to ip address";
$_CONVERT[$_OPT]['type'] = array(0);
$_CONVERT[$_OPT]['group'] = "networking";
$_CONVERT[$_OPT]['fieldnames'] = array("long number");
$_CONVERT[$_OPT]['position'] = 2;
$_CONVERT[$_OPT]['function'] = "long2ip";
$_OPT++;
$_CONVERT[$_OPT] = array();
$_CONVERT[$_OPT]['label'] = "ip to long";
$_CONVERT[$_OPT]['description'] = "Converts ip address to long number";
$_CONVERT[$_OPT]['type'] = array(0);
$_CONVERT[$_OPT]['group'] = "networking";
$_CONVERT[$_OPT]['fieldnames'] = array("ip");
$_CONVERT[$_OPT]['position'] = 3;
$_CONVERT[$_OPT]['function'] = "ip2long";
$_OPT++;
$_CONVERT[$_OPT] = array();
$_CONVERT[$_OPT]['label'] = "get dns records";
$_CONVERT[$_OPT]['description'] = "obtain all dns records from given host";
$_CONVERT[$_OPT]['type'] = array(0);
$_CONVERT[$_OPT]['group'] = "networking";
$_CONVERT[$_OPT]['fieldnames'] = array("host");
$_CONVERT[$_OPT]['position'] = 4;
$_CONVERT[$_OPT]['function'] = "getdns";
$_OPT++;
// string functions
$_CONVERT[$_OPT] = array();
$_CONVERT[$_OPT]['label'] = "strip slashes";
$_CONVERT[$_OPT]['description'] = "Strips slashes in a string";
$_CONVERT[$_OPT]['type'] = array(1);
$_CONVERT[$_OPT]['group'] = "string functions";
$_CONVERT[$_OPT]['fieldnames'] = array("text");
$_CONVERT[$_OPT]['position'] = 0;
$_CONVERT[$_OPT]['function'] = "stripslashes";
$_CONVERT[$_OPT]['nl2br'] = 1;
$_OPT++;
$_CONVERT[$_OPT] = array();
$_CONVERT[$_OPT]['label'] = "escape single quotes";
$_CONVERT[$_OPT]['description'] = "Escape single quotes in a string";
$_CONVERT[$_OPT]['type'] = array(1);
$_CONVERT[$_OPT]['group'] = "string functions";
$_CONVERT[$_OPT]['fieldnames'] = array("text");
$_CONVERT[$_OPT]['position'] = 1;
$_CONVERT[$_OPT]['function'] = "escapesinglequotes";
$_CONVERT[$_OPT]['nl2br'] = 1;
$_OPT++;
$_CONVERT[$_OPT] = array();
$_CONVERT[$_OPT]['label'] = "escape double quotes";
$_CONVERT[$_OPT]['description'] = "Escape double quotes in a string";
$_CONVERT[$_OPT]['type'] = array(1);
$_CONVERT[$_OPT]['group'] = "string functions";
$_CONVERT[$_OPT]['fieldnames'] = array("text");
$_CONVERT[$_OPT]['position'] = 2;
$_CONVERT[$_OPT]['function'] = "escapedoublequotes";
$_CONVERT[$_OPT]['nl2br'] = 1;
$_OPT++;
$_CONVERT[$_OPT] = array();
$_CONVERT[$_OPT]['label'] = "escape variables";
$_CONVERT[$_OPT]['description'] = "Escape variables in a string";
$_CONVERT[$_OPT]['type'] = array(1);
$_CONVERT[$_OPT]['group'] = "string functions";
$_CONVERT[$_OPT]['fieldnames'] = array("text");
$_CONVERT[$_OPT]['position'] = 3;
$_CONVERT[$_OPT]['function'] = "escapevariables";
$_CONVERT[$_OPT]['nl2br'] = 1;
$_OPT++;
$_CONVERT[$_OPT] = array();
$_CONVERT[$_OPT]['label'] = "substring";
$_CONVERT[$_OPT]['description'] = "Works the same as substr in php";
$_CONVERT[$_OPT]['type'] = array(1,0,0);
$_CONVERT[$_OPT]['group'] = "string functions";
$_CONVERT[$_OPT]['fieldnames'] = array("this text","start","length");
$_CONVERT[$_OPT]['position'] = 4;
$_CONVERT[$_OPT]['function'] = "substr";
$_CONVERT[$_OPT]['nl2br'] = 1;
$_OPT++;
$_CONVERT[$_OPT] = array();
$_CONVERT[$_OPT]['label'] = "string replace";
$_CONVERT[$_OPT]['description'] = "Works the same as str_replace in php";
$_CONVERT[$_OPT]['type'] = array(0,0,1);
$_CONVERT[$_OPT]['group'] = "string functions";
$_CONVERT[$_OPT]['fieldnames'] = array("find","replace","in this text");
$_CONVERT[$_OPT]['position'] = 5;
$_CONVERT[$_OPT]['function'] = "str_replace";
$_CONVERT[$_OPT]['nl2br'] = 1;
$_OPT++;
$_CONVERT[$_OPT] = array();
$_CONVERT[$_OPT]['label'] = "string reverse";
$_CONVERT[$_OPT]['description'] = "Works the same as strrev in php";
$_CONVERT[$_OPT]['type'] = array(1);
$_CONVERT[$_OPT]['group'] = "string functions";
$_CONVERT[$_OPT]['fieldnames'] = array("string");
$_CONVERT[$_OPT]['position'] = 6;
$_CONVERT[$_OPT]['function'] = "strrev";
$_CONVERT[$_OPT]['nl2br'] = 1;
$_OPT++;
$_CONVERT[$_OPT] = array();
$_CONVERT[$_OPT]['label'] = "string to lower";
$_CONVERT[$_OPT]['description'] = "Works the same as strtolower in php";
$_CONVERT[$_OPT]['type'] = array(1);
$_CONVERT[$_OPT]['group'] = "string functions";
$_CONVERT[$_OPT]['fieldnames'] = array("string");
$_CONVERT[$_OPT]['position'] = 7;
$_CONVERT[$_OPT]['function'] = "strtolower";
$_CONVERT[$_OPT]['nl2br'] = 1;
$_OPT++;
$_CONVERT[$_OPT] = array();
$_CONVERT[$_OPT]['label'] = "string to upper";
$_CONVERT[$_OPT]['description'] = "Works the same as strtoupper in php";
$_CONVERT[$_OPT]['type'] = array(1);
$_CONVERT[$_OPT]['group'] = "string functions";
$_CONVERT[$_OPT]['fieldnames'] = array("string");
$_CONVERT[$_OPT]['position'] = 8;
$_CONVERT[$_OPT]['function'] = "strtoupper";
$_CONVERT[$_OPT]['nl2br'] = 1;
$_OPT++;
$_CONVERT[$_OPT] = array();
$_CONVERT[$_OPT]['label'] = "string length";
$_CONVERT[$_OPT]['description'] = "Length of string";
$_CONVERT[$_OPT]['type'] = array(0);
$_CONVERT[$_OPT]['group'] = "string functions";
$_CONVERT[$_OPT]['fieldnames'] = array("string");
$_CONVERT[$_OPT]['position'] = 9;
$_CONVERT[$_OPT]['function'] = "strlen";
$_OPT++;
$_CONVERT[$_OPT] = array();
$_CONVERT[$_OPT]['label'] = "dump variable";
$_CONVERT[$_OPT]['description'] = "Dump variable data";
$_CONVERT[$_OPT]['type'] = array(0);
$_CONVERT[$_OPT]['group'] = "string functions";
$_CONVERT[$_OPT]['fieldnames'] = array("string");
$_CONVERT[$_OPT]['position'] = 10;
$_CONVERT[$_OPT]['function'] = "var_dump";
$_OPT++;
$_CONVERT[$_OPT] = array();
$_CONVERT[$_OPT]['label'] = "export variable";
$_CONVERT[$_OPT]['description'] = "Export variable data";
$_CONVERT[$_OPT]['type'] = array(0);
$_CONVERT[$_OPT]['group'] = "string functions";
$_CONVERT[$_OPT]['fieldnames'] = array("string");
$_CONVERT[$_OPT]['position'] = 11;
$_CONVERT[$_OPT]['function'] = "export_var";
$_OPT++;
$_CONVERT[$_OPT] = array();
$_CONVERT[$_OPT]['label'] = "unserialize variable";
$_CONVERT[$_OPT]['description'] = "Serialize variable data";
$_CONVERT[$_OPT]['type'] = array(0);
$_CONVERT[$_OPT]['group'] = "string functions";
$_CONVERT[$_OPT]['fieldnames'] = array("string");
$_CONVERT[$_OPT]['position'] = 12;
$_CONVERT[$_OPT]['function'] = "unserialize";
$_OPT++;
$_CONVERT[$_OPT] = array();
$_CONVERT[$_OPT]['label'] = "newline to break";
$_CONVERT[$_OPT]['description'] = "Newline to break tag";
$_CONVERT[$_OPT]['type'] = array(0);
$_CONVERT[$_OPT]['group'] = "string functions";
$_CONVERT[$_OPT]['fieldnames'] = array("string");
$_CONVERT[$_OPT]['position'] = 13;
$_CONVERT[$_OPT]['function'] = "nl2br";
$_OPT++;
$_CONVERT[$_OPT] = array();
$_CONVERT[$_OPT]['label'] = "trim whitespace";
$_CONVERT[$_OPT]['description'] = "Removes extra whitespace from a string";
$_CONVERT[$_OPT]['type'] = array(0);
$_CONVERT[$_OPT]['group'] = "string functions";
$_CONVERT[$_OPT]['fieldnames'] = array("string");
$_CONVERT[$_OPT]['position'] = 14;
$_CONVERT[$_OPT]['function'] = "trim";
$_OPT++;
$_CONVERT[$_OPT] = array();
$_CONVERT[$_OPT]['label'] = "convert to html_entities";
$_CONVERT[$_OPT]['description'] = "Converts a string to html entities";
$_CONVERT[$_OPT]['type'] = array(0);
$_CONVERT[$_OPT]['group'] = "string functions";
$_CONVERT[$_OPT]['fieldnames'] = array("string");
$_CONVERT[$_OPT]['position'] = 15;
$_CONVERT[$_OPT]['function'] = "htmlentities";
$_OPT++;
// file functions
$_CONVERT[$_OPT] = array();
$_CONVERT[$_OPT]['label'] = "get file content";
$_CONVERT[$_OPT]['description'] = "Fetches data from from a local file";
$_CONVERT[$_OPT]['type'] = array(0);
$_CONVERT[$_OPT]['group'] = "file functions";
$_CONVERT[$_OPT]['fieldnames'] = array("path");
$_CONVERT[$_OPT]['position'] = 0;
$_CONVERT[$_OPT]['function'] = "file_get_contents";
$_CONVERT[$_OPT]['nl2br'] = 1;
$_OPT++;
$_CONVERT[$_OPT] = array();
$_CONVERT[$_OPT]['label'] = "view source";
$_CONVERT[$_OPT]['description'] = "source of a http file";
$_CONVERT[$_OPT]['type'] = array(0);
$_CONVERT[$_OPT]['group'] = "file functions";
$_CONVERT[$_OPT]['fieldnames'] = array("http path");
$_CONVERT[$_OPT]['position'] = 1;
$_CONVERT[$_OPT]['function'] = "viewsource";
$_CONVERT[$_OPT]['nl2br'] = 1;
$_OPT++;
$_CONVERT[$_OPT] = array();
$_CONVERT[$_OPT]['label'] = "write to file";
$_CONVERT[$_OPT]['description'] = "write text to file";
$_CONVERT[$_OPT]['type'] = array(0,1);
$_CONVERT[$_OPT]['group'] = "file functions";
$_CONVERT[$_OPT]['fieldnames'] = array("location","text");
$_CONVERT[$_OPT]['position'] = 2;
$_CONVERT[$_OPT]['function'] = "writef";
$_OPT++;
// server info functions
$_CONVERT[$_OPT] = array();
$_CONVERT[$_OPT]['label'] = "phpinfo";
$_CONVERT[$_OPT]['description'] = "Fetches php configuration";
$_CONVERT[$_OPT]['type'] = array();
$_CONVERT[$_OPT]['group'] = "server info";
$_CONVERT[$_OPT]['fieldnames'] = array();
$_CONVERT[$_OPT]['position'] = 0;
$_CONVERT[$_OPT]['function'] = "phpinfo";
/* keep this for template purposes
$_OPT++;
$_CONVERT[$_OPT] = array();
$_CONVERT[$_OPT]['label'] = "";
$_CONVERT[$_OPT]['description'] = "";
$_CONVERT[$_OPT]['type'] = array(0);
$_CONVERT[$_OPT]['group'] = "";
$_CONVERT[$_OPT]['fieldnames'] = array("");
$_CONVERT[$_OPT]['position'] = 0;
$_CONVERT[$_OPT]['function'] = "";
*/
?>