<?php
/* THC xExecute commands

Author: Remco Kouw
Site: http://www.hacksuite.com
Last Edit: 02-12-2023
*/
if(!defined('IN_SCRIPT')){
	exit;
}
$_CONTEXT['thc_xe']['commands'] = array();
$_CONTEXT['thc_xe']['commands']['ping'] = array();
$_CONTEXT['thc_xe']['commands']['ping']['description'] = "send ping packages";
$_CONTEXT['thc_xe']['commands']['ping']['os'] = array("windows","linux");
$_CONTEXT['thc_xe']['commands']['ping']['commands'] = array();
$_CONTEXT['thc_xe']['commands']['ping']['commands'][0] = array("ping [host]","sends icmp messages to the specified host [host] and waits for echo replies");
$_CONTEXT['thc_xe']['commands']['netstat'] = array();
$_CONTEXT['thc_xe']['commands']['netstat']['description'] = "shows connections on the system";
$_CONTEXT['thc_xe']['commands']['netstat']['os'] = array("linux");
$_CONTEXT['thc_xe']['commands']['netstat']['commands'] = array();
$_CONTEXT['thc_xe']['commands']['netstat']['commands'][0] = array("netstat -l","lists all listening ports on the system");
$_CONTEXT['thc_xe']['commands']['netstat']['commands'][1] = array("netstat -a","displays all active network connections and listening sockets");
$_CONTEXT['thc_xe']['commands']['netstat']['commands'][2] = array("netstat -p","adds the pid and the name of the program associated with each network connection");
$_CONTEXT['thc_xe']['commands']['netstat']['commands'][3] = array("netstat -s","shows network statistics, including various counts of tcp, udp, ip packets");
$_CONTEXT['thc_xe']['commands']['netstat']['commands'][4] = array("netstat -M","shows information about the loaded kernel modules related to networking");
$_CONTEXT['thc_xe']['commands']['dig'] = array();
$_CONTEXT['thc_xe']['commands']['dig']['description'] = "gets dns records";
$_CONTEXT['thc_xe']['commands']['dig']['os'] = array("linux");
$_CONTEXT['thc_xe']['commands']['dig']['commands'] = array();
$_CONTEXT['thc_xe']['commands']['dig']['commands'][0] = array("dig [domain] A","queries the dns server for the ipv4 address associated with the domain [domain]");
$_CONTEXT['thc_xe']['commands']['dig']['commands'][1] = array("dig [domain] AAAA","queries the dns server for the ipv6 address associated with the domain [domain]");
$_CONTEXT['thc_xe']['commands']['dig']['commands'][2] = array("dig [domain] MX","queries for the mx records of the domain [domain]");
$_CONTEXT['thc_xe']['commands']['dig']['commands'][3] = array("dig [domain] SOA","fetches the start of authority record for the domain [domain]");
$_CONTEXT['thc_xe']['commands']['dig']['commands'][4] = array("dig [domain] NS","retrieves the name server records for the domain [domain]");
$_CONTEXT['thc_xe']['commands']['dig']['commands'][5] = array("dig -x [ip]","performs a reverse dns lookup for the ip address [ipv4]");
$_CONTEXT['thc_xe']['commands']['nslookup'] = array();
$_CONTEXT['thc_xe']['commands']['nslookup']['description'] = "gets dns records";
$_CONTEXT['thc_xe']['commands']['nslookup']['os'] = array("windows");
$_CONTEXT['thc_xe']['commands']['nslookup']['commands'] = array();
$_CONTEXT['thc_xe']['commands']['nslookup']['commands'][0] = array("nslookup [domain]","performs a dns lookup for the domain [domain] and displays information such as the corresponding ip addresses");
$_CONTEXT['thc_xe']['commands']['nslookup']['commands'][1] = array("nslookup -type=ns [domain]","retrieves the name server records for the domain [domain]");
$_CONTEXT['thc_xe']['commands']['nslookup']['commands'][2] = array("nslookup -type=aaaa [domain]","queries the dns server for the ipv6 address associated with the domain [domain]");
$_CONTEXT['thc_xe']['commands']['nslookup']['commands'][3] = array("nslookup -type=mx [domain]","queries for the mx records of the domain [domain]");
$_CONTEXT['thc_xe']['commands']['nslookup']['commands'][4] = array("nslookup -type=soa [domain]","fetches the start of authority record for the domain [domain]");
$_CONTEXT['thc_xe']['commands']['nslookup']['commands'][5] = array("nslookup [ipv4]","performs a reverse dns lookup for the ip address [ipv4]");
$_CONTEXT['thc_xe']['commands']['tracert'] = array();
$_CONTEXT['thc_xe']['commands']['tracert']['description'] = "traces the route packets travel";
$_CONTEXT['thc_xe']['commands']['tracert']['os'] = array("windows");
$_CONTEXT['thc_xe']['commands']['tracert']['commands'] = array();
$_CONTEXT['thc_xe']['commands']['tracert']['commands'][0] = array("tracert [domain]","traces the route to the destination domain [domain] and displays the ip addresses of routers along the path");
$_CONTEXT['thc_xe']['commands']['tracert']['commands'][1] = array("tracert -h [hops] [domain]","command limits the number of hops to [hops] (default is 30) when tracing the route to the destination domain [domain]");
$_CONTEXT['thc_xe']['commands']['tracert']['commands'][2] = array("tracert -d [domain]","prevents tracert from attempting to resolve ip addresses to hostnames when tracing the route to the destination domain [domain]");
$_CONTEXT['thc_xe']['commands']['tracert']['commands'][3] = array("tracert -q [queries] [domain]","sets the number of queries per hop to [queries] when tracing the route to the destination domain [domain]");
$_CONTEXT['thc_xe']['commands']['tracert']['commands'][4] = array("tracert -p [port] [domain]","specifies the destination port [port] when tracing the route to the destination domain [domain]");
$_CONTEXT['thc_xe']['commands']['tracert']['commands'][5] = array("tracert -P mtu [domain]","option uses path mtu discovery when tracing the route to the destination domain [domain]");
$_CONTEXT['thc_xe']['commands']['tracert']['commands'][6] = array("tracert -6 [domain]","traces the route to the destination ipv6 domain [domain]");
$_CONTEXT['thc_xe']['commands']['tracert']['commands'][7] = array("tracert -t [domain]","includes timestamps for each hop when tracing the route to the destination domain [domain]");
$_CONTEXT['thc_xe']['commands']['tracert']['commands'][8] = array("tracert -w [ms] [domain]","sets the timeout for each probe to [ms] milliseconds (1 second) when tracing the route to the destination domain [domain]");
$_CONTEXT['thc_xe']['commands']['tracert']['commands'][9] = array("tracert -d [domain] -D [dscp]","traces the route to the destination domain [domain] without resolving ip addresses to hostnames and uses the specified dscp value [dscp]");
$_CONTEXT['thc_xe']['commands']['traceroute'] = array();
$_CONTEXT['thc_xe']['commands']['traceroute']['description'] = "traces the route packets travel";
$_CONTEXT['thc_xe']['commands']['traceroute']['os'] = array("linux");
$_CONTEXT['thc_xe']['commands']['traceroute']['commands'] = array();
$_CONTEXT['thc_xe']['commands']['traceroute']['commands'][0] = array("traceroute [domain]","traces the route to the destination domain [domain]");
$_CONTEXT['thc_xe']['commands']['traceroute']['commands'][1] = array("traceroute -m [hops] [domain]","limits the number of hops to [hops] (default is 64) when tracing the route to the destination domain [domain]");
$_CONTEXT['thc_xe']['commands']['traceroute']['commands'][2] = array("traceroute -s [bytes] [domain]","sets the packet size to [bytes] bytes when tracing the route to the destination domain [domain]");
$_CONTEXT['thc_xe']['commands']['traceroute']['commands'][3] = array("traceroute -T [domain]","uses tcp syn packets instead of icmp packets for the traceroute to the destination domain [domain]");
$_CONTEXT['thc_xe']['commands']['traceroute']['commands'][4] = array("traceroute -U [domain]","uses udp packets instead of icmp packets for the traceroute to the destination domain [domain]");
$_CONTEXT['thc_xe']['commands']['traceroute']['commands'][5] = array("traceroute -n [domain]","prevents a traceroute on domain [domain] from attempting to resolve ip addresses to hostnames, showing numeric ip addresses instead");
$_CONTEXT['thc_xe']['commands']['net'] = array();
$_CONTEXT['thc_xe']['commands']['net']['description'] = "windows network related tasks";
$_CONTEXT['thc_xe']['commands']['net']['os'] = array("windows");
$_CONTEXT['thc_xe']['commands']['net']['commands'] = array();
$_CONTEXT['thc_xe']['commands']['net']['commands'][0] = array("net user","shows a list of users on the network");
$_CONTEXT['thc_xe']['commands']['net']['commands'][1] = array("net group","displays information about groups on the network");
$_CONTEXT['thc_xe']['commands']['net']['commands'][2] = array("net share","shows a list of shared resources on the computer");
$_CONTEXT['thc_xe']['commands']['ps'] = array();
$_CONTEXT['thc_xe']['commands']['ps']['description'] = "shows current processes";
$_CONTEXT['thc_xe']['commands']['ps']['os'] = array("linux");
$_CONTEXT['thc_xe']['commands']['ps']['commands'] = array();
$_CONTEXT['thc_xe']['commands']['ps']['commands'][0] = array("ps aux","detailed information about all processes");
$_CONTEXT['thc_xe']['commands']['tasklist'] = array();
$_CONTEXT['thc_xe']['commands']['tasklist']['description'] = "shows current processes";
$_CONTEXT['thc_xe']['commands']['tasklist']['os'] = array("windows");
$_CONTEXT['thc_xe']['commands']['tasklist']['commands'] = array();
$_CONTEXT['thc_xe']['commands']['tasklist']['commands'][0] = array("tasklist","detailed information about all processes");
$_CONTEXT['thc_xe']['commands']['lsof'] = array();
$_CONTEXT['thc_xe']['commands']['lsof']['description'] = "list open files";
$_CONTEXT['thc_xe']['commands']['lsof']['os'] = array("linux");
$_CONTEXT['thc_xe']['commands']['lsof']['commands'] = array();
$_CONTEXT['thc_xe']['commands']['lsof']['commands'][0] = array("lsof","open files and the processes that opened them");
$_CONTEXT['thc_xe']['commands']['whoami'] = array();
$_CONTEXT['thc_xe']['commands']['whoami']['description'] = "displays username";
$_CONTEXT['thc_xe']['commands']['whoami']['os'] = array("linux","windows");
$_CONTEXT['thc_xe']['commands']['whoami']['commands'] = array();
$_CONTEXT['thc_xe']['commands']['whoami']['commands'][0] = array("whoami","displays username of current user");
$_CONTEXT['thc_xe']['commands']['ifconfig'] = array();
$_CONTEXT['thc_xe']['commands']['ifconfig']['description'] = "network interface information";
$_CONTEXT['thc_xe']['commands']['ifconfig']['os'] = array("linux");
$_CONTEXT['thc_xe']['commands']['ifconfig']['commands'] = array();
$_CONTEXT['thc_xe']['commands']['ifconfig']['commands'][0] = array("ifconfig","information about network interfaces on a linux system");
$_CONTEXT['thc_xe']['commands']['ipconfig'] = array();
$_CONTEXT['thc_xe']['commands']['ipconfig']['description'] = "network interface information";
$_CONTEXT['thc_xe']['commands']['ipconfig']['os'] = array("windows");
$_CONTEXT['thc_xe']['commands']['ipconfig']['commands'] = array();
$_CONTEXT['thc_xe']['commands']['ipconfig']['commands'][0] = array("ipconfig","information about network interfaces on a windows system");
$_CONTEXT['thc_xe']['commands']['arp'] = array();
$_CONTEXT['thc_xe']['commands']['arp']['description'] = "address translation tables";
$_CONTEXT['thc_xe']['commands']['arp']['os'] = array("windows");
$_CONTEXT['thc_xe']['commands']['arp']['commands'] = array();
$_CONTEXT['thc_xe']['commands']['arp']['commands'][0] = array("arp -a","ip-to-physical address translation tables used by the address resolution protocol");
$_CONTEXT['thc_xe']['commands']['route'] = array();
$_CONTEXT['thc_xe']['commands']['route']['description'] = "ip routing table";
$_CONTEXT['thc_xe']['commands']['route']['os'] = array("windows");
$_CONTEXT['thc_xe']['commands']['route']['commands'] = array();
$_CONTEXT['thc_xe']['commands']['route']['commands'][0] = array("route print","display and manipulate the ip routing table");
$_CONTEXT['thc_xe']['commands']['tree'] = array();
$_CONTEXT['thc_xe']['commands']['tree']['description'] = "output files and folders";
$_CONTEXT['thc_xe']['commands']['tree']['os'] = array("windows","linux");
$_CONTEXT['thc_xe']['commands']['tree']['commands'] = array();
$_CONTEXT['thc_xe']['commands']['tree']['commands'][0] = array("tree","displays all folders and files on a windows system");
$_CONTEXT['thc_xe']['commands']['cd'] = array();
$_CONTEXT['thc_xe']['commands']['cd']['description'] = "print work directory";
$_CONTEXT['thc_xe']['commands']['cd']['os'] = array("windows");
$_CONTEXT['thc_xe']['commands']['cd']['commands'] = array();
$_CONTEXT['thc_xe']['commands']['cd']['commands'][0] = array("cd","prints the current directory");
$_CONTEXT['thc_xe']['commands']['pwd'] = array();
$_CONTEXT['thc_xe']['commands']['pwd']['description'] = "print work directory";
$_CONTEXT['thc_xe']['commands']['pwd']['os'] = array("linux");
$_CONTEXT['thc_xe']['commands']['pwd']['commands'] = array();
$_CONTEXT['thc_xe']['commands']['pwd']['commands'][0] = array("pwd","prints the current directory");
?>