/*
Contains all js for THC_XS

Author: Remco Kouw
Site: http://www.hacksuite.com
Last Edit: 23-02-2019
*/
/* create forms for scan settings */
$(document).on("change","select.scantype",function(){
	$('.modrow#select').remove();
	$('input.harvestip').remove();
	$('input.scanbutton').remove();
	$('input.dumpbutton').remove();
	$('input.manageremove').remove();
	$('input.managedump').remove();
	$('input.copy').remove();
	$('.modrow#ports').show();
	$('.modrow#hosts').show();
	if($(this).val()=="tcp"){
		/* ipv4/ipv6 tcp */
		$('div.mt5').append('<input type=\"submit\" name=\"submit\" class=\"scanbutton\" value=\"Scan\" />');
	}
	else if($(this).val()=="udp"){
		/* ipv4/ipv6 udp */
		$('div.mt5').append('<input type=\"submit\" name=\"submit\" class=\"scanbutton\" value=\"Scan\" />');
	}
	else if($(this).val()==5){
		/* harvest ip addresses */
		$.ajax({
			type: "POST",
			url: "Modules/thc_sh/load_queries.php",
			dataType: "json",
			success: function(json){
				if(json.jresult==false){
					alert(json.jmessage);
				}
				else{
					$('div.mt5').append(' <input type="submit" name="submit" class="harvestip" value="Harvest" />');
					$('.modrow#scansettings').after('<div class="modrow" id="select"><div class="modleft">results</div><div class="modright">'+json.jmessage+'</div></div>');
				}
			},
			error:function(xhr,ajaxOptions,thrownError){
				if(xhr.status==404) {
					alert("Can't find the Shodown module");
				}
				else{
					alert("Failed to access the Shodown module");
				}
			}
		});
	}
	else if($(this).val()==6){
		/* result files managing */
		$.ajax({
			type: "POST",
			url: "Modules/thc_xs/scans.php",
			dataType: "json",
			success: function(json){
				if(json.jresult==false){
					alert(json.jmessage);
				}
				else{
					$('div.mt5').append(' <input type="submit" name="submit" class="manageremove" value="Remove File" />');
					$('div.mt5').append(' <input type="submit" name="submit" class="managedump" value="View File" />');
					$('.modrow#scansettings').after('<div class="modrow" id="select"><div class="modleft">results</div><div class="modright">'+json.jmessage+'</div></div>');
					$('.modrow#ports').hide();
					$('.modrow#hosts').hide();
					$('div.mt5').append(' <input type=\"submit\" name=\"submit\" class=\"copy\" value=\"Reset\" />');
				}
			},
		});
	}
	else{
		/* invalid option */
		alert('Action doesn\'t exist');
	}
});
/* collect ip addresses from shodan search */
$(document).on("submit","form.shodan",function(e){
	e.preventDefault();
	dataString = $(this).serialize();
	$.ajax({
		type: "POST",
		data: dataString,
		url: "Modules/thc_xs/harvest.php",
		dataType: "json",
		success: function(json){
			if(json.jresult==false){
				alert(json.jmessage);
			}
			else{
				// add found ip address from shodan search into input field
				$('input.ipaddresses').val(json.jmessage);
				$('input.harvestip').remove();
				$('div.mt5').append('<input type=\"submit\" name=\"submit\" class=\"scanbutton\" value=\"Scan\" />');
				$('div.mt5').append(' <input type=\"submit\" name=\"submit\" class=\"copy\" value=\"Reset\" />');
				// remove harvest and dump log options from selection menu and instead highlight tcp ipv4 scan
				$(".scantype option[value='5']").remove();
				$(".scantype option[value='6']").remove();
				$(".scantype option[value='1']").attr('selected','selected');
				$('.modrow#select').remove();
			}
		}
	});
});
/* generate form for shodan ip harvester */
$(document).on("click","input.harvestip",function(e){
	e.preventDefault();
	var form = $('<form action="Modules/thc_xs/harvest.php" method="post" class="shodan">' + '<input type="hidden" name="sResultFile" value="'+$('select.sQuery').val()+'" />' + '</form>');
	$('body').append(form);
	$(form).submit();
});
/* reset form to its orginal state */
$(document).on("click","input.copy",function(e){
	e.preventDefault();
	$('input.ipaddresses').val('');
	// if the values are already in the selection menu, there's no need to add them again
	if(0==$('.scantype option[value=5]').length){
		$(".scantype").append('<option value=\"5\">Harvest IPs from Shodown Scan</option>');
		$(".scantype").append('<option value=\"6\">Result Files</option>');
	}
	$('#sType').show('slow');
	$('input.manualports').remove();
	$('.modrow#ports').show();
	$('.modrow#hosts').show();
	$('input.manageremove').remove();
	$('input.managedump').remove();
	$('input.copy').remove();
	$('.modrow#select').remove();
});
/* use manual ports instead of port ranges */
$(document).on("change","#sType",function(e){
	e.preventDefault();
	if(this.value=='manual'){
	 	$('#sType').hide('slow');
	 	$("#sPorts").append('<input type="text" name="sManualPorts" value="" class=\"manualports\" title="Separate ports by commas">');
	}
});