<?php
/* Log manager

Author: Remco Kouw
Site: http://www.hacksuite.com
Last Edit: 06-02-2024
*/
if(!defined('IN_SCRIPT')){
	exit;
}
if(defined('SPIDER')){
	$_CONTEXT['nativekeywords'][6] = array("native","view","log","logging","logbook","create","editor","query");
}
else{
	$_CONTEXT['subtitle'] = "Log Manager";
	// target files we need, so make sure they are present
	$aFiles = array($_PATHS['functions_root']."/raw_to_array.php",$_PATHS['functions_root']."/getfilebydir.php",$_PATHS['functions_root']."/fwrite.php",$_PATHS['functions_root']."/get_file_data.php");
	for($x=0;$x<count($aFiles);$x++){
		(!IsThere($aFiles[$x]) ? include_once($_PATHS['end']) : include_once($aFiles[$x]));
	}
	// no need to go on if there are no files in the log directory
	if(false==($aFiles = GetFilesByDirectory($_PATHS['log_root'],0))){
		$_CONTEXT['errors'][] = array('error'=>'No log files in <b>'.$_PATHS['log_root'].'</b>','type'=>'2','fatal'=>'1','line'=>__LINE__,'file'=>__FILE__);
		include_once($_PATHS['end']);
	}
	include($_PATHS['data_root']."/logsdata.php");
	// validate whether we have valid log files and data structures
	$aLogFileNames = array();
	$iLogIndex = -1;
	if(isset($_POST['sSelectOption']) && $_POST['sSelectOption']==6 && isset($_POST['sLogName']) && ($_POST['sLogName']==0 || $_POST['sLogName']==-1)){
		// if no log file is specified in the log query creation tool, the default log will be set
		if(!isset($_PATHS['write_def']) || $_PATHS['write_def']==""){
			$_CONTEXT['errors'][] = array('error'=>'No default log is set in paths.php','type'=>'2','fatal'=>'1','line'=>__LINE__,'file'=>__FILE__);
			include_once($_PATHS['end']);
		}
		$aLogFileParts = explode("/",$_PATHS['write_def']);
		$_POST['sLogName'] = $aLogFileParts[count($aLogFileParts)-1];
		$_POST['iDefaultLog'] = 1;
	}
	if(count($_CONTEXT['l_formats'])==($iFiles = @count($aFiles))){
		for($x=0;$x<$iFiles;$x++){
			$aLogFileNames[$x] = $_CONTEXT['l_formats'][$x]['file'];
			if($iLogIndex==-1 && isset($_POST['sLogName']) && $_CONTEXT['l_formats'][$x]['file']==$_POST['sLogName']){
				$iLogIndex = $x;
			}
		}
	}
	else{
		$_CONTEXT['errors'][] = array('error'=>'Amount of log files doesn\'t correspond with content in <b>'.$_PATHS['data_root'].'/logsdata.php</b>','type'=>'1','fatal'=>'1','line'=>__LINE__,'file'=>__FILE__);
		include_once($_PATHS['end']);
	}
	$iTotalLogFiles = count($aLogFileNames);
	if(isset($_POST['sLogName']) && $iLogIndex==-1){
		$_CONTEXT['errors'][] = array('error'=>'Requested log file hasn\'t been configured in '.$_PATHS['data_root'].'/logsdata.php','type'=>'1','fatal'=>'1','line'=>__LINE__,'file'=>__FILE__);
		include_once($_PATHS['end']);
	}
	if(isset($_POST['sSelectOption'])){
		switch($_POST['sSelectOption']){
			/* view logs */
			case"1":
			if(!isset($_POST['sLogName'])){
				// form
				$sSelect = "<select name=\"sLogName\">\n";
				// output the logs that are available
				$sSelect .= "<option value=\"-1\">select a log</option>\n";
				for($x=0;$x<count($aFiles);$x++){
					// let's make the file selection menu
					$sSelect .= "<option value=\"".$aFiles[$x]."\">".$aFiles[$x]."</option>\n";
				}
				$sSelect .= "</select>\n";
				$sCode .= "			<form method=\"post\">\n";
				$sCode .= "			<div class=\"emboss borderr5 border1pxtrans pad5 edgeglow overflw\">\n";
				$sCode .= "				<div class=\"embosshdrnocenter border1pxtrans pad10\">View carnivore log files</div>\n";
				$sCode .= "				<div class=\"cc_record\">\n";
				$sCode .= "					<div class=\"flt pad3 w150\">select log:</div><div class=\"flt pad3\">".$sSelect."</div>\n";
				$sCode .= "				</div>\n";
				$sCode .= "				<div class=\"clear\"></div>\n";
				$sCode .= "				<div class=\"cc_record\">\n";
				$sCode .= "					<div class=\"flt pad3\"><input type=\"hidden\" name=\"sSelectOption\" value=\"".(isset($_POST['sSelectOption']) ? $_POST['sSelectOption'] : 0)."\" /><input type=\"hidden\" name=\"iCFG\" value=\"".$_POST['iCFG']."\" /><input type=\"submit\" name=\"send\" value=\"View Log\" /></div>\n";
				$sCode .= "				</div>\n";
				$sCode .= "				<div class=\"clear\"></div>\n";
				$sCode .= "			</div>\n";
				$sCode .= "			</form>\n";
			}
			else{
				// handler
				$sCode .= "<style>.cc_record{display:flex;flex-direction:column;}.rowlog{display:flex;width:100%;box-sizing:border-box;}.header{font-weight:bold;padding:3px;}.pad3{padding:3px;flex:1;}</style>";
				$sCode .= "			<form method=\"post\">\n";
				$sCode .= "			<div class=\"emboss borderr5 border1pxtrans pad5 edgeglow overflw\">\n";
				$sCode .= "				<div class=\"embosshdrnocenter border1pxtrans pad10\">View carnivore log files</div>\n";
				$sCode .= "				<div class=\"cc_record\">\n";
				$aLogProperties = $_CONTEXT['l_formats'][$iLogIndex];
				if($aLogProperties['format']['type']=="array"){
					// include the logfile, because this is an array
					include($_PATHS['log_root']."/".$_POST['sLogName']);
					if(!isset($_CONTEXT[$_CONTEXT['l_formats'][$iLogIndex]['format']['root']]) || !is_array($_CONTEXT[$_CONTEXT['l_formats'][$iLogIndex]['format']['root']])){
						$_CONTEXT['errors'][] = array('error'=>'Root variable '.(!isset($_CONTEXT['l_formats'][$iLogIndex]['format']['root']) ? '[undefined]' : $_CONTEXT['l_formats'][$iLogIndex]['format']['root']).' hasn\'t been defined or is not an array in log '.$_POST['sLogName'],'type'=>'2','fatal'=>'1','line'=>__LINE__,'file'=>__FILE__);
						include_once($_PATHS['end']);
					}
					$aContent = $_CONTEXT[$_CONTEXT['l_formats'][$iLogIndex]['format']['root']];
					// print head and body
					$sHeadTable = "<div class=\"rowlog header\">\n";
					$sBodyTable = "<div class=\"rowlog\">\n";
					$iKeys = 0;
					foreach($aContent as $sKey=>$mVarProperties){
						$iKeys++;
						$sHeadTable .= "	<div class=\"pad3\">".$sKey."</div>\n";
						$sBodyTable .= "	<div class=\"pad3\">";
						if(is_array($mVarProperties)){
							// implode arrays
							$sBodyTable .= implode(",",$mVarProperties);
						}
						else{
							if($sKey=="installed" || $sKey=="last_update" || $sKey=="timestamp" || $sKey=="time" || $sKey=="last_scan"){
								$sBodyTable .= date($_CONTEXT['time_pattern']." H:i:s",$mVarProperties);
							}
							else{
								$sBodyTable .= $mVarProperties;
							}
						}
						$sBodyTable .= "</div>\n";
					}
					// before we print the results make sure the content is not corrupt
					if(count($aLogProperties['format']['keys'])!=$iKeys){
						$_CONTEXT['errors'][] = array('error'=>'The number of properties for the specified log defined in logsdata.php doesn\'t match the content in the specified log','type'=>'2','fatal'=>'1','line'=>__LINE__,'file'=>__FILE__);
						include_once($_PATHS['end']);
					}
					$sHeadTable .= "</div>\n";
					$sBodyTable .= "</div>\n";
					// add to output buffer
					$sCode .= $sHeadTable;
					$sCode .= $sBodyTable;
				}
				else{
					if(false==($aFileData = RawToArray($_PATHS['log_root']."/".$_POST['sLogName']))){
						// we need to change the file and line number to prevent confusion where the error has taken place
						$iErrors = count($_CONTEXT['errors'])-1;
						$_CONTEXT['errors'][$iErrors]['file'] = __FILE__;
						$_CONTEXT['errors'][$iErrors]['line'] = __LINE__;
						include($_PATHS['end']);
					}
					// print head
					$sCode .= "<div class=\"rowlog header\">\n";
					for($z=0;$z<$aLogProperties['format']['items'];$z++){
						$sCode .= "	<div class=\"pad3\">".$aLogProperties['format']['labels'][$z]."</div>\n";
					}
					$sCode .= "</div>\n";
					// print loglines
					$iRoot = strlen($_SERVER['DOCUMENT_ROOT']);
					for($z=0;$z<count($aFileData);$z++){
						$sCode .= "<div class=\"rowlog\">\n";
						for($y=0;$y<$aLogProperties['format']['items'];$y++){
							if($aLogProperties['format']['labels'][$y]=="file"){
								$aFileData[$z][$y] = substr($aFileData[$z][$y],$iRoot);
							}
							if($aLogProperties['format']['labels'][$y]=="time" || $aLogProperties['format']['labels'][$y]=="timestamp"){
								$aFileData[$z][$y] = date($_CONTEXT['time_pattern']." H:i:s",$aFileData[$z][$y]);
							}
							$sCode .= "	<div class=\"pad3\">".$aFileData[$z][$y]."</div>\n";
						}
						$sCode .= "</div>\n";
					}
				}
				$sCode .= "				</div>\n";
				$sCode .= "			</div>\n";
				$sCode .= "			</form>\n";
			}
			break;
			/* create a new logfile */
			case"2":
			if(!isset($_POST['sNewLog'])){
				// form
				$sCode .= "			<form method=\"post\">\n";
				$sCode .= "			<div class=\"emboss borderr5 border1pxtrans pad5 edgeglow overflw\">\n";
				$sCode .= "				<div class=\"embosshdrnocenter border1pxtrans pad10\">Create log files</div>\n";
				$sCode .= "				<div class=\"cc_record\">\n";
				$sCode .= "					<div class=\"flt pad3 w150\">filename:</div><div class=\"flt pad3\"><input type=\"text\" name=\"sNewLog\" value=\"\" /><br />name of the new log file</div>\n";
				$sCode .= "				</div>\n";
				$sCode .= "				<div class=\"clear\"></div>\n";
				$sCode .= "				<div class=\"cc_record\">\n";
				$sCode .= "					<div class=\"flt pad3 w150\">labels:</div><div class=\"flt pad3\"><input type=\"text\" name=\"sLabels\" value=\"\"  placeholder=\"eg ip|time|username\" /><br />labels are the items that you want to log, use the pipe character to separate characters</div>\n";
				$sCode .= "				</div>\n";
				$sCode .= "				<div class=\"clear\"></div>\n";
				$sCode .= "				<div class=\"cc_record\">\n";
				$sCode .= "					<div class=\"flt pad3\"><input type=\"hidden\" name=\"sSelectOption\" value=\"".(isset($_POST['sSelectOption']) ? $_POST['sSelectOption'] : 0)."\" /><input type=\"hidden\" name=\"iCFG\" value=\"".$_POST['iCFG']."\" /><input type=\"submit\" name=\"send\" value=\"Create Log\" /></div>\n";
				$sCode .= "				</div>\n";
				$sCode .= "				<div class=\"clear\"></div>\n";
				$sCode .= "			</div>\n";
				$sCode .= "			</form>\n";
			}
			else{
				// handler
				$_POST['sNewLog'] = trim($_POST['sNewLog']);
				if(!preg_match('/^[a-z0-9\-_]+\.[a-z0-9]+$/i',$_POST['sNewLog'])){
					$_CONTEXT['errors'][] = array('error'=>'New log has an invalid name','type'=>'1','fatal'=>'0','line'=>__LINE__,'file'=>__FILE__);
					include_once($_PATHS['end']);
				}
				if(in_array($_POST['sNewLog'],$aLogFileNames)){
					$_CONTEXT['errors'][] = array('error'=>'File already exists in '.$_PATHS['data_dir'].'/logsdata.php','type'=>'1','fatal'=>'0','line'=>__LINE__,'file'=>__FILE__);
					include_once($_PATHS['end']);
				}
				if(!isset($_POST['sLabels']) || $_POST['sLabels']==""){
					$_CONTEXT['errors'][] = array('error'=>'Invalid label data specified','type'=>'1','fatal'=>'0','line'=>__LINE__,'file'=>__FILE__);
					include_once($_PATHS['end']);
				}
				// check if we have proper labels
				$aLabels = @explode("|",$_POST['sLabels']);
				$iLabels = @count($aLabels);
				$aUnique = @array_unique($aLabels);
				$iUnique = @count($aUnique);
				if($iUnique!=$iLabels){
					$_CONTEXT['errors'][] = array('error'=>'Can only use a label name once','type'=>'1','fatal'=>'0','line'=>__LINE__,'file'=>__FILE__);
					include_once($_PATHS['end']);
				}
				// filter out bad characters
				$sLabelString = "";
				for($z=0;$z<$iLabels;$z++){
					$aLabels[$z] = trim($aLabels[$z]);
					if(!preg_match('/^[a-z0-9\-_ ]+$/',$aLabels[$z])){
						$_CONTEXT['errors'][] = array('error'=>'Label names can contain the following characters: [a-z0-9\-_ ]','type'=>'1','fatal'=>'0','line'=>__LINE__,'file'=>__FILE__);
						include_once($_PATHS['end']);
						break;
					}
					if($z!=0){
						$sLabelString .= ",";
					}
					$sLabelString .= "\"".$aLabels[$z]."\"";
				}
				// create the data for logsdata.php
				$sBuffer = "\$_CONTEXT['l_formats'][".$iTotalLogFiles."] = array();\n";
				$sBuffer .= "\$_CONTEXT['l_formats'][".$iTotalLogFiles."]['file'] = \"".$_POST['sNewLog']."\";\n";
				$sBuffer .= "\$_CONTEXT['l_formats'][".$iTotalLogFiles."]['format'] = array();\n";
				$sBuffer .= "\$_CONTEXT['l_formats'][".$iTotalLogFiles."]['format']['type'] = \"plain\";\n";
				$sBuffer .= "\$_CONTEXT['l_formats'][".$iTotalLogFiles."]['format']['separate'] = \"|\";\n";
				$sBuffer .= "\$_CONTEXT['l_formats'][".$iTotalLogFiles."]['format']['labels'] = array(".$sLabelString.");\n";
				$sBuffer .= "\$_CONTEXT['l_formats'][".$iTotalLogFiles."]['format']['items'] = count(\$_CONTEXT['l_formats'][".$iTotalLogFiles."]['format']['labels']);\n";
				$sBuffer .= "\$_CONTEXT['l_formats'][".$iTotalLogFiles."]['format']['editable'] = true;\n";
				$sBuffer .= "?>";
				// get the raw data from logsdata.php
				if(false==($sFileData = GetFileData($_PATHS['data_root']."/logsdata.php"))){
					include_once($_PATHS['end']);
				}
				$aData = explode("?>",$sFileData);
				$sData = $aData[0].$sBuffer;
				// replace current date
				$sCurrentDate = date($_CONTEXT['time_pattern'],time());
				$sReplaceDate = "/(Last Edit:\s)(\d+\-\d+\-\d+)/";
				// extract the last edit time
				preg_match($sReplaceDate,$sData,$aPieces);
				if(!isset($aPieces[2])){
					$_CONTEXT['errors'][] = array('error'=>'Invalid last edit time properties in header comment','type'=>'2','fatal'=>'1','line'=>__LINE__,'file'=>__FILE__);
					include_once($_PATHS['end']);
				}
				// replace previous edit time with the current date
				$sData = str_replace($aPieces[2],$sCurrentDate,$sData);
				// overwrite data file
				if(!WriteF($_PATHS['data_root']."/logsdata.php",$sData,"w")){
					// we need to change the file and line number to prevent confusion where the error has taken place
					$iErrors = count($_CONTEXT['errors'])-1;
					$_CONTEXT['errors'][$iErrors]['file'] = __FILE__;
					$_CONTEXT['errors'][$iErrors]['line'] = __LINE__;
					include_once($_PATHS['end']);
				}
				// create log file
				if(!WriteF($_PATHS['log_root']."/".$_POST['sNewLog'],"","w")){
					$_CONTEXT['errors'][] = array('error'=>'Failed to create log file '.$_POST['sNewLog'].', it\'s highly recommended to create it manually in order to prevent fatal errors when you open this configuration page','type'=>'1','fatal'=>'1','line'=>__LINE__,'file'=>__FILE__);
					include_once($_PATHS['end']);
				}
				else{
					$sCode .= "<div class=\"spacingmsg\">".$_CONTEXT['result_headers']['result']."<p>Successfully created log file ".$_POST['sNewLog']."</p></div>\n";
				}
			}
			break;
			/* delete a logfile */
			case"3":
			$sSelect = "<select name=\"sLogName\">\n";
			// output the logs that have editable set to true
			$sSelect .= "<option value=\"-1\">select a log</option>\n";
			$iFiles = count($aFiles);
			$iFilesEditable = 0;
			for($x=0;$x<count($aFiles);$x++){
				// let's make the file selection menu
				$sAbleToDelete = " disabled";
				if($_CONTEXT['l_formats'][$x]['format']['editable']==true){
					$sAbleToDelete = "";
					$iFilesEditable++;
				}
				$sSelect .= "<option value=\"".$_CONTEXT['l_formats'][$x]['file']."\"".$sAbleToDelete.">".$_CONTEXT['l_formats'][$x]['file']."</option>\n";
			}
			$sSelect .= "</select><br />".(!$iFilesEditable ? "can't delete log files that are native to Carnivore" : "select a log to delete")."\n";
			if(!isset($_POST['sLogName'])){
				// form
				$sCode .= "			<form method=\"post\">\n";
				$sCode .= "			<div class=\"emboss borderr5 border1pxtrans pad5 edgeglow overflw\">\n";
				$sCode .= "				<div class=\"embosshdrnocenter border1pxtrans pad10\">Delete log files</div>\n";
				$sCode .= "				<div class=\"cc_record\">\n";
				$sCode .= "					<div class=\"flt pad3 w150\">select a file:</div><div class=\"flt pad3\">".$sSelect."</div>\n";
				$sCode .= "				</div>\n";
				$sCode .= "				<div class=\"clear\"></div>\n";
				$sCode .= "				<div class=\"cc_record\">\n";
				$sCode .= "					<div class=\"flt pad3\"><input type=\"hidden\" name=\"sSelectOption\" value=\"".(isset($_POST['sSelectOption']) ? $_POST['sSelectOption'] : 0)."\" /><input type=\"hidden\" name=\"iCFG\" value=\"".$_POST['iCFG']."\" /><input type=\"submit\" name=\"send\" value=\"Remove Log\" /></div>\n";
				$sCode .= "				</div>\n";
				$sCode .= "				<div class=\"clear\"></div>\n";
				$sCode .= "			</div>\n";
				$sCode .= "			</form>\n";
			}
			else{
				// handler
				if(!file_exists($_PATHS['log_root']."/".$_POST['sLogName'])){
					// we can continue
					$_CONTEXT['errors'][] = array('error'=>'Log file '.$_POST['sLogName'].' doesn\'t exist','type'=>'1','fatal'=>'0','line'=>__LINE__,'file'=>__FILE__);
				}
				$bEditable = $_CONTEXT['l_formats'][$iLogIndex]['format']['editable']==false ? false : true;
				if(!$bEditable){
					$_CONTEXT['errors'][] = array('error'=>'Log file '.$_POST['sLogName'].' can\'t be removed','type'=>'2','fatal'=>'1','line'=>__LINE__,'file'=>__FILE__);
					include_once($_PATHS['end']);
				}
				$sFile = GetFileData($_PATHS['data_root']."/logsdata.php");
				if(!@unlink($_PATHS['log_root']."/".$_POST['sLogName'])){
					$_CONTEXT['errors'][] = array('error'=>'Failed to remove log file '.$_POST['sLogName'].', if you encounter any fatal error on this page you need to remove the log file by yourself','type'=>'2','fatal'=>'1','line'=>__LINE__,'file'=>__FILE__);
					include_once($_PATHS['end']);
				}
				$bCommentUpdated = false;
				$aComment = array();
				$sCurrentDate = date($_CONTEXT['time_pattern'],time());
				$sReplaceDate = "/(Last Edit:\s)(\d+\-\d+\-\d+)/";
				$aComment = explode("*/",$sFile,2);
				if(!isset($aComment[1])){
					// no comment found
					$_CONTEXT['errors'][] = array('error'=>'Failed to extract comment data from '.$_PATHS['data_root'].'/logsdata.php','type'=>'2','fatal'=>'1','line'=>__LINE__,'file'=>__FILE__);
					include_once($_PATHS['end']);
				}
				// extract the last edit time
				preg_match($sReplaceDate,$aComment[0],$aPieces);
				if(!isset($aPieces[2])){
					$_CONTEXT['errors'][] = array('error'=>'Invalid last edit time properties in header comment','type'=>'2','fatal'=>'1','line'=>__LINE__,'file'=>__FILE__);
					include_once($_PATHS['end']);
				}
				// replace previous edit time with the current date
				$aComment[0] = str_replace($aPieces[2],$sCurrentDate,$aComment[0]);
				$bCommentUpdated = true;
				if(!$bCommentUpdated){
					$_CONTEXT['errors'][] = array('error'=>'Failed to replace last edit time','type'=>'2','fatal'=>'1','line'=>__LINE__,'file'=>__FILE__);
					include_once($_PATHS['end']);
				}
				// slap the source back together
				$sFile = $aComment[0]."*/".$aComment[1];
				$aFile = explode("\n",$sFile);
				// find the lines we need to get rid of
				$sSearch = "\$_CONTEXT['l_formats'][".$iLogIndex."]";
				$iLength = strlen($sSearch);
				$sFile = "";
				$bFound = false;
				for($z=0;$z<count($aFile);$z++){
					if(substr($aFile[$z],0,$iLength)==$sSearch){
						// skip lines that match pattern
						if(!$bFound){
							$bFound = true;
						}
						continue;
					}
					if($z!=0){
						$sFile .= "\n";
					}
					$sFile .= $aFile[$z];
				}
				if(!$bFound){
					$_CONTEXT['errors'][] = array('error'=>'Failed to find log properties in '.$_PATHS['data_root'].'/logsdata.php','type'=>'2','fatal'=>'1','line'=>__LINE__,'file'=>__FILE__);
					include_once($_PATHS['end']);
				}
				if(!WriteF($_PATHS['data_root']."/logsdata.php",$sFile,"w")){
					$_CONTEXT['errors'][] = array('error'=>'Failed to update log file properties, it\'s highly recommended to remove it manually in order to prevent fatal errors when you open this configuration page','type'=>'2','fatal'=>'1','line'=>__LINE__,'file'=>__FILE__);
					include_once($_PATHS['end']);
				}
				else{
					$sCode .= "<div class=\"spacingmsg\">".$_CONTEXT['result_headers']['result']."<p>Successfully removed log file</p></div>\n";
				}
			}
			break;
			/* clean a logfile */
			case"4":
			if(!isset($_POST['sLogName'])){
				// form
				$sSelect = "<select name=\"sLogName\">\n";
				// output the logs that have no notempty property defined and set to true
				$sSelect .= "<option value=\"-1\">select a log</option>\n";
				$iFiles = count($aFiles);
				$iFilesEditable = 0;
				for($x=0;$x<count($aFiles);$x++){
					// let's make the file selection menu
					$sAbleToClean = " disabled";
					if(!isset($_CONTEXT['l_formats'][$x]['format']['notempty']) || $_CONTEXT['l_formats'][$x]['format']['notempty']==false){
						$sAbleToClean = "";
						$iFilesEditable++;
					}
					$sSelect .= "<option value=\"".$_CONTEXT['l_formats'][$x]['file']."\"".$sAbleToClean.">".$_CONTEXT['l_formats'][$x]['file']."</option>\n";
				}
				$sSelect .= "</select><br />".(!$iFilesEditable ? "can't clean log files that have the notempty property set to true" : "select a log to clean")."\n";
				$sCode .= "			<form method=\"post\">\n";
				$sCode .= "			<div class=\"emboss borderr5 border1pxtrans pad5 edgeglow overflw\">\n";
				$sCode .= "				<div class=\"embosshdrnocenter border1pxtrans pad10\">Clean log files</div>\n";
				$sCode .= "				<div class=\"cc_record\">\n";
				$sCode .= "					<div class=\"flt pad3 w150\">options:</div><div class=\"flt pad3\">".$sSelect."</div>\n";
				$sCode .= "				</div>\n";
				$sCode .= "				<div class=\"clear\"></div>\n";
				$sCode .= "				<div class=\"cc_record\">\n";
				$sCode .= "					<div class=\"flt pad3\"><input type=\"hidden\" name=\"sSelectOption\" value=\"".(isset($_POST['sSelectOption']) ? $_POST['sSelectOption'] : 0)."\" /><input type=\"hidden\" name=\"iCFG\" value=\"".$_POST['iCFG']."\" /><input type=\"submit\" name=\"send\" value=\"Clean Log\" /></div>\n";
				$sCode .= "				</div>\n";
				$sCode .= "				<div class=\"clear\"></div>\n";
				$sCode .= "			</div>\n";
				$sCode .= "			</form>\n";
			}
			else{
				// handler
				if(!isset($_CONTEXT['l_formats'][$iLogIndex]['format']['notempty']) || !$_CONTEXT['l_formats'][$iLogIndex]['format']['notempty']){
					if(!WriteF($_PATHS['log_root']."/".$_POST['sLogName'],"","w")){
						$iErrors = count($_CONTEXT['errors'])-1;
						$_CONTEXT['errors'][$iErrors]['file'] = __FILE__;
						$_CONTEXT['errors'][$iErrors]['line'] = __LINE__;
						include($_PATHS['end']);
					}
					$sCode .= "<div class=\"spacingmsg\">".$_CONTEXT['result_headers']['result']."<p>Successfully cleaned log file</p></div>\n";
				}
				else{
					$_CONTEXT['errors'][] = array('error'=>'This file can\'t be cleaned','type'=>'1','fatal'=>'1','line'=>__LINE__,'file'=>__FILE__);
					include_once($_PATHS['end']);
				}
			}
			break;
			/* search logs */
			case"5":
			if(!isset($_POST['sSearch']) && !isset($_POST['sLogName'])){
				// form select log
				$sSelect = "<select name=\"sLogName\">\n";
				// output the logs that have no notempty property defined and set to true
				$sSelect .= "<option value=\"-1\">select a log</option>\n";
				$iFiles = count($aFiles);
				$iFilesSearchable = 0;
				for($x=0;$x<count($aFiles);$x++){
					// let's make the file selection menu
					$sAbleToSearch = " disabled";
					if(!isset($_CONTEXT['l_formats'][$x]['format']['type']) || $_CONTEXT['l_formats'][$x]['format']['type']!="array"){
						$sAbleToSearch = "";
						$iFilesSearchable++;
					}
					$sSelect .= "<option value=\"".$_CONTEXT['l_formats'][$x]['file']."\"".$sAbleToSearch.">".$_CONTEXT['l_formats'][$x]['file']."</option>\n";
				}
				$sSelect .= "</select><br />".(!$iFilesSearchable ? "can't search log files that have the type property set to array" : "select a log to search through")."\n";
				$sCode .= "			<form method=\"post\">\n";
				$sCode .= "			<div class=\"emboss borderr5 border1pxtrans pad5 edgeglow overflw\">\n";
				$sCode .= "				<div class=\"embosshdrnocenter border1pxtrans pad10\">Search log files</div>\n";
				$sCode .= "				<div class=\"cc_record\">\n";
				$sCode .= "					<div class=\"flt pad3 w150\">select file:</div><div class=\"flt pad3\">".$sSelect."</div>\n";
				$sCode .= "				</div>\n";
				$sCode .= "				<div class=\"clear\"></div>\n";
				$sCode .= "				<div class=\"cc_record\">\n";
				$sCode .= "					<div class=\"flt pad3\"><input type=\"hidden\" name=\"sSelectOption\" value=\"".(isset($_POST['sSelectOption']) ? $_POST['sSelectOption'] : 0)."\" /><input type=\"hidden\" name=\"iCFG\" value=\"".$_POST['iCFG']."\" /><input type=\"submit\" name=\"send\" value=\"Search\" /></div>\n";
				$sCode .= "				</div>\n";
				$sCode .= "				<div class=\"clear\"></div>\n";
				$sCode .= "			</div>\n";
				$sCode .= "			</form>\n";
			}
			elseif(!isset($_POST['sSearch']) && isset($_POST['sLogName'])){
				// form search
				if(isset($_CONTEXT['l_formats'][$iLogIndex]['format']['type']) && $_CONTEXT['l_formats'][$iLogIndex]['format']['type']=="array"){
					$_CONTEXT['errors'][] = array('error'=>'This type of log can\'t be searched, select a log that doesn\'t have an array structure','type'=>'1','fatal'=>'1','line'=>__LINE__,'file'=>__FILE__);
					include_once($_PATHS['end']);
				}
				// create search types
				$sSelect = "<select name=\"sSearchType\" class=\"searchtype\">\n";
				$sSelect .= "<option value=\"-1\">select an option</option>\n";
				for($x=0;$x<count($_CONTEXT['l_formats'][$iLogIndex]['format']['labels']);$x++){
					// identify the property we're going to search through
					if($_CONTEXT['l_formats'][$iLogIndex]['format']['labels'][$x]=="time"){
						$sSelect .= "<option value=\"".$_CONTEXT['l_formats'][$iLogIndex]['format']['labels'][$x]."\">search for records between two timestamps</option>\n";
					}
					elseif($_CONTEXT['l_formats'][$iLogIndex]['format']['labels'][$x]=="timestamp"){
						$sSelect .= "<option value=\"".$_CONTEXT['l_formats'][$iLogIndex]['format']['labels'][$x]."\">search for records between two timestamps</option>\n";
					}
					elseif($_CONTEXT['l_formats'][$iLogIndex]['format']['labels'][$x]=="ip"){
						$sSelect .= "<option value=\"".$_CONTEXT['l_formats'][$iLogIndex]['format']['labels'][$x]."\">search for a certain ip address</option>\n";
					}
					elseif($_CONTEXT['l_formats'][$iLogIndex]['format']['labels'][$x]=="fatal"){
						$sSelect .= "<option value=\"".$_CONTEXT['l_formats'][$iLogIndex]['format']['labels'][$x]."\">search for fatal errors</option>\n";
					}
					elseif($_CONTEXT['l_formats'][$iLogIndex]['format']['labels'][$x]=="error"){
						$sSelect .= "<option value=\"".$_CONTEXT['l_formats'][$iLogIndex]['format']['labels'][$x]."\">search for text in an error string</option>\n";
					}
					elseif($_CONTEXT['l_formats'][$iLogIndex]['format']['labels'][$x]=="file"){
						$sSelect .= "<option value=\"".$_CONTEXT['l_formats'][$iLogIndex]['format']['labels'][$x]."\">search for an error in a specific file</option>\n";
					}
					elseif($_CONTEXT['l_formats'][$iLogIndex]['format']['labels'][$x]=="line"){
						$sSelect .= "<option value=\"".$_CONTEXT['l_formats'][$iLogIndex]['format']['labels'][$x]."\">search for errors on a certain line number</option>\n";
					}
					elseif($_CONTEXT['l_formats'][$iLogIndex]['format']['labels'][$x]=="type"){
						$sSelect .= "<option value=\"".$_CONTEXT['l_formats'][$iLogIndex]['format']['labels'][$x]."\">search for severity of an error</option>\n";
					}
					else{
						// property is not defined, skip it, but add to log instead as not severe
						$_CONTEXT['errors'][] = array('error'=>'Property '.htmlspecialchars($_CONTEXT['l_formats'][$iLogIndex]['format']['labels'][$x]).' hasn\'t been setup in your log manager','type'=>'0','fatal'=>'0','line'=>__LINE__,'file'=>__FILE__);
					}
				}
				$sSelect .= "</select>\n";
				$sCode .= "			<script type=\"text/javascript\" src=\"Templates/".$_PATHS['style_user']."/js/logmanager.js\"></script>\n";
				$sCode .= "			<form method=\"post\">\n";
				$sCode .= "			<div class=\"emboss borderr5 border1pxtrans pad5 edgeglow overflw\">\n";
				$sCode .= "				<div class=\"embosshdrnocenter border1pxtrans pad10\">Search log files</div>\n";
				$sCode .= "				<div class=\"cc_record\">\n";
				$sCode .= "					<div class=\"flt pad3 w150\">search type:</div><div class=\"flt pad3\">".$sSelect."</div>\n";
				$sCode .= "				</div>\n";
				$sCode .= "				<div class=\"clear\"></div>\n";
				$sCode .= "				<div class=\"cc_record\" id=\"searchproperties\">\n";
				$sCode .= "					<div class=\"flt pad3 w150\">search</div><div class=\"flt pad3\" id=\"searchfield\"></div>\n";
				$sCode .= "				</div>\n";
				$sCode .= "				<div class=\"clear\"></div>\n";
				$sCode .= "				<div class=\"cc_record\">\n";
				$sCode .= "					<div class=\"flt pad3\"><input type=\"hidden\" name=\"sSelectOption\" value=\"".(isset($_POST['sSelectOption']) ? $_POST['sSelectOption'] : 0)."\" /><input type=\"hidden\" name=\"sLogName\" value=\"".(isset($_POST['sLogName']) ? $_POST['sLogName'] : 0)."\" /><input type=\"hidden\" name=\"iCFG\" value=\"".$_POST['iCFG']."\" /><input type=\"submit\" name=\"send\" value=\"Search\" /></div>\n";
				$sCode .= "				</div>\n";
				$sCode .= "				<div class=\"clear\"></div>\n";
				$sCode .= "			</div>\n";
				$sCode .= "			</form>\n";
			}
			else{
				// handler
				if(!isset($_POST['sSearchType']) || !isset($_POST['sSearch'])){
					$_CONTEXT['errors'][] = array('error'=>'Invalid form variables or values for search options in log manager','type'=>'1','fatal'=>'1','line'=>__LINE__,'file'=>__FILE__);
					include($_PATHS['end']);
				}
				if($_POST['sSearch']==""){
					$_CONTEXT['errors'][] = array('error'=>'No search value has been specified','type'=>'0','fatal'=>'1','line'=>__LINE__,'file'=>__FILE__);
					include($_PATHS['end']);
				}
				if(isset($_POST['sSearchEnd'])){
					// this is the only option that has two input fields
					if(!preg_match('/^[1][0-9]{9}$/',$_POST['sSearch']) || !preg_match('/^[1][0-9]{9}$/',$_POST['sSearchEnd'])){
						$_CONTEXT['errors'][] = array('error'=>'Both start and end time have to be a timestamp','type'=>'0','fatal'=>'1','line'=>__LINE__,'file'=>__FILE__);
						include($_PATHS['end']);
					}
					if($_POST['sSearch']>$_POST['sSearchEnd']){
						$_CONTEXT['errors'][] = array('error'=>'Start time can\'t be higher than end time','type'=>'0','fatal'=>'1','line'=>__LINE__,'file'=>__FILE__);
						include($_PATHS['end']);
					}
				}
				else{
					$_POST['sSearch'] = strtolower($_POST['sSearch']);
				}
				if(!in_array($_POST['sSearchType'],$_CONTEXT['l_formats'][$iLogIndex]['format']['labels'])){
					$_CONTEXT['errors'][] = array('error'=>'Specified search property doesn\'t exist in '.$_PATHS['data_root'].'/logsdata.php','type'=>'0','fatal'=>'1','line'=>__LINE__,'file'=>__FILE__);
					include($_PATHS['end']);
				}
				if($_CONTEXT['l_formats'][$iLogIndex]['format']['type']!="plain"){
					$_CONTEXT['errors'][] = array('error'=>'This logfile can\'t be searched through','type'=>'0','fatal'=>'1','line'=>__LINE__,'file'=>__FILE__);
					include($_PATHS['end']);
				}
				if(false==($aFileData = RawToArray($_PATHS['log_root']."/".$_POST['sLogName']))){
					$iErrors = count($_CONTEXT['errors'])-1;
					$_CONTEXT['errors'][$iErrors]['file'] = __FILE__;
					$_CONTEXT['errors'][$iErrors]['line'] = __LINE__;
					include($_PATHS['end']);
				}
				// find the proper field and buffer the keys for the logfile
				$iKey = 0;
				$iLabels = count($_CONTEXT['l_formats'][$iLogIndex]['format']['labels']);
				$sHeadTable = "				<div class=\"rowlog header\">\n";
				for($x=0;$x<$iLabels;$x++){
					$sHeadTable .= "					<div class=\"pad3\">".$_CONTEXT['l_formats'][$iLogIndex]['format']['labels'][$x]."</div>\n";
					if($_CONTEXT['l_formats'][$iLogIndex]['format']['labels'][$x]==$_POST['sSearchType']){
						$iKey = $x;
					}
				}
				$sHeadTable .= "				</div>\n";
				// get the data field and see if we have a match
				$aResults = array();
				for($x=0;$x<count($aFileData);$x++){
					if(isset($_POST['sSearchEnd'])){
						if(!preg_match('/^[1][0-9]{9}$/',$aFileData[$x][$iKey])){
							// we are expecting a timestamp
							continue;
						}
						if($aFileData[$x][$iKey]>=$_POST['sSearch'] && $_POST['sSearchEnd']>=$aFileData[$x][$iKey]){
							$aResults[] = $aFileData[$x];
						}
						continue;
					}
					$sDataField = trim(strtolower($aFileData[$x][$iKey]));
					$aTestField = explode($_POST['sSearch'],$sDataField);
					if(isset($aTestField[1]) || $_POST['sSearch']==$sDataField){
						$aResults[] = $aFileData[$x];
					}
				}
				$sCode .= "<style>.cc_record{display:flex;flex-direction:column;}.rowlog{display:flex;width:100%;box-sizing:border-box;}.header{font-weight:bold;padding:3px;}.pad3{padding:3px;flex:1;}</style>";
				$sCode .= "			<form method=\"post\">\n";
				$sCode .= "			<div class=\"emboss borderr5 border1pxtrans pad5 edgeglow overflw\">\n";
				$sCode .= "				<div class=\"embosshdrnocenter border1pxtrans pad10\">View carnivore log files</div>\n";
				$sCode .= "				<div class=\"cc_record\">\n";
				$sCode .= $sHeadTable;
				if(false!=($iCount = count($aResults))){
					for($x=0;$x<$iCount;$x++){
						$sCode .= "					<div class=\"rowlog\">\n";
						for($y=0;$y<$iLabels;$y++){
							if($_CONTEXT['l_formats'][$iLogIndex]['format']['labels'][$y]=="time" || $_CONTEXT['l_formats'][$iLogIndex]['format']['labels'][$y]=="timestamp"){
								// convert to readable date
								$aFileData[$x][$y] = date($_CONTEXT['time_pattern']." H:i:s",$aFileData[$x][$y]);
							}
							$sCode .= "						<div class=\"pad3\">".$aFileData[$x][$y]."</div>\n";
						}
						$sCode .= "					</div>\n";
					}
				}
				$sCode .= "				</div>\n";
				$sCode .= "			</div>\n";
				$sCode .= "			</form>\n";
			}
			break;
			/* write log query */
			case"6":
			if(!isset($_POST['sQuery'])){
				// form
				$sSelect = "<select name=\"sLogName\">\n";
				// output the logs that have no notempty property defined and set to true
				$sSelect .= "<option value=\"-1\">select a log</option>\n";
				$sSelect .= "<option value=\"0\">default log</option>\n";
				$iFiles = count($aFiles);
				$iFilesSearchable = 0;
				for($x=0;$x<count($aFiles);$x++){
					// let's make the file selection menu
					$sAbleToSearch = " disabled";
					if(!isset($_CONTEXT['l_formats'][$x]['format']['type']) || $_CONTEXT['l_formats'][$x]['format']['type']!="array"){
						$sAbleToSearch = "";
						$iFilesSearchable++;
					}
					$sSelect .= "<option value=\"".$_CONTEXT['l_formats'][$x]['file']."\"".$sAbleToSearch.">".$_CONTEXT['l_formats'][$x]['file']."</option>\n";
				}
				$sSelect .= "</select><br />".(!$iFilesSearchable ? "can't create queries for these kind of log files" : "select a log to create a query for")."\n";
				// print severity level
				$sSelectSeverityLevel = "<select name=\"iSeverityLevel\">\n";
				$sSelectSeverityLevel .= "<option value=\"-1\">select a severity level</option>\n";
				$sSelectSeverityLevel .= "<option value=\"0\">0 - no impact</option>\n";
				$sSelectSeverityLevel .= "<option value=\"1\">1 - low impact</option>\n";
				$sSelectSeverityLevel .= "<option value=\"2\">2 - significant impact</option>\n";
				$sSelectSeverityLevel .= "</select>\n";
				$sCode .= "			<form method=\"post\">\n";
				$sCode .= "			<div class=\"emboss borderr5 border1pxtrans pad5 edgeglow overflw\">\n";
				$sCode .= "				<div class=\"embosshdrnocenter border1pxtrans pad10\">Create log query</div>\n";
				$sCode .= "				<div class=\"cc_record\">\n";
				$sCode .= "					<div class=\"flt pad3 w150\">select file:</div><div class=\"flt pad3\">".$sSelect."</div>\n";
				$sCode .= "				</div>\n";
				$sCode .= "				<div class=\"clear\"></div>\n";
				$sCode .= "				<div class=\"cc_record\">\n";
				$sCode .= "					<div class=\"flt pad3 w150\">error string:</div><div class=\"flt pad3\"><input type=\"text\" name=\"sQuery\" /><br />text that will be logged</div>\n";
				$sCode .= "				</div>\n";
				$sCode .= "				<div class=\"clear\"></div>\n";
				$sCode .= "				<div class=\"cc_record\">\n";
				$sCode .= "					<div class=\"flt pad3 w150\">json error:</div><div class=\"flt pad3\"><input type=\"radio\" name=\"iError\" value=\"1\" /><br />1- when the error is on a page that outputs json</div>\n";
				$sCode .= "				</div>\n";
				$sCode .= "				<div class=\"clear\"></div>\n";
				$sCode .= "				<div class=\"cc_record\">\n";
				$sCode .= "					<div class=\"flt pad3 w150\">screen error:</div><div class=\"flt pad3\"><input type=\"radio\" name=\"iError\" value=\"2\" /><br />2- used for errors in screen.php module files</div>\n";
				$sCode .= "				</div>\n";
				$sCode .= "				<div class=\"clear\"></div>\n";
				$sCode .= "				<div class=\"cc_record\">\n";
				$sCode .= "					<div class=\"flt pad3 w150\">normal error:</div><div class=\"flt pad3\"><input type=\"radio\" name=\"iError\" value=\"3\" /><br />3- any other error</div>\n";
				$sCode .= "				</div>\n";
				$sCode .= "				<div class=\"clear\"></div>\n";
				$sCode .= "				<div class=\"cc_record\">\n";
				$sCode .= "					<div class=\"flt pad3 w150\">severity:</div><div class=\"flt pad3\">".$sSelectSeverityLevel."<br />severity level of the error<br />0- used for bad user input or other minor issues<br />1- something bad happened, but carnivore can still function as usual<br />2- serious issue, needs to be dealt with asap</div>\n";
				$sCode .= "				</div>\n";
				$sCode .= "				<div class=\"clear\"></div>\n";
				$sCode .= "				<div class=\"cc_record\">\n";
				$sCode .= "					<div class=\"flt pad3 w150\">fatal error:</div><div class=\"flt pad3\"><input type=\"checkbox\" name=\"iFatal\" value=\"1\" /><br />indicates that after this error the script must terminate</div>\n";
				$sCode .= "				</div>\n";
				$sCode .= "				<div class=\"clear\"></div>\n";
				$sCode .= "				<div class=\"cc_record\">\n";
				$sCode .= "					<div class=\"flt pad3\"><input type=\"hidden\" name=\"sSelectOption\" value=\"".(isset($_POST['sSelectOption']) ? $_POST['sSelectOption'] : 0)."\" /><input type=\"hidden\" name=\"iCFG\" value=\"".$_POST['iCFG']."\" /><input type=\"submit\" name=\"send\" value=\"Create\" /></div>\n";
				$sCode .= "				</div>\n";
				$sCode .= "				<div class=\"clear\"></div>\n";
				$sCode .= "			</div>\n";
				$sCode .= "			</form>\n";
			}
			else{
				// handler
				if(!isset($_POST['sQuery']) || $_POST['sQuery']==""){
					$_CONTEXT['errors'][] = array('error'=>'No error text specified','type'=>'0','fatal'=>'1','line'=>__LINE__,'file'=>__FILE__);
					include($_PATHS['end']);
				}
				if(!isset($_POST['iFatal']) || $_POST['iFatal']==""){
					// not specified, assume it's not an error that needs to halt the script
					$_POST['iFatal'] = 0;
				}
				if(!isset($_POST['iSeverityLevel']) || $_POST['iSeverityLevel']=="-1" || ($_POST['iSeverityLevel']!=1 && $_POST['iSeverityLevel']!=2)){
					// if no severity error has been set then it's probably not an important error
					$_POST['iSeverityLevel'] = 0;
				}
				if(!isset($_POST['iError']) || $_POST['iError']==""){
					// most errors take place on normal pages, so use this
					$_POST['iError'] = 3;
				}
				// escape slashes in words like can't etc
				$_POST['sQuery'] = preg_replace("/([a-zA-Z])'([a-zA-Z])/","$1\\'$2",$_POST['sQuery']);
				// create the query
				$sError = "\$_CONTEXT['errors'][] = array(";
				$sError .= "'error'=>'".$_POST['sQuery']."'";
				$sError .= ",'type'=>'".$_POST['iSeverityLevel']."'";
				if(!isset($_POST['iDefaultLog'])){
					$sError .= ",'log'=>'".$_POST['sLogName']."'";
				}
				if($_POST['iFatal']==1){
					$sError .= ",'fatal'=>'1'";
				}
				else{
					$sError .= ",'fatal'=>'0'";
				}
				if($_POST['iError']==1){
					// output as json
					$sError .= " ,'json'=>'1'";
				}
				elseif($_POST['iError']==2){
					// output on module screen.php files
					$sError .= " ,'screen'=>'1'";
				}
				$sError .= ",'line'=>__LINE__,'file'=>__FILE__);";
				if($_POST['iFatal']==1){
					$sError .= "<br />include(\$_PATHS['end']);";
				}
				$sCode .= "<div class=\"spacingmsg\">".$_CONTEXT['result_headers']['result']."<p>".$sError."</p></div>";
			}
			break;
			default:
			$_CONTEXT['errors'][] = array('error'=>'Invalid action for log manager','type'=>'1','line'=>__LINE__,'file'=>__FILE__);
			include_once($_PATHS['end']);
		}
	}
	else{
		// output the templates that are available
		$sSelect = "<select name=\"sLog\">\n";
		for($x=0;$x<count($aFiles);$x++){
			// let's make the file selection menu
			$sSelect .= "<option value=\"".$aFiles[$x]."\">".$aFiles[$x]."</option>\n";
		}
		$sSelect .= "</select>\n";
		$sSelectOption = "<select name=\"sSelectOption\">\n";
		$sSelectOption .= "<option value=\"-1\">select an option</option>\n";
		$sSelectOption .= "<option value=\"1\">view logs</option>\n";
		$sSelectOption .= "<option value=\"2\">create a new logfile</option>\n";
		$sSelectOption .= "<option value=\"3\">delete a logfile</option>\n";
		$sSelectOption .= "<option value=\"4\">clean a logfile</option>\n";
		$sSelectOption .= "<option value=\"5\">search logs</option>\n";
		$sSelectOption .= "<option value=\"6\">create error query</option>\n";
		$sSelectOption .= "</select>\n";
		$sCode .= "			<form method=\"post\">\n";
		$sCode .= "			<div class=\"emboss borderr5 border1pxtrans pad5 edgeglow overflw\">\n";
		$sCode .= "				<div class=\"embosshdrnocenter border1pxtrans pad10\">Manage carnivore log files</div>\n";
		$sCode .= "				<div class=\"cc_record\">\n";
		$sCode .= "					<div class=\"flt pad3 w150\">options:</div><div class=\"flt pad3\">".$sSelectOption."</div>\n";
		$sCode .= "				</div>\n";
		$sCode .= "				<div class=\"clear\"></div>\n";
		$sCode .= "				<div class=\"cc_record\">\n";
		$sCode .= "					<div class=\"flt pad3\"><input type=\"hidden\" name=\"iCFG\" value=\"".$_POST['iCFG']."\" /><input type=\"submit\" name=\"send\" value=\"Send\" /></div>\n";
		$sCode .= "				</div>\n";
		$sCode .= "				<div class=\"clear\"></div>\n";
		$sCode .= "			</div>\n";
		$sCode .= "			</form>\n";
	}
}
?>