<?php
/* Configuration for time limit, error reporting and memory usage in screen files

Author: Remco Kouw
Site: http://www.hacksuite.com
Last Edit: 07-01-2024
*/
if(!defined('IN_SCRIPT')){
	exit;
}
if(defined('SPIDER')){
	$_CONTEXT['nativekeywords'][17] = array("native","time","limit","memory","module","screen","execution","running");
}
else{
	$_CONTEXT['subtitle'] = "Screen Settings";
	$sJSDev = "<script type=\"text/javascript\" src=\"Templates/".$_PATHS['style_user']."/js/screenedit.js\"></script>\n";
	$_CONTEXT['headers'] = isset($_CONTEXT['headers']) ? $_CONTEXT['headers'].$sJSDev : $sJSDev;
	// output the templates that are available
	$sSelect = "<select name=\"sSetupType\" class=\"setuptype\">\n";
	$sSelect .= "<option value=\"-1\">select a property</option>\n";
	$sSelect .= "<option value=\"1\">memory limit</option>\n";
	$sSelect .= "<option value=\"2\">time limit</option>\n";
	$sSelect .= "</select>\n";
	$sSelectMemory = "<select name=\"sMemoryLimit\" class=\"memorylimit\">\n";
	$sSelectMemory .= "<option value=\"-1\">select memory limit</option>\n";
	$sSelectMemory .= "<option value=\"128M\">128MB</option>\n";
	$sSelectMemory .= "<option value=\"256M\">256M</option>\n";
	$sSelectMemory .= "<option value=\"512M\">512MB</option>\n";
	$sSelectMemory .= "<option value=\"768M\">768MB</option>\n";
	$sSelectMemory .= "<option value=\"1024M\">1024MB</option>\n";
	$sSelectMemory .= "<option value=\"1536M\">1536MB</option>\n";
	$sSelectMemory .= "<option value=\"2048M\">2048MB</option>\n";
	$sSelectMemory .= "<option value=\"2560M\">2560MB</option>\n";
	$sSelectMemory .= "<option value=\"3072M\">3072MB</option>\n";
	$sSelectMemory .= "<option value=\"3584M\">3584MB</option>\n";
	$sSelectMemory .= "<option value=\"4096M\">4096MB</option>\n";
	$sSelectMemory .= "<option value=\"4608M\">4608MB</option>\n";
	$sSelectMemory .= "<option value=\"5120M\">5120MB</option>\n";
	$sSelectMemory .= "<option value=\"5632M\">5632MB</option>\n";
	$sSelectMemory .= "<option value=\"6144M\">6144MB</option>\n";
	$sSelectMemory .= "<option value=\"6656M\">6656MB</option>\n";
	$sSelectMemory .= "<option value=\"7168M\">7168MB</option>\n";
	$sSelectMemory .= "<option value=\"7680M\">7680MB</option>\n";
	$sSelectMemory .= "<option value=\"8192M\">8192MB</option>\n";
	$sSelectMemory .= "</select>\n";
	$sSelectTime = "<select name=\"sTimeLimit\" class=\"timelimit\">\n";
	$sSelectTime .= "<option value=\"-1\">select time limit</option>\n";
	$sSelectTime .= "<option value=\"30\">30s</option>\n";
	$sSelectTime .= "<option value=\"45\">45s</option>\n";
	$sSelectTime .= "<option value=\"60\">60s</option>\n";
	$sSelectTime .= "<option value=\"90\">90s</option>\n";
	$sSelectTime .= "<option value=\"120\">120s</option>\n";
	$sSelectTime .= "<option value=\"180\">180s</option>\n";
	$sSelectTime .= "<option value=\"300\">300s</option>\n";
	$sSelectTime .= "<option value=\"500\">500s</option>\n";
	$sSelectTime .= "<option value=\"900\">900s</option>\n";
	$sSelectTime .= "<option value=\"infinite\">infinite</option>\n";
	$sSelectTime .= "</select>\n";
	$sSelectModules = "<select name=\"sModName\" class=\"modname\">\n";
	$sSelectModules .= "<option value=\"-1\">select a module</option>\n";
	foreach($_CONTEXT['modules'] as $sModName=>$aValues){
		if(!file_exists("Modules/".$sModName."/screen.php")){
			continue;
		}
		$sSelectModules .= "<option value=\"".$sModName."\">".$sModName." - ".$aValues['name']."</option>\n";
	}
	$sSelectModules .= "</select>\n";
	$sCode .= "			<form method=\"post\" class=\"setscreen\">\n";
	$sCode .= "			<div class=\"emboss borderr5 border1pxtrans pad5 edgeglow overflw\">\n";
	$sCode .= "				<div class=\"embosshdrnocenter border1pxtrans pad10\">Setup screen files</div>\n";
	$sCode .= "				<div class=\"cc_record\" id=\"typefield\">\n";
	$sCode .= "					<div class=\"flt pad3 w150\">type:</div><div class=\"flt pad3\">".$sSelect."<br />set maximum execution time and maximum available memory</div>\n";
	$sCode .= "				</div>\n";
	$sCode .= "				<div class=\"clear\"></div>\n";
	$sCode .= "				<div class=\"cc_record\">\n";
	$sCode .= "					<div class=\"flt pad3 w150\">module:</div><div class=\"flt pad3\">".$sSelectModules."<br />only modules that have a screen file can be selected</div>\n";
	$sCode .= "				</div>\n";
	$sCode .= "				<div class=\"clear\"></div>\n";
	$sCode .= "				<div class=\"cc_record\" id=\"mem\">\n";
	$sCode .= "					<div class=\"flt pad3 w150\">memory limit:</div><div class=\"flt pad3\">".$sSelectMemory."<br />current value ".ini_get("memory_limit")."B</div>\n";
	$sCode .= "				</div>\n";
	$sCode .= "				<div class=\"clear\"></div>\n";
	$sCode .= "				<div class=\"cc_record\" id=\"tim\">\n";
	$sCode .= "					<div class=\"flt pad3 w150\">time limit:</div><div class=\"flt pad3\">".$sSelectTime."<br />current value ".ini_get("max_execution_time")."s</div>\n";
	$sCode .= "				</div>\n";
	$sCode .= "				<div class=\"clear\"></div>\n";
	$sCode .= "				<div class=\"cc_record\">\n";
	$sCode .= "					<div class=\"flt pad3\"><input type=\"hidden\" name=\"iCFG\" value=\"".$_POST['iCFG']."\" /><input type=\"submit\" class=\"submitbutton\" name=\"send\" value=\"Edit\" /> <input type=\"submit\" class=\"submitbutton\" class=\"findbutton\" name=\"send\" value=\"Find Settings\" /></div>\n";
	$sCode .= "				</div>\n";
	$sCode .= "				<div class=\"clear\"></div>\n";
	$sCode .= "			</div>\n";
	$sCode .= "			</form>\n";
}
?>