<?php
/* Handle errors that may have occured

There's three ways an error can be displayed in the browser:
1- screen files: these will be plain text
use -> $_CONTEXT['errors'][$x]['screen'] = 1;
2- json files: typically these will be send back to the browser in $aDataR with the keys 'jmessage' containing the error and 'jresult' with a false value
use -> $_CONTEXT['errors'][$x]['json'] = 1;
3- other files: displayed as a normal error

Author: Remco Kouw
Site: http://www.hacksuite.com
Last Edit: 24-01-2023
*/
if(!defined('IN_SCRIPT')){
	exit;
}
// is logging enabled?
if($_CONTEXT['log']==true && !defined('LOG_SKIP')){
	// now if we call IsThere we might just bump into an infinite loop, so let's include the log handler
	@include($_PATHS['includes_root']."/log_errors.php");
}
if($_CONTEXT['silent']==true){
	// keep output empty
	exit;
}
include_once($_PATHS['style_root']."/head.php");
// make sure errors have occured
$iErrors = count($_CONTEXT['errors']);
$iLastError = $iErrors-1;
/* output error */
if($iErrors!=0){
	if(isset($_CONTEXT['errors'][$iLastError]['json']) && $_CONTEXT['errors'][$iLastError]['json']==1){
		// json
		$aDataR['jmessage'] = $_CONTEXT['errors'][$iLastError]['error'];
		$aDataR['jresult'] = false;
		die(json_encode($aDataR));
	}
	elseif(isset($_CONTEXT['errors'][$iLastError]['screen']) && $_CONTEXT['errors'][$iLastError]['screen']==1){
		// screen
		for($x=0;$x<$iErrors;$x++){
			$sCode = "<b id=h7>".$_CONTEXT['errors'][$x]['error']."</b><br />\n";
		}
	}
	else{
		// normal
		$sCode = "<div class=\"spacingmsg\">".$_CONTEXT['result_headers']['error'];
		for($x=0;$x<$iErrors;$x++){
			$sCode .= "<b>error message:</b> ".(@strlen($_CONTEXT['errors'][$x]['error'])>0 ? strip_tags($_CONTEXT['errors'][$x]['error'],"<p><a><b><i><u>") : "no error defined")."<br>\n";
			if($x==$iLastError){
				// ok this is the last item, if there was a fatal set then show it now
				if(isset($_CONTEXT['errors'][$x]['fatal']) && $_CONTEXT['errors'][$x]['fatal']==1){
					$sCode .= "<b>type of error:</b> fatal<br />\n";
					break;
				}
			}
			$sCode .= "<b>type of error:</b> not critical<br />\n";
		}
		$sCode .= "</div>";
		include_once($_PATHS['style_root']."/body.php");
		include_once($_PATHS['style_root']."/footer.php");
	}
	/* make sure we don't continue with more code parsing */
	exit;
}
?>