<?php
/* Setup the default values for the environment variables */
if(!defined('IN_SCRIPT')){
	exit;
}
// context of session
$_CONTEXT = array();
// errors that have occured
$_CONTEXT['errors'] = array();
// silence error output of the THC suite, php errors may take place anyway, errors in the header.php file will always be shown
$_CONTEXT['silent'] = false;
// log errors that have occured
$_CONTEXT['log'] = true;
// did a fatal error take place?
$_CONTEXT['fatal'] = false;
// verbose output on scripts?
$_CONTEXT['verbose'] = true;
// debug scripts?
$_CONTEXT['debug'] = false;
// debug vars
$_CONTEXT['debug_vars'] = array("_PATHS","_CONTEXT","_SERVER","_POST","_GET","_COOKIE","_SESSION");
// current module
$_CONTEXT['module_current'] = "";
// available modules
$_CONTEXT['modules'] = array();
// page title
$_CONTEXT['page_title'] = "Carnivore CMS";
// restricted ip access to the suite?
$_CONTEXT['ip_access'] = false;
// if above is true, set your allowed ip(s) here
$_CONTEXT['ip_allowed'] = array();
// 0.5 - restricted password access to the suite?
$_CONTEXT['pass_access'] = false;
// 0.5 - pass hash
$_CONTEXT['pass_hash'] = 0;
// 0.5 - pass salt
$_CONTEXT['pass_salt'] = 0;
// 0.5 - sleep after failure in seconds
$_CONTEXT['sleeptime'] = 3;
// 0.5 - cookie life in seconds
$_CONTEXT['cookielife'] = 86400;
// 0.5 - login file
$_CONTEXT['login_file'] = "login.php";
// 0.5 - redirect login failure
$_CONTEXT['redirect_fail_login'] = "http://www.google.com";
// 0.5 - allow remote rss feeds
$_CONTEXT['allow_remote_locations'] = false;
// 0.5 - used for automatic module category filtering
$_CONTEXT['modcats'] = array();
// 0.5 - used for automatic configuration category filtering
$_CONTEXT['cfgcats'] = array();
// 0.6 - enable or disable maintenance scans
$_CONTEXT['allow_maintenance_scan'] = true;
// 0.6 - will scan for log,configuration and data files that became bigger than $_CONTEXT['maxflsz']
$_CONTEXT['allow_filesizescan'] = true;
// 0.6 - maximum filesize of log,configuration and data files in KB
$_CONTEXT['maxflsz'] = 512;
// 0.6 - analyzes logfiles
$_CONTEXT['allow_logfileanalyze'] = true;
// 0.6 - checks if all required functions are there
$_CONTEXT['allow_functcheck'] = true;
// 0.6 - will count the files in specific folders in order to minimize the amount of garbage
$_CONTEXT['allow_filesindirscan'] = true;
// 0.6 - maximum files in dir before reporting
$_CONTEXT['maxflsindir'] = 25;
// 0.6 - the global interval between a next maintenance scan, note that this doesn't work as a cron job, instead it will be compared to your last scan when you visit the index page
$_CONTEXT['nextscanseconds'] = 500000;
// 0.6 - enable or disable test servers
$_CONTEXT['allow_testservers'] = false;
// 0.6 - time pattern
$_CONTEXT['time_pattern'] = "d-m-Y";
// 0.6.1 - checks tool versions
$_CONTEXT['allow_version_check'] = true;
// 0.7.0 - spider for keywords
$_CONTEXT['keywords_spider'] = true;
?>