<?php
/* Filters out exploits

Filters some common exploits like xss,lfi and sqli from a string.

PARAMETERS:
$sString: text string
$bXSS: filters xss
$bFI: filters file injections
$bSQL: filters sql injections

RETURNS:
STRING: filtered data

Author: Remco Kouw
Site: http://www.hacksuite.com
Last Edit: 19-05-2023
*/

function ExploitFilter($sString,$bXSS=false,$bFI=false,$bSQL=false){
	if($bXSS==false && $bFI==false && $bSQL==false){
		return($sString);
	}
	if(!is_string($sString)){
		return($sString);
	}
	if($bXSS){
		$sString = strip_tags($sString);
	}
	if($bFI){
		$sString = preg_replace('/\.\.\/|\.\/|[^a-zA-Z0-9\-_\.\/ ]/','',$sString);
	}
	if($bSQL){
		$sString = preg_replace('/[\x00\x0A\x0D\x1A\x22\x25\x27\x5C\x5F]/u','\\\$0',$sString);
	}
	return($sString);
}
?>