<?php
/* Returns and installs setup.php files in Apps

Author: Remco Kouw
Site: http://www.hacksuite.com
Last Edit: 11-02-2024
*/
session_cache_limiter('nocache');
header('Expires: '.gmdate('r',0));
header('Content-type: application/json');
$_DYNAMIC_ROOT = "..";
include_once("../header.php");
$aDataR = array();
$aDataR['jresult'] = false;
$sDataFile = "../Data/extra.php";
$_CONTEXT['time_pattern'] = isset($_CONTEXT['time_pattern']) ? $_CONTEXT['time_pattern'] : "d-m-Y";
if(!file_exists($sDataFile)){
	// this file is crucial
	$_CONTEXT['errors'][] = array('error'=>'Data file '.$sDataFile.' doesn\'t exist','type'=>'2','fatal'=>'1','json'=>'1','line'=>__LINE__,'file'=>__FILE__);
	include_once($_PATHS['end']);
}
@include_once($sDataFile);
if(!isset($aExtra)){
	// expecting $aExtra data array
	$_CONTEXT['errors'][] = array('error'=>'Data file '.$sDataFile.' doesn\'t contain proper data','type'=>'2','fatal'=>'1','json'=>'1','line'=>__LINE__,'file'=>__FILE__);
	include_once($_PATHS['end']);
}
if(isset($_POST['sInstallApp'])){
	if(!isset($_POST['sInstallApp'])){
		$aDataR['jmessage'] = "No app specified to install";
	}
	else{
		// let's make sure the file is valid
		$sApp = str_replace("\/","/",ExploitFilter($_POST['sInstallApp'],0,1));
		if(substr($sApp,0,4)!="Apps" && substr($sApp,(strlen($sApp)-9))=="setup.php"){
			$_CONTEXT['errors'][] = array('error'=>'Invalid setup location specified to install','type'=>'1','fatal'=>'1','json'=>'1','line'=>__LINE__,'file'=>__FILE__);
			include_once($_PATHS['end']);
		}
		else{
			// include setup file to see if the data is valid
			include_once("../".$sApp);
			if(!isset($aProperties['name'])){
				$_CONTEXT['errors'][] = array('error'=>'Invalid setup location specified to install','type'=>'1','fatal'=>'1','json'=>'1','line'=>__LINE__,'file'=>__FILE__);
				include_once($_PATHS['end']);
			}
			else{
				$bExists = false;
				for($x=0;$x<count($aExtra);$x++){
					if($aExtra[$x][0]==$aProperties['name']){
						$bExists = true;
					}
				}
				if($bExists){
					// make sure we don't install anything more than once
					$aDataR['jmessage'] = "App has already been installed";
				}
				else{
					// function for overwriting existing app library
					$sDest = "../Functions/fwrite.php";
					if(file_exists($sDest)){
						@include_once($sDest);
					}
					if(!function_exists("WriteF")){
						$_CONTEXT['errors'][] = array('error'=>'Failed to include WriteF function','type'=>'2','fatal'=>'1','json'=>'1','line'=>__LINE__,'file'=>__FILE__);
						include_once($_PATHS['end']);
					}
					else{
						// install apps
						$sTemplate = "<?php\n";
						$sTemplate .= "/*\n";
						$sTemplate .= "Installed apps\n\n";
						$sTemplate .= "Author: Remco Kouw\n";
						$sTemplate .= "Site: http://www.hacksuite.com\n";
						$sTemplate .= "Last Edit: ".date($_CONTEXT['time_pattern'],time())."\n";
						$sTemplate .= "*/\n";
						$sTemplate .= "if(!defined('IN_SCRIPT')){\n";
						$sTemplate .= "\texit;\n";
						$sTemplate .= "}\n";
						$sTemplate .= "\$aExtra = array();\n";
						// amount of installed products
						$iInstalledPaths = count($aExtra);
						// go through the $aReadyToInstall array to see which setups are already installed
						for($x=0;$x<$iInstalledPaths;$x++){
							$sTemplate .= "\$aExtra[".$x."] = array(\"".$aExtra[$x][0]."\",\"".$aExtra[$x][1]."\");\n";
						}
						$sTemplate .= "\$aExtra[".$iInstalledPaths."] = array(\"".$aProperties['name']."\",\"Apps/".$aProperties['location']."\");\n";
						$sTemplate .= "?>";
						// install
						if(false===($bResult = WriteF($sDataFile,$sTemplate,"w"))){
							$_CONTEXT['errors'][count($_CONTEXT['errors'])-1] = array('error'=>'Failed to write template to '.$sDataFile,'type'=>'2','fatal'=>'1','json'=>'1','line'=>__LINE__,'file'=>__FILE__);
							include_once($_PATHS['end']);
						}
						else{
							$sDest = "../Logs/log_activity.php";
							if(!file_exists($sDest)){
								$_CONTEXT['errors'][] = array('error'=>'Activity log '.$sDest.' doesn\'t exist','type'=>'2','fatal'=>'1','json'=>'1','line'=>__LINE__,'file'=>__FILE__);
								include_once($_PATHS['end']);
							}
							elseif(!is_writable($sDest)){
								$_CONTEXT['errors'][] = array('error'=>'Activity log '.$sDest.' isn\'t writable','type'=>'2','fatal'=>'1','json'=>'1','line'=>__LINE__,'file'=>__FILE__);
								include_once($_PATHS['end']);
							}
							else{
								@include_once($sDest);
								$sTemplate = "<?php\n";
								$sTemplate .= "/* Activity log\n\n";
								$sTemplate .= "Author: Remco Kouw\n";
								$sTemplate .= "Site: http://www.hacksuite.com\n";
								$sTemplate .= "Last Edit: ".date($_CONTEXT['time_pattern'],time())."\n";
								$sTemplate .= "*/\n";
								$sTemplate .= "if(!defined('IN_SCRIPT')){\n\t";
								$sTemplate .= "exit;\n";
								$sTemplate .= "}\n";
								$sTemplate .= "\$_CONTEXT['useraccessdata'] = array();\n";
								$sTemplate .= "\$_CONTEXT['useraccessdata']['installed'] = ".$_CONTEXT['useraccessdata']['installed'].";\n";
								$sTemplate .= "\$_CONTEXT['useraccessdata']['last_update'] = ".time().";\n";
								$sTemp = "";
								for($x=0;$x<count($_CONTEXT['useraccessdata']['ip']);$x++){
									if($x!=0){
										$sTemp .= ",";
									}
									$sTemp .= "\"".$_CONTEXT['useraccessdata']['ip'][$x]."\"";
								}
								if(!in_array($_SERVER['REMOTE_ADDR'],$_CONTEXT['useraccessdata']['ip'])){
									// this ip is not used for installing stuff yet, so let's log it
									$sTemp = ($sTemp=="" ? "\"".$_SERVER['REMOTE_ADDR']."\"" : $sTemp.",\"".$_SERVER['REMOTE_ADDR']."\"");
								}
								$sTemplate .= "\$_CONTEXT['useraccessdata']['ip'] = array(".$sTemp.");\n";
								$sTemplate .= "\$_CONTEXT['useraccessdata']['last_scan'] = ".$_CONTEXT['useraccessdata']['last_scan'].";\n";
								$sTemplate .= "\$_CONTEXT['useraccessdata']['action'] = \"installed ".$aProperties['name']."\";\n";
								$sTemplate .= "?>";
								// file is writable...what can go wrong?
								$aDataR['jresult'] = WriteF($sDest,$sTemplate,"w") ? true : false;
								if(isset($_CONTEXT['errors'][0])){
									$_CONTEXT['errors'][count($_CONTEXT['errors'])-1] = array('error'=>'Failed to write cms stats to '.$sDest,'type'=>'2','fatal'=>'1','json'=>'1','line'=>__LINE__,'file'=>__FILE__);
									include_once($_PATHS['end']);
								}
								$aDataR['jmessage'] = "Successfully installed application";
							}
						}
					}
				}
			}
		}
	}
}
else{
	// find new apps
	$iterator = new RecursiveIteratorIterator(new RecursiveDirectoryIterator($_PATHS['root']."/Apps"),RecursiveIteratorIterator::CHILD_FIRST);
	$aReadyToInstall = array();
	foreach($iterator as $path){
		if(!$path->isDir()){
			if($path->getFilename()=="setup.php"){
				$aReadyToInstall[] = str_replace("\\","/",str_replace("../","",$path->getPathname()));
			}
		}
	}
	// how many products are ready to be installed
	$iReadyToInstall = count($aReadyToInstall);
	if(!$iReadyToInstall){
		// nothing to install
		$aDataR['jmessage'] = "No new products";
	}
	else{
		// new setup buffer
		$aSetups = array();
		// amount of installed products
		$iInstalledPaths = count($aExtra);
		// go through the $aReadyToInstall array to see which setups are already installed
		for($x=0;$x<$iReadyToInstall;$x++){
			// which are installed
			$bInstalled = false;
			for($y=0;$y<$iInstalledPaths;$y++){
				if($aExtra[$y][1]."/setup.php"==$aReadyToInstall[$x]){
					$bInstalled = true;
					break;
				}
			}
			if(!$bInstalled){
				$aSetups[] = $aReadyToInstall[$x];
			}
		}
		if(false==($iSetups = count($aSetups))){
			$aDataR['jmessage'] = "No new products";
		}
		else{
			// build selection menu
			$aDataR['jresult'] = true;
			$aDataR['jmessage'] = "\n<select name=\"sInstallApp\">\n";
			for($x=0;$x<$iSetups;$x++){
				// get the name of the app
				include_once("../".$aSetups[$x]);
				if(!isset($aProperties['name'])){
					$aProperties['name'] = "no name defined";
				}
				$aDataR['jmessage'] .= "<option value=\"".$aSetups[$x]."\">".$aProperties['name']."</option>\n";
			}
			$aDataR['jmessage'] .= "</select>\n";
		}
	}
}
echo json_encode($aDataR);
?>