<?php
/* Log filename editor

Author: Remco Kouw
Site: http://www.hacksuite.com
Last Edit: 12-02-2024
*/
session_cache_limiter('nocache');
header('Expires: '.gmdate('r',0));
header('Content-type: application/json');
$_DYNAMIC_ROOT = "..";
include_once("../header.php");
$aDataR = array();
$aDataR['jresult'] = false;
$aDataR['jmessage'] = "An error occured";
$aFiles = array($_PATHS['functions_root']."/fwrite.php",$_PATHS['functions_root']."/get_file_data.php",$_PATHS['functions_root']."/getfilebydir.php");
for($x=0;$x<count($aFiles);$x++){
	if(!file_exists($aFiles[$x])){
		$_CONTEXT['errors'][] = array('error'=>'Missing required file: '.$aFiles[$x],'type'=>'2','fatal'=>'1','json'=>'1','line'=>__LINE__,'file'=>__FILE__);
		include_once($_PATHS['end']);
	}
	@include_once($aFiles[$x]);
}
$sDest = $_PATHS['data_root']."/logsdata.php";
if(!isset($_CONTEXT['l_formats']) || false===($iSelect = @count($_CONTEXT['l_formats']))){
	if(!file_exists($sDest)){
		$_CONTEXT['errors'][] = array('error'=>'Failed to load log formats file '.$sDest,'type'=>'2','fatal'=>'1','json'=>'1','line'=>__LINE__,'file'=>__FILE__);
		include_once($_PATHS['end']);
	}
	include($sDest);
	if(!isset($_CONTEXT['l_formats'])){
		$_CONTEXT['errors'][] = array('error'=>'Corrupt data in log formats file','type'=>'2','fatal'=>'1','json'=>'1','line'=>__LINE__,'file'=>__FILE__);
		include_once($_PATHS['end']);
	}
}
if(isset($_POST['sNewName'],$_POST['sLogName'])){
	// validate filenames
	$sNewFile = @trim($_POST['sNewName']);
	$sOldFile = @trim($_POST['sLogName']);
	if($sNewFile==$sOldFile){
		$aDataR['jmessage'] = "Source and destination are the same";
	}
	elseif($sNewFile=="" || $sOldFile==""){
		$aDataR['jmessage'] = "No filename specified";
	}
	else{
		if(!@preg_match('/^([0-9a-z_\-])+(\.){1}(php|txt){1}$/i',$sNewFile)){
			$aDataR['jmessage'] = "Invalid new file name structure";
		}
		else{
			// get environment conditions
			$_CONTEXT['oldnameexists'] = false;
			$_CONTEXT['newnameexists'] = false;
			$_CONTEXT['oldfileexists'] = false;
			$_CONTEXT['newfileexists'] = false;
			for($x=0;$x<count($_CONTEXT['l_formats']);$x++){
				if(isset($_CONTEXT['l_formats'][$x]['file'])){
					if($_CONTEXT['l_formats'][$x]['file']==$sNewFile){
						$_CONTEXT['newnameexists'] = true;
					}
					if($_CONTEXT['l_formats'][$x]['file']==$sOldFile){
						$_CONTEXT['oldnameexists'] = true;
						$_CONTEXT['oldnamekey'] = $x;
					}
				}
			}
			$sOld = $_PATHS['log_root']."/".ExploitFilter($sOldFile,0,1);
			$sNew = $_PATHS['log_root']."/".ExploitFilter($sNewFile,0,1);
			$_CONTEXT['oldfileexists'] = file_exists($sOld) ? true : false;
			$_CONTEXT['newfileexists'] = file_exists($sNew) ? true : false;
			if(!$_CONTEXT['oldfileexists']){
				$aDataR['jmessage'] = "Source file doesn't exist";
			}
			elseif(!$_CONTEXT['oldnameexists']){
				$aDataR['jmessage'] = "Source file hasn't been registered in the log_edit.php file";
			}
			elseif($_CONTEXT['newfileexists']){
				$aDataR['jmessage'] = "New file already exists";
			}
			elseif($_CONTEXT['newnameexists']){
				$aDataR['jmessage'] = "Destination file has already been registered in the log_edit.php file";
			}
			else{
				// meets conditions, get the file data of edit_file.php, change it and rename the old file to new file
				if(false==($sFileData = GetFileData($sDest))){
					$_CONTEXT['errors'][count($_CONTEXT['errors'])-1] = array('error'=>'Failed to get file '.$sDest,'type'=>'2','fatal'=>'1','json'=>'1','line'=>__LINE__,'file'=>__FILE__);
					include_once($_PATHS['end']);
				}
				$sMD5Old = md5($sFileData);
				$sFileData = str_replace("\$_CONTEXT['l_formats'][".$_CONTEXT['oldnamekey']."]['file'] = \"".$sOldFile."\";","\$_CONTEXT['l_formats'][".$_CONTEXT['oldnamekey']."]['file'] = \"".$sNewFile."\";",$sFileData);
				$sMD5New = md5($sFileData);
				if($sMD5Old==$sMD5New){
					$aDataR['jmessage'] = "Failed to update file data";
				}
				else{
					if(!WriteF($sDest,$sFileData,"w")){
						$_CONTEXT['errors'][count($_CONTEXT['errors'])-1] = array('error'=>'Failed to update file '.$sDest,'type'=>'2','fatal'=>'1','json'=>'1','line'=>__LINE__,'file'=>__FILE__);
						include_once($_PATHS['end']);
					}
					else{
						if(@rename($sOld,$sNew)){
							$aDataR['jresult'] = true;
							$aDataR['jmessage'] = "Successfully changed filename";
						}
						else{
							$aDataR['jmessage'] = "Filedata updated, but failed to change to new filename";
						}
					}
				}
			}
		}
	}
}
else{
	$aDataR['jmessage'] = "Invalid post data specified";
}
echo json_encode($aDataR);
?>