<?php
/* Configure screen setup

Author: Remco Kouw
Site: http://www.hacksuite.com
Last Edit: 19-02-2024
*/
session_cache_limiter('nocache');
header('Expires: '.gmdate('r',0));
header('Content-type: application/json');
$_DYNAMIC_ROOT = "..";
include_once("../header.php");
$aDataR = array();
$aDataR['jresult'] = false;
$aDataR['jmessage'] = "an error occured";
$aDataR['jwrite'] = false;
// target files we need, so make sure they are present
$aFiles = array($_PATHS['functions_root']."/fwrite.php",$_PATHS['functions_root']."/get_file_data.php",$_PATHS['functions_root']."/exploitfilter.php");
for($x=0;$x<count($aFiles);$x++){
	(!IsThere($aFiles[$x]) ? include_once($_PATHS['end']) : include_once($aFiles[$x]));
}
$sBaseDir = "../Modules/";
if(!isset($_POST['submitbutton'])){
	$aDataR['jmessage'] = "No valid submit button specified";
}
else{
	$_POST['sModName'] = !isset($_POST['sModName']) ? "" : $_POST['sModName'];
	$_POST['sMemoryLimit'] = !isset($_POST['sMemoryLimit']) ? "" : trim($_POST['sMemoryLimit']);
	$_POST['sTimeLimit'] = !isset($_POST['sTimeLimit']) ? "" : trim($_POST['sTimeLimit']);
	$sScreenFile = $sBaseDir.ExploitFilter($_POST['sModName'],0,1)."/screen.php";
	if(!file_exists($sScreenFile)){
		$aDataR['jmessage'] = "No screen file found in this module";
	}
	else{
		if(isset($_POST['sSetupType'])){
			$sData = GetFileData($sScreenFile);
			$bCommentUpdated = false;
			$aComment = array();
			if($_POST['submitbutton']=="Edit"){
				// apart from updating memory limit or time limit, the edit time also needs to be updated
				$sCurrentDate = date($_CONTEXT['time_pattern'],time());
				$sReplaceDate = "/(Last Edit:\s)(\d+\-\d+\-\d+)/";
				$aComment = explode("*/",$sData,2);
				if(!isset($aComment[1])){
					// no comment found
					$_CONTEXT['errors'][] = array('error'=>'File screen.php is corrupted, unable to find header comment','type'=>'2','fatal'=>'1','json'=>'1','line'=>__LINE__,'file'=>__FILE__);
					include_once($_PATHS['end']);
				}
				else{
					// extract the last edit time
					preg_match($sReplaceDate,$aComment[0],$aPieces);
					if(!isset($aPieces[2])){
						$_CONTEXT['errors'][] = array('error'=>'Invalid last edit time properties in header comment','type'=>'2','fatal'=>'1','json'=>'1','line'=>__LINE__,'file'=>__FILE__);
						include_once($_PATHS['end']);
					}
					else{
						// replace previous edit time with the current date
						$aComment[0] = str_replace($aPieces[2],$sCurrentDate,$aComment[0]);
						$bCommentUpdated = true;
					}
				}
				if(!$bCommentUpdated){
					die(json_encode($aDataR));
				}
			}
			if($_POST['sSetupType']!="1" && $_POST['sSetupType']!="2"){
				$aDataR['jmessage'] = "No valid property specified";
			}
			else{
				if($_POST['sSetupType']==1){
					// memory
					$sFindMemoryLimit = "/ini_set\('memory_limit',\s*'(\d+[MG])'\);/";
					preg_match($sFindMemoryLimit,(!isset($aComment[1]) ? $sData : $aComment[1]),$aMatches);
					$bMatch = isset($aMatches[1]) ? $aMatches[1] : false;
					if($_POST['submitbutton']=="Edit"){
						if(!preg_match('/^\d+[MG]$/',$_POST['sMemoryLimit'])){
							$aDataR['jmessage'] = "Invalid memory limit posted from form";
						}
						else{
							if($bMatch){
								// memory limit is already set, just replace the value
								$aComment[1] = preg_replace($sFindMemoryLimit,"ini_set('memory_limit','".$_POST['sMemoryLimit']."');",$aComment[1]);
								$sData = $aComment[0]."*/".$aComment[1];
								$aDataR['jmessage'] = "Successfully replaced memory limit in screen file";
							}
							else{
								// memory limit not defined yet, insert the memory limit settings
								$sData = $aComment[0]."*/\n"."ini_set('memory_limit','".$_POST['sMemoryLimit']."');".$aComment[1];
								$aDataR['jmessage'] = "Successfully created memory limit settings";
							}
							$aDataR['jwrite'] = true;
						}
					}
					elseif($_POST['submitbutton']=="Find Settings"){
						// display current memory limit settings
						if(isset($aMatches[1])){
							$aDataR['jmessage'] = "Memory limit is ".$aMatches[1]."B";
						}
						else{
							$aDataR['jmessage'] = "No memory limit settings in this screen file";
						}
					}
					else{
						$aDataR['jmessage'] = "No valid option specified for memory limit";
					}
				}
				else{
					// time limit
					$sFind = "/set_time_limit\((\d+)\);/";
					preg_match($sFind,$sData,$aMatches);
					if($_POST['submitbutton']=="Edit"){
						if($_POST['sTimeLimit']=="-1"){
							$aDataR['jmessage'] = "No value selected for time limit value";
						}
						else{
							if($_POST['sTimeLimit']=="infinite"){
								$_POST['sTimeLimit'] = 0;
							}
							if(!preg_match('/^0|[1-9][0-9]+$/',$_POST['sTimeLimit'])){
								$aDataR['jmessage'] = "Invalid value selected for time limit value";
							}
							else{
								if(!isset($aMatches[1])){
									// time limit not found
									$sData = $aComment[0]."*/\nset_time_limit(".$_POST['sTimeLimit'].");".$aComment[1];
									$aDataR['jmessage'] = "Successfully created time limit settings";
								}
								else{
									// update time limit value
									$aComment[1] = str_replace($aMatches[0],"set_time_limit(".$_POST['sTimeLimit'].");",$aComment[1]);
									$sData = $aComment[0]."*/".$aComment[1];
									$aDataR['jmessage'] = "Successfully replaced time limit in screen file";
								}
								$aDataR['jwrite'] = true;
							}
						}
					}
					elseif($_POST['submitbutton']=="Find Settings"){
						// display current execution time limit settings
						if(isset($aMatches[1])){
							$aDataR['jmessage'] = "Execution time limit is ".$aMatches[1]." seconds";
						}
						else{
							$aDataR['jmessage'] = "No execution time limit set";
						}
					}
					else{
						$aDataR['jmessage'] = "No valid option specified for time limit";
					}
				}
			}
			if($aDataR['jwrite']){
				$aDataR['jresult'] = WriteF($sScreenFile,$sData,"w") ? true : false;
			}
		}
		else{
			$aDataR['jmessage'] = "Invalid form specified";
		}
	}
}
echo json_encode($aDataR);
?>