<?php
/*
Handler for AntiHash

ModGlue Variables:
$_CONTEXT['thc_ah']['logfile']
$_CONTEXT['thc_ah']['hashdetect']
$_CONTEXT['thc_ah']['hashdetectfunc']
$_CONTEXT['thc_ah']['wordlistdata']
$_CONTEXT['thc_ah']['encoding_func']
$_CONTEXT['thc_ah']['password']
$_CONTEXT['thc_ah']['hash']
$_CONTEXT['thc_ah']['saltstructure']
$_CONTEXT['thc_ah']['saltstring']
$_CONTEXT['thc_ah']['wordlist']
$_CONTEXT['thc_ah']['hashlength']
$_CONTEXT['thc_ah']['attackresult']

Author: Remco Kouw
Site: http://www.hacksuite.com
Last Edit: 25-04-2024
*/
// set variable to be able to save a task
$_MODULE_C = "thc_ah";
include_once("../../Includes/screen_header.php");
include_once($_PATHS['style_root']."/screen.php");
include_once($_PATHS['functions_root']."/scrn.php");
$_CONTEXT['thc_ah'] = array();
$_CONTEXT['thc_ah']['logfile'] = $_PATHS['module_default_root']."/cracked.txt";
$_CONTEXT['thc_ah']['hashdetect'] = $_PATHS['module_default_root']."/hash_detect.php";
$_CONTEXT['thc_ah']['hashdetectfunc'] = $_PATHS['module_default_root']."/func_antihash.php";
$_CONTEXT['thc_ah']['wordlistdata'] = "";
$_CONTEXT['thc_ah']['encoding_func'] = "";
$_CONTEXT['thc_ah']['password'] = "";
$_CONTEXT['thc_ah']['hash'] = "";
$_CONTEXT['thc_ah']['saltstructure'] = "";
$_CONTEXT['thc_ah']['saltstring'] = "";
(!IsThere($sDest) ? include_once($_PATHS['end']) : include_once($_CONTEXT['thc_ah']['hashdetect']));
if(!function_exists("WriteF")){
	$sDest = $_PATHS['functions_root']."/fwrite.php";
	(!IsThere($sDest) ? include_once($_PATHS['end']) : include_once($sDest));
}
// options
$sOptions = "<b>logging:</b> ".($_CONTEXT['log']==true ? "on" : "off")."<br>\n";
$sOptions .= "<b>silence:</b> ".($_CONTEXT['silent']==true ? "on" : "off")."<br>\n";
$sOptions .= "<b>verbose:</b> ".($_CONTEXT['verbose']==true ? "on" : "off")."\n";
$aFileData = array();
if(isset($_POST['submit'])){
	switch($_POST['submit']){
		// quick 'n dirty input validation
		case"Crack":
		if(!isset($_POST['sHash']) || $_POST['sHash']==""){
			die(Screen($sOut."No hash specified to crack".$sEnd,$_CONTEXT['verbose'],$_CONTEXT['silent']));
		}
		if(strlen($_POST['sHash'])<16){
			die(Screen($sOut."Hashes should at least be 16 characters long".$sEnd,$_CONTEXT['verbose'],$_CONTEXT['silent']));
		}
		if(isset($_POST['sSalt']) && $_POST['sSalt']==2){
			if(!isset($_POST['sSaltString']) || $_POST['sSaltString']==""){
				die(Screen($sOut."No salt string specified".$sEnd,$_CONTEXT['verbose'],$_CONTEXT['silent']));
			}
			if(!isset($_POST['sSaltStructure']) || $_POST['sSaltStructure']==""){
				die(Screen($sOut."No salt structure specified".$sEnd,$_CONTEXT['verbose'],$_CONTEXT['silent']));
			}
			$_CONTEXT['thc_ah']['saltstructure'] = $_POST['sSaltStructure'];
			$_CONTEXT['thc_ah']['saltstring'] = $_POST['sSaltString'];
		}
		// load wordlist
		$_CONTEXT['thc_ah']['wordlist'] = $_PATHS['wordlists_root']."/".ExploitFilter($_POST['sWordlist'],0,1);
		if(false===($_CONTEXT['thc_ah']['wordlistdata'] = @file($_CONTEXT['thc_ah']['wordlist']))){
			die(Screen($sOut."Wordlist doesn't exist".$sEnd,$_CONTEXT['verbose'],$_CONTEXT['silent']));
		}
		$_CONTEXT['thc_ah']['hash'] = $_POST['sHash'];
		$_CONTEXT['thc_ah']['hashlength'] = strlen($_CONTEXT['thc_ah']['hash']);
		foreach($_CONTEXT['hashes'] as $sKey=>$aValues){
			if($aValues[0]==$_CONTEXT['thc_ah']['hashlength']){
				$_CONTEXT['thc_ah']['encoding_func'] = $sKey;
				break;
			}
		}
		if($_CONTEXT['thc_ah']['encoding_func']==""){
			die($sOut."Unknown encryption type".$sEnd);
		}
		(!IsThere($_CONTEXT['thc_ah']['hashdetectfunc']) ? include_once($_PATHS['end']) : include_once($_CONTEXT['thc_ah']['hashdetectfunc']));
		// get it on with..
		include($_PATHS['includes_root']."/task_start.php");
		echo Screen($sOut,$_CONTEXT['verbose'],$_CONTEXT['silent']);
		echo Screen("<br />\n<b>Running..</b><p>\n",$_CONTEXT['verbose'],$_CONTEXT['silent']);
		// spit fire...
		flush();
		ob_flush();
		$_CONTEXT['thc_ah']['attackresult'] = false;
		// wordlist attack
		for($x=0;$x<count($_CONTEXT['thc_ah']['wordlistdata']);$x++){
			$_CONTEXT['thc_ah']['wordlistdata'][$x] = trim($_CONTEXT['thc_ah']['wordlistdata'][$x]);
			echo Screen($_CONTEXT['thc_ah']['wordlistdata'][$x]."=&gt;",$_CONTEXT['verbose'],$_CONTEXT['silent']);
			if(AntiHash($_CONTEXT['thc_ah']['wordlistdata'][$x],$_CONTEXT['thc_ah']['hash'],$_CONTEXT['thc_ah']['encoding_func'],$_CONTEXT['thc_ah']['saltstring'],$_CONTEXT['thc_ah']['saltstructure'])){
				echo Screen("<b>success</b>",$_CONTEXT['verbose'],$_CONTEXT['silent']);
				$_CONTEXT['thc_ah']['password'] = $_CONTEXT['thc_ah']['wordlistdata'][$x];
				$_CONTEXT['thc_ah']['attackresult'] = true;
				if($_CONTEXT['log']){
					WriteF($_CONTEXT['thc_ah']['logfile'],time()."|".$_CONTEXT['thc_ah']['hash']."|".$_CONTEXT['thc_ah']['wordlistdata'][$x]."|".$_CONTEXT['thc_ah']['encoding_func']."\n");
				}
				break;
			}
			else{
				echo Screen("failed",$_CONTEXT['verbose'],$_CONTEXT['silent']);
			}
			echo Screen("<br />\n",$_CONTEXT['verbose'],$_CONTEXT['silent']);
			flush();
			ob_flush();
		}
		echo Screen("<p>Script terminated after ".(time()-$_CONTEXT['start_task'])." seconds</p>",$_CONTEXT['verbose'],$_CONTEXT['silent']);
		if($_CONTEXT['thc_ah']['password']!=""){
			echo Screen("<p>Password is ".$_CONTEXT['thc_ah']['password']."</p>",$_CONTEXT['verbose'],$_CONTEXT['silent']);
		}
		else{
			echo Screen("<p>Failed to get password</p>",$_CONTEXT['verbose'],$_CONTEXT['silent']);
		}
		break;
		// View Passes
		case"View Passes":
		echo Screen($sOut,$_CONTEXT['verbose'],$_CONTEXT['silent']);
		if(!function_exists("RawToArray")){
			include_once($_PATHS['functions_root']."/raw_to_array.php");
		}
		if(false==($aKeys = RawToArray($_CONTEXT['thc_ah']['logfile']))){
			echo Screen("[no passwords found yet]",$_CONTEXT['verbose'],$_CONTEXT['silent']);
		}
		else{
			for($x=0;$x<count($aKeys);$x++){
				echo Screen("<b>".date($_CONTEXT['time_pattern'].' H:i:s',$aKeys[$x][0])."</b> hash <b>".$aKeys[$x][1]."</b>(".trim($aKeys[$x][3]).") is <b>".$aKeys[$x][2]."</b><br>\n",$_CONTEXT['verbose'],$_CONTEXT['silent']);
			}
		}
		exit;
		break;
		// Clear Passes
		case"Clear Passes":
		echo Screen($sOut.(WriteF($_CONTEXT['thc_ah']['logfile'],"","w")==true ? "Successfully deleted old entries." : "Failed to delete old entries.").$sEnd,$_CONTEXT['verbose'],$_CONTEXT['silent']);
		exit;
		break;
		default:
		// default template
		die(Screen($sOut.$sOptions.$sEnd,$_CONTEXT['verbose'],$_CONTEXT['silent']));
	}
}
else{
	die(Screen($sOut.$sOptions.$sEnd,$_CONTEXT['verbose'],$_CONTEXT['silent']));
}
// update entry in background task file
include($_PATHS['includes_root']."/task_end.php");
echo Screen($sEnd,$_CONTEXT['verbose'],$_CONTEXT['silent']);
?>
