<?php
/*
Handler for Sscan

ModGlue Variables:
$_CONTEXT['thc_ss']['paths']['logs']
$_CONTEXT['thc_ss']['paths']['logtemplate']
$_CONTEXT['thc_ss']['paths']['callbacks']
$_CONTEXT['thc_ss']['paths']['emailtemplate']
$_CONTEXT['thc_ss']['paths']['callbackpath']
$_CONTEXT['thc_ss']['paths']['emailtemplatepath']
$_CONTEXT['thc_ss']['paths']['loggingpath']
$_CONTEXT['thc_ss']['paths']['logtemplatefile']
$_CONTEXT['thc_ss']['paths']['dumplogtemplatefile']
$_CONTEXT['thc_ss']['paths']['dumplogfile']
$_CONTEXT['thc_ss']['urlparts']['host']
$_CONTEXT['thc_ss']['urlparts']['query']
$_CONTEXT['thc_ss']['urlparts']['scheme']
$_CONTEXT['thc_ss']['urlparts']['path']
$_CONTEXT['thc_ss']['urlparts']['queryold']
$_CONTEXT['thc_ss']['callbacksearch']
$_CONTEXT['thc_ss']['regex']
$_CONTEXT['thc_ss']['transfermethod']
$_CONTEXT['thc_ss']['temporary_scan']
$_CONTEXT['thc_ss']['negative_scan']
$_CONTEXT['thc_ss']['timebased_scan']
$_CONTEXT['thc_ss']['mail_notify']
$_CONTEXT['thc_ss']['file_logging']
$_CONTEXT['thc_ss']['endscript']
$_CONTEXT['thc_ss']['search']
$_CONTEXT['thc_ss']['endmessage']
$_CONTEXT['thc_ss']['cancelled']
$_CONTEXT['thc_ss']['matches']
$_CONTEXT['thc_ss']['condition']
$_CONTEXT['thc_ss']['total_time']
$_CONTEXT['thc_ss']['response']
$_CONTEXT['thc_ss']['responselength']
$_CONTEXT['thc_ss']['result']
$_CONTEXT['thc_ss']['resultstring']

Author: Remco Kouw
Site: http://www.hacksuite.com
Last Edit: 17-05-2024
*/
// set variable to be able to save a task
$_MODULE_C = "thc_ss";
include_once("../../Includes/screen_header.php");
include_once($_PATHS['style_root']."/screen.php");
// add some new paths
$_CONTEXT['thc_ss'] = array();
$_CONTEXT['thc_ss']['paths'] = array();
$_CONTEXT['thc_ss']['paths']['logs'] = $_PATHS['module_default_root']."/LOGS";
$_CONTEXT['thc_ss']['paths']['logtemplate'] = $_PATHS['module_default_root']."/LOGT";
$_CONTEXT['thc_ss']['paths']['callbacks'] = $_PATHS['module_default_root']."/CALLBACKS";
$_CONTEXT['thc_ss']['paths']['emailtemplate'] = $_PATHS['module_default_root']."/EMAILT";
// add file writing and screen options
include_once($_PATHS['functions_root']."/scrn.php");
include_once($_PATHS['functions_root']."/fwrite.php");
// options
$sOptions = "<b>logging:</b> ".($_CONTEXT['log']==true ? "on" : "off")."<br>\n";
$sOptions .= "<b>silence:</b> ".($_CONTEXT['silent']==true ? "on" : "off")."<br>\n";
$sOptions .= "<b>verbose:</b> ".($_CONTEXT['verbose']==true ? "on" : "off")."\n";
if(isset($_POST['submit']) && $_POST['submit']=="Scan Target"){
	// numeric
	$iInterval = @intval($_POST['iInterval']);
	$iScan = @intval($_POST['iScan']);
	$iNotify = @intval($_POST['iNotify']);
	$iScanTime = @intval($_POST['iScanSec']);
	$iKill = @intval($_POST['iKill']);
	$iRegex = @intval($_POST['iRegex']);
	// string
	$sSearch = isset($_POST['sSearch']) ? trim($_POST['sSearch']) : "";
	$sEndMessage = isset($_POST['sEndMessage']) ? trim($_POST['sEndMessage']) : "";
	$sMethod = isset($_POST['sMethod']) ? strtoupper($_POST['sMethod']) : "";
	$sEmail = isset($_POST['sEmail']) ? $_POST['sEmail'] : "";
	$sScanUrl = isset($_POST['sScanUrl']) ? $_POST['sScanUrl'] : "";
	$sSendVars = isset($_POST['sSendVars']) ? $_POST['sSendVars'] : "";
	$sCallback = isset($_POST['sCallback']) ? $_POST['sCallback'] : "";
	// files
	$sEmailT = isset($_POST['sEmailT']) ? ExploitFilter($_POST['sEmailT'],0,1) : "";
	$sCallbackF = isset($_POST['sCallbackF']) ? ExploitFilter($_POST['sCallbackF'],0,1) : "";
	$sLogTemplate = isset($_POST['sLogTemplate']) ? ExploitFilter($_POST['sLogTemplate'],0,1) : "";
	$sLogFile = isset($_POST['sLogFile']) ? ExploitFilter($_POST['sLogFile'],0,1) : "";
	// first of all let's see if the url looks valid..
	$_CONTEXT['thc_ss']['urlparts'] = @parse_url($sScanUrl);
	if(!isset($_CONTEXT['thc_ss']['urlparts']['host']) || !strlen($_CONTEXT['thc_ss']['urlparts']['host'])){
		die(Screen($sOut."Invalid target specified.".$sEnd,$_CONTEXT['verbose'],$_CONTEXT['silent']));
	}
	if($sSearch==""){
		die(Screen($sOut."Please insert a string or pattern to search for.".$sEnd,$_CONTEXT['verbose'],$_CONTEXT['silent']));
	}
	// CALLBACKS MAY ADJUST SETTINGS REGARDLESS OF WHAT YOU HAVE SPECIFIED!
	$_CONTEXT['thc_ss']['callbacksearch'] = $sCallback=="yes" ? true : false;
	if($_CONTEXT['thc_ss']['callbacksearch']){
		// ok let's see if the callback exists and contains the right data
		$_CONTEXT['thc_ss']['paths']['callbackpath'] = $_CONTEXT['thc_ss']['paths']['callbacks']."/".$sCallbackF;
		if(file_exists($_CONTEXT['thc_ss']['paths']['callbackpath'])){
			include_once($_CONTEXT['thc_ss']['paths']['callbackpath']);
			if(!function_exists("Callbck")){
				die(Screen($sOut."Failed to find callback function.".$sEnd,$_CONTEXT['verbose'],$_CONTEXT['silent']));
			}
		}
		else{
			die(Screen($sOut."Please insert a valid filename for the callback file.".$sEnd,$_CONTEXT['verbose'],$_CONTEXT['silent']));
		}
	}
	// do we use preg searches?
	$_CONTEXT['thc_ss']['regex'] = ($iRegex==1 ? true : false);
	// make sure we have a valid method
	$_CONTEXT['thc_ss']['transfermethod'] = $sMethod=="GET" ? "GET" : "POST";
	// set default values for scan types
	$_CONTEXT['thc_ss']['temporary_scan'] = ($iScan>2 ? true : false);
	$_CONTEXT['thc_ss']['negative_scan'] = ($iScan==2 || $iScan==4 ? true : false);
	$_CONTEXT['thc_ss']['timebased_scan'] = ($iScan==3 || $iScan==4 ? true : false);
	// notification system
	$_CONTEXT['thc_ss']['mail_notify'] = $iNotify==1 ? true : false;
	$_CONTEXT['thc_ss']['file_logging'] = $iNotify==2 ? true : false;
	// end after requirements are met
	$_CONTEXT['thc_ss']['endscript'] = $iKill==1 ? true : false;
	// strings to search for
	$_CONTEXT['thc_ss']['search'] = $sSearch;
	// if the value of the end message is set, the program will end right away when the message was found
	$_CONTEXT['thc_ss']['endmessage'] = $sEndMessage!="" ? $sEndMessage : false;
	// indicates when the end message has been found and the script was terminated right away
	$_CONTEXT['thc_ss']['cancelled'] = false;
	// do we have a callback or will we just use static variables or send nothing
	if(@strpos($sSendVars,"=")>0){
		// add to query
		if($sSendVars[0]=="?"){
			// remove the question mark
			$sSendVars = substr($sSendVars,1);
		}
		if($sSendVars[strlen($sSendVars)-1]=="&"){
			// remove the last ampersand to prevent mixed up urls
			$sSendVars = substr($sSendVars,0,-1);
		}
		$_CONTEXT['thc_ss']['urlparts']['query'] = (isset($_CONTEXT['thc_ss']['urlparts']['query']) && $_CONTEXT['thc_ss']['urlparts']['query']!="" ? $_CONTEXT['thc_ss']['urlparts']['query']."&".$sSendVars : $sSendVars);
	}
	if($_CONTEXT['thc_ss']['temporary_scan']){
		// only applies to temporary scans
		if($iInterval!==false){
			if($iInterval<0){
				die(Screen($sOut."Interval must be a number above 0.".$sEnd,$_CONTEXT['verbose'],$_CONTEXT['silent']));
			}
			if($iInterval>$iScanTime){
				die(Screen($sOut."Interval must be lower than total scan time.".$sEnd,$_CONTEXT['verbose'],$_CONTEXT['silent']));
			}
		}
		else{
			die(Screen($sOut."Invalid value for interval.".$sEnd,$_CONTEXT['verbose'],$_CONTEXT['silent']));
		}
	}
	if($_CONTEXT['thc_ss']['mail_notify']){
		// send mail
		if(!filter_var($sEmail,FILTER_VALIDATE_EMAIL)){
			die(Screen($sOut."Invalid email specified.".$sEnd,$_CONTEXT['verbose'],$_CONTEXT['silent']));
		}
		if($sEmailT!=""){
			// email template
			$_CONTEXT['thc_ss']['paths']['emailtemplatepath'] = $_CONTEXT['thc_ss']['paths']['emailtemplate']."/".$sEmailT;
			if(file_exists($_CONTEXT['thc_ss']['paths']['emailtemplatepath'])){
				include_once($_CONTEXT['thc_ss']['paths']['emailtemplatepath']);
				if(!function_exists("TemplateEmail")){
					die(Screen($sOut."Email template function <b>TemplateEmail</b> doesn't exist.".$sEnd,$_CONTEXT['verbose'],$_CONTEXT['silent']));
				}
			}
			else{
				die(Screen($sOut."Email template file doesn't exist.".$sEnd,$_CONTEXT['verbose'],$_CONTEXT['silent']));
			}
		}
	}
	elseif($_CONTEXT['thc_ss']['file_logging']){
		// log results to a file
		if($sLogFile!=""){
			// log file
			$_CONTEXT['thc_ss']['paths']['loggingpath'] = $_CONTEXT['thc_ss']['paths']['logs']."/".$sLogFile;
			if(!file_exists($_CONTEXT['thc_ss']['paths']['loggingpath'])){
				// try to create it
				if(!WriteF($_CONTEXT['thc_ss']['paths']['loggingpath'],"","w")){
					die(Screen($sOut."Log file doesn't exist and can't be created either.".$sEnd,$_CONTEXT['verbose'],$_CONTEXT['silent']));
				}
			}
		}
		if($sLogTemplate!=""){
			// log template
			$_CONTEXT['thc_ss']['paths']['logtemplatefile'] = $_CONTEXT['thc_ss']['paths']['logtemplate']."/".$sLogTemplate;
			if(file_exists($_CONTEXT['thc_ss']['paths']['logtemplatefile'])){
				include_once($_CONTEXT['thc_ss']['paths']['logtemplatefile']);
			}
			else{
				die(Screen($sOut."Log template file doesn't exist.".$sEnd,$_CONTEXT['verbose'],$_CONTEXT['silent']));
			}
		}
	}
}
if(isset($_POST['submit'])){
	switch($_POST['submit']){
		// start task enter
		case"Scan Target":
		include_once("../../Includes/task_start.php");
		echo Screen($sOut,$_CONTEXT['verbose'],$_CONTEXT['silent']);
		break;
		// dump of log
		case"Dump Default Log":
		// make sure functions are loaded, this feature will be extended in later versions so you can select your own files w/o changing code
		include_once($_PATHS['module_default_root']."/fpaths.php");
		$_CONTEXT['thc_ss']['paths']['dumplogtemplatefile'] = $_CONTEXT['thc_ss']['paths']['logtemplate']."/".$_DPATHS['logtemplate'];
		include_once($_CONTEXT['thc_ss']['paths']['dumplogtemplatefile']);
		$_CONTEXT['thc_ss']['paths']['dumplogfile'] = $_CONTEXT['thc_ss']['paths']['logs']."/".$_DPATHS['logfile'];
		echo Screen($sOut.Array2Output(Template2Array(file_get_contents($_CONTEXT['thc_ss']['paths']['dumplogfile']),$_CONTEXT['time_pattern'])).$sEnd,$_CONTEXT['verbose'],$_CONTEXT['silent']);
		exit;
		break;
		// delete log entries
		case"Truncate Default Log":
		// overwrite default logfile
		include_once($_PATHS['module_default_root']."/fpaths.php");
		echo Screen($sOut.(WriteF($_CONTEXT['thc_ss']['paths']['logs']."/".$_DPATHS['logfile'],"","w") ? "Successfully deleted old entries." : "Failed to delete old entries.").$sEnd);
		exit;
		break;
		// just show index
		default:
		die(Screen($sOut.$sOptions.$sEnd,$_CONTEXT['verbose'],$_CONTEXT['silent']));
	}
}
else{
	die(Screen($sOut.$sOptions.$sEnd,$_CONTEXT['verbose'],$_CONTEXT['silent']));
}
// okidoki let's prepare the task
echo Screen("<br>\n<b>Running thc_ss @ ".$_CONTEXT['thc_ss']['urlparts']['scheme']."://".$_CONTEXT['thc_ss']['urlparts']['host'].@$_CONTEXT['thc_ss']['urlparts']['path']."</b><br>\n",$_CONTEXT['verbose'],$_CONTEXT['silent']);
// spit fire...
flush();
ob_flush();
echo Screen("<br>\n<b>Sending all information via curl using the ".$_CONTEXT['thc_ss']['transfermethod']." method..</b><br>\n",$_CONTEXT['verbose'],$_CONTEXT['silent']);
flush();
ob_flush();
$_CONTEXT['thc_ss']['matches'] = 0;
while(true){
	// keeps track of when the search query is found
	$_CONTEXT['thc_ss']['condition'] = false;
	if($_CONTEXT['thc_ss']['callbacksearch']){
		// let's get the dynamic content from the callback and add it to the query
		$sCBack = Callbck();
		if($sCBack=="BREAK"){
			$_CONTEXT['thc_ss']['total_time'] = (time()-$_CONTEXT['start_task']);
			echo Screen("<p><b>callback terminated script after running ".$_CONTEXT['thc_ss']['total_time']." seconds</b><br>\n",$_CONTEXT['verbose'],$_CONTEXT['silent']);
			if(isset($_CONTEXT['cbackerror'])){
				echo Screen("<b id=h7>".$_CONTEXT['cbackerror']."</b>\n",$_CONTEXT['verbose'],$_CONTEXT['silent']);
			}
			break;
		}
		$_CONTEXT['thc_ss']['urlparts']['query'] = (isset($_CONTEXT['thc_ss']['urlparts']['queryold']) && $_CONTEXT['thc_ss']['urlparts']['queryold']!="" ? $_CONTEXT['thc_ss']['urlparts']['queryold']."&" : "").$sCBack;
	}
	// make a connection and search for the string we want in the response
	$ch = curl_init();
	$_CONTEXT['thc_ss']['urlparts']['path'] = !isset($_CONTEXT['thc_ss']['urlparts']['path']) ? "" : $_CONTEXT['thc_ss']['urlparts']['path'];
	if($_CONTEXT['thc_ss']['transfermethod']=="GET"){
		// include the query into the url when using GET
		curl_setopt($ch, CURLOPT_URL, $_CONTEXT['thc_ss']['urlparts']['scheme']."://".$_CONTEXT['thc_ss']['urlparts']['host'].$_CONTEXT['thc_ss']['urlparts']['path'].(isset($_CONTEXT['thc_ss']['urlparts']['query']) && $_CONTEXT['thc_ss']['urlparts']['query']!="" ? "?".$_CONTEXT['thc_ss']['urlparts']['query'] : ""));
	}
	else{
		// include the query into the post fields when using POST
		curl_setopt($ch, CURLOPT_URL, $_CONTEXT['thc_ss']['urlparts']['scheme']."://".$_CONTEXT['thc_ss']['urlparts']['host'].$_CONTEXT['thc_ss']['urlparts']['path']);
		curl_setopt($ch, CURLOPT_POST,1);
		curl_setopt($ch, CURLOPT_POSTFIELDS,(isset($_CONTEXT['thc_ss']['urlparts']['query']) && $_CONTEXT['thc_ss']['urlparts']['query']!="" ? $_CONTEXT['thc_ss']['urlparts']['query'] : ""));
	}
	curl_setopt($ch, CURLOPT_FOLLOWLOCATION,1);
	curl_setopt($ch, CURLOPT_HEADER,0);
	curl_setopt($ch, CURLOPT_RETURNTRANSFER,1);
	$_CONTEXT['thc_ss']['response'] = @curl_exec($ch);
	curl_close($ch);
	// connection closed.. let's see what we have here..
	$_CONTEXT['thc_ss']['responselength'] = strlen($_CONTEXT['thc_ss']['response']);
	if($_CONTEXT['thc_ss']['endmessage']!=false){
		if(strlen(str_replace($_CONTEXT['thc_ss']['endmessage'],"",$_CONTEXT['thc_ss']['response']))!=$_CONTEXT['thc_ss']['responselength']){
			// end this script
			$_CONTEXT['thc_ss']['cancelled'] = true;
			echo Screen("<p>\nFound cancellation message: ".htmlspecialchars($_CONTEXT['thc_ss']['endmessage'])."</p>\n",$_CONTEXT['verbose'],$_CONTEXT['silent']);
			echo Screen("<p><b>terminating script after running ".(time()-$_CONTEXT['start_task'])." seconds</b><br>\n",$_CONTEXT['verbose'],$_CONTEXT['silent']);
			break;
		}
	}
	$sOccurence = "";
	if(!$_CONTEXT['thc_ss']['negative_scan']){
		// when string is found
		if($_CONTEXT['thc_ss']['regex']){
			// search using a regular expression
			if(preg_match($_CONTEXT['thc_ss']['search'],$_CONTEXT['thc_ss']['response'])){
				// match found
				$_CONTEXT['thc_ss']['matches']++;
				$_CONTEXT['thc_ss']['condition'] = true;
			}
		}
		else{
			if(strlen(str_replace($_CONTEXT['thc_ss']['search'],"",$_CONTEXT['thc_ss']['response']))!=$_CONTEXT['thc_ss']['responselength']){
				$_CONTEXT['thc_ss']['condition'] = true;
				$_CONTEXT['thc_ss']['matches']++;
			}
		}
	}
	else{
		// when string not found
		$sOccurence = "<b>!</b>";
		if($_CONTEXT['thc_ss']['regex']){
			// search using a regular expression
			if(!preg_match(stripslashes($_CONTEXT['thc_ss']['search']),$_CONTEXT['thc_ss']['response'])){
				$_CONTEXT['thc_ss']['condition'] = true;
				$_CONTEXT['thc_ss']['matches']++;
			}
		}
		else{
			if(strlen(str_replace($_CONTEXT['thc_ss']['search'],"",$_CONTEXT['thc_ss']['response']))==$_CONTEXT['thc_ss']['responselength']){
				$_CONTEXT['thc_ss']['condition'] = true;
				$_CONTEXT['thc_ss']['matches']++;
			}
		}
	}
	// output what we search for
	$sStringT = "[".$sOccurence.htmlspecialchars((strlen($_CONTEXT['thc_ss']['search'])>17 ? substr($_CONTEXT['thc_ss']['search'],0,15)."..." : $_CONTEXT['thc_ss']['search']))."]";
	$aResultX = array();
	$aResultX['result'] = $sStringT." ".(isset($_CONTEXT['thc_ss']['urlparts']['query']) && $_CONTEXT['thc_ss']['urlparts']['query']!="" ? " =&gt; ".$_CONTEXT['thc_ss']['urlparts']['query'] : "");
	// do we need to log this output or email it?
	if($_CONTEXT['thc_ss']['condition']){
		include_once($_PATHS['module_default_root']."/fpaths.php");
		$sDest = $_CONTEXT['thc_ss']['paths']['logtemplate']."/".$_DPATHS['logtemplate'];
		include_once($sDest);
		$aResultX['date'] = time();
		$aResultX['keyword'] = $_CONTEXT['thc_ss']['search'];
		$aResultX['result'] .= " =&gt; <b>true</b>";
		$mResult = ($iNotify==1 ? TemplateEmail($sEmail,$aResultX) : WriteF($_CONTEXT['thc_ss']['paths']['logs']."/".$sLogFile,TemplateLog($aResultX['keyword'],$aResultX['result'],$aResultX['date'])));
		if($_CONTEXT['thc_ss']['endscript']){
			// real end time
			echo Screen("<br>\n".$aResultX['result']."\n",$_CONTEXT['verbose'],$_CONTEXT['silent']);
			echo Screen("<p><b>terminating script after running ".(time()-$_CONTEXT['start_task'])." seconds</b><br>\n",$_CONTEXT['verbose'],$_CONTEXT['silent']);
			break;
		}
	}
	else{
		$aResultX['result'] .= " =&gt; <b>false</b>";
	}
	echo Screen("<br>\n".$aResultX['result']."\n",$_CONTEXT['verbose'],$_CONTEXT['silent']);
	$_CONTEXT['thc_ss']['result'] = $aResultX['result'];
	flush();
	ob_flush();
	if($_CONTEXT['thc_ss']['timebased_scan']){
		// ..we'll depend on the time
		$iTotalTime = (time()-$_CONTEXT['start_task']);
		if($iScanTime<=$iTotalTime){
			// time's over, let's get the hell out of here..
			echo Screen("<p><b>terminating script after running ".$iTotalTime." seconds</b><br>\n",$_CONTEXT['verbose'],$_CONTEXT['silent']);
			break;
		}
	}
	if($iInterval>0){
		sleep($iInterval);
	}
}
$_CONTEXT['thc_ss']['resultstring'] = "<p><b>matches:</b> ".$_CONTEXT['thc_ss']['matches']." (running time) ".(time()-$_CONTEXT['start_task'])."(s)\n";
echo Screen($_CONTEXT['thc_ss']['resultstring'],$_CONTEXT['verbose'],$_CONTEXT['silent']);
// update entry in background task file
include($_PATHS['includes_root']."/task_end.php");
echo $sEnd;
?>
